create or replace FUNCTION  es_data
/******************************************************************************
   NOM:         Es_Data
   DESCRIPCI:
                Comprova si el parmetro c_data te el format de data especificat
                pel parmetre c_format. Per defecte el format de la data ser DD/MM/AAAA

   RETORNA:     Un boole que ser vertader si compleix el format i fals si no compleix.

   EXEMPLE:     Es_Data('22/04/2008 08:00', 'DD/MM/YYYY hh24:mi:ss')
******************************************************************************/
(
   c_data     VARCHAR2,
   c_format   VARCHAR2 := 'DD/MM/YYYY'
)
       RETURN BOOLEAN
    AS
       d_data_text   DATE;
    BEGIN
       d_data_text := TO_DATE (c_data, c_format);
       RETURN TRUE;
    EXCEPTION
       WHEN OTHERS
       THEN
          RETURN FALSE;
END es_data;

/


create or replace
FUNCTION  quinTrimestre(n_mes number) RETURN number 
/******************************************************************************
   NOM:         quinTrimestre

   RETORNA:     Un numero de mes de la data.

   EXEMPLE:     quinTrimestre(11) retorna 4
******************************************************************************/
    AS
       trimestre NUMBER;
    BEGIN
        IF ( n_mes > 0 AND n_mes < 4 ) THEN 
          trimestre := 1;
        END IF;
        IF ( n_mes > 3 AND n_mes < 7 ) THEN 
          trimestre := 1;
        END IF;
        IF ( n_mes > 6 AND n_mes < 10 ) THEN 
          trimestre := 1;
        END IF;
        IF ( n_mes > 10 AND n_mes < 13 ) THEN 
          trimestre := 1;
        END IF;        
        RETURN trimestre;

    EXCEPTION
       WHEN OTHERS
       THEN
          RETURN 0;
END quinTrimestre;
/

create or replace FUNCTION es_numero(s_param VARCHAR2) RETURN BOOLEAN IS
/******************************************************************************
   NOM:         Es_Numero
   DESCRIPCI:
                Comprova si el parmetre s_param es numric o no. 
                Es comprova amb la funci TO_NUMBER, a la que si es passa un 
                parmetre no numric provoca una excepci que ens indica que 
                no s numrico, en cas contrari sabrem que s ho s.

   RETORNA:     Un boole que ser vertader si el parmetre s_param s un nmero
                o fals si no ho s.

   EXEMPLE:     Es_Numero(25)-> Retorna True, Es_Numero('TENIS')-> Retorna False
******************************************************************************/

 n NUMBER;
BEGIN
  n := TO_NUMBER(s_param);
  RETURN TRUE; 
EXCEPTION
  WHEN OTHERS THEN
    RETURN FALSE;
END es_numero;

/
