/********************************************************************************
Autor: Eduard Monzonis Hierro                                   UOC
18/05/2012                                             TFC: CONTROL ENERGIA.
   NOM:         CREACIO DE TAULAS DEL SISTEMA
   
********************************************************************************/
/
CREATE TABLE ESTAT /* 1 */
(
	idEstat 		INT CONSTRAINT PK_idEstat PRIMARY KEY,
	descripcioEstat 	VARCHAR2(20 CHAR) CONSTRAINT NN_Estat_descripcio NOT NULL
);
/
--	TAULA VIA
CREATE TABLE VIA /* 2 */
(
	idVia 	      		INT CONSTRAINT PK_idVia PRIMARY KEY,
	descripcioVia 		VARCHAR2(20 CHAR) CONSTRAINT NN_Via_descripcio NOT NULL
);
/
--	TAULA PERSONA
CREATE TABLE PERSONA /* 3 */
(
	idPersona 	  	INT CONSTRAINT PK_idPersona PRIMARY KEY,
	descripcioPersona	VARCHAR2(20 CHAR) CONSTRAINT NN_Persona_descripcio NOT NULL
);
/
--	TAULA CLASSE CENTRAL
CREATE TABLE CLASSE_CENTRAL  /* 4 */ 
(
	idClasse 	 	INT CONSTRAINT PK_idClasse PRIMARY KEY,
	descripcioClasse 	VARCHAR2(20 CHAR) CONSTRAINT NN_Classe_Central_descripcio NOT NULL
);
/
--	TAULA TIPUS FUNCIONS
CREATE TABLE TIPUS_FUNCIONS  /* 5 */
(
	idFuncio 	  	INT CONSTRAINT PK_funcio PRIMARY KEY,
 	descripcionFuncio 	VARCHAR2(50 CHAR) CONSTRAINT NN_Tipus_Funcions_descripcion NOT NULL
 );
/
--	TIPO LECTURA
CREATE TABLE TIPO_LECTURA /* 6 */
(
	idTipoLectura 		INT CONSTRAINT PK_idTipoLectura PRIMARY KEY,
	descripcioLectura 	VARCHAR2(50 CHAR) CONSTRAINT NN_Tipo_Lectura_descripcio NOT NULL
);
/
--	TAULA TIPUS CENTRAL 
CREATE TABLE TIPO_CENTRAL  /* 7 */
(
	idTipoCentral 		INT CONSTRAINT PK_idTipoCentral PRIMARY KEY,
 	descripcioTipoCentral 	VARCHAR2(20 CHAR) CONSTRAINT NN_TIPO_CENTRAL_descripcio NOT NULL,
 	idFuncioTipoCentral 	CONSTRAINT FK_Tipo_Central_idfuncio 	REFERENCES TIPUS_FUNCIONS(idFuncio) NOT NULL,
 	quantitatTipoCentral 	DECIMAL(9,2) CONSTRAINT NN_Tipo_Central_quantitat NOT NULL,
 	estatTipoCentral 	CONSTRAINT FK_tipo_central_estado 	REFERENCES ESTAT(idEstat) NOT NULL,
--	1=Alta OR 2=Baixa 	
	dataEstatTipoCentral	DATE CONSTRAINT NN_tCentrales_dataEstat  NOT NULL,
 	observacionsTipoCentral VARCHAR2(250 CHAR)
);
/
--	TAULA PAIS  /* 8 */
CREATE TABLE PAIS
(
  	idPais             	INT CONSTRAINT PK_idPais PRIMARY KEY,  
   	descripcioPais      	VARCHAR2(50 CHAR) CONSTRAINT NN_Pais_nomPais NOT NULL,
	codiPais            	VARCHAR2(5 CHAR) CONSTRAINT NN_Pais_codiPais NOT NULL 
  );
/
--	TAULA PROVINCIA
CREATE TABLE PROVINCIA  /* 9 */
(
	idProvincia         	INT  CONSTRAINT PK_IdProvincia PRIMARY KEY,  
   	descripcioProvincia 	VARCHAR2(50 CHAR) CONSTRAINT NN_provincia_NomProvincia NOT NULL,
   	idPaisProvincia      	CONSTRAINT FK_Provincia_idiPais 	REFERENCES PAIS (idPais)NOT NULL
 );
/
--	TAULA LOCALITAT
CREATE TABLE LOCALITAT  /* 10 */
(
   	idLocalitat        	INT CONSTRAINT PK_idLocalitat PRIMARY KEY,
   	descripcioLocalitat 	VARCHAR2(50 CHAR) CONSTRAINT NN_Localitat_NomLocalitat NOT NULL,
   	idProvinciaLocalitat  	CONSTRAINT FK_Localitat_idiProvincia 	REFERENCES PROVINCIA (idProvincia)NOT NULL
);
/
--	TAULA UBICACIO
CREATE TABLE UBICACIO  /* 11 */
(
  	idUbica              	INT CONSTRAINT PK_Ubicacio PRIMARY KEY,
  	idViaUbicacio        	CONSTRAINT FK1_Ubicacio_codiVia 	REFERENCES VIA (idVia) NOT NULL,
	direccionUbicacio    	VARCHAR2(50 CHAR) CONSTRAINT NN_Ubicacio_direccio NOT NULL,  
	numeroUbicacio       	VARCHAR2(5 CHAR) CONSTRAINT NN_Ubicacio_Numero NOT NULL,
	pisUbicacio          	VARCHAR2(10 CHAR) CONSTRAINT NN_Ubicacio_Pis  NULL,
 	portaUbicacio        	VARCHAR2(10 CHAR) CONSTRAINT NN_Ubicacio_Porta NULL,
	codiPostal           	VARCHAR2(10 CHAR) CONSTRAINT NN_Ubicacio_CP NOT NULL,  
	idLocalitatUbicacio  	CONSTRAINT FK2_Ubicacio_idLocalitat 	REFERENCES LOCALITAT (idLocalitat) NOT NULL
);
/
--	TAULA TIPUS INSPECCIO
CREATE TABLE TIPO_INSPECCIO  /* 13 */
(
	idTInspccio		INT CONSTRAINT PK_idTInspeccio PRIMARY KEY,
	descripcioTInspeccio 	VARCHAR2(50 CHAR)CONSTRAINT NN_Tipo_Inspeccio_descripcio NOT NULL
);
/
--	TAULA INSPECCIO
CREATE TABLE INSPECCIO  /* 14 */
(
	idInspeccio             INT CONSTRAINT PK_Inspeccio_idInspeccio PRIMARY KEY,
        dataInspeccio 		DATE CONSTRAINT NN_Inspeccio_dataInspecio NOT NULL,
	codiInspector 		VARCHAR2(20 CHAR) CONSTRAINT NN_Inspeccio_inspector NOT NULL,
	idsuperaInspeccio      	CONSTRAINT FK_Tipo_Inspeccio_idSupera 	REFERENCES TIPO_INSPECCIO(idTInspccio) NOT NULL,
	observacionsInspeccio	VARCHAR2(250 CHAR)
);
/
--	TAULA CENTRAL
CREATE TABLE CENTRAL  /* 12 */
(
	idCentral          	    INT CONSTRAINT PK_idCent PRIMARY KEY,
 	dataAltaCentral    	    DATE CONSTRAINT NN_Central_dataAltaCent  NOT NULL,
	estatCentral		    CONSTRAINT FK1_Central_estatCent REFERENCES ESTAT(idEstat) NOT NULL,
	dataModificaCentral   	    DATE CONSTRAINT NN_Central_dataModifCent  NULL,
	idclasseCentral	   	    CONSTRAINT FK2_Central_idclasseCent 	 REFERENCES CLASSE_CENTRAL(idClasse) NOT NULL,
	idtipoCentral       	    CONSTRAINT FK3_Central_idtipoCent   	 REFERENCES TIPO_CENTRAL(idTipoCentral) NULL,
	dataUltimaInspeccioCentral  DATE CONSTRAINT NN_Central_dataUltimaInsCent  NOT NULL,
        idInspeccioCentral	    CONSTRAINT FK4_Central_idInspeccioCent REFERENCES TIPO_INSPECCIO(idTInspccio) NOT NULL,
	energiaMaxima               DECIMAL(9,2) CONSTRAINT NN_Central_energiaMax NOT NULL,
	energiaMinima               DECIMAL(9,2) CONSTRAINT NN_Central_energiaMin  NOT NULL,
        idUbicaCentral       	    CONSTRAINT FK5_Central_idUbicaCent 	 REFERENCES UBICACIO(idUbica) NOT NULL,
	observacionsCentral         VARCHAR2(250 CHAR)
);
/
--	TAULA FABRICANT
CREATE TABLE FABRICANT  /* 15 */
(
	idFabricant		INT CONSTRAINT PK_idFabricant PRIMARY KEY,
	nifFabricant		VARCHAR2(15 CHAR) CONSTRAINT NN_Fabricant_nif NOT NULL,
	dataAltaFabricant	DATE CONSTRAINT NN_Fabricant_dataAlta NOT NULL,
	estatFabricant		CONSTRAINT FK1_Fabricant_estat 		REFERENCES ESTAT(idEstat) NOT NULL,
	dataModifcaFabricant   	DATE CONSTRAINT NN_Fabricant_fechaModifica  NULL,
	nomComercialFabricant	VARCHAR2(70 CHAR) CONSTRAINT NN_Fabricant_nomComercial NOT NULL,
	idUbicaFabricant	CONSTRAINT FK2_Fabricant_idUbica 	REFERENCES UBICACIO(idUbica) NOT NULL,
 	CONSTRAINT UN_Fabricant_nif UNIQUE (nifFabricant)
);
/
--	TAULA CLIENT
CREATE TABLE CLIENT /* 16 */
(
	idClient      		INT CONSTRAINT PK_Client PRIMARY KEY,
	dniClient     		VARCHAR2(10 CHAR) CONSTRAINT AK_Client_dni UNIQUE,
	dataAltaClient  	DATE DEFAULT(sysdate) CONSTRAINT NN_Client_dataAlta  NOT NULL, 
	estatClient		CONSTRAINT FK1_Client_estat REFERENCES ESTAT(idEstat) NOT NULL,
	dataModificacioClient	DATE,
	nomClient 		VARCHAR2(50 CHAR) CONSTRAINT NN_Client_nom NOT NULL,
	cognom1Client 		VARCHAR2(50 CHAR) CONSTRAINT NN_Client_cognom1 NOT NULL,
	cognom2Client 		VARCHAR2(50 CHAR),
	idUbicaClient   	CONSTRAINT FK2_Client_idUbica REFERENCES UBICACIO(idUbica) NOT NULL,
	idtipoClient		CONSTRAINT FK3_Client_idtipoClient REFERENCES PERSONA(idPersona) NOT NULL,
	observacioClient 	VARCHAR2(250 CHAR)
);
/
--	TAULA MODEL 
CREATE TABLE MODELO  /* 17 */
(
	idModelo        	INT  CONSTRAINT PK_idModelo PRIMARY KEY,
 	descripcioModelo   	VARCHAR2(50 CHAR),
 	anyoFabricaModelo	VARCHAR2(4 CHAR), 
 	idFabricantModelo	CONSTRAINT FK1_Modelo_idiFabricant  	REFERENCES FABRICANT(idFabricant) NOT NULL,
 	dataAltaModelo		DATE CONSTRAINT NN_Modelo_dataAlta NOT NULL,
	estatModelo		CONSTRAINT FK2_Modelo_estat 		REFERENCES ESTAT(idEstat) NOT NULL,
 	dataModificacioModelo	DATE CONSTRAINT NN_Modelo_fechaModifica  NULL,   
 	observacionsModelo	VARCHAR2(50 CHAR)
);
/
--	TAULA COMPTADOR
CREATE TABLE COMPTADOR  /* 18 */
(
 	idComptador            	INT  CONSTRAINT PK_idComptador PRIMARY KEY,
 	idModeloComptador	CONSTRAINT FK1_Comptador_idModel	REFERENCES MODELO(idModelo) NOT NULL,
	idUbicaComptador        CONSTRAINT FK2_Comptador_idUbica 	REFERENCES UBICACIO(idUbica) NOT NULL,
	dataAltaComptador  	DATE CONSTRAINT NN_Comptador_fechaAlta  NOT NULL,  
	idEstadoCompator	CONSTRAINT FK3_Comptador_idEstat 	REFERENCES ESTAT(idEstat) NOT NULL,
	dataModificacioCompator	DATE CONSTRAINT NN_Comptador_fechaEstado   NULL, 
 	numSerieComptador 	VARCHAR2(20 CHAR) CONSTRAINT NN_Comptador_numSerie NOT NULL,
        observacionsComptador   VARCHAR2(70 CHAR)
);
/
--	TAULA CONTRACTE 
CREATE TABLE CONTRACTE  /* 19 */
(
	idContracte           	 INT CONSTRAINT PK_idContracte PRIMARY KEY,
 	dniClienteContracte    	 CONSTRAINT FK1_Contracte_dniCliente   REFERENCES CLIENT(dnicLIENT) NOT NULL,
 	idContadorContracte	 CONSTRAINT FK2_Contracte_idContador   REFERENCES COMPTADOR(idComptador) NOT NULL,
	dataAltaContracte	 DATE CONSTRAINT NN_Contracte_fechaAlta  NOT NULL, 	
	idEstatContracte	 CONSTRAINT FK3_Contracte_idEstat      REFERENCES ESTAT(idEstat) NOT NULL,
 	dataModificacioContracte DATE CONSTRAINT NN_Contracte_fechaModifica  NULL,   
 	potenciaContracte   	 DECIMAL(9,2)   CONSTRAINT NN_Contracte_potenciaContrato NOT NULL,
 	observacioContracte	 VARCHAR2(100 CHAR)
);
/
--  TAULA TIPUS DE LINEA
CREATE TABLE LINEA_TIPUS /* 20 */
(
  idTlinea          INT CONSTRAINT PK_Tlinea  PRIMARY KEY,
  idEstatTlinea     CONSTRAINT FK_Tlinea_idEstado  REFERENCES ESTAT(idEstat) NOT NULL,
  dataEstatTLinea  DATE CONSTRAINT NN_linea_fechaEstat NOT NULL,
  consumMaximTLinea DECIMAL(9,2) CONSTRAINT NN_Tlinea_consumMaxim NOT NULL,
  observacioTlinea  VARCHAR(50 CHAR) 
);
/
--	TAULA LINEA CONNECTAR  CENTRALS
CREATE TABLE LINEA_CONECTA_CENTRAL /* 30 */
(
 	idConecta         INT CONSTRAINT PK_idConecta   PRIMARY KEY,
	dataAltaC         DATE  DEFAULT(sysdate)CONSTRAINT NN_CONECTA_fechaAlta  NOT NULL, 	
	idEstatC           CONSTRAINT FK1_CONECTA_idEstat REFERENCES ESTAT(idEstat) NOT NULL,
	dataModificacioC    	DATE CONSTRAINT NN_CONECTA_fechaModifica  NULL,  
	connectaCProdu        CONSTRAINT FK2_CONECTA_connectaCentProdu  REFERENCES CENTRAL(idCentral) NOT NULL,
	connectaCDistri    	CONSTRAINT FK3_CONECTA_connectaCentDistri  REFERENCES CENTRAL(idCentral) NOT NULL,
 	observacioC         VARCHAR(50 CHAR)
);
/
--	TAULA LINEA CONNECTAR COMPTADOR AMB CENTRAL DISTRIBUCIO
CREATE TABLE LINEA_CONECTAR_COMPTADOR /* 21 */
(
 	idLineaConecta         	INT CONSTRAINT PK_idLinea  PRIMARY KEY,
	idLineaTipoLineaConecta    CONSTRAINT FK2_lineaConecta_idLineaTLinea REFERENCES LINEA_TIPUS(idTlinea) NOT NULL,
        dataAltaLineaConecta    DATE  DEFAULT(sysdate)CONSTRAINT NN_Linea_fechaAlta  NOT NULL, 	
	idEstatLineaConecta     CONSTRAINT FK1_Linea_idEstat REFERENCES ESTAT(idEstat) NOT NULL,
	dataModificacioLineaConecta    	DATE CONSTRAINT NN_Linea_fechaModifica  NULL,  
	connecta1_CentralConecta        CONSTRAINT FK2_Linea_connectaCentral 	REFERENCES LINEA_CONECTA_CENTRAL(idConecta) NOT NULL,
	connecta2_ComptadorConecta    	CONSTRAINT FK3_Linea_connectaComptador  REFERENCES COMPTADOR(idComptador) NOT NULL,
 	parLineaComptadorConecta        NUMBER NOT NULL, 
	observacioLineaConecta          VARCHAR(50 CHAR)
);
/
--	TAULA LECTURA 
CREATE TABLE LECTURA /* 22 */
(
 	idLectura       	INT CONSTRAINT PK_idLectura  PRIMARY KEY,
	--idLineaLectura	CONSTRAINT FK1_Lectura_idLinea REFERENCES LINEA_CONECTAR_COMPTADOR(idLineaConecta) NOT NULL,
 	idComptadorLectura      CONSTRAINT FK1_Lectures_idcomptador REFERENCES COMPTADOR(idComptador) NOT NULL,
        confirmaLectura        	INT CONSTRAINT FK2_Lectura_Comfirma CHECK(confirmaLectura='0' OR confirmaLectura='1')NOT NULL, 
-- estat opcional per dona per validar 0=No validada OR 1=Validada 
	dataLectura		DATE CONSTRAINT NN_Lectura_fechaLectura NOT NULL,
 	idTipoLectura     	CONSTRAINT FK3_Lectura_tipusLectura REFERENCES TIPO_LECTURA(idTipoLectura) NOT NULL,                                   -- tipo lectura 0 telematica, 1 presencial
	consumLectura		DECIMAL(9,2) CONSTRAINT NN_Lectura_Consumo  NULL,
        lecturaActual           DECIMAL(9,2) CONSTRAINT NN_Lectura_Consumo  NULL,
        lecturaAnterior         DECIMAL(9,2) CONSTRAINT NN_Lectura_Consumo  NULL
);
/
--	TAULA HIST_LECTURA 
CREATE TABLE HIST_LECTURA  /* 23 */
(
 	regHistLectura		INT CONSTRAINT  PK_numReg PRIMARY KEY,
        idLineaHistLectura      CONSTRAINT FK2_Hist_Lectura_idLinea REFERENCES LINEA_CONECTAR_COMPTADOR(idLineaConecta) NOT NULL,
 	idComptadorHistLectura	CONSTRAINT FK1_Hist_Lectura_idContador  REFERENCES COMPTADOR(idComptador) NOT NULL,
 	anyoHistLectura         VARCHAR2(4 CHAR) CONSTRAINT NN_Hist_Lectura_anyo NOT NULL,
        mesHistLectura          VARCHAR2(2 CHAR) CONSTRAINT NN_Hist_Lectura_mes  NOT NULL,
 	totalConsumoHistLectura DECIMAL(9,2)
);
-- TAULA LOG_TFC
CREATE TABLE LOG_TFC 
(
  idLog         NUMBER CONSTRAINT PK_log PRIMARY KEY, 
  procesLog     VARCHAR2(1000 BYTE)   CONSTRAINT NN_procesoLog_Log NOT NULL, 
  dataHoraLog   DATE  CONSTRAINT NN_fechaHoraLog_Log NOT NULL, 
  entradaLog    VARCHAR2(1000 BYTE)  CONSTRAINT NN_entradaLog_Log NOT NULL, 
  sortidaLog    VARCHAR2(1000 BYTE)  CONSTRAINT NN_salidaLog_Log NOT NULL, 
  rspLog        VARCHAR2(1000 BYTE)  CONSTRAINT NN_RSPLog_log NOT NULL
);
--	MODUL ESTADISTIC
/
--	TAULA E 1 
CREATE TABLE E_1 /* 24 */
(
  idE_1       INT CONSTRAINT PK_idE_1 PRIMARY KEY,
  idCentral   CONSTRAINT FK1_E_1_idCentral REFERENCES CENTRAL(idCentral) NOT NULL,
  idComptador_E_1 CONSTRAINT FK2_E_1 REFERENCES COMPTADOR(idComptador) NOT NULL,
  sumaConsums DECIMAL(9,2)
);

/
--	TAULA E 2 /* 23 */
-- Donada una lnia de comunicaci i un any concret, el valor mitj de lenergia consumida,
-- tenint en compte que aquest
-- consum depn dels comptadors que salimenten mitjanant  aquesta lnia.
-- Si un comptador pot fer servir dues lnies, suposeu que les dues lnies computen el consum per
-- garantir que les lnies estan ben dimensionades en cas de caiguda dalguna delles.
/
CREATE TABLE E_2 /*25*/
(
  idE_2 INT CONSTRAINT PK_idE_2 PRIMARY KEY,
  idLineaConectaE_2 CONSTRAINT FK_E_2_idLineaConectaE_2 REFERENCES LINEA_CONECTAR_COMPTADOR(idLineaConecta) NOT NULL,
  anyoE_2    VARCHAR2(4 CHAR) CONSTRAINT NN_e2_anyo NOT NULL,
  consumoContadoresE_2    NUMBER(9,2) CONSTRAINT NN_e2_consumoContadores  NOT NULL,
 consumoEnergiaMedioE_2  NUMBER(9,2) CONSTRAINT NN_e2_consumoEnergiaMedio  NOT NULL
);
/
--  TAULA E_3
-- E3_Lnia que ha estat ms carregada a nivell denergia consumida.
CREATE TABLE E_3 /*26*/ 
(
id_E3      NUMBER   CONSTRAINT      PK_e_3_ID_E3 PRIMARY KEY,
 linea_E3      CONSTRAINT      FK_e_3_linea_E3  REFERENCES  LINEA_CONECTAR_COMPTADOR(idLineaConecta) NOT NULL,
 consumoContadores_E3    NUMBER(9,2) CONSTRAINT      NN_e_3_consumoContadores_E3  NULL,
 any_E3               VARCHAR2(4 CHAR) CONSTRAINT     NN_e_3_any_E3  NOT NULL
);

/
-- TAULA E_4
-- E4 Donat un any concret: percentatge de lnies que superen el 50% denergia consumida.
CREATE TABLE E_4 /*27*/
(
idE_4 NUMBER  CONSTRAINT PK_idE4   PRIMARY KEY,
lineaE_4  CONSTRAINT      FK_e_4_linea_E4  REFERENCES  LINEA_CONECTAR_COMPTADOR(idLineaConecta) NOT NULL,
anyoE_4   VARCHAR2(4 CHAR) CONSTRAINT  NN_E4_anyo  NOT NULL,
percentageE_4 NUMBER(9,2) CONSTRAINT NN_E4_percentageE_4  NOT NULL
);
/
-- TAULA E_5
-- E5 Donat un any concret: el nombre de centrals de producci que generen menys del 30% de producci.
CREATE TABLE E_5 /*28*/
(
idE_5 NUMBER  CONSTRAINT PK_idE5   PRIMARY KEY,
lineaE_5  CONSTRAINT      FK_e_5_linea_E5  REFERENCES  LINEA_CONECTAR_COMPTADOR(idLineaConecta) NOT NULL,
anyoE_5   VARCHAR2(4 CHAR) CONSTRAINT  NN_E5_anyo  NOT NULL,
centProducMenos30 NUMBER(9,2) CONSTRAINT NN_E5_centProduMenos30 NOT NULL
);
/
-- TAULA E_6 
-- E6 Top-10 de comptadors que histricament han tingut ms consum.
CREATE TABLE E_6 /*29*/
(
idE_6 NUMBER  CONSTRAINT PK_idE6   PRIMARY KEY,
idcontadorE_6 CONSTRAINT FK_E6_idContadorE_6 REFERENCES  COMPTADOR(idComptador)  NOT NULL,
consumoE_6     NUMBER(9,2) CONSTRAINT NN_E6_consumoE_6 NOT NULL
);
/
-- TAULA E_7
-- E7 Consum mig de tots dels clients.
CREATE TABLE E_7    
(
 idE_7 NUMBER CONSTRAINT PK_E7 PRIMARY KEY,
 dniClient  CONSTRAINT FK_E7_clientDni  REFERENCES  CLIENT(dniClient)  NOT NULL,
 consumoMedioCli  NUMBER(9,2) CONSTRAINT  NN_e7_consumoMedio NOT NULL
);
/

/*************** FINAL PROCES CREACIO TAULES ************************************/

