CREATE OR REPLACE
PACKAGE BODY          "GESTION_CLIENT" AS
   n_registres      NUMBER;
  s_sql            VARCHAR2 (2000);
  n_NUM_ERR 	  NUMBER(10);
 
  c_procesLog	  LOG_TFC.procesLog%TYPE;	
  c_dataHoraLog    LOG_TFC.dataHoraLog%TYPE;
  c_entradaLog     LOG_TFC.entradaLog%TYPE;	
  c_sortidaLog     LOG_TFC.sortidaLog%TYPE;
  s_rsp	        LOG_TFC.rspLog%TYPE; 
  
  n_texte1 VARCHAR2(30);
  n_texte2 VARCHAR2(30);
  
 n_DESCRIPCIOESTAT ESTAT.DESCRIPCIOESTAT%TYPE;
  n_DESCRIPCIOPERSONA PERSONA.DESCRIPCIOPERSONA%TYPE;
 n_DESCRIPCIOVIA VIA.DESCRIPCIOVIA%TYPE;
 n_DIRECCIONUBICACIO UBICACIO.DIRECCIONUBICACIO%TYPE;
 n_NUMEROUBICACIO UBICACIO.NUMEROUBICACIO%TYPE;
 n_PISUBICACIO UBICACIO.PISUBICACIO%TYPE;
 n_PORTAUBICACIO UBICACIO.PORTAUBICACIO%TYPE;
 n_CODIPOSTAL UBICACIO.CODIPOSTAL%TYPE;
 n_DESCRIPCIOLOCALITAT LOCALITAT.DESCRIPCIOLOCALITAT%TYPE;
 n_DESCRIPCIOPROVINCIA PROVINCIA.DESCRIPCIOPROVINCIA%TYPE;
 n_DESCRIPCIOPAIS PAIS.DESCRIPCIOPAIS%TYPE;     
 
n_dataAltaClient      CLIENT.dataAltaClient%TYPE;
n_dataModificacioClient CLIENT.dataModificacioClient%TYPE;
n_estatClient CLIENT.estatClient%TYPE;
n_dniClient CLIENT.dniClient%TYPE;
n_nomClient CLIENT.nomClient%TYPE;
n_cognom1Client CLIENT.cognom1Client%TYPE;
n_cognom2Client CLIENT.cognom2Client%TYPE;
n_idUbicaClient CLIENT.idUbicaClient%TYPE;
n_idTipoClient CLIENT.idTipoClient%TYPE;
n_observacioClient	CLIENT.observacioClient%TYPE;
n_idClient CLIENT.idClient%TYPE;


 n_via VIA.DESCRIPCIOVIA%TYPE;
 n_direccio UBICACIO.DIRECCIONUBICACIO%TYPE;
 n_numero UBICACIO.NUMEROUBICACIO%TYPE;
 n_pis UBICACIO.PISUBICACIO%TYPE;
 n_porta UBICACIO.PORTAUBICACIO%TYPE;
 n_cp UBICACIO.CODIPOSTAL%TYPE;
 n_localitat LOCALITAT.DESCRIPCIOLOCALITAT%TYPE;

sortida VARCHAR2(1000):='';
e_client        EXCEPTION;

/********************************************************************************
      NOM:         PRC_ALTA_CLIENT
      DESCRIPCIÃ“:
                   Procediment encarregat de l'alta les dades d'un Client. 
                  
********************************************************************************/   
PROCEDURE PRC_ALTA_CLIENT(
    p_dniClient in CLIENT.dniClient%Type,
    p_dataAltaCLient in CLIENT.dataAltaCLient%Type,
    p_estatClient in CLIENT.estatClient%Type,
    p_nomClient in CLIENT.nomClient%Type,
    p_cognom1Client in CLIENT.cognom1Client%Type,
    p_cognom2Client in CLIENT.cognom2Client%Type,
    p_idUbicaClient in CLIENT.idUbicaClient%Type,
    p_idTipoClient in CLIENT.idTipoClient%Type,
    p_observacioClient in CLIENT.observacioClient%Type,
    s_rsp out NOCOPY VARCHAR2)
  AS
 n_controlEstat number;
  BEGIN
 
 --Parametres per la taula LOG
      c_procesLog := 'PRC_ALTA_CLIENT';
      c_dataHoraLog := SYSDATE;
      c_entradaLog :=   'dniClient: ' || p_dniClient || 
                        ', data Alta Client: ' || p_dataAltaClient ||
                        --', estat Client: ' || p_estatClient || 
                        ', nom Client: ' || p_nomClient ||
                        ', cognom1 Client: ' || p_cognom1Client || 
                        ', cognom2 Client: ' || p_cognom2Client ||
                        ', id Ubica Client: ' || p_idUbicaClient ||
                        ', id Tipo Client: ' || p_idTipoClient ||
                         --, p_dataModificacioClient: ' || p_dataModificacioClient ||
                        ', observacioClient: ' || p_observacioClient;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' ');
      DBMS_OUTPUT.PUT_LINE('          ALTA DE CLIENTS        ');
      DBMS_OUTPUT.PUT_LINE('-------------------------------- ');
      DBMS_OUTPUT.PUT_LINE(' dniClient: ' || p_dniClient || 
                        ', data Alta Client: ' || p_dataAltaClient ||
                        --', estat Client: ' || p_estatClient || 
                        ', nom Client: ' || p_nomClient ||
                        ', cognom1 Client: ' || p_cognom1Client || 
                        ', cognom2 Client: ' || p_cognom2Client ||
                        ', id Ubica Client: ' || p_idUbicaClient ||
                        ', id Tipo Client: ' || p_idTipoClient ||
                         --, p_dataModificacioClient: ' || p_dataModificacioClient ||
                        ', observacioClient: ' || p_observacioClient);     
    c_sortidalog := 's_rsp'; 
    
    n_controlEstat:=1;
-- Comprovem que el dni client  no sigui NULL
    If p_dniClient IS NULL then
       DBMS_OUTPUT.ENABLE;
       DBMS_OUTPUT.PUT_LINE('ALTA DE CLIENTS: ');             
       s_rsp := 'Falta especificar el DNI';
       DBMS_OUTPUT.PUT_LINE(s_rsp);                
       RAISE e_client;
    END IF;
    SELECT COUNT(PERSONA.IDPERSONA) INTO n_idTipoClient
    FROM PERSONA
    WHERE PERSONA.IDPERSONA=p_idTipoClient;
   -- Comprovem els parÃ metres NULL i advertim si falta algun parÃ metre
    IF n_idTipoClient=0 THEN
       DBMS_OUTPUT.ENABLE;
       DBMS_OUTPUT.PUT_LINE('ALTA DE CLIENTS: ');                        	
       s_rsp := 'Falta especificar el tipu de client.';
       DBMS_OUTPUT.PUT_LINE(s_rsp);
       RAISE e_client;
    END IF;          
    If p_nomClient  IS NULL THEN
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('ALTA DE CLIENTS: ');                                 
      s_rsp := 'Falta especificar el nom ';
      DBMS_OUTPUT.PUT_LINE(s_rsp);
      RAISE e_client;
    END IF;
    If p_cognom1Client   IS NULL THEN
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('ALTA DE CLIENTS: ');                                 
      s_rsp := 'Falta especificar cognom1 ';
      DBMS_OUTPUT.PUT_LINE(s_rsp);
      RAISE e_client;
    END IF;
    If p_cognom2Client   IS NULL THEN
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('ALTA DE CLIENTS: ');                                 
      s_rsp := 'Falta especificar cognom2 ';
      DBMS_OUTPUT.PUT_LINE(s_rsp);
      RAISE e_client;
    END IF;   
    If p_idUbicaClient   IS NULL THEN
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('ALTA DE CLIENTS: ');                                 
      s_rsp := 'Falta especificar el codi ubicacio on conte la direccio. ';
      DBMS_OUTPUT.PUT_LINE(s_rsp);
      RAISE e_client;
    END IF;
             
-- Comprovem si existeix el dni client a  donar d'alta
    SELECT COUNT (*) INTO n_registres 
    FROM CLIENT 
    WHERE DNICLIENT=p_dniClient;
    	 
    If n_registres=0 then
 -- El donem d'alta a Persona i a CLIENT 
    INSERT INTO CLIENT(
                        dniClient,
                        dataAltaClient,
                        estatClient,
                        nomClient,
                        cognom1Client,
                        cognom2Client,
                        idUbicaClient,
                        idTipoClient,
                        observacioClient) 
   		VALUES(
   			p_dniClient,
   			p_dataAltaClient,
   			n_controlEstat,
   			p_nomClient,
   			p_cognom1Client,
   			p_cognom2Client,
   			p_idUbicaClient, 
   			p_idTipoClient, 
   			p_observacioClient);
      
      SELECT PERSONA.DESCRIPCIOPERSONA INTO n_texte1
      FROM PERSONA
      WHERE PERSONA.IDPERSONA=p_idTipoClient;
      
      SELECT ESTAT.DESCRIPCIOESTAT INTO n_texte2
      FROM ESTAT
      WHERE ESTAT.IDESTAT=1;
     
      SELECT DISTINCT
      VIA.DESCRIPCIOVIA,
      UBICACIO.DIRECCIONUBICACIO,
      UBICACIO.NUMEROUBICACIO,
      UBICACIO.PISUBICACIO,
      UBICACIO.PORTAUBICACIO,
      UBICACIO.CODIPOSTAL,
      LOCALITAT.DESCRIPCIOLOCALITAT
      INTO n_via,n_direccio,n_numero,n_pis,n_porta,n_cp,n_localitat  
      FROM VIA,UBICACIO,LOCALITAT
      WHERE UBICACIO.IDUBICA=p_idUbicaClient
      AND VIA.IDVIA= UBICACIO.IDVIAUBICACIO
      AND UBICACIO.IDLOCALITATUBICACIO=LOCALITAT.IDLOCALITAT;
     
   
            DBMS_OUTPUT.ENABLE;
            DBMS_OUTPUT.PUT_LINE('Insertat el Client:  
             Dni: '||p_dniClient||
            ' Data alta:  '||p_dataAltaClient||
            ' Estat:  '||n_texte2||
            ' Tipus Client: '||n_texte1||
            ' Nom:  '||p_nomClient||
            ' Cognom1:  '||p_cognom1Client||
            ' Cognom2:  '||p_cognom2Client||
            ' Direccio:  '||n_direccio||
            ' Numero:  '||n_numero||
            ' Pis:  '||n_pis||
            ' Porta::  '||n_porta||
            ' Codi Postal:  '||n_cp||
            ' Poblacio:  '||n_localitat||
            ' Observacions: '||p_observacioClient);
            DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
            s_rsp :='Ok: Insertat el Clinet:  Insertat el Client:  
             Dni: '||p_dniClient||
            ' Data alta:  '||p_dataAltaClient||
            ' Estat:  '||n_texte2||
            ' Nom:  '||p_nomClient||
            ' Cognom1:  '||p_cognom1Client||
            ' Cognom2:  '||p_cognom2Client;
            pkg_general.gravar_log_procedure(c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
            DBMS_OUTPUT.PUT_LINE(s_rsp);
          ELSE
           DBMS_OUTPUT.ENABLE;
           DBMS_OUTPUT.PUT_LINE('     ALTA DE CLIENTS      ');
           DBMS_OUTPUT.PUT_LINE('_____________________________');       
           s_rsp := 'DADES duplicades';
           DBMS_OUTPUT.PUT_LINE(s_rsp);
          RAISE e_client;
 END IF;
    
COMMIT;
    
    EXCEPTION
       WHEN OTHERS THEN
          IF s_rsp IS NULL THEN
             -- L'error no ha estat controlat per codi
             s_rsp := 'Error: ' || SQLCODE || SUBSTR (SQLERRM, 1, 100);
          ELSE
             -- L'error si ha estat controlat per codi
             s_rsp := 'Error: ' || s_rsp;
          END IF;
            DBMS_OUTPUT.ENABLE;
            DBMS_OUTPUT.PUT_LINE(' ');      
            DBMS_OUTPUT.put_line(s_rsp);
            pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
          ROLLBACK;  
END PRC_ALTA_CLIENT;

/********************************************************************************
     NOM:       PRC_MODIFICAR_CLIENT
     DESCRIPCIÃ“:
                Procediment encarregat de modificar les dades d'un contacte. 
                Les dades es modificaran en la taula persona i el identificador de 
                Persona apuntarÃ  a la clau primaria del contacte de la taula CLIENT
                   o contacte_Proveidor.
********************************************************************************/  
PROCEDURE PRC_MODIFICAR_CLIENT(
    p_idTipoClient in CLIENT.idTipoClient%Type,
    p_dniClient in CLIENT.dniClient%Type,	
    p_nomClient in CLIENT.nomClient%Type,
    p_cognom1Client in CLIENT.cognom1Client%Type,
    p_cognom2Client in CLIENT.cognom2Client%Type,
    p_estatClient in CLIENT.estatClient%Type,
    p_idUbicaClient in CLIENT.idUbicaClient%Type,
    p_dataAltaCLient in CLIENT.dataAltaCLient%Type,
    p_dataModificacioClient in CLIENT.dataModificacioCLient%Type,
    p_observacioClient in CLIENT.observacioClient%Type,
    s_rsp out NOCOPY VARCHAR2)
       	
AS
 n_dni VARCHAR2(15);      		
BEGIN
--Parametres per la taula LOG--------------------------------------------------------------
  c_procesLog := 'PRC_MODIFICAR_CLIENT';
  c_dataHoraLog := SYSDATE;
  c_entradaLog := 'dni Client: ' || p_dniClient || 
   		', nom Client: ' || p_nomClient || 
                ', cognom1 Client: ' || p_cognom1Client || 
        	', cognom2 Client: ' || p_cognom2Client || 
   		--', estat Client: ' || p_estatClient || 
        	', id Ubica Client: ' || p_idUbicaClient ||
                ', id Tipo Client: ' || p_idTipoClient ||
        	--', data Alta Client: ' || p_dataAltaClient ||
   		', data Modificacio Client: ' || p_dataModificacioClient;
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE(' ');
  DBMS_OUTPUT.PUT_LINE('          MODIFICAR UN CLIENT        ');
  DBMS_OUTPUT.PUT_LINE('------------------------------------ ');
  DBMS_OUTPUT.PUT_LINE(' dni Client: ' || p_dniClient || 
   		', nom Client: ' || p_nomClient || 
                ', cognom1 Client: ' || p_cognom1Client || 
        	', cognom2 Client: ' || p_cognom2Client || 
   		', estat Client: ' || p_estatClient || 
        	', id Ubica Client: ' || p_idUbicaClient ||
                ', id Tipo Client: ' || p_idTipoClient ||
        	', data Alta Client: ' || p_dataAltaClient ||
   		', data Modificacio Client: ' || p_dataModificacioClient);
  c_sortidalog := 's_rsp';  
   
-- Comprovem que p_dniClient no sigui NULL----------------------------------------------
  If p_dniClient IS NULL then
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('MODIFICAR UN CLIENT: ');  
    s_rsp := 'Falta especificarel NIF de Client';
    DBMS_OUTPUT.PUT_LINE(s_rsp);           
    RAISE e_client;
  END IF;
  --1er. Comprovem que el client existeix-------------------------------
  SELECT COUNT (*) INTO n_registres 
  FROM CLIENT
  WHERE dniClient= p_dniClient;
  If n_registres=0 then
     DBMS_OUTPUT.ENABLE;
     DBMS_OUTPUT.PUT_LINE('MODIFICAR CLIENT:  ');              
     s_rsp := 'Persona no existent a la BBDD';
     DBMS_OUTPUT.PUT_LINE(s_rsp);
     RAISE e_client;
  END IF;
  -- Comprovem els parÃ metres NULL i advertim si falta algun parÃ metre
  If (p_nomClient  IS NULL) or (p_cognom1Client IS NULL) or (p_cognom2Client  IS NULL)
      or (p_idUbicaClient IS NULL) or (p_dataModificacioClient IS NULL)
      OR (p_idTipoClient IS NULL) THEN
     DBMS_OUTPUT.ENABLE;
     DBMS_OUTPUT.PUT_LINE('MODIFICAR CLIENT: ');                   
     s_rsp := 'Falta especificar algun pararametre del client.  ';
     DBMS_OUTPUT.PUT_LINE(s_rsp);
     RAISE e_client;
   END IF; 
   
   SELECT CLIENT.DNICLIENT INTO n_dni 
   FROM CLIENT
   WHERE CLIENT.DNICLIENT=p_dniClient; 
   
   s_sql := 'UPDATE CLIENT SET ';
--Construirem la sentencia UPDATE segons si hi ha valor en els parÃ metres-
    IF p_nomClient IS NOT NULL THEN
    -- Modifiquem el nom
       s_sql := s_sql || 'NOMCLIENT=''' || p_nomClient || ''',';
    END IF;
    IF p_cognom1Client IS NOT NULL THEN
    -- Modifiquem el cognom1----------------------------------------
      s_sql := s_sql || 'COGNOM1CLIENT=''' || p_cognom1Client || ''',';
    END IF;
    IF p_cognom2Client IS NOT NULL THEN
    -- Modifiquem el cognom2----------------------------------------
       s_sql := s_sql || 'COGNOM2CLIENT=''' || p_cognom2Client || ''',';
    END IF;
    -- Modificar data modificacio
    IF p_dataModificacioClient IS NOT NULL THEN
      s_sql := s_sql || 'DATAMODIFICACIOCLIENT=''' ||p_dataModificacioClient|| ''',';
    END IF;
    IF p_idUbicaClient IS NOT NULL THEN
    -- Modifiquem l'adreca-------------------------------------------
      s_sql := s_sql || 'IDUBICACLIENT=''' || p_idUbicaClient || ''',';
    END IF;
    IF p_idTipoClient IS NOT NULL THEN
    -- Modifiquem id Tipo Client-------------------------------------------
      s_sql := s_sql || 'IDTIPOCLIENT=''' || p_idTipoClient || ''',';
    END IF;
-- Eliminem la coma final de la sentencia SQL--------------------------
    s_sql := SUBSTR (s_sql, 1, LENGTH (s_sql) - 1);
-- Afegim a la sentencia la condiciÃ³ del WHERE------------------------
    s_sql := s_sql || ' WHERE DNICLIENT=''' ||n_dni || '''';
         
EXECUTE IMMEDIATE s_sql;
   IF SQL%ROWCOUNT = 0 THEN
--L'error serÃ  que el DNI ja el tenim en la taula i no admet duplicats--
     DBMS_OUTPUT.ENABLE;
     DBMS_OUTPUT.PUT_LINE('MODIFICAR CLIENT: ');                     
     s_rsp := 'Actualitzacio no realitzada';
     DBMS_OUTPUT.PUT_LINE(s_rsp);                     
     RAISE e_client;
   ELSE
      SELECT PERSONA.DESCRIPCIOPERSONA INTO n_texte1
      FROM PERSONA
      WHERE PERSONA.IDPERSONA=p_idTipoClient;
      
      SELECT ESTAT.DESCRIPCIOESTAT INTO n_texte2
      FROM ESTAT
      WHERE ESTAT.IDESTAT=1;
     
      SELECT 
      VIA.DESCRIPCIOVIA,
      UBICACIO.DIRECCIONUBICACIO,
      UBICACIO.NUMEROUBICACIO,
      UBICACIO.PISUBICACIO,
      UBICACIO.PORTAUBICACIO,
      UBICACIO.CODIPOSTAL,
      LOCALITAT.DESCRIPCIOLOCALITAT
      INTO n_via,n_direccio,n_numero,n_pis,n_porta,n_cp,n_localitat
      FROM VIA,UBICACIO,LOCALITAT
      WHERE UBICACIO.IDUBICA=p_idUbicaClient
      AND VIA.IDVIA= UBICACIO.IDVIAUBICACIO
      AND UBICACIO.IDLOCALITATUBICACIO=LOCALITAT.IDLOCALITAT;   

    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('Modificacio feta al Client: 
              Dni: '||p_dniClient||
            ' Data Modificacio:  '||p_dataModificacioClient||
            ' Estat:  '||n_texte2||
            ' Tipus Client: '||n_texte1||
            ' Nom:  '||p_nomClient||
            ' Cognom1:  '||p_cognom1Client||
            ' Cognom2:  '||p_cognom2Client||
            ' Direccio:  '||n_direccio||
            ' Numero:  '||n_numero||
            ' Pis:  '||n_pis||
            ' Porta::  '||n_porta||
            ' Codi Postal:  '||n_cp||
            ' Poblacio:  '||n_localitat||
            ' Observacions: '||p_observacioClient);
    DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
            s_rsp := 'OK Modificacio al Client:  
             Dni: '||p_dniClient||
            ' Data alta:  '||p_dataAltaClient||
            ' Estat:  '||n_texte2||
            ' Nom:  '||p_nomClient||
            ' Cognom1:  '||p_cognom1Client||
            ' Cognom2:  '||p_cognom2Client;
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  END IF;
COMMIT;
EXCEPTION
      WHEN DUP_VAL_ON_INDEX THEN
         DBMS_OUTPUT.ENABLE;
         DBMS_OUTPUT.PUT_LINE('MODIFICAR CLIENT:  ');      
         s_rsp := 'Error: NIF duplicat. No es poden fer les modificacions';
         DBMS_OUTPUT.put_line (s_rsp);
         pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
         ROLLBACK;
   	
      WHEN OTHERS THEN
         IF s_rsp IS NULL THEN
            -- L'error no ha estat controlat per codi-----------------------------------------
            s_rsp := 'Error: ' || SQLCODE || SUBSTR(SQLERRM, 1, 100);
         ELSE
            -- L'error si ha estat controlat per codi-----------------------------------------
            s_rsp := 'Error: ' || s_rsp;
         END IF;
         DBMS_OUTPUT.ENABLE;
         DBMS_OUTPUT.PUT_LINE(' ');   
         DBMS_OUTPUT.put_line (s_rsp);
         pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
         ROLLBACK;
end PRC_MODIFICAR_CLIENT;

/********************************************************************************
        NOM:         PRC_BAIXA_CLIENT
        DESCRIPCIÃ“:
                     Procediment encarregat de donar de baixa lÃ²gica a un contacte.
********************************************************************************/
PROCEDURE PRC_BAIXA_CLIENT(
           p_idClient in CLIENT.idClient%TYPE,
           p_estatClient in CLIENT.estatClient%Type,	
           p_dataModificacioClient in CLIENT.dataModificacioCLient%Type,
           p_dniClient in CLIENT.dniClient%Type,
           s_rsp out NOCOPY VARCHAR2) 
AS
  n_controlEstat number;
  n_dni VARCHAR2(15);
BEGIN
--Parametres per la taula LOG--------------------------------------------------------------
  c_procesLog := 'PRC_BAIXA_CLIENT';
  c_dataHoraLog := SYSDATE;
  c_entradaLog :=' dni Client: ' || p_dniClient||
              ' data Modificacio Client: ' || p_dataModificacioClient;
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE(' ');
  DBMS_OUTPUT.PUT_LINE('         BAIXA CLIENT          ');
  DBMS_OUTPUT.PUT_LINE('-------------------------------');
  DBMS_OUTPUT.PUT_LINE(' dni Client: ' || p_dniClient||
              ' data Modificacio Client: ' || p_dataModificacioClient);
  c_sortidalog := 's_rsp';  
  n_controlEstat:=2;   
-- Comprovem que el idClient
  If  p_dniClient IS NULL then
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('BAIXA CLIENT: ');          
    s_rsp := 'Falta especificar el DNI Client.  ';
    DBMS_OUTPUT.PUT_LINE(s_rsp);                
    RAISE e_client;      
  END IF;
-- Comprovem que la data modificacio CLIENT no sigui NULL----------------------------------------------
  If p_dataModificacioClient IS NULL then
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('BAIXA CLIENT: ');             
    s_rsp := 'Falta especificar el NIF del Client';
    DBMS_OUTPUT.PUT_LINE(s_rsp);                 
    RAISE e_client;
  END IF;
--1er. Comprovem que l'estat del Client sigui actiu=1-------------------------------
  SELECT COUNT (*) INTO n_registres 
  FROM CLIENT
  WHERE dniClient=p_dniClient
  AND CLIENT.estatClient=1;
-- MIRO SI ESTA EN SITUACIO ALTA
 If n_registres=0 then
   DBMS_OUTPUT.ENABLE;
   DBMS_OUTPUT.PUT_LINE('BAIXA_CLIENT: ');                 
   s_rsp := 'Client no existent a la BBDD';
   DBMS_OUTPUT.PUT_LINE(s_rsp);
   RAISE e_client;
END IF;
-- RECUPERO EL DNI SI ESTA EN SITUACIO 1=ALTA
   SELECT dniClient INTO n_texte2 
   FROM CLIENT
   WHERE dniClient=p_dniClient
   AND CLIENT.estatClient=1;
                 
   IF p_dniClient IS NOT NULL  THEN
      s_sql := 'UPDATE CLIENT SET dniClient = ''' ||p_dniClient || '''';
      s_sql := 'UPDATE CLIENT SET estatClient='''||n_controlEstat||'''';
      s_sql := 'UPDATE CLIENT SET dataModificacioClient='''||p_dataModificacioClient||'''';
-- Eliminem la coma final de la sentencia SQL--------------------------
      s_sql := SUBSTR (s_sql, 1, LENGTH (s_sql) - 1);
-- Afegim a la sentencia la condiciÃ³ del WHERE------------------------
      s_sql := s_sql || ' WHERE DNICLIENT=''' ||n_dni || '''';
    END IF; 
EXECUTE IMMEDIATE s_sql;
   IF SQL%ROWCOUNT = 0 THEN
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('BAIXA_CLIENT:  ');                      
      s_rsp := 'Actualitzacio no realitzada';
      DBMS_OUTPUT.PUT_LINE(s_rsp);                       
      RAISE e_client;
    ELSE
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('Client donat de Baixa:
      DNI: '||p_dniClient||
      ' Data Modificacio: '||p_dataModificacioClient ); 
    DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
    s_rsp := 'OK: Client donat de Baixa:
      DNI: '||p_dniClient||
      ' Data Modificacio: '||p_dataModificacioClient;
  pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
    END IF;

COMMIT;
  EXCEPTION
     	
    WHEN OTHERS THEN
     IF s_rsp IS NULL THEN
--L'error no ha estat controlat per codi-----------------------------------------
        s_rsp := 'Error: ' || SQLCODE || SUBSTR(SQLERRM, 1, 100);
      ELSE
-- L'error si ha estat controlat per codi-----------------------------------------
        s_rsp := 'Error: ' || s_rsp;
     END IF;
           DBMS_OUTPUT.ENABLE;
           DBMS_OUTPUT.PUT_LINE(' ');      
           DBMS_OUTPUT.put_line (s_rsp);
           pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
ROLLBACK;
end PRC_BAIXA_CLIENT;

/********************************************************************************
       NOM:         PRC_CONSULTAR_DNI_CLIENT
       DESCRIPCIÃ“:
                   Procediment encarregat de consultar les dades d'un contacte
                  i mostrarles per pantalla.
********************************************************************************/
PROCEDURE PRC_CONSULTAR_DNI_CLIENT(
  p_dniClient in CLIENT.dniClient%Type,
  s_rsp out NOCOPY VARCHAR2)  
AS
n_IDCLIENT number;
BEGIN
 --Parametres per la taula LOG--------------------------------------------------------------
       c_procesLog := 'PRC_CONSULTAR_CLIENT';
       c_dataHoraLog := SYSDATE;
       c_entradaLog :=' Dni Client: ' || p_dniClient;
      DBMS_OUTPUT.PUT_LINE(' ');
      DBMS_OUTPUT.PUT_LINE('         CONSULTA CLIENT          ');
      DBMS_OUTPUT.PUT_LINE('----------------------------------');
      DBMS_OUTPUT.PUT_LINE('Dni Client: ' || p_dniClient);
      c_sortidalog := 's_rsp';  
     
 -- Comprovem que p_dniClient no sigui NULL----------------------------------------------
    If p_dniClient IS NULL then
         DBMS_OUTPUT.ENABLE;
         DBMS_OUTPUT.PUT_LINE('CONSULTA CLIENT : ');            
         s_rsp := 'Falta especificar el DNI del Client';
         DBMS_OUTPUT.put_line (s_rsp);                   
         RAISE e_client;
    END IF;
 --1er. Comprovem que existeixi la persona-------------------------------
           SELECT COUNT (*) INTO n_registres 
           FROM CLIENT
           WHERE CLIENT.DNICLIENT= p_dniClient;
           
  If n_registres=0 then
            DBMS_OUTPUT.ENABLE;
            DBMS_OUTPUT.PUT_LINE('CONSULTAR CLIENT: ');                  
            s_rsp := 'Client no existent a la BBDD';
            DBMS_OUTPUT.PUT_LINE(s_rsp);
            RAISE e_client;
      END IF;       
     
 -- Recuperem les dades de la taula Client--------------------------
SELECT
      CLIENT.IDCLIENT,
      CLIENT.DNICLIENT,
      CLIENT.DATAALTACLIENT,
      ESTAT.DESCRIPCIOESTAT,
      CLIENT.DATAMODIFICACIOCLIENT,
      CLIENT.NOMCLIENT,
      CLIENT.COGNOM1CLIENT,
      CLIENT.COGNOM2CLIENT,
      PERSONA.DESCRIPCIOPERSONA,
      VIA.DESCRIPCIOVIA,
      UBICACIO.DIRECCIONUBICACIO,
      UBICACIO.NUMEROUBICACIO,
      UBICACIO.PISUBICACIO,
      UBICACIO.PORTAUBICACIO,
      UBICACIO.CODIPOSTAL,
      LOCALITAT.DESCRIPCIOLOCALITAT,
      PROVINCIA.DESCRIPCIOPROVINCIA,
      PAIS.DESCRIPCIOPAIS
      INTO
      n_IDCLIENT,
      n_DNICLIENT,
      n_DATAALTACLIENT,
      n_DESCRIPCIOESTAT,
      n_DATAMODIFICACIOCLIENT,
      n_NOMCLIENT,
      n_COGNOM1CLIENT,
      n_COGNOM2CLIENT,
      n_DESCRIPCIOPERSONA,
      n_DESCRIPCIOVIA,
      n_DIRECCIONUBICACIO,
      n_NUMEROUBICACIO,
      n_PISUBICACIO,
      n_PORTAUBICACIO,
      n_CODIPOSTAL,
      n_DESCRIPCIOLOCALITAT,
      n_DESCRIPCIOPROVINCIA,
      n_DESCRIPCIOPAIS
FROM CLIENT,VIA,UBICACIO,LOCALITAT,PROVINCIA,PAIS,ESTAT,PERSONA
WHERE CLIENT.DNICLIENT=p_dniClient
AND CLIENT.IDTIPOCLIENT=PERSONA.IDPERSONA
AND CLIENT.ESTATCLIENT=ESTAT.IDESTAT
AND CLIENT.IDUBICACLIENT=UBICACIO.IDUBICA
AND UBICACIO.IDVIAUBICACIO=VIA.IDVIA
AND UBICACIO.IDLOCALITATUBICACIO=LOCALITAT.IDLOCALITAT
AND LOCALITAT.IDPROVINCIALOCALITAT=PROVINCIA.IDPROVINCIA
AND PROVINCIA.IDPAISPROVINCIA=PAIS.IDPAIS;
                
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('CONSULTAR CLIENT: ');
    DBMS_OUTPUT.PUT_LINE(
    '   Codi Client: '
 || n_IDCLIENT||
 ' Dni: '
 ||n_DNICLIENT||
 ' Data alta: '
 ||n_DATAALTACLIENT||
 ' Estat: '
 ||n_DESCRIPCIOESTAT||
 ' Data ultima modificacio: '
 ||n_DATAMODIFICACIOCLIENT||
 ' Nom: '
 ||n_NOMCLIENT||
 ' Cognom1: '
 ||n_COGNOM1CLIENT||
 ' Cognom2: '
 ||n_COGNOM2CLIENT||
 ' Tipus de Client: '
 ||n_DESCRIPCIOPERSONA||
 /*****************************
 ' Via Publica: '
 ||n_DESCRIPCIOVIA||
 ' Direccio: '
 ||n_DIRECCIONUBICACIO||
 ' Numero:  '
 ||n_NUMEROUBICACIO||
 ' Pis:  '
 ||n_PISUBICACIO||
 ' Porta:  '
 ||n_PORTAUBICACIO||
 ' Codi Postal:  '
 ||n_CODIPOSTAL||
  *******************************/
 ' Poblacio: '
 ||n_DESCRIPCIOLOCALITAT||
 ' Provincia: '
 ||n_DESCRIPCIOPROVINCIA||
 ' Pais:  '
 ||n_DESCRIPCIOPAIS);

 DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
  s_rsp := ('OK: CONSULTA CLIENT: '||p_dniClient);
  DBMS_OUTPUT.put_line (s_rsp);
  pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  
COMMIT;
     
   EXCEPTION
     	
      WHEN OTHERS THEN
         IF s_rsp IS NULL THEN
 -- L'error no ha estat controlat per codi-----------------------------------------
            s_rsp := 'Error: ' || SQLCODE || SUBSTR(SQLERRM, 1, 100);
        ELSE
 -- L'error si ha estat controlat per codi-----------------------------------------
              s_rsp := 'Error: ' || s_rsp;
        END IF;
           DBMS_OUTPUT.ENABLE;
           DBMS_OUTPUT.PUT_LINE(' ');        
           DBMS_OUTPUT.put_line (s_rsp);
           pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
           ROLLBACK;
end PRC_CONSULTAR_DNI_CLIENT;
  
-- CONSULTA DELS CLIENTS  
PROCEDURE PRC_CONSULTAR_CLIENT(
  s_rsp out NOCOPY VARCHAR2)
AS
n_IDCLIENT number;

CURSOR C_CLIENT IS
SELECT
      CLIENT.IDCLIENT,
      CLIENT.DNICLIENT,
      CLIENT.DATAALTACLIENT,
      ESTAT.DESCRIPCIOESTAT,
      CLIENT.DATAMODIFICACIOCLIENT,
      CLIENT.NOMCLIENT,
      CLIENT.COGNOM1CLIENT,
      CLIENT.COGNOM2CLIENT,
      PERSONA.DESCRIPCIOPERSONA,
      VIA.DESCRIPCIOVIA,
      UBICACIO.DIRECCIONUBICACIO,
      UBICACIO.NUMEROUBICACIO,
      UBICACIO.PISUBICACIO,
      UBICACIO.PORTAUBICACIO,
      UBICACIO.CODIPOSTAL,
      LOCALITAT.DESCRIPCIOLOCALITAT,
      PROVINCIA.DESCRIPCIOPROVINCIA,
      PAIS.DESCRIPCIOPAIS
FROM CLIENT,VIA,UBICACIO,LOCALITAT,PROVINCIA,PAIS,ESTAT,PERSONA
WHERE CLIENT.DNICLIENT=CLIENT.DNICLIENT
AND CLIENT.IDTIPOCLIENT=PERSONA.IDPERSONA
AND CLIENT.ESTATCLIENT=ESTAT.IDESTAT
AND CLIENT.IDUBICACLIENT=UBICACIO.IDUBICA
AND UBICACIO.IDVIAUBICACIO=VIA.IDVIA
AND UBICACIO.IDLOCALITATUBICACIO=LOCALITAT.IDLOCALITAT
AND LOCALITAT.IDPROVINCIALOCALITAT=PROVINCIA.IDPROVINCIA
AND PROVINCIA.IDPAISPROVINCIA=PAIS.IDPAIS;
    
BEGIN
   c_procesLog := 'PRC_CONSULTA_VIAS';
   c_dataHoraLog := SYSDATE;
   c_entradaLog :='CONSULTA CLIENTS';
   c_sortidalog := 's_rsp';
 SELECT DISTINCT COUNT(*) INTO n_registres
 FROM CLIENT
 WHERE CLIENT.DNICLIENT=CLIENT.DNICLIENT
 AND CLIENT.IDCLIENT=CLIENT.IDCLIENT;

  IF n_registres=0 THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('CONSULTA CLIENT: ');
    s_rsp := 'No hi han clients donades en al BDD. ';
    DBMS_OUTPUT.PUT_LINE(s_rsp);
    RAISE e_client;
  ELSE
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('           CONSULTA DE CLIENTS                       ');
  DBMS_OUTPUT.PUT_LINE('-----------------------------------------------------');
  OPEN C_CLIENT;
  FETCH C_CLIENT INTO
      n_IDCLIENT,
      n_DNICLIENT,
      n_DATAALTACLIENT,
      n_DESCRIPCIOESTAT,
      n_DATAMODIFICACIOCLIENT,
      n_NOMCLIENT,
      n_COGNOM1CLIENT,
      n_COGNOM2CLIENT,
      n_DESCRIPCIOPERSONA,
      n_DESCRIPCIOVIA,
      n_DIRECCIONUBICACIO,
      n_NUMEROUBICACIO,
      n_PISUBICACIO,
      n_PORTAUBICACIO,
      n_CODIPOSTAL,
      n_DESCRIPCIOLOCALITAT,
      n_DESCRIPCIOPROVINCIA,
      n_DESCRIPCIOPAIS;
   WHILE C_CLIENT%FOUND LOOP
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE(
    '   Codi Client: '
 || n_IDCLIENT||
 ' Dni: '
 ||n_DNICLIENT||
 ' Data alta: '
 ||n_DATAALTACLIENT||
 ' Estat: '
 ||n_DESCRIPCIOESTAT||
 ' Data ultima modificacio: '
 ||n_DATAMODIFICACIOCLIENT||
 ' Nom: '
 ||n_NOMCLIENT||
 ' Cognom1: '
 ||n_COGNOM1CLIENT||
 ' Cognom2: '
 ||n_COGNOM2CLIENT||
 ' Tipus de Client: '
 ||n_DESCRIPCIOPERSONA||
 /********************************
 ' Via Publica: '
 ||n_DESCRIPCIOVIA||
 ' Direccio: '
 ||n_DIRECCIONUBICACIO||
 ' Numero:  '
 ||n_NUMEROUBICACIO||
 ' Pis:  '
 ||n_PISUBICACIO||
 ' Porta:  '
 ||n_PORTAUBICACIO||
 ' Codi Postal:  '
 ||n_CODIPOSTAL||
 ****************************/
 ' Poblacio: '
 ||n_DESCRIPCIOLOCALITAT||
 ' Provincia: '
 ||n_DESCRIPCIOPROVINCIA||
 ' Pais:  '
 ||n_DESCRIPCIOPAIS);
  s_rsp := 'OK  CONSULTA CLIENTS
  Codi Client: '
 || n_IDCLIENT
 ||' Dni: '
 ||n_DNICLIENT;
  FETCH C_CLIENT INTO
      n_IDCLIENT,
      n_DNICLIENT,
      n_DATAALTACLIENT,
      n_DESCRIPCIOESTAT,
      n_DATAMODIFICACIOCLIENT,
      n_NOMCLIENT,
      n_COGNOM1CLIENT,
      n_COGNOM2CLIENT,
      n_DESCRIPCIOPERSONA,
      n_DESCRIPCIOVIA,
      n_DIRECCIONUBICACIO,
      n_NUMEROUBICACIO,
      n_PISUBICACIO,
      n_PORTAUBICACIO,
      n_CODIPOSTAL,
      n_DESCRIPCIOLOCALITAT,
      n_DESCRIPCIOPROVINCIA,
      n_DESCRIPCIOPAIS;

pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  END LOOP;
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('Total clients: '||n_registres);
  DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
CLOSE C_CLIENT;
END IF;
COMMIT;
   EXCEPTION
     	
      WHEN OTHERS THEN
         IF s_rsp IS NULL THEN
 -- L'error no ha estat controlat per codi-----------------------------------------
            s_rsp := 'Error: ' || SQLCODE || SUBSTR(SQLERRM, 1, 100);
        ELSE
 -- L'error si ha estat controlat per codi-----------------------------------------
              s_rsp := 'Error: ' || s_rsp;
        END IF;
           DBMS_OUTPUT.ENABLE;
           DBMS_OUTPUT.PUT_LINE(' ');        
           DBMS_OUTPUT.put_line (s_rsp);
           pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
           ROLLBACK;
END PRC_CONSULTAR_CLIENT;
end GESTION_CLIENT;
