CREATE OR REPLACE
PACKAGE BODY          "GESTION_CONTRACTE" AS
  n_registres      NUMBER;
  s_sql           VARCHAR2 (2000);
  n_NUM_ERR 	  NUMBER(10);
 
  n_idContracte  NUMBER; 
  n_dniClientContracte VARCHAR2(10);
  n_idComptadorContracte  NUMBER;
 -- n_fechaEstado_ins     VARCHAR2(11 CHAR);
 
  n_idComptadorLectura number;
  n_confirmaLectura  number;
  n_dataLectura VARCHAR2(11 CHAR);
  n_idTipoLectura  number;
  n_consumLectura  number;
  n_lecturaActual  number;
  n_lecturaAnterior  number;
  
  n_estat NUMBER;
  
  lec_idComptadorLectura number;
  lec_confirmaLectura  number;
  lec_dataLectura VARCHAR2(11 CHAR);
  lec_idTipoLectura  number;
  lec_consumLectura  number;
  lec_lecturaActual  number;
  lec_lecturaAnterior  number;
  
  n_descEstat ESTAT.DESCRIPCIOESTAT%TYPE;
  n_controlEstat ESTAT.IDESTAT%TYPE;
  
  n_dniContracte CONTRACTE.DNICLIENTECONTRACTE%TYPE;
  n_observacionsContracte CONTRACTE.OBSERVACIOCONTRACTE%TYPE;
  n_potenciaContracte CONTRACTE.POTENCIACONTRACTE%TYPE;
  n_dataAltaContracte CONTRACTE.DATAALTACONTRACTE%TYPE;
  n_dataModificacioContracte CONTRACTE.DATAMODIFICACIOCONTRACTE%TYPE;
  
  n_nomClient CLIENT.NOMCLIENT%TYPE;
  n_cognom1Client CLIENT.COGNOM1CLIENT%TYPE;
  n_cognom2Client CLIENT.COGNOM2CLIENT%TYPE;
   
  c_procesLog	  	LOG_TFC.procesLog%TYPE;	
  c_dataHoraLog   	LOG_TFC.dataHoraLog%TYPE;
  c_entradaLog     	LOG_TFC.entradaLog%TYPE;	
  c_sortidaLog     	LOG_TFC.sortidaLog%TYPE;
  s_rsp	 		LOG_TFC.RSPLOG%TYPE;
    
  sortida VARCHAR2(2000):='';
  e_contracte   EXCEPTION;
 
-- ALTA DE UN CONTRACTE A UN CLIENT SEGONS DNI
PROCEDURE PRC_ALTA_CONTRACTE(	    	
 	p_dniClientContracte IN CONTRACTE.DNICLIENTECONTRACTE%TYPE,   	 
 	p_idComptadorContracte IN CONTRACTE.IDCONTADORCONTRACTE%TYPE,	 
	p_dataAltaContracte IN CONTRACTE.DATAALTACONTRACTE%TYPE,	 	
	p_potenciaContracte IN CONTRACTE.POTENCIACONTRACTE%TYPE,  	 
 	p_observacioContracte IN CONTRACTE.OBSERVACIOCONTRACTE%TYPE,	
	s_rsp out NOCOPY VARCHAR)
  AS
 BEGIN
           
    c_procesLog := 'PRC_ALTA_CONTRACTE';
    c_dataHoraLog := SYSDATE;
    c_entradaLog :=' Dni Client: ' ||p_dniClientContracte||
    ', Codi Comptador: ' ||p_idComptadorContracte||
    ', Data Alta Contracte: ' ||p_dataAltaContracte||
    ', Potencia Contractada: ' ||p_potenciaContracte||
    ', Observacions Contracte: ' ||p_observacioContracte;
    
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE('       ASSIGNAR CONTRACTES A CLIENTS     ');
    DBMS_OUTPUT.PUT_LINE('-----------------------------------------');
    DBMS_OUTPUT.PUT_LINE('    Dni Client: ' ||p_dniClientContracte||
    ', Codi Comptador: ' ||p_idComptadorContracte||
    ', Data Alta Contracte: ' ||p_dataAltaContracte||
    ', Potencia Contractada: ' ||p_potenciaContracte||
    ', Observacions Contracte: ' ||p_observacioContracte);
      c_sortidalog := 's_rsp';  
      
    n_dataLectura 	:= SUBSTR (p_dataAltaContracte , 1, 11);
    n_controlEstat:=1; 
    
 -- CONSULTEM EL CLIENT SI EXISTEIX
    SELECT CLIENT.DNICLIENT INTO n_dniClientContracte
    FROM CLIENT
    WHERE CLIENT.DNICLIENT=p_dniClientContracte;
      
    IF n_dniClientContracte IS NULL THEN
     DBMS_OUTPUT.ENABLE;
            DBMS_OUTPUT.PUT_LINE('ASSIGNAR CONTRACTE A CLIENT:   ');
            s_rsp := 'El DNI no existeix, el client no esta  en alta ';
            DBMS_OUTPUT.PUT_LINE(s_rsp);           
          RAISE e_contracte ;
     END IF;     
     
 --CONSULTEM SI EL COMPTADOR ES DIPONIBLE
   SELECT COMPTADOR.IDCOMPTADOR INTO n_idComptadorContracte
    FROM COMPTADOR
    WHERE COMPTADOR.IDCOMPTADOR=p_idComptadorContracte
    AND COMPTADOR.IDESTADOCOMPATOR=n_controlEstat; 
    
     IF p_idComptadorContracte=0 THEN
     DBMS_OUTPUT.ENABLE;
            DBMS_OUTPUT.PUT_LINE('ASSIGNAR CONTRACTE A CLIENT:   ');
            s_rsp := 'El Comptador no existeix o no esta disponible ';
            DBMS_OUTPUT.PUT_LINE(s_rsp);           
          RAISE e_contracte ;
     END IF;
     
     IF p_dataAltaContracte IS NULL THEN
     DBMS_OUTPUT.ENABLE;
            DBMS_OUTPUT.PUT_LINE('ASSIGNAR CONTRACTE A CLIENT:   ');
            s_rsp := 'Falta la Data alta ';
            DBMS_OUTPUT.PUT_LINE(s_rsp);           
          RAISE e_contracte ;
     END IF;
      IF (p_potenciaContracte IS NULL OR p_potenciaContracte=0
      OR p_potenciaContracte<0) THEN
     DBMS_OUTPUT.ENABLE;
            DBMS_OUTPUT.PUT_LINE('ASSIGNAR CONTRACTE A CLIENT:   ');
            s_rsp := 'La potencia contractada no es correcte ';
            DBMS_OUTPUT.PUT_LINE(s_rsp);           
          RAISE e_contracte ;
     END IF;
     -- controlem si exiteix el contracte
     SELECT COUNT (*)INTO n_registres 
     FROM CONTRACTE
     WHERE CONTRACTE.DNICLIENTECONTRACTE=n_dniClientContracte
     AND CONTRACTE.IDCONTADORCONTRACTE=n_idComptadorContracte;
   
      IF n_registres= 0 THEN
       n_dataLectura:= SUBSTR (p_dataAltaContracte , 1, 11);
       n_controlEstat:=1; 
      lec_idComptadorLectura:=p_idComptadorContracte;
      lec_dataLectura:=n_dataLectura;
      
      SELECT ESTAT.DESCRIPCIOESTAT INTO n_descEstat
      FROM ESTAT
      WHERE ESTAT.IDESTAT=n_controlEstat;
      
      INSERT INTO CONTRACTE(DNICLIENTECONTRACTE,
                            IDCONTADORCONTRACTE,
                            DATAALTACONTRACTE,
                            IDESTATCONTRACTE,
                            POTENCIACONTRACTE,
                            OBSERVACIOCONTRACTE) 
            VALUES(p_dniClientContracte,
                  p_idComptadorContracte,
                  p_dataAltaContracte,
                  n_controlEstat,
                  p_potenciaContracte,
                  p_observacioContracte);
                  
  GESTION_LECTURA.PRC_INICIA_LECTURA(
                lec_idComptadorLectura,
                lec_dataLectura,
                s_rsp);                
                        
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('  Contracte realitzat Dni Client: '||p_dniClientContracte||
      ' Estat : '||n_descEstat||
      ' en la data:' ||lec_dataLectura||
      ' amb el Comptador: '||lec_idComptadorLectura);
      --Gravem en la taula log-----------------------------------------------------
      s_rsp :='Ok Contracte realitzat Dni Client: '||p_dniClientContracte||
      ' Estat : '||n_descEstat||
      ' en la data:' ||lec_dataLectura||
      ' amb el Comptador: '||lec_idComptadorLectura;
      pkg_general.gravar_log_procedure(c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('Inicialitzat el comptador amb lectura a zero:
       Contracte realitzat '||p_dniClientContracte||
    ' Estat : '||n_descEstat||
    ' amb el Comptador: '||p_idComptadorContracte||
      'Lectura: inicial: '||lec_idComptadorLectura||
      ' Data inicialitzada: '||lec_dataLectura);
     DBMS_OUTPUT.PUT_LINE('********* FI DE LES OPERACIONS *********');
      --Gravem en la taula log-----------------------------------------------------
     s_rsp :='Ok Inicialitzat el comptador amb lectura a zero:
       Contracte realitzat '||p_dniClientContracte||
    ' Estat : '||n_descEstat||
    ' amb el Comptador: '||p_idComptadorContracte||
      'Lectura: inicial: '||lec_idComptadorLectura||
      ' Data inicialitzada: '||lec_dataLectura;
    pkg_general.gravar_log_procedure(c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
           
      ELSE
      DBMS_OUTPUT.ENABLE;
          DBMS_OUTPUT.PUT_LINE('ASSIGNAR CONTRACTE A CLIENT: ');
          s_rsp := 'Contracte de Client duplicat';
          DBMS_OUTPUT.PUT_LINE(s_rsp);
          RAISE e_contracte ;
      END IF;
 COMMIT;     
EXCEPTION
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         s_rsp := 'Error: ' || SQLCODE || SUBSTR (SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('  '); 
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  ROLLBACK;     
END PRC_ALTA_CONTRACTE;
      
 
PROCEDURE PRC_MODIFICAR_CONTRACTE(
	p_idContracte IN CONTRACTE.IDCONTRACTE%TYPE,      
	p_idComptadorContracte	IN CONTRACTE.IDCONTADORCONTRACTE%TYPE, 
	p_dataModificacioContracte IN CONTRACTE.DATAMODIFICACIOCONTRACTE%TYPE,   
	p_potenciaContracte  IN CONTRACTE.POTENCIACONTRACTE%TYPE,  	 
	p_observacioContracte 	IN CONTRACTE.OBSERVACIOCONTRACTE%TYPE,
        s_rsp out NOCOPY VARCHAR)
AS
BEGIN
    c_procesLog := 'PRC_MODIFICAR_CONTRACTE';
    c_dataHoraLog := SYSDATE;
    c_entradaLog :=' Numero Contracte: '||p_idContracte||
    ', Codi Comptador: ' ||p_idComptadorContracte||
    ', Data modificacio Contracte: ' ||p_dataModificacioContracte||
    ', Potencia Contractada: ' ||p_potenciaContracte||
    ', Observacions Contracte: ' ||p_observacioContracte;
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE('    MODIFICAR UN CONTRACTE     ');
    DBMS_OUTPUT.PUT_LINE('------------------------------ '); 
    DBMS_OUTPUT.PUT_LINE('    Numero Contracte: '||p_idContracte||
    --', Dni Client: ' ||p_dniClientContracte||
    ', Codi Comptador: ' ||p_idComptadorContracte||
    ', Data Alta Contracte: ' ||p_dataModificacioContracte||
    ', Potencia Contractada: ' ||p_potenciaContracte||
    ', Observacions Contracte: ' ||p_observacioContracte);
    c_sortidalog := 's_rsp';  
 
 SELECT CONTRACTE.IDESTATCONTRACTE INTO n_controlEstat
 FROM CONTRACTE
 WHERE CONTRACTE.IDCONTRACTE=p_idContracte;
    
  IF p_idContracte IS NULL THEN
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('MODIFICAR UN CONTRACTE:  ');
  s_rsp := 'Falta entrar el num.Contracte  ';
  DBMS_OUTPUT.PUT_LINE(s_rsp);           
  RAISE e_contracte ;
  END IF;     
 
 -- CONSULTEM EL CLIENT SI EXISTEIX
    SELECT CLIENT.DNICLIENT INTO n_dniClientContracte
    FROM CLIENT, CONTRACTE
    WHERE CONTRACTE.IDCONTRACTE=p_idContracte
    AND CLIENT.ESTATCLIENT=n_controlEstat;
      
    IF n_dniClientContracte IS NULL THEN
     DBMS_OUTPUT.ENABLE;
     DBMS_OUTPUT.PUT_LINE('MODIFICAR UN CONTRACTE:  ');
     s_rsp := 'El DNI no existeix no t cap contracte assignat ';
     DBMS_OUTPUT.PUT_LINE(s_rsp);           
     RAISE e_contracte ;
     END IF;     
     
 --CONSULTEM SI EL COMPTADOR ES DIPONIBLE
   SELECT DISTINCT COUNT (COMPTADOR.IDCOMPTADOR) INTO n_idComptadorContracte
    FROM COMPTADOR
    WHERE COMPTADOR.IDCOMPTADOR=p_idContracte
    AND COMPTADOR.IDESTADOCOMPATOR=n_controlEstat; 
    
     IF p_idComptadorContracte=0 THEN
     DBMS_OUTPUT.ENABLE;
     DBMS_OUTPUT.PUT_LINE('MODIFICAR UN CONTRACTE:    ');
      s_rsp := 'El Comptador no existeix o no esta disponible ';
      DBMS_OUTPUT.PUT_LINE(s_rsp);           
          RAISE e_contracte ;
     END IF;
     
     IF p_dataModificacioContracte IS NULL THEN
     DBMS_OUTPUT.ENABLE;
            DBMS_OUTPUT.PUT_LINE('MODIFICAR UN CONTRACTE:    ');
            s_rsp := 'Falta la Data en que modifica les dades  ';
            DBMS_OUTPUT.PUT_LINE(s_rsp);           
          RAISE e_contracte ;
     END IF;
      IF (p_potenciaContracte IS NULL OR p_potenciaContracte=0
      OR p_potenciaContracte<0) THEN
     DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('MODIFICAR UN CONTRACTE:     ');
      s_rsp := 'La potencia contractada no es correcte ';
      DBMS_OUTPUT.PUT_LINE(s_rsp);           
      RAISE e_contracte ;
     END IF;
     -- controlem si exiteix el contracte
     SELECT COUNT (*)INTO n_registres 
     FROM CONTRACTE
     WHERE CONTRACTE.DNICLIENTECONTRACTE=n_dniClientContracte
     AND CONTRACTE.IDCONTRACTE=p_idContracte;
    
    IF n_registres=0 THEN
       DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('MODIFICAR UN CONTRACTE:     ');
      s_rsp := 'No existeix Id del contracte ';
      DBMS_OUTPUT.PUT_LINE(s_rsp);           
      RAISE e_contracte ;
      END IF; 
     --recuperem el contracte 
    SELECT CONTRACTE.IDCONTRACTE INTO n_idContracte
            FROM CONTRACTE
            WHERE CONTRACTE.IDCONTRACTE=p_idContracte;
            
    SELECT ESTAT.DESCRIPCIOESTAT INTO n_descEstat
    FROM ESTAT
    WHERE ESTAT.IDESTAT=n_controlEstat;
     
      s_sql := 'UPDATE CONTRACTE SET ';
      IF p_idComptadorContracte IS NOT NULL THEN
    -- Modifiquem  id Comptador Contracte
       s_sql := s_sql || 'IDCONTADORCONTRACTE=''' ||p_idComptadorContracte|| ''',';
       END IF;
      IF p_dataModificacioContracte IS NOT NULL THEN
      -- Modifiquem data Modificacio Contracte
        s_sql := s_sql || 'DATAMODIFICACIOCONTRACTE=''' ||p_dataModificacioContracte|| ''',';
        END IF;                   
      IF n_controlEstat IS NOT NULL THEN
        -- Modifiquem id Estat Contracte
        s_sql := s_sql || 'IDESTATCONTRACTE=''' ||n_controlEstat|| ''',';
       END IF;
      IF p_potenciaContracte IS NOT NULL THEN
   -- Modifiquem potencia Contracte
      s_sql := s_sql || 'POTENCIACONTRACTE=''' ||p_potenciaContracte|| ''',';
      END IF; 
      IF p_observacioContracte IS NOT NULL THEN
  -- Modifiquem Observacions Tipo Linea
      s_sql := s_sql || 'OBSERVACIOCONTRACTE=''' ||p_observacioContracte|| ''',';
      END IF; 
 -- Eliminem la coma final de la sentencia SQL--------------------------
    s_sql := SUBSTR (s_sql, 1, LENGTH (s_sql) - 1);
-- Afegim a la sentencia la condiciÃƒÂ³ del WHERE------------------------
    s_sql := s_sql || ' WHERE IDCONTRACTE=''' ||p_idContracte|| '''';
EXECUTE IMMEDIATE s_sql;   
  IF SQL%ROWCOUNT = 0 THEN
 --L'error serÃ  que Tipo Linea ja el tenim en la taula i no admet duplicats--
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('MODIFICAR_CONTRACTE:  ');                  
  s_rsp := 'Actualitzacio no realitzada';
  DBMS_OUTPUT.PUT_LINE(s_rsp);                  
  RAISE e_contracte ;
  ELSE
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE(' La modificacio del Contracte numero: '||p_idContracte||
  ' en la data: '||p_dataModificacioContracte||
  ' en estat: '||n_descEstat||
  ' amb el comptador: '||p_idComptadorContracte||
  ' amb la Potecnia contratade de: '||p_potenciaContracte||
  ' Onservacions: '||p_observacioContracte|| ' modificacio realitzada'); 
  DBMS_OUTPUT.PUT_LINE('********* FI DE LES OPERACIONS *********');
    s_rsp := 'OK MODIFICAR CONTRACTE: El Contracte numero: '||p_idContracte||
  ' en la data: '||p_dataModificacioContracte||
  ' en estat: '||n_descEstat||
  ' amb el comptador: '||p_idComptadorContracte||
  ' amb la Potecnia contratade de: '||p_potenciaContracte||
  ' Onservacions: '||p_observacioContracte|| ' modificacio realitzada';
  pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  END IF;
COMMIT;
  EXCEPTION
    WHEN DUP_VAL_ON_INDEX THEN
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('MODIFICAR CONTRACTE:  ');    
      s_rsp := 'Error: CONTRACTE duplicat. No es poden fer les modificacions';
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;      
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         -----------------------------------------
         s_rsp := 'Error: ' || SQLCODE || SUBSTR(SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         -----------------------------------------
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('  '); 
      DBMS_OUTPUT.put_line (s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;             
       
END PRC_MODIFICAR_CONTRACTE;

PROCEDURE PRC_CANVIAR_ALTA_CONTRACTE(
	p_idContracte IN CONTRACTE.IDCONTRACTE%TYPE,
	p_dataModificacioContracte IN CONTRACTE.DATAMODIFICACIOCONTRACTE%TYPE,    
	s_rsp out NOCOPY VARCHAR)
AS
BEGIN
    c_procesLog := 'PRC_CANVIAR_ALTA_CONTRACTE';
    c_dataHoraLog := SYSDATE;
    c_entradaLog :=' Numero Contracte: '||p_idContracte||
    ', Data modificacio Contracte: ' ||p_dataModificacioContracte;
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE('       CANVIAR ALTA A UN CONTRACTE      ');
    DBMS_OUTPUT.PUT_LINE('--------------------------------------- '); 
    DBMS_OUTPUT.PUT_LINE('   Numero Contracte: '||p_idContracte||
    ', Data modificacio Contracte: ' ||p_dataModificacioContracte);
    c_sortidalog := 's_rsp';         
    IF p_idContracte IS NULL THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('CANVIAR ALTA A UN CONTRACTE:  ');                  
    s_rsp := 'Falta el numero de contracte. ';
    DBMS_OUTPUT.PUT_LINE(s_rsp);                  
    RAISE e_contracte ;
    END IF;
    IF p_dataModificacioContracte IS NULL THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('CANVIAR ALTA A UN CONTRACTE:  ');                  
    s_rsp := 'Falta la data de la modificacio. ';
    DBMS_OUTPUT.PUT_LINE(s_rsp);                  
    RAISE e_contracte ;
    END IF;
    
    SELECT COUNT (p_idContracte) INTO n_idContracte
    FROM CONTRACTE
    WHERE CONTRACTE.IDCONTRACTE=p_idContracte;
    
    IF n_idContracte=0 THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('CANVIAR ALTA A UN CONTRACTE:  ');                  
    s_rsp := 'El contracte no exiteix. ';
    DBMS_OUTPUT.PUT_LINE(s_rsp);                  
    RAISE e_contracte ;
    END IF;
    n_controlEstat:=1;
    SELECT CONTRACTE.IDESTATCONTRACTE INTO n_estat
    FROM CONTRACTE
    WHERE CONTRACTE.IDESTATCONTRACTE=n_controlEstat
    AND CONTRACTE.IDCONTRACTE=p_idContracte;    
    
    IF n_estat=n_controlEstat THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('CANVIAR ALTA A UN CONTRACTE:  ');                  
    s_rsp := 'El contracte ja esta en ALTA. ';
    DBMS_OUTPUT.PUT_LINE(s_rsp);                  
    RAISE e_contracte ;
    END IF;
    
    SELECT CONTRACTE.IDCONTRACTE INTO n_idContracte
    FROM CONTRACTE
    WHERE CONTRACTE.IDCONTRACTE=p_idContracte
    AND CONTRACTE.IDESTATCONTRACTE=n_controlEstat;
    
 s_sql := 'UPDATE CONTRACTE SET ';
      IF p_dataModificacioContracte IS NOT NULL THEN
      -- Modifiquem data Modificacio Contracte
        s_sql := s_sql || 'DATAMODIFICACIOCONTRACTE=''' ||p_dataModificacioContracte|| ''',';
        END IF;                   
      IF n_controlEstat IS NOT NULL THEN
        -- Modifiquem id Estat Contracte
        s_sql := s_sql || 'IDESTATCONTRACTE=''' ||n_controlEstat|| ''',';
       END IF;
 -- Eliminem la coma final de la sentencia SQL--------------------------
    s_sql := SUBSTR (s_sql, 1, LENGTH (s_sql) - 1);
-- Afegim a la sentencia la condiciÃƒÂ³ del WHERE------------------------
    s_sql := s_sql || ' WHERE IDCONTRACTE=''' ||p_idContracte|| '''';
    
EXECUTE IMMEDIATE s_sql;   
  IF SQL%ROWCOUNT = 0 THEN
 --L'error serÃ  que Tipo Linea ja el tenim en la taula i no admet duplicats--
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('CANVIAR ALTA A UN CONTRACTE: ');                  
  s_rsp := 'Actualitzacio no realitzada';
  DBMS_OUTPUT.PUT_LINE(s_rsp);                  
  RAISE e_contracte ;
  ELSE
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE(' Alta del Contracte numero: '||p_idContracte||
  ' en la data: '||p_dataModificacioContracte||
  ' en estat: '||n_descEstat||
  ' modificacio realitzada'); 
  DBMS_OUTPUT.PUT_LINE('********* FI DE LES OPERACIONS *********');
    s_rsp := 'OK Alta del Contracte numero: '||p_idContracte||
  ' en la data: '||p_dataModificacioContracte||
  ' en estat: '||n_descEstat||
  ' modificacio realitzada';
  pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  END IF;
COMMIT;
  EXCEPTION
    WHEN DUP_VAL_ON_INDEX THEN
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('CANVIAR ALTA A UN CONTRACTE:  ');    
      s_rsp := 'Error: CONTRACTE duplicat. No es poden fer les modificacions';
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;      
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         -----------------------------------------
         s_rsp := 'Error: ' || SQLCODE || SUBSTR(SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         -----------------------------------------
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('  '); 
      DBMS_OUTPUT.put_line (s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK; 
    
END PRC_CANVIAR_ALTA_CONTRACTE;	

PROCEDURE PRC_CANVIAR_BAIXA_CONTRACTE(	
	p_idContracte IN CONTRACTE.IDCONTRACTE%TYPE,
	p_dataModificacioContracte IN CONTRACTE.DATAMODIFICACIOCONTRACTE%TYPE,   
	s_rsp out NOCOPY VARCHAR)
AS
BEGIN
    c_procesLog := 'PRC_CANVIAR_BAIXA_CONTRACTE';
    c_dataHoraLog := SYSDATE;
    c_entradaLog :=' Numero Contracte: '||p_idContracte||
    ', Data modificacio Contracte: ' ||p_dataModificacioContracte;
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE('       BAIXA DE CONTRACTE             ');
    DBMS_OUTPUT.PUT_LINE('--------------------------------------- '); 
    DBMS_OUTPUT.PUT_LINE('   Numero Contracte: '||p_idContracte||
    ', Data modificacio Contracte: ' ||p_dataModificacioContracte);
    c_sortidalog := 's_rsp'; 
    
    IF p_idContracte IS NULL THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('BAIXA DE CONTRACTE:  ');                  
    s_rsp := 'Falta el numero de contracte. ';
    DBMS_OUTPUT.PUT_LINE(s_rsp);                  
    RAISE e_contracte ;
    END IF;
    IF p_dataModificacioContracte IS NULL THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('BAIXA DE CONTRACTE:  ');                  
    s_rsp := 'Falta la data de la modificacio. ';
    DBMS_OUTPUT.PUT_LINE(s_rsp);                  
    RAISE e_contracte ;
    END IF;
    
    SELECT COUNT (p_idContracte) INTO n_idContracte
    FROM CONTRACTE
    WHERE CONTRACTE.IDCONTRACTE=p_idContracte;
    
    IF n_idContracte=0 THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('BAIXA DE CONTRACTE:  ');                  
    s_rsp := 'El contracte no exiteix. ';
    DBMS_OUTPUT.PUT_LINE(s_rsp);                  
    RAISE e_contracte ;
    END IF;
    n_controlEstat:=2;
    SELECT CONTRACTE.IDESTATCONTRACTE INTO n_estat
    FROM CONTRACTE
    WHERE CONTRACTE.IDESTATCONTRACTE=n_controlEstat
    AND CONTRACTE.IDCONTRACTE=p_idContracte;    
    
    IF n_estat=n_controlEstat THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('BAIXA DE CONTRACTE:  ');                  
    s_rsp := 'El contracte ja esta en Baixa. ';
    DBMS_OUTPUT.PUT_LINE(s_rsp);                  
    RAISE e_contracte ;
    END IF;
    
    SELECT CONTRACTE.IDCONTRACTE INTO n_idContracte
    FROM CONTRACTE
    WHERE CONTRACTE.IDCONTRACTE=p_idContracte
    AND CONTRACTE.IDESTATCONTRACTE=n_controlEstat;
    
 s_sql := 'UPDATE CONTRACTE SET ';
      IF p_dataModificacioContracte IS NOT NULL THEN
      -- Modifiquem data Modificacio Contracte
        s_sql := s_sql || 'DATAMODIFICACIOCONTRACTE=''' ||p_dataModificacioContracte|| ''',';
        END IF;                   
      IF n_controlEstat IS NOT NULL THEN
        -- Modifiquem id Estat Contracte
        s_sql := s_sql || 'IDESTATCONTRACTE=''' ||n_controlEstat|| ''',';
       END IF;
 -- Eliminem la coma final de la sentencia SQL--------------------------
    s_sql := SUBSTR (s_sql, 1, LENGTH (s_sql) - 1);
-- Afegim a la sentencia la condiciÃƒÂ³ del WHERE------------------------
    s_sql := s_sql || ' WHERE IDCONTRACTE=''' ||p_idContracte|| '''';
    
EXECUTE IMMEDIATE s_sql;   
  IF SQL%ROWCOUNT = 0 THEN
 --L'error serÃ  que Tipo Linea ja el tenim en la taula i no admet duplicats--
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('BAIXA DE CONTRACTE: ');                  
  s_rsp := 'Actualitzacio no realitzada';
  DBMS_OUTPUT.PUT_LINE(s_rsp);                  
  RAISE e_contracte ;
  ELSE
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE(' Baixa del Contracte numero: '||p_idContracte||
  ' en la data: '||p_dataModificacioContracte||
  ' en estat: '||n_descEstat||
  ' modificacio realitzada'); 
  DBMS_OUTPUT.PUT_LINE('********* FI DE LES OPERACIONS *********');
    s_rsp := 'OK Baixa del Contracte numero: '||p_idContracte||
  ' en la data: '||p_dataModificacioContracte||
  ' en estat: '||n_descEstat||
  ' modificacio realitzada';
  pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  END IF;
COMMIT;
  EXCEPTION
    WHEN DUP_VAL_ON_INDEX THEN
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('BAIXA DE CONTRACTE:  ');    
      s_rsp := 'Error: CONTRACTE duplicat. No es poden fer les modificacions';
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;      
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         -----------------------------------------
         s_rsp := 'Error: ' || SQLCODE || SUBSTR(SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         -----------------------------------------
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('  '); 
      DBMS_OUTPUT.put_line (s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK; 
        
END PRC_CANVIAR_BAIXA_CONTRACTE;

PROCEDURE PRC_CONSULTA_CONTRACTE(
	s_rsp out NOCOPY VARCHAR)
AS

CURSOR C_CONTRACTE IS
SELECT 
CONTRACTE.IDCONTRACTE,
CONTRACTE.DATAALTACONTRACTE,
ESTAT.DESCRIPCIOESTAT,
CONTRACTE.DATAMODIFICACIOCONTRACTE,
CONTRACTE.DNICLIENTECONTRACTE,
CLIENT.NOMCLIENT,
CLIENT.COGNOM1CLIENT,
CLIENT.COGNOM2CLIENT,
CONTRACTE.IDCONTADORCONTRACTE,
CONTRACTE.POTENCIACONTRACTE,
CONTRACTE.OBSERVACIOCONTRACTE
FROM ESTAT, CLIENT,CONTRACTE
WHERE CONTRACTE.IDCONTRACTE=CONTRACTE.IDCONTRACTE
AND CONTRACTE.DNICLIENTECONTRACTE=CLIENT.DNICLIENT
AND CONTRACTE.IDESTATCONTRACTE=ESTAT.IDESTAT;

BEGIN
    c_procesLog := 'PRC_CONSULTAR_CONTRACTE';
    c_dataHoraLog := SYSDATE;
    c_entradaLog :='CONSULTAR CONTRACTES';
    c_sortidalog := 's_rsp';  
    
SELECT DISTINCT COUNT (*) INTO n_registres
FROM CONTRACTE
WHERE CONTRACTE.IDCONTRACTE=CONTRACTE.IDCONTRACTE;

IF n_registres=0 THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('CONSULTAR CONTRACTES:  ');                  
    s_rsp := 'No hi han contractes. ';
    DBMS_OUTPUT.PUT_LINE(s_rsp);                  
    RAISE e_contracte ;
   ELSE
 
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('       CONSULTA CONTRACTES         ');
    DBMS_OUTPUT.PUT_LINE('-----------------------------------');
    
OPEN C_CONTRACTE;
FETCH C_CONTRACTE INTO
n_idContracte,
n_dataAltaContracte,
n_descEstat,
n_dataModificacioContracte,
n_dniContracte,
n_nomClient,
n_cognom1Client,
n_cognom2Client,
n_idComptadorContracte,
n_potenciaContracte,
n_observacionsContracte;
WHILE C_CONTRACTE%FOUND LOOP
DBMS_OUTPUT.ENABLE;
   DBMS_OUTPUT.PUT_LINE(
 '   Numero contracte:  '
 ||n_idContracte||
 ' Data alta Contracte:  '
 ||n_dataAltaContracte||
 ' Estat:  '
 ||n_descEstat||
 ' Data Modificacio: '
 ||n_dataModificacioContracte||
 ' Dni Client: '
 ||n_dniContracte||
 ' Nom: '
 ||n_nomClient||
 ' Cognom1: '
 ||n_cognom1Client||
 ' Cognom2: '
 ||n_cognom2Client||
 ' Codi Comptador: '
 ||n_idComptadorContracte||
 ' Potencia Contractada: '
 ||n_potenciaContracte||
 ' Observacions: '
 ||n_observacionsContracte);
  s_rsp := 'OK  CONSULTA CONTRACTES 
    Numero contracte:  '
 ||n_idContracte||
 --' Data alta Contracte:  '
 --||n_dataAltaContracte||
 --' Estat:  '
 --||n_descEstat||
 /****************************
 ' Data Modificacio: '
 ||n_dataModificacioContracte||
 ' Dni Client: '
 ||n_dniContracte||
 ' Nom: '
 ||n_nomClient||
 ' Cognom1: '
 ||n_cognom1Client||
 ' Cognom2: '
 ||n_cognom2Client||
 ' Codi Comptador: '
 ||n_idComptadorContracte||
 ' Potencia Contractada: '
 ||n_potenciaContracte||
 *****************************/
 ' Observacions: '
 ||n_observacionsContracte;
FETCH C_CONTRACTE INTO n_idContracte,
n_dataAltaContracte,
n_descEstat,
n_dataModificacioContracte,
n_dniContracte,
n_nomClient,
n_cognom1Client,
n_cognom2Client,
n_idComptadorContracte,
n_potenciaContracte,
n_observacionsContracte;
pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  
  END LOOP;
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('Total contractes: '||n_registres);
  DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');

CLOSE C_CONTRACTE;
 END IF;
COMMIT;
 EXCEPTION
	
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi-----------------------------------------
         s_rsp := 'Error: ' || SQLCODE || SUBSTR(SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi-----------------------------------------
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' '); 
      DBMS_OUTPUT.put_line (s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;
END PRC_CONSULTA_CONTRACTE;

PROCEDURE PRC_CONSULTA_CONTRACTE_DNI(
	p_dniClientContracte IN CONTRACTE.DNICLIENTECONTRACTE%TYPE, 
	s_rsp out NOCOPY VARCHAR)
AS

CURSOR C_CONTRACTE_DNI IS
SELECT CONTRACTE.IDCONTRACTE,
CONTRACTE.DATAALTACONTRACTE,
ESTAT.DESCRIPCIOESTAT,
CONTRACTE.DATAMODIFICACIOCONTRACTE,
CONTRACTE.DNICLIENTECONTRACTE,
CLIENT.NOMCLIENT,
CLIENT.COGNOM1CLIENT,
CLIENT.COGNOM2CLIENT,
CONTRACTE.IDCONTADORCONTRACTE,
CONTRACTE.POTENCIACONTRACTE,
CONTRACTE.OBSERVACIOCONTRACTE
FROM ESTAT, CLIENT,CONTRACTE
WHERE CONTRACTE.IDCONTRACTE=CONTRACTE.IDCONTRACTE
AND CONTRACTE.DNICLIENTECONTRACTE=CLIENT.DNICLIENT
AND CONTRACTE.IDESTATCONTRACTE=ESTAT.IDESTAT
AND CONTRACTE.DNICLIENTECONTRACTE=p_dniClientContracte;
BEGIN        
    c_procesLog := 'PRC_CONSULTA_CONTRACTE_DNI';
    c_dataHoraLog := SYSDATE;
    c_entradaLog :=' DNI Client: '||p_dniClientContracte;
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE('       CONSULTAR CONTRACTE UN CLIENT             ');
    DBMS_OUTPUT.PUT_LINE('----------------------------------------------- '); 
    DBMS_OUTPUT.PUT_LINE('   DNI Client: '||p_dniClientContracte);
    c_sortidalog := 's_rsp';   
    
 IF p_dniClientContracte IS NULL THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE(' CONSULTAR CONTRACTE UN CLIENT:  ');                  
    s_rsp := 'Falta DNI del Client. ';
    DBMS_OUTPUT.PUT_LINE(s_rsp);                  
    RAISE e_contracte ;
    END IF; 
SELECT COUNT(*) INTO n_registres
FROM CONTRACTE
WHERE CONTRACTE.DNICLIENTECONTRACTE=p_dniClientContracte;

IF n_registres=0 THEN
 DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE(' CONSULTAR CONTRACTE UN CLIENT:  ');                  
    s_rsp := 'No hi han contractes del client aquest. ';
    DBMS_OUTPUT.PUT_LINE(s_rsp);                  
    RAISE e_contracte ;
    END IF;
 
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('        CONSULTA CONTRACTES UN CLIENT            ');
    DBMS_OUTPUT.PUT_LINE('-------------------------------------------------');
    
OPEN C_CONTRACTE_DNI;
FETCH C_CONTRACTE_DNI INTO n_idContracte,
n_dataAltaContracte,
n_descEstat,
n_dataModificacioContracte,
n_dniContracte,
n_nomClient,
n_cognom1Client,
n_cognom2Client,
n_idComptadorContracte,
n_potenciaContracte,
n_observacionsContracte;
WHILE C_CONTRACTE_DNI%FOUND LOOP
DBMS_OUTPUT.ENABLE;
   DBMS_OUTPUT.PUT_LINE(
 '   Numero contracte:  '
 ||n_idContracte||
 ' Data alta Contracte:  '
 ||n_dataAltaContracte||
 ' Estat:  '
 ||n_descEstat||
 ' Data Modificacio: '
 ||n_dataModificacioContracte||
 ' Dni Client: '
 ||n_dniContracte||
 ' Nom: '
 ||n_nomClient||
 ' Cognom1: '
 ||n_cognom1Client||
 ' Cognom2: '
 ||n_cognom2Client||
 ' Codi Comptador: '
 ||n_idComptadorContracte||
 ' Potencia Contractada: '
 ||n_potenciaContracte||
 ' Observacions: '
 ||n_observacionsContracte);
  s_rsp := 'OK  CONSULTA CONTRACTES UN CLIENT 
   Numero contracte:  '
 ||n_idContracte||
 ' Data alta Contracte:  '
 ||n_dataAltaContracte||
 ' Estat:  '
 ||n_descEstat||
 ' Data Modificacio: '
 ||n_dataModificacioContracte||
 ' Dni Client: '
 ||n_dniContracte;
FETCH C_CONTRACTE_DNI INTO n_idContracte,
n_dataAltaContracte,
n_descEstat,
n_dataModificacioContracte,
n_dniContracte,
n_nomClient,
n_cognom1Client,
n_cognom2Client,
n_idComptadorContracte,
n_potenciaContracte,
n_observacionsContracte;
pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  
  END LOOP;
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('Total contractes: '||n_registres);
  DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');

CLOSE C_CONTRACTE_DNI;
COMMIT;
 EXCEPTION
	
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi-----------------------------------------
         s_rsp := 'Error: ' || SQLCODE || SUBSTR(SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi-----------------------------------------
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' '); 
      DBMS_OUTPUT.put_line (s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;
        
        
END PRC_CONSULTA_CONTRACTE_DNI;

END "GESTION_CONTRACTE";
