CREATE OR REPLACE
PACKAGE BODY          "GESTION_FABRICANT" AS
  n_registres      NUMBER;
  s_sql            VARCHAR2 (2000);
  n_NUM_ERR 	  NUMBER(10);
 
  c_procesLog	    LOG_TFC.procesLog%TYPE;	
  c_dataHoraLog     LOG_TFC.dataHoraLog%TYPE;
  c_entradaLog      LOG_TFC.entradaLog%TYPE;	
  c_sortidaLog      LOG_TFC.sortidaLog%TYPE;
  s_rsp	            LOG_TFC.rspLog%TYPE; 
  --s_rsp VARCHAR2 (2000);
  n_estat NUMBER;
  n_controlEstat FABRICANT.ESTATFABRICANT%TYPE;
  
  n_idFabricant  FABRICANT.IDFABRICANT%Type;
  n_nifFabricant  FABRICANT.NIFFABRICANT%TYPE;
  n_dataAltaFabricant      FABRICANT.DATAALTAFABRICANT%TYPE;
  n_estatFabricant  FABRICANT.ESTATFABRICANT%TYPE;
  n_dataModificacioFabricant  FABRICANT.DATAMODIFCAFABRICANT%TYPE;
  n_nomComercialFabricant  FABRICANT.NOMCOMERCIALFABRICANT%Type;
  n_idUbicaFabricant FABRICANT.IDUBICAFABRICANT%TYPE;
  
  n_via VIA.DESCRIPCIOVIA%TYPE;
  n_direccioFabricant UBICACIO.DIRECCIONUBICACIO%TYPE;
  n_numeroFabricant UBICACIO.NUMEROUBICACIO%TYPE;
  n_pisFabricant UBICACIO.PISUBICACIO%TYPE;
  n_portaFabricant UBICACIO.PORTAUBICACIO%TYPE; 
  n_codiPostalFabricant UBICACIO.CODIPOSTAL%TYPE;  
  n_poblacioFabricant LOCALITAT.DESCRIPCIOLOCALITAT%TYPE;
  n_provinvciaFabricant PROVINCIA.DESCRIPCIOPROVINCIA%TYPE;
  n_paisFabricant PAIS.DESCRIPCIOPAIS%TYPE;
  n_descEstat ESTAT.DESCRIPCIOESTAT%TYPE;

  sortida VARCHAR2(2000):='';
  e_fabricant        EXCEPTION;
/******************************************************************************
  ALTA DE FABRICANT
  Procediment per donar d'alta al Fabricant de models de comptadors.
******************************************************************************/
PROCEDURE PRC_ALTA_FABRICANT(
    p_NIFFabricant in FABRICANT.NIFFABRICANT%Type,
    p_dataAltaFabricant in FABRICANT.DATAALTAFABRICANT%Type,
    p_estatFabricant in FABRICANT.ESTATFABRICANT%Type,
    p_nomComercialFabricant in FABRICANT.NOMCOMERCIALFABRICANT%Type,
    p_idUbicaFabricant in FABRICANT.IDUBICAFABRICANT%Type,
    s_rsp out NOCOPY VARCHAR2)
    AS
    BEGIN
--Parametres per la taula FABRICANT
    c_procesLog := 'PRC_ALTA_FABRICANT';
    c_dataHoraLog := SYSDATE;
    c_entradaLog :=   ' NIF : ' ||p_NIFFabricant|| 
                      ', Data alta: ' ||p_dataAltaFabricant||
                      ', Nom Comercial: ' ||p_nomComercialFabricant||
                      ', Direccio: ' ||p_idUbicaFabricant;
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE('   ALTA FABRICANT     ');
    DBMS_OUTPUT.PUT_LINE('______________________');
    DBMS_OUTPUT.PUT_LINE(' NIF : ' ||p_NIFFabricant|| 
                        ', Data alta: ' ||p_dataAltaFabricant||
                        ', Nom Comercial: ' ||p_nomComercialFabricant||
                        ', Direccio: ' ||p_idUbicaFabricant);
    c_sortidalog := 's_rsp';   
    
-- Comprovem que el NIF no sigui NULL
  If p_NIFFabricant IS NULL then
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('ALTA FABRICANT: ');   
      s_rsp := 'Falta especificar el NIF ';
      DBMS_OUTPUT.PUT_LINE(s_rsp);
      RAISE e_fabricant;
  END IF;
-- Comprovem els parÃ metres NULL i advertim si falta algun parÃ metre
  if p_dataAltaFabricant  IS NULL THEN
     DBMS_OUTPUT.ENABLE;
     DBMS_OUTPUT.PUT_LINE('ALTA FABRICANT: ');
     s_rsp := 'Falta especificar la dta alta  ';
     DBMS_OUTPUT.PUT_LINE(s_rsp);
     RAISE e_fabricant;
  END IF;
  IF p_nomComercialFabricant IS NULL THEN
     DBMS_OUTPUT.ENABLE;
     DBMS_OUTPUT.PUT_LINE('ALTA FABRICANT: ');
     s_rsp := 'Falta especificar nom comercial  ';
     DBMS_OUTPUT.PUT_LINE(s_rsp);
     RAISE e_fabricant;
  END IF;
  IF p_idUbicaFabricant IS NULL THEN
     DBMS_OUTPUT.ENABLE;
     DBMS_OUTPUT.PUT_LINE('ALTA FABRICANT: ');
     s_rsp := 'Falta especificar el codi ubicacio   ';
     DBMS_OUTPUT.PUT_LINE(s_rsp);
     RAISE e_fabricant;
  END IF;
  
-- Comprovem si existeix el NIF a  donar d'alta
  SELECT COUNT (*) INTO n_registres 
  FROM FABRICANT 
  WHERE FABRICANT.NIFFABRICANT=p_NIFFabricant;
    	 
  If n_registres=0 then
-- El donem d'alta a FABRICANT 
  n_estat:=1;
  INSERT INTO FABRICANT(NIFFABRICANT,
                        DATAALTAFABRICANT,
                        ESTATFABRICANT,
                        NOMCOMERCIALFABRICANT,
                        IDUBICAFABRICANT) 
  VALUES(p_NIFFabricant,
         p_dataAltaFabricant,
         n_estat,
         p_nomComercialFabricant,
         p_idUbicaFabricant);
         
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('Insertat el Fabricant: NIF: '
                      ||p_NIFFabricant||
                      ' Data alta: '
                      ||p_dataAltaFabricant||
                      ' Nom Fabricant: '
                      ||p_nomComercialFabricant||
                      ' Codi Ubicacio: '
                      ||p_idUbicaFabricant);
  DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
  s_rsp :='Ok: Insertat el Fabricant: NIF: '
                      ||p_NIFFabricant||
                      ' Data alta: '
                      ||p_dataAltaFabricant||
                      ' Nom Fabricant: '
                      ||p_nomComercialFabricant||
                      ' Codi Ubicacio: '
                      ||p_idUbicaFabricant;
  pkg_general.gravar_log_procedure(c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  DBMS_OUTPUT.PUT_LINE(s_rsp);
 ELSE
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('ALTA FABRICANT: ');              
  s_rsp := 'NIF duplicat';
  DBMS_OUTPUT.PUT_LINE(s_rsp);
  RAISE e_fabricant;
END IF;
COMMIT;
  EXCEPTION
       WHEN OTHERS THEN
          IF s_rsp IS NULL THEN
             -- L'error no ha estat controlat per codi
             s_rsp := 'Error: ' || SQLCODE || SUBSTR (SQLERRM, 1, 100);
          ELSE
             -- L'error si ha estat controlat per codi
             s_rsp := 'Error: ' || s_rsp;
          END IF;
          DBMS_OUTPUT.ENABLE;
          DBMS_OUTPUT.PUT_LINE(' ');    
          DBMS_OUTPUT.put_line(s_rsp);
          pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  ROLLBACK;  
END PRC_ALTA_FABRICANT;
/*****************************************************************
    PROCEDIMENT MODIFICAR FABRICANT
*****************************************************************/
PROCEDURE PRC_MODIFICAR_FABRICANT(
    p_idFabricant in FABRICANT.IDFABRICANT%Type,
    p_NIFFabricant in FABRICANT.NIFFABRICANT%Type,
    p_dataModificaFabricant in FABRICANT.DATAMODIFCAFABRICANT%Type,
    p_estatFabricant in FABRICANT.ESTATFABRICANT%Type,
    p_nomComercialFabricant in FABRICANT.NOMCOMERCIALFABRICANT%Type,
    p_idUbicaFabricant in FABRICANT.IDUBICAFABRICANT%Type,
    s_rsp out NOCOPY VARCHAR2)  
  AS
  BEGIN
    c_procesLog := 'PRC_MODIFICAR_FABRICANT';
    c_dataHoraLog := SYSDATE;
    c_entradaLog := 'Nif Fabricant: ' || p_NIFFabricant || 
   		', Data Modificacio Fabricant: ' ||p_dataModificaFabricant || 
                ', Nom Comercial Fabricant: ' || p_nomComercialFabricant || 
   		', Id Ubicacio Fabricant: ' || p_idUbicaFabricant;
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE('     MODIFICAR FABRICANT     ');
    DBMS_OUTPUT.PUT_LINE('_____________________________');
    DBMS_OUTPUT.PUT_LINE(' NIF Fabricant: ' 
                        || p_NIFFabricant || 
                        '  Data Modificacio Fabricant: ' 
                        ||p_dataModificaFabricant || 
                        '  Nom Comercial Fabricant: ' 
                        || p_nomComercialFabricant || 
                        '  Codi Ubicacio Fabricant: ' 
                        || p_idUbicaFabricant);
    c_sortidalog := 's_rsp';
  If p_NIFFabricant  IS NULL then
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('MODIFICAR FABRICANT: ');  
    s_rsp := 'Falta especificarel NIF de Fabricant';
    DBMS_OUTPUT.PUT_LINE(s_rsp);           
    RAISE e_fabricant;
  END IF;
  If p_dataModificaFabricant IS NULL then
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('MODIFICAR FABRICANT: ');  
    s_rsp := 'Falta especificar la data de Fabricant ';
    DBMS_OUTPUT.PUT_LINE(s_rsp);           
    RAISE e_fabricant;
  END IF;
  If p_nomComercialFabricant IS NULL then
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('MODIFICAR FABRICANT: ');  
    s_rsp := 'Falta especificar Nom Comercial de Fabricant ';
    DBMS_OUTPUT.PUT_LINE(s_rsp);           
    RAISE e_fabricant;
  END IF;
  If p_idUbicaFabricant IS NULL then
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('MODIFICAR FABRICANT: ');  
    s_rsp := 'Falta especificar el Codi ubicacio de Fabricant ';
    DBMS_OUTPUT.PUT_LINE(s_rsp);           
    RAISE e_fabricant;
  END IF;
--1er. Comprovem  Fabricant-------------------------------
  SELECT COUNT (*) INTO n_registres 
  FROM FABRICANT
  WHERE FABRICANT.NIFFABRICANT=p_NIFFabricant;
-- si exiteix el FABRICANT
  If n_registres=0 then
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('MODIFICAR_FABRICANT:  ');              
    s_rsp := 'Fabricant no existent a la BBDD';
    DBMS_OUTPUT.PUT_LINE(s_rsp);
    RAISE e_fabricant;
  END IF;
-- recuperem dades
  SELECT FABRICANT.NIFFABRICANT INTO n_NIFFabricant
  FROM FABRICANT
  WHERE FABRICANT.NIFFABRICANT=p_NIFFabricant;
  s_sql := 'UPDATE FABRICANT SET ';
--Construirem la sentencia UPDATE segons si hi ha valor en els parÃ metres-
  IF p_NIFFabricant  IS NOT NULL THEN
-- Modifiquem el nif Fabricant
      s_sql := s_sql || 'NIFFABRICANT=''' || p_NIFFabricant || ''',';
  END IF;
  IF p_dataModificaFabricant IS NOT NULL THEN
-- Modifiquem els data Modifica Fabricant----------------------------------------
    s_sql := s_sql || 'DATAMODIFCAFABRICANT =''' || p_dataModificaFabricant || ''',';
  END IF;
  IF p_nomComercialFabricant IS NOT NULL THEN
-- Modifiquem nom Comercial Fabricant--------------------------------------------
    s_sql := s_sql || 'NOMCOMERCIALFABRICANT=''' ||p_nomComercialFabricant || ''',';
  END IF;
  IF p_idUbicaFabricant IS NOT NULL THEN
-- Modifiquem l'adreca-------------------------------------------
     s_sql := s_sql || 'idUbicaFabricant=''' || p_idUbicaFabricant || ''',';
   END IF;
-- Eliminem la coma final de la sentencia SQL--------------------------
   s_sql := SUBSTR (s_sql, 1, LENGTH (s_sql) - 1);
-- Afegim a la sentencia la condiciÃ³ del WHERE------------------------
   s_sql := s_sql || ' WHERE NIFFABRICANT  =''' ||n_NIFFabricant|| '''';
    
EXECUTE IMMEDIATE s_sql;
         
    IF SQL%ROWCOUNT = 0  THEN
--L'error serÃ  que el DNI ja el tenim en la taula i no admet duplicats--
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('MODIFICAR_FABRICANT: ');                     
      s_rsp := 'Actualitzacio no realitzada  ';
      DBMS_OUTPUT.PUT_LINE(s_rsp);                     
      RAISE e_fabricant;
    ELSE
      DBMS_OUTPUT.PUT_LINE('Modificacio feta del Fabricant amd NIF: '
      ||n_NIFFabricant||
      '  Data modificacio: '||p_dataModificaFabricant||
      '  Nom Comercial: '||p_nomComercialFabricant||
      '  Codi Ubicacio: '||p_idUbicaFabricant);
      DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
      DBMS_OUTPUT.PUT_LINE('MODIFICAR_FABRICANT: ');                  
      s_rsp := 'OK: Modificacio feta del Fabricant amd NIF: '
                ||n_NIFFabricant||
                '  Data modificacio: '||p_dataModificaFabricant||
                '  Nom Comercial: '||p_nomComercialFabricant||
                '  Codi Ubicacio: '||p_idUbicaFabricant;
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
   END IF;
COMMIT;
  EXCEPTION
   WHEN OTHERS THEN
    IF s_rsp IS NULL THEN
-- L'error no ha estat controlat per codi
      s_rsp := 'Error: ' || SQLCODE || SUBSTR (SQLERRM, 1, 100);
    ELSE
-- L'error si ha estat controlat per codi
     s_rsp := 'Error: ' || s_rsp;
    END IF;
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('  ');    
    DBMS_OUTPUT.put_line(s_rsp);
    pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  ROLLBACK;  
END PRC_MODIFICAR_FABRICANT; 
    
/******************************************************************************
PROCEDIMENT PER DONA DE BAIXA A UN FABRICANT
Segon el NIF si existeix l'estat canvia a situacio 2=BAIXA
******************************************************************************/
PROCEDURE PRC_BAIXA_FABRICANT(
    p_idFabricant in FABRICANT.IDFABRICANT%Type,
    p_NIFFabricant in FABRICANT.NIFFABRICANT%Type,
    p_estatFabricant in FABRICANT.ESTATFABRICANT%Type,	
    p_dataModificaFabricant in FABRICANT.DATAMODIFCAFABRICANT%Type,
    p_nomComercialFabricant in FABRICANT.NOMCOMERCIALFABRICANT%Type,
    s_rsp out NOCOPY VARCHAR2)
    AS
    BEGIN
    c_procesLog := 'PRC_BAIXA_FABRICANT';
    c_dataHoraLog := SYSDATE;
    c_entradaLog := ' NIF Fabricant: ' || p_NIFFabricant || 
   		'  Data de la baixa del Fabricant: ' 
                ||p_dataModificaFabricant;
    DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE('    BAIXA UN FABRICANT       ');
    DBMS_OUTPUT.PUT_LINE('_____________________________');
    DBMS_OUTPUT.PUT_LINE(' NIF del Fabricant: ' 
               || p_NIFFabricant || 
   		', Data de la baixa del Fabricant: ' 
                ||p_dataModificaFabricant );
               	c_sortidalog := 's_rsp';
-- DONEM EL VALOR DE BAIXA A LA VARIABLE
    n_estat:=2;
-- comprovem si el fabricant existeix a la BDD
SELECT COUNT  (*) INTO n_registres
FROM FABRICANT
WHERE FABRICANT.NIFFABRICANT=p_NIFFabricant;
  
  IF n_registres=0 THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('BAIXA_FABRICANT: ');          
    s_rsp := 'El Fabricant no exiteix en la BDD ha de fer-se un alta.  ';
    DBMS_OUTPUT.PUT_LINE(s_rsp);                
    RAISE e_fabricant;     
  END IF;
  
-- Comprovem que el Nif Fabricant no estigui en blancs o null
  If (p_NIFFabricant IS NULL) then
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('BAIXA_FABRICANT: ');          
    s_rsp := 'Falta especificar el Nif Fabricant ';
    DBMS_OUTPUT.PUT_LINE(s_rsp);                
    RAISE e_fabricant;     
  END IF;
  
-- si esta donat alta
SELECT DISTINCT FABRICANT.ESTATFABRICANT INTO n_controlEstat
FROM FABRICANT
WHERE FABRICANT.NIFFABRICANT=p_NIFFabricant;

  IF n_controlEstat=2 THEN
   DBMS_OUTPUT.ENABLE;
   DBMS_OUTPUT.PUT_LINE('BAIXA FABRICANT: ');               
               s_rsp := 'El fabricant: '||p_NIFFabricant||' ja esta donant de baixa. ';
   DBMS_OUTPUT.PUT_LINE(s_rsp);               
   RAISE e_fabricant;           
  END IF;
-- recuperem dades del fabricant
  SELECT FABRICANT.NIFFABRICANT INTO n_NIFFabricant
  FROM FABRICANT
  WHERE FABRICANT.NIFFABRICANT=p_NIFFabricant;
              
  IF p_NIFFabricant IS NOT NULL  THEN
     s_sql := 'UPDATE FABRICANT SET  estatFabricant='''||n_estat||'''';
     s_sql := 'UPDATE FABRICANT SET  dataModificacioClient='''|| p_dataModificaFabricant||'''';
-- Eliminem la coma final de la sentencia SQL--------------------------
      s_sql := SUBSTR (s_sql, 1, LENGTH (s_sql) - 1);
-- Afegim a la sentencia la condiciÃ³ del WHERE------------------------
    s_sql := s_sql || ' WHERE NifFabricant=''' ||n_NIFFabricant|| '''';
  END IF; 
EXECUTE IMMEDIATE s_sql;
  IF SQL%ROWCOUNT = 0 THEN
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('BAIXA FABRICANT:  ');                      
      s_rsp := 'Actualitzacio no realitzada';
      DBMS_OUTPUT.PUT_LINE(s_rsp);                       
      RAISE e_fabricant; 
  ELSE
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('BAIXA FABRICANT:  '); 
      DBMS_OUTPUT.PUT_LINE('Actualitzacio de baixa del Fabricant: '||n_NIFFabricant||
      ' data de la baixa: '||p_dataModificaFabricant||
      ' estat: '||n_estat||'= Baixa ha estat satisfactoria.');
      DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
      s_rsp := 'OK Actualitzacio de baixa del Fabricant: '||n_NIFFabricant||
      ' data de la baixa: '||p_dataModificaFabricant||
      ' estat: '||n_estat||'= Baixa ha estat satisfactoria.';
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  END IF;
COMMIT;
EXCEPTION
       WHEN OTHERS THEN
          IF s_rsp IS NULL THEN
             -- L'error no ha estat controlat per codi
             s_rsp := 'Error: ' || SQLCODE || SUBSTR (SQLERRM, 1, 100);
          ELSE
             -- L'error si ha estat controlat per codi
             s_rsp := 'Error: ' || s_rsp;
          END IF;
          DBMS_OUTPUT.ENABLE;
          DBMS_OUTPUT.PUT_LINE(' ');    
          DBMS_OUTPUT.put_line(s_rsp);
          pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
          ROLLBACK;  
END PRC_BAIXA_FABRICANT;
/******************************************************************************
PROCEDIMENT CONSULTAR AMB UN NIF FABRICANT
Segon el NIF si existeix l'estat canvia a situacio 2=BAIXA
******************************************************************************/ 
PROCEDURE PRC_CONSULTAR_UN_FABRICANT(
  p_NIFFabricant in FABRICANT.NIFFABRICANT%Type,
  s_rsp out NOCOPY VARCHAR2)
 AS
 CURSOR C_FABRIANT IS
SELECT  DISTINCT   FABRICANT.IDFABRICANT AS CODI,
           FABRICANT.NIFFABRICANT AS NIF,
           FABRICANT.DATAALTAFABRICANT AS DATA_ALTA,
           ESTAT.DESCRIPCIOESTAT AS ESTAT,
           FABRICANT.DATAMODIFCAFABRICANT AS DATA_MODIFICACIO,
           FABRICANT.NOMCOMERCIALFABRICANT AS NOM_COMERCIAL,
           VIA.DESCRIPCIOVIA AS VIA_PUBLICA,
           UBICACIO.DIRECCIONUBICACIO AS DIRECCIO,
           UBICACIO.NUMEROUBICACIO AS NUMERO,
           UBICACIO.PISUBICACIO AS PIS,
           UBICACIO.PORTAUBICACIO AS PORTA,
           UBICACIO.CODIPOSTAL AS CODI_POSTAL,
           LOCALITAT.DESCRIPCIOLOCALITAT AS POBLACIO,
           PROVINCIA.DESCRIPCIOPROVINCIA AS PROVINCIA,
           PAIS.DESCRIPCIOPAIS AS PAIS
      FROM FABRICANT,ESTAT,UBICACIO,LOCALITAT,PROVINCIA,PAIS,VIA
      WHERE FABRICANT.NIFFABRICANT=p_NIFFabricant
           AND FABRICANT.ESTATFABRICANT=ESTAT.IDESTAT
           AND FABRICANT.IDUBICAFABRICANT=UBICACIO.IDUBICA
           AND LOCALITAT.IDLOCALITAT=UBICACIO.IDLOCALITATUBICACIO
           AND LOCALITAT.IDPROVINCIALOCALITAT=PROVINCIA.IDPROVINCIA
           AND PROVINCIA.IDPAISPROVINCIA=PAIS.IDPAIS
           AND UBICACIO.IDVIAUBICACIO=VIA.IDVIA
          AND FABRICANT.IDFABRICANT=FABRICANT.IDFABRICANT
          ORDER BY FABRICANT.IDFABRICANT;           

 BEGIN
  c_procesLog := 'PRC_CONSULTAR_UN_FABRICANT';
  c_dataHoraLog := SYSDATE;
  c_entradaLog := 'NIF Fabricant: ' || p_NIFFabricant;
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE('     CONSULTA DADES UN FABRICANT     ');
    DBMS_OUTPUT.PUT_LINE('_____________________________________');
    DBMS_OUTPUT.PUT_LINE(' NIF Fabricant: ' 
                        || p_NIFFabricant);
    c_sortidalog := 's_rsp';
             -- Comprovem que Nif Fabricant no sigui NULL----------------------------------------------
 If p_NIFFabricant IS NULL then
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('CONSULTA DADES UN FABRICANT : ');            
    s_rsp := 'Falta especificar el Nif Fabricant ';
    DBMS_OUTPUT.put_line (s_rsp);                   
    RAISE  e_fabricant; 
 END IF;
--1er. Comprovem que existeixi Fabricant-------------------------------
  SELECT DISTINCT COUNT (FABRICANT.NIFFABRICANT) INTO n_registres 
  FROM FABRICANT
  WHERE FABRICANT.NIFFABRICANT=p_NIFFabricant;
             
  If n_registres=0 then
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('CONSULTAR FABRICANT:  ');                  
    s_rsp := 'Fabricant no existent a la BBDD';
    DBMS_OUTPUT.PUT_LINE(s_rsp);
    RAISE e_fabricant;
 END IF;
OPEN C_FABRIANT;
    FETCH C_FABRIANT INTO 
    n_idFabricant,
    n_nifFabricant,
    n_dataAltaFabricant,
    n_descEstat,
    n_dataModificacioFabricant,
    n_nomComercialFabricant,
    n_via,n_direccioFabricant,
    n_numeroFabricant,
    n_pisFabricant,
    n_portaFabricant,
    n_codiPostalFabricant,
    n_poblacioFabricant,
    n_provinvciaFabricant,
    n_paisFabricant;
  WHILE C_FABRIANT%FOUND LOOP
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('  
   Codi Fabricant:'||n_idFabricant||
  ' NIF: '||n_nifFabricant||
  ' Data Alta: '||n_dataAltaFabricant||
  ' Estat: '||n_descEstat ||
  ' Data ultima modificacio: '||n_dataModificacioFabricant||
  ' Nom Comercial: '||n_nomComercialFabricant);
    s_rsp :='OK  CONSULTAR UN FABRICANT:  
    Codi Fabricant:'||n_idFabricant||
  ' NIF: '||n_nifFabricant||
  ' Data Alta: '||n_dataAltaFabricant||
  ' Estat: '||n_descEstat||
  ' Data ultima modificacio: '||n_dataModificacioFabricant||
  ' Nom Comercial: '||n_nomComercialFabricant;   
FETCH C_FABRIANT INTO 
    n_idFabricant,
    n_nifFabricant,
    n_dataAltaFabricant,
    n_descEstat,
    n_dataModificacioFabricant,
    n_nomComercialFabricant,
    n_via,n_direccioFabricant,
    n_numeroFabricant,
    n_pisFabricant,
    n_portaFabricant,
    n_codiPostalFabricant,
    n_poblacioFabricant,
    n_provinvciaFabricant,
    n_paisFabricant;
  pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
END LOOP;
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('Total fabricants: '||n_nifFabricant);
  DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
CLOSE C_FABRIANT;

COMMIT;
 EXCEPTION
       WHEN OTHERS THEN
          IF s_rsp IS NULL THEN
             -- L'error no ha estat controlat per codi
             s_rsp := 'Error: ' || SQLCODE || SUBSTR (SQLERRM, 1, 100);
          ELSE
             -- L'error si ha estat controlat per codi
             s_rsp := 'Error: ' || s_rsp;
          END IF;
          DBMS_OUTPUT.ENABLE;
          DBMS_OUTPUT.PUT_LINE(' ');    
          DBMS_OUTPUT.put_line(s_rsp);
          pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
          ROLLBACK;  
END PRC_CONSULTAR_UN_FABRICANT;
 
PROCEDURE PRC_CONSULTAR_FABRICANTS(
   s_rsp out NOCOPY VARCHAR2)
 AS
 CURSOR C_FABRIANT IS
SELECT  DISTINCT   FABRICANT.IDFABRICANT AS CODI,
           FABRICANT.NIFFABRICANT AS NIF,
           FABRICANT.DATAALTAFABRICANT AS DATA_ALTA,
           ESTAT.DESCRIPCIOESTAT AS ESTAT,
           FABRICANT.DATAMODIFCAFABRICANT AS DATA_MODIFICACIO,
           FABRICANT.NOMCOMERCIALFABRICANT AS NOM_COMERCIAL,
           VIA.DESCRIPCIOVIA AS VIA_PUBLICA,
           UBICACIO.DIRECCIONUBICACIO AS DIRECCIO,
           UBICACIO.NUMEROUBICACIO AS NUMERO,
           UBICACIO.PISUBICACIO AS PIS,
           UBICACIO.PORTAUBICACIO AS PORTA,
           UBICACIO.CODIPOSTAL AS CODI_POSTAL,
           LOCALITAT.DESCRIPCIOLOCALITAT AS POBLACIO,
           PROVINCIA.DESCRIPCIOPROVINCIA AS PROVINCIA,
           PAIS.DESCRIPCIOPAIS AS PAIS
      FROM FABRICANT,ESTAT,UBICACIO,LOCALITAT,PROVINCIA,PAIS,VIA
      WHERE FABRICANT.NIFFABRICANT=FABRICANT.NIFFABRICANT
           AND FABRICANT.ESTATFABRICANT=ESTAT.IDESTAT
           AND FABRICANT.IDUBICAFABRICANT=UBICACIO.IDUBICA
           AND LOCALITAT.IDLOCALITAT=UBICACIO.IDLOCALITATUBICACIO
           AND LOCALITAT.IDPROVINCIALOCALITAT=PROVINCIA.IDPROVINCIA
           AND PROVINCIA.IDPAISPROVINCIA=PAIS.IDPAIS
           AND UBICACIO.IDVIAUBICACIO=VIA.IDVIA
           AND FABRICANT.IDFABRICANT=FABRICANT.IDFABRICANT
           ORDER BY FABRICANT.NIFFABRICANT; 
 BEGIN
  c_procesLog := 'PRC_CONSULTAR_UN_FABRICANT';
  c_dataHoraLog := SYSDATE;
  c_entradaLog := '     CONSULTA DADES UN FABRICANT       ';
  c_sortidalog := 's_rsp';

 --1er. Comprovem que existeixi Fabricant-------------------------------
  SELECT  DISTINCT COUNT (FABRICANT.IDFABRICANT) INTO n_registres 
  FROM FABRICANT
  WHERE FABRICANT.NIFFABRICANT=FABRICANT.NIFFABRICANT
  AND FABRICANT.IDFABRICANT=FABRICANT.IDFABRICANT;
             
  If n_registres=0 then
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('CONSULTAR FABRICANT:  ');                  
    s_rsp := 'Fabricant no existent a la BBDD';
    DBMS_OUTPUT.PUT_LINE(s_rsp);
    RAISE e_fabricant;
END IF;

    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('           CONSULTA TIPUS DE LINEAS ACTIVADES            ');
    DBMS_OUTPUT.PUT_LINE('---------------------------------------------------------');
  
OPEN C_FABRIANT;
    FETCH C_FABRIANT INTO 
    n_idFabricant,
    n_nifFabricant,
    n_dataAltaFabricant,
    n_descEstat,
    n_dataModificacioFabricant,
    n_nomComercialFabricant,
    n_via,n_direccioFabricant,
    n_numeroFabricant,
    n_pisFabricant,
    n_portaFabricant,
    n_codiPostalFabricant,
    n_poblacioFabricant,
    n_provinvciaFabricant,
    n_paisFabricant;
  WHILE C_FABRIANT%FOUND LOOP
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE(' 
   Codi Fabricant:'||n_idFabricant||' '||
  ' NIF: '||n_nifFabricant||
  ' Data Alta: '||n_dataAltaFabricant||' '||
  ' Estat: '||n_descEstat ||
  ' Data ultima modificacio: '||n_dataModificacioFabricant||' '||
  ' Nom Comercial: '||n_nomComercialFabricant);
   s_rsp :='OK  CONSULTAR UN FABRICANT:  
    Codi Fabricant:'||n_idFabricant||
  ' NIF: '||n_nifFabricant||
  ' Data Alta: '||n_dataAltaFabricant||
  ' Estat: '||n_descEstat||
  ' Data ultima modificacio: '||n_dataModificacioFabricant||
  ' Nom Comercial: '||n_nomComercialFabricant;   
FETCH C_FABRIANT INTO 
    n_idFabricant,
    n_nifFabricant,
    n_dataAltaFabricant,
    n_descEstat,
    n_dataModificacioFabricant,
    n_nomComercialFabricant,
    n_via,n_direccioFabricant,
    n_numeroFabricant,
    n_pisFabricant,
    n_portaFabricant,
    n_codiPostalFabricant,
    n_poblacioFabricant,
    n_provinvciaFabricant,
    n_paisFabricant;
  pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
END LOOP;
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE(' Total fabricants: '||n_registres);
  DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
CLOSE C_FABRIANT;
COMMIT;

EXCEPTION
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         s_rsp := 'Error: ' || SQLCODE || SUBSTR (SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' ');
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;    

  END PRC_CONSULTAR_FABRICANTS;
END "GESTION_FABRICANT";
