CREATE OR REPLACE
PACKAGE BODY          "GESTION_E_1" AS
  c_procesLog	   LOG_TFC.procesLog%TYPE;	
  c_dataHoraLog    LOG_TFC.dataHoraLog%TYPE;
  c_entradaLog     LOG_TFC.entradaLog%TYPE;	
  c_sortidaLog     LOG_TFC.sortidaLog%TYPE;
  s_rsp	           LOG_TFC.rspLog%TYPE; 
  n_mes NUMBER;
  n_any NUMBER;
  n_idCentral NUMBER;
  n_idContador NUMBER;
  n_produccio VARCHAR2(50);
  n_consumContadorCentProdu NUMBER;
  n_linea NUMBER;
  totals NUMBER;
  n_registres  NUMBER;
  s_sql VARCHAR2 (2000);
   n_NUM_ERR NUMBER(10);
  sortida varchar2(500):=''; 
  e_e_1     EXCEPTION;
  
PROCEDURE PRC_ALTA_E1(
    p_idCentral in E_1.IDE_1%TYPE,
    s_rsp out NOCOPY VARCHAR)
    AS
 CURSOR C_LINEA_E1 IS
 --LINEA DE LA CENTRAL CONECTA
 SELECT DISTINCT 
LINEA_CONECTA_CENTRAL.IDCONECTA
FROM LINEA_CONECTA_CENTRAL
WHERE LINEA_CONECTA_CENTRAL.CONNECTACPRODU=p_idCentral;

--OBTE COMPTADORS ON HI HA LECTURES
CURSOR C_CALCULA_E1 IS
SELECT DISTINCT HIST_LECTURA.IDCOMPTADORHISTLECTURA
  FROM LINEA_CONECTAR_COMPTADOR, HIST_LECTURA, LECTURA
  WHERE LINEA_CONECTAR_COMPTADOR.CONNECTA1_CENTRALCONECTA=n_linea
  AND (SELECT     SUM(HIST_LECTURA.TOTALCONSUMOHISTLECTURA) 
      FROM HIST_LECTURA
      GROUP BY HIST_LECTURA.IDCOMPTADORHISTLECTURA 
      HAVING SUM(HIST_LECTURA.TOTALCONSUMOHISTLECTURA)>-1
      AND  HIST_LECTURA.IDCOMPTADORHISTLECTURA=2)>0;
      
CURSOR C_CALCULA IS
        SELECT     SUM(HIST_LECTURA.TOTALCONSUMOHISTLECTURA),
      HIST_LECTURA.MESHISTLECTURA,HIST_LECTURA.ANYOHISTLECTURA
      FROM  HIST_LECTURA, LECTURA
      GROUP BY HIST_LECTURA.IDCOMPTADORHISTLECTURA,HIST_LECTURA.MESHISTLECTURA,
      HIST_LECTURA.ANYOHISTLECTURA
      HAVING SUM(HIST_LECTURA.TOTALCONSUMOHISTLECTURA)>-1
      AND  HIST_LECTURA.IDCOMPTADORHISTLECTURA=n_idContador;
      
--OBTE LES CENTRALS PRODUCIO CONECTADES EN LINEA
CURSOR C_CENTRALS IS
  SELECT DISTINCT LINEA_CONECTA_CENTRAL.CONNECTACPRODU AS CENTRAL
FROM HIST_LECTURA, LINEA_CONECTAR_COMPTADOR, CENTRAL, LINEA_CONECTA_CENTRAL
WHERE LINEA_CONECTAR_COMPTADOR.IDLINEACONECTA=n_linea
AND LINEA_CONECTAR_COMPTADOR.CONNECTA1_CENTRALCONECTA=
LINEA_CONECTA_CENTRAL.IDCONECTA
AND CENTRAL.IDCLASSECENTRAL=1;

   BEGIN
    c_procesLog := 'PRC_ALTA_E1';
    c_dataHoraLog := SYSDATE;
    c_entradaLog :='Id Central: ' ||p_idCentral;
          DBMS_OUTPUT.ENABLE;
          DBMS_OUTPUT.PUT_LINE(' ');
          DBMS_OUTPUT.PUT_LINE('ESTADISTIQUES E_1');
          DBMS_OUTPUT.PUT_LINE(' Consulta del Codi de Central de Produccio:'||p_idCentral);
    c_sortidalog := 's_rsp';
    SELECT COUNT(*) INTO n_registres
FROM CENTRAL
WHERE CENTRAL.IDCLASSECENTRAL=1
AND CENTRAL.IDCENTRAL=p_idCentral;
IF n_registres>0 THEN

OPEN  C_LINEA_E1;
FETCH C_LINEA_E1 INTO  
 n_linea;

OPEN  C_CENTRALS;
FETCH C_CENTRALS INTO 
 n_idCentral;
 
 OPEN  C_CALCULA_E1;
FETCH C_CALCULA_E1 INTO 
n_idContador;

 OPEN C_CALCULA;
 FETCH C_CALCULA INTO n_consumContadorCentProdu,n_mes,n_any;
   DBMS_OUTPUT.ENABLE;
   DBMS_OUTPUT.PUT_LINE(' ');
   DBMS_OUTPUT.PUT_LINE('     ESTADISTIQUES E_1     ');
   DBMS_OUTPUT.PUT_LINE(' ---------------------------');
WHILE C_CENTRALS%FOUND AND C_LINEA_E1%FOUND AND C_CALCULA%FOUND 
AND  C_CALCULA_E1%FOUND LOOP

INSERT INTO E_1 (idCentral,idComptador_E_1,sumaConsums)

VALUES(n_idCentral,n_idContador,n_consumContadorCentProdu);

 DBMS_OUTPUT.ENABLE;
   DBMS_OUTPUT.PUT_LINE(' En la linea: '||n_linea||
 ' amb la Central de produccio: '||n_idCentral||
 ' el consum que fet el comptador:' ||n_idContador||'
  es de: '||n_consumContadorCentProdu|| ' Kw/h.  en durant el 20'||n_any );
 s_rsp := 'OK En la linea: '||n_linea||
 ' amb la Central de produccio: '||n_idCentral||
 ' el consum que fet el comptador:' ||n_idContador||'
  es de: '||n_consumContadorCentProdu|| ' Kw/h. '; 
FETCH C_CENTRALS INTO 
 n_idCentral;
 FETCH C_LINEA_E1 INTO  
 n_linea;
 FETCH C_CALCULA_E1 INTO 
n_idContador;
FETCH C_CALCULA INTO n_consumContadorCentProdu,N_MES,N_ANY;
 pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  END LOOP;
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE(' ');
  DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
  DBMS_OUTPUT.PUT_LINE(' ');

CLOSE C_CENTRALS; 
CLOSE C_LINEA_E1; 
CLOSE C_CALCULA_E1;
CLOSE C_CALCULA;
ELSE
  DBMS_OUTPUT.PUT_LINE(' ');
   DBMS_OUTPUT.PUT_LINE('     ESTADISTIQUES E_1:     ');
   DBMS_OUTPUT.PUT_LINE(' La Central  '||p_idCentral||' no es de Produccio');
     DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
 s_rsp := ' La Central no es de Produccio: '||p_idCentral;
  RAISE  e_e_1;
END IF;
COMMIT;
  EXCEPTION
     	
    WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
  -- L'error no ha estat controlat per codi-----------------------------------------
        s_rsp := 'Error: ' || SQLCODE || SUBSTR(SQLERRM, 1, 100);
      ELSE
   -- L'error si ha estat controlat per codi-----------------------------------------
         s_rsp := 'Error: ' || s_rsp;
      END IF;
         DBMS_OUTPUT.ENABLE;
         DBMS_OUTPUT.PUT_LINE('   ');        
         DBMS_OUTPUT.put_line (s_rsp);
         pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
ROLLBACK;   
 END PRC_ALTA_E1;
    
END "GESTION_E_1";
