CREATE OR REPLACE
PACKAGE BODY "GESTION_E_4" AS
 
  c_procesLog	   LOG_TFC.procesLog%TYPE;	
  c_dataHoraLog    LOG_TFC.dataHoraLog%TYPE;
  c_entradaLog     LOG_TFC.entradaLog%TYPE;	
  c_sortidaLog     LOG_TFC.sortidaLog%TYPE;
  s_rsp	           LOG_TFC.rspLog%TYPE; 
  n_aux NUMBER;
  n_percent NUMBER (9,2);
  n_linea NUMBER;
  n_numLineas NUMBER;
  n_central NUMBER;
  n_TotalComsumGlobal NUMBER;
  n_comsumEnergiaMax number;
  n_valorMitat number;
  n_maxValorLinea number;
  n_registres NUMBER;
  s_sql VARCHAR2 (2000);
   n_NUM_ERR NUMBER(10);
  sortida varchar2(500):=''; 
  e_e_4     EXCEPTION;
PROCEDURE PRC_ALTA_E_4(
 p_any in HIST_LECTURA.ANYOHISTLECTURA%TYPE,
  s_rsp out NOCOPY VARCHAR)
AS
CURSOR C_LINEAS IS
-- OBTING LES LINEAS
SELECT DISTINCT HIST_LECTURA.IDLINEAHISTLECTURA,
SUM( HIST_LECTURA.TOTALCONSUMOHISTLECTURA)
FROM  LINEA_CONECTAR_COMPTADOR,HIST_LECTURA
GROUP BY HIST_LECTURA.ANYOHISTLECTURA,HIST_LECTURA.IDLINEAHISTLECTURA 
HAVING SUM( HIST_LECTURA.TOTALCONSUMOHISTLECTURA)>-1
and HIST_LECTURA.ANYOHISTLECTURA=p_any
AND LINEA_CONECTAR_COMPTADOR.IDLINEACONECTA=
HIST_LECTURA.IDLINEAHISTLECTURA
ORDER BY HIST_LECTURA.IDLINEAHISTLECTURA;
BEGIN
 c_procesLog := 'PRC_ALTA_E2';
    c_dataHoraLog := SYSDATE;
    c_entradaLog :=' Any a consultar: '||p_any;
          DBMS_OUTPUT.ENABLE;
          DBMS_OUTPUT.PUT_LINE(' ');
          DBMS_OUTPUT.PUT_LINE('     ESTADISTIQUES E_4             ');
          DBMS_OUTPUT.PUT_LINE('___________________________________');
          DBMS_OUTPUT.PUT_LINE(' Consulta  Any : 20'||p_any);
          DBMS_OUTPUT.PUT_LINE('___________________________________ ');
          DBMS_OUTPUT.PUT_LINE(' ');
    c_sortidalog := 's_rsp';
 
--- NOMBRE TOTAL DE LINEAS
SELECT DISTINCT COUNT (HIST_LECTURA.IDLINEAHISTLECTURA) INTO n_numLineas
FROM  HIST_LECTURA,LINEA_CONECTAR_COMPTADOR
WHERE HIST_LECTURA.ANYOHISTLECTURA=p_any
AND LINEA_CONECTAR_COMPTADOR.IDLINEACONECTA=
HIST_LECTURA.IDLINEAHISTLECTURA;

IF n_numLineas=0 THEN
DBMS_OUTPUT.ENABLE;
DBMS_OUTPUT.PUT_LINE(' ');
   DBMS_OUTPUT.PUT_LINE(' ');
   DBMS_OUTPUT.PUT_LINE(' No hi han lineas que hagin consumit res o no hi han lineas en valors. ');
     DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
    s_rsp := 'No hi han lineas que hagin consumit res o no hi han lineas en valors. ';
  RAISE  e_e_4;
END IF;
SELECT MAX(SUM(HIST_LECTURA.TOTALCONSUMOHISTLECTURA)) INTO n_comsumEnergiaMax
FROM HIST_LECTURA
GROUP BY HIST_LECTURA.ANYOHISTLECTURA,HIST_LECTURA.IDLINEAHISTLECTURA
HAVING  SUM(HIST_LECTURA.TOTALCONSUMOHISTLECTURA)>-1
AND HIST_LECTURA.ANYOHISTLECTURA=p_any;

-- total del consum
SELECT DISTINCT SUM( HIST_LECTURA.TOTALCONSUMOHISTLECTURA) INTO n_TotalComsumGlobal
FROM  HIST_LECTURA
WHERE HIST_LECTURA.ANYOHISTLECTURA=p_any;
-- del total n_valorMitat te el 50%

    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('      ');
    DBMS_OUTPUT.PUT_LINE('   ESTADISTIQUES E_4     ');
    DBMS_OUTPUT.PUT_LINE('-----------------------------');
OPEN C_LINEAS;
FETCH C_LINEAS INTO
n_linea,
n_maxValorLinea;

WHILE  C_LINEAS%FOUND   LOOP
n_valorMitat:=n_TotalComsumGlobal/2;
n_aux:=n_maxValorLinea-n_valorMitat;
n_percent:=(n_aux*100)/n_TotalComsumGlobal;
if n_valorMitat<n_maxValorLinea THEN
SELECT COUNT(HIST_LECTURA.IDLINEAHISTLECTURA) into n_registres
FROM HIST_LECTURA
WHERE HIST_LECTURA.IDLINEAHISTLECTURA=n_linea;
INSERT INTO E_4 (LINEAE_4,ANYOE_4,PERCENTAGEE_4)
VALUES(n_linea,p_any,n_percent);
DBMS_OUTPUT.ENABLE;
   DBMS_OUTPUT.PUT_LINE(' Linea: '||n_linea);
   DBMS_OUTPUT.PUT_LINE(' Te un exces de:  '||n_aux||' Kw/h.' );
   DBMS_OUTPUT.PUT_LINE(' Representa el  '||n_percent||'% sobre el 50% del total anual.');
   DBMS_OUTPUT.PUT_LINE(' Consum anual de la linea:  '||n_maxValorLinea||' Kw/h.');
       DBMS_OUTPUT.PUT_LINE(' ');
    s_rsp := 'OK linea que sobrepasa el 50% es la linea: '||n_linea||
    ' Representa el  '||n_percent||'% sobre el 50% del total anual.
     Te un exces de:  '||n_aux||' Kw/h.
     Consum:  '||n_maxValorLinea||' Kw/h.';
   ELSE
 DBMS_OUTPUT.ENABLE;
DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE(' La linea: '||n_linea||' no ha consumit per sobre del 50%. ');
     DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
    s_rsp := 'La linea: '||n_linea||' no ha consumit per sobre del 50%. ';
  RAISE  e_e_4;
END IF; 
FETCH C_LINEAS INTO
n_linea,
n_maxValorLinea;
pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);

END LOOP;
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('__________________________________ ');
  DBMS_OUTPUT.PUT_LINE('Total Lineas analitzades: '||n_numLineas);
  DBMS_OUTPUT.PUT_LINE('Total Genral consums: '||n_valorMitat||' Kw/h. any: 20'||p_any);
  DBMS_OUTPUT.PUT_LINE(' ');
  DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
DBMS_OUTPUT.PUT_LINE(' ');
CLOSE C_LINEAS;
COMMIT;
COMMIT;
EXCEPTION
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi-----------------------------------------
         s_rsp := 'Error: ' || SQLCODE || SUBSTR(SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi-----------------------------------------
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' '); 
      DBMS_OUTPUT.put_line (s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK; 
      
 END PRC_ALTA_E_4;    
END "GESTION_E_4";
