CREATE OR REPLACE PACKAGE BODY "GESTION_E_7" AS
  c_procesLog	   LOG_TFC.procesLog%TYPE;	
  c_dataHoraLog    LOG_TFC.dataHoraLog%TYPE;
  c_entradaLog     LOG_TFC.entradaLog%TYPE;	
  c_sortidaLog     LOG_TFC.sortidaLog%TYPE;
  s_rsp	           LOG_TFC.rspLog%TYPE; 
  
  n_dni CLIENT.DNICLIENT%TYPE;
 n_DNICLIENT CLIENT.DNICLIENT%TYPE;
 n_COGNOM1CLIENT CLIENT.COGNOM1CLIENT%TYPE;
 n_COGNOM2CLIENT CLIENT.COGNOM2CLIENT%TYPE;
  n_comsumEnergiaMax number;
  n_registres NUMBER;
  n_idClient CLIENT.idClient%TYPE;
  n_DESCRIPCIOESTAT ESTAT.DESCRIPCIOESTAT%TYPE;
  n_DESCRIPCIOPERSONA PERSONA.DESCRIPCIOPERSONA%TYPE;
 n_DESCRIPCIOVIA VIA.DESCRIPCIOVIA%TYPE;
 n_DIRECCIONUBICACIO UBICACIO.DIRECCIONUBICACIO%TYPE;
 n_NUMEROUBICACIO UBICACIO.NUMEROUBICACIO%TYPE;
 n_PISUBICACIO UBICACIO.PISUBICACIO%TYPE;
 n_PORTAUBICACIO UBICACIO.PORTAUBICACIO%TYPE;
 n_CODIPOSTAL UBICACIO.CODIPOSTAL%TYPE;
 n_DESCRIPCIOLOCALITAT LOCALITAT.DESCRIPCIOLOCALITAT%TYPE;
 n_DESCRIPCIOPROVINCIA PROVINCIA.DESCRIPCIOPROVINCIA%TYPE;
 n_DESCRIPCIOPAIS PAIS.DESCRIPCIOPAIS%TYPE; 
 n_NOMCLIENT CLIENT.NOMCLIENT%TYPE;
  n_contracte NUMBER;
  n_comptador NUMBER;
  s_sql VARCHAR2 (2000);
   n_NUM_ERR NUMBER(10);
  sortida varchar2(500):=''; 
  e_e_7     EXCEPTION;

PROCEDURE PRC_ALTA_E_7(
  s_rsp out NOCOPY VARCHAR)
AS
CURSOR C_MITJA_CLI IS
SELECT DISTINCT AVG (HIST_LECTURA.TOTALCONSUMOHISTLECTURA),
CLIENT.DNICLIENT,CONTRACTE.IDCONTADORCONTRACTE,
HIST_LECTURA.IDCOMPTADORHISTLECTURA
FROM CONTRACTE, CLIENT,COMPTADOR, HIST_LECTURA
GROUP BY CLIENT.DNICLIENT,HIST_LECTURA.IDCOMPTADORHISTLECTURA,
CONTRACTE.DNICLIENTECONTRACTE,
CONTRACTE.IDCONTADORCONTRACTE,COMPTADOR.IDCOMPTADOR
HAVING AVG (HIST_LECTURA.TOTALCONSUMOHISTLECTURA)>-1
AND CLIENT.DNICLIENT=CONTRACTE.DNICLIENTECONTRACTE
AND COMPTADOR.IDCOMPTADOR=CONTRACTE.IDCONTADORCONTRACTE
AND COMPTADOR.IDCOMPTADOR=HIST_LECTURA.IDCOMPTADORHISTLECTURA;
BEGIN
    c_procesLog := 'ESTADISTIQUES E_7 ';
    c_dataHoraLog := SYSDATE;
    c_entradaLog :='ESTADISTICA E_7';
          DBMS_OUTPUT.ENABLE;
          DBMS_OUTPUT.PUT_LINE(' ');
          DBMS_OUTPUT.PUT_LINE('     ESTADISTIQUES E_7             ');
          DBMS_OUTPUT.PUT_LINE('___________________________________');
          DBMS_OUTPUT.PUT_LINE(' ');
    c_sortidalog := 's_rsp';
SELECT COUNT (CONTRACTE.DNICLIENTECONTRACTE) INTO n_registres
FROM CONTRACTE, CLIENT, COMPTADOR
WHERE CLIENT.DNICLIENT=
CONTRACTE.DNICLIENTECONTRACTE
AND COMPTADOR.IDCOMPTADOR=
CONTRACTE.IDCONTADORCONTRACTE
AND CONTRACTE.IDESTATCONTRACTE=1;
IF n_registres=0 THEN
DBMS_OUTPUT.ENABLE;
DBMS_OUTPUT.PUT_LINE(' ');
   DBMS_OUTPUT.PUT_LINE('       ESTADISTIQUES E_7             ');
   DBMS_OUTPUT.PUT_LINE(' No hi han client en que analitzar per no hever lectures fetes. ');
     DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
    s_rsp := ' No hi han clients en que analitzar per no hever lectures fetes. ';
  RAISE  e_e_7;
END IF;  
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('      ');
    DBMS_OUTPUT.PUT_LINE('   ESTADISTIQUES E_7         ');
    DBMS_OUTPUT.PUT_LINE('-----------------------------');
OPEN C_MITJA_CLI;
FETCH C_MITJA_CLI INTO
n_comsumEnergiaMax,
n_dni,
n_contracte,
n_comptador;

WHILE C_MITJA_CLI%FOUND  LOOP
SELECT
      CLIENT.IDCLIENT,
      CLIENT.DNICLIENT,
      CLIENT.NOMCLIENT,
      CLIENT.COGNOM1CLIENT,
      CLIENT.COGNOM2CLIENT,
      PERSONA.DESCRIPCIOPERSONA,
      VIA.DESCRIPCIOVIA,
      UBICACIO.DIRECCIONUBICACIO,
      UBICACIO.NUMEROUBICACIO,
      UBICACIO.PISUBICACIO,
      UBICACIO.PORTAUBICACIO,
      UBICACIO.CODIPOSTAL,
      LOCALITAT.DESCRIPCIOLOCALITAT,
      PROVINCIA.DESCRIPCIOPROVINCIA,
      PAIS.DESCRIPCIOPAIS
      INTO
      n_IDCLIENT,
      n_DNICLIENT,
      n_NOMCLIENT,
      n_COGNOM1CLIENT,
      n_COGNOM2CLIENT,
      n_DESCRIPCIOPERSONA,
      n_DESCRIPCIOVIA,
      n_DIRECCIONUBICACIO,
      n_NUMEROUBICACIO,
      n_PISUBICACIO,
      n_PORTAUBICACIO,
      n_CODIPOSTAL,
      n_DESCRIPCIOLOCALITAT,
      n_DESCRIPCIOPROVINCIA,
      n_DESCRIPCIOPAIS
FROM CLIENT,VIA,UBICACIO,LOCALITAT,PROVINCIA,PAIS,PERSONA
WHERE CLIENT.DNICLIENT=n_dni
AND CLIENT.IDTIPOCLIENT=PERSONA.IDPERSONA
AND CLIENT.IDUBICACLIENT=UBICACIO.IDUBICA
AND UBICACIO.IDVIAUBICACIO=VIA.IDVIA
AND UBICACIO.IDLOCALITATUBICACIO=LOCALITAT.IDLOCALITAT
AND LOCALITAT.IDPROVINCIALOCALITAT=PROVINCIA.IDPROVINCIA
AND PROVINCIA.IDPAISPROVINCIA=PAIS.IDPAIS;
DBMS_OUTPUT.ENABLE;
DBMS_OUTPUT.PUT_LINE(' Client DNI: '||n_DNICLIENT||' Consum mitja de:'
||n_comsumEnergiaMax||' Kw/h.');
DBMS_OUTPUT.PUT_LINE('Nom:    '||n_NOMCLIENT||'  Cognom1: '||n_COGNOM1CLIENT||
' Cognom2:' ||n_COGNOM2CLIENT);
DBMS_OUTPUT.PUT_LINE(' Tipus de Client: '||n_DESCRIPCIOPERSONA);
DBMS_OUTPUT.PUT_LINE(' Direccio: '||n_DESCRIPCIOVIA||' 
'||n_DIRECCIONUBICACIO||' num.'||n_NUMEROUBICACIO||
' pis '||n_PISUBICACIO||' porta '||n_PORTAUBICACIO);
DBMS_OUTPUT.PUT_LINE(' Codi postal:'||n_CODIPOSTAL);
DBMS_OUTPUT.PUT_LINE(' Localitat:  '||n_DESCRIPCIOLOCALITAT||
' Provincia '||n_DESCRIPCIOPROVINCIA );
DBMS_OUTPUT.PUT_LINE(' Pais:       '||n_DESCRIPCIOPAIS);
DBMS_OUTPUT.PUT_LINE(' ');
s_rsp := 'OK  Client DNI: '||n_dni||
        ' Consum mitja  '||n_comsumEnergiaMax||' Kw/h.';

FETCH C_MITJA_CLI INTO
n_comsumEnergiaMax,
n_dni,
n_contracte,
n_comptador;

pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  END LOOP;
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('Total clients: '||n_registres);
  DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
CLOSE C_MITJA_CLI;

COMMIT;
EXCEPTION
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi-----------------------------------------
         s_rsp := 'Error: ' || SQLCODE || SUBSTR(SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi-----------------------------------------
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' '); 
      DBMS_OUTPUT.put_line (s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK; 

END PRC_ALTA_E_7;

END "GESTION_E_7";
