CREATE OR REPLACE
PACKAGE BODY          "GESTION_ESTAT" AS
  c_procesLog	   LOG_TFC.procesLog%TYPE;	
  c_dataHoraLog    LOG_TFC.dataHoraLog%TYPE;
  c_entradaLog     LOG_TFC.entradaLog%TYPE;	
  c_sortidaLog     LOG_TFC.sortidaLog%TYPE;
  s_rsp	           LOG_TFC.rspLog%TYPE; 
  n_registres  NUMBER;
  s_sql VARCHAR2 (2000);
  
  n_descripcioEstat ESTAT.DESCRIPCIOESTAT%TYPE;
  n_idEstat   ESTAT.IDESTAT%TYPE;
  n_NUM_ERR NUMBER(10);
  sortida varchar2(500):=''; 
  e_estat     EXCEPTION;
--------------------------------------------------------------
-- create procedure for table "LOG_TFC i ESTAT"
   procedure PRC_ALTA_ESTAT(
    p_descripcioEstat in ESTAT.DESCRIPCIOESTAT%TYPE,
    s_rsp out NOCOPY VARCHAR2) 
   AS
 
   BEGIN
    c_procesLog := 'PRC_ALTA_ESTAT';
    c_dataHoraLog := SYSDATE;
    c_entradaLog :='Decripcio Estat: ' || p_descripcioEstat;
       DBMS_OUTPUT.ENABLE;
       DBMS_OUTPUT.PUT_LINE(' ');
       DBMS_OUTPUT.PUT_LINE('ALTA DE ESTAT O SITUACIO');
     DBMS_OUTPUT.PUT_LINE('______________________');
          DBMS_OUTPUT.PUT_LINE('Descripcio: '|| p_descripcioEstat);
    c_sortidalog := 's_rsp';   
    If (p_descripcioEstat IS NULL) then
          DBMS_OUTPUT.ENABLE;
          DBMS_OUTPUT.PUT_LINE('ALTA_ESTAT: '); 
           s_rsp := 'Falta especificar estat';
          DBMS_OUTPUT.PUT_LINE(s_rsp);           
          RAISE e_estat;
     END IF;
      -- Comprovem si existeix el estat  donar d'alta
         SELECT COUNT (*)INTO n_registres 
            FROM ESTAT 
            WHERE descripcioEstat = p_descripcioEstat;
      If n_registres=0 then
          -- El donem d'alta a la estat          
            INSERT INTO ESTAT(descripcioEstat) 
            VALUES(p_descripcioEstat);
            --Gravem en la taula log-----------------------------------------------------
           DBMS_OUTPUT.ENABLE;
           DBMS_OUTPUT.PUT_LINE('Insertat estat: '||p_descripcioEstat);
                DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
            s_rsp :='Ok: Insertat estat: '||p_descripcioEstat;
            pkg_general.gravar_log_procedure(c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
            DBMS_OUTPUT.PUT_LINE(s_rsp);
          ELSE
          DBMS_OUTPUT.ENABLE;
          DBMS_OUTPUT.PUT_LINE('ALTA_ESTAT:  ');           
          s_rsp := 'DESCRICIO Estat  duplicat';
          DBMS_OUTPUT.PUT_LINE(s_rsp);
          RAISE e_estat;
      END IF;
   COMMIT;
EXCEPTION
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         s_rsp := 'Error: ' || SQLCODE || SUBSTR (SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' '); 
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;

   end PRC_ALTA_ESTAT;
   
 PROCEDURE PRC_MODIFICAR_ESTAT(
/********************************************************************************
   NOM:         PRC_MODIFICAR_PAIS
   DESCRIPCIÓ:
                Procediment encarregat de modificar les dades d'un pais. 
                Les dades es modificaran en la taula persona i el identificador de 
                Via apuntarà a la clau primaria del contacte de la taula Pais.
********************************************************************************/  
       p_descripcioEstat in ESTAT.DESCRIPCIOESTAT%TYPE,
       p_idEstat in ESTAT.IDESTAT%TYPE,
        s_rsp out NOCOPY VARCHAR2) 
   AS
 
   BEGIN
    c_procesLog := 'PRC_MODIFICAR_ESTAT';
    c_dataHoraLog := SYSDATE;
    c_entradaLog :='Decripcio Estat: ' || p_descripcioEstat;
     DBMS_OUTPUT.ENABLE;
     DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE('MODIFICAR ESTAT');
     DBMS_OUTPUT.PUT_LINE('______________________');
    c_sortidalog := 's_rsp';
    -- Comprovació del identificador Estat-----
          
      If  (p_descripcioEstat IS NULL) THEN
          DBMS_OUTPUT.ENABLE;
          DBMS_OUTPUT.PUT_LINE('MODIFICAR_ESTAT: ');
   	   s_rsp := 'Falta especificar el Estat';
            DBMS_OUTPUT.PUT_LINE(s_rsp); 
           RAISE e_estat;
        ELSE
          
            SELECT COUNT (*)INTO n_registres 
            FROM ESTAT 
            WHERE DESCRIPCIOESTAT= p_descripcioEstat;
            
           If n_registres=0 then
            DBMS_OUTPUT.ENABLE;
            DBMS_OUTPUT.PUT_LINE('MODIFICAR_ESTAT: ');           
              s_rsp := 'ESTAT no existeix a la BBDD';
              DBMS_OUTPUT.PUT_LINE(s_rsp);
               RAISE e_estat;
            END IF;
 
         -- recuperem el codi ESTAT
   SELECT ESTAT.IDESTAT, ESTAT.DESCRIPCIOESTAT INTO n_idEstat,n_descripcioEstat
   FROM ESTAT
   WHERE ESTAT.IDESTAT=ESTAT.IDESTAT;

        --s_sql :='UPDATE ESTAT SET';
         
         s_sql := 'UPDATE ESTAT SET ';
      
     

         -- Construirem la sentencia UPDATE segons si hi ha valor en els paràmetres-
             IF p_descripcioEstat IS NOT NULL THEN
                     -- Modifiquem el descripcio ESTAT
                     s_sql := s_sql || 'DESCRIPCIOESTAT=''' || p_descripcioEstat || ''',';
                     --s_sql := s_sql || ' Codi Estat=''' || p_idEstat || ''',';
               END IF;
            
                               
               -- Eliminem la coma final de la sentencia SQL
               s_sql := SUBSTR (s_sql, 1, LENGTH (s_sql) - 1);
               -- Afegim a la sentencia la condició del WHERE
               s_sql := s_sql || ' WHERE idEstat=''' || n_idEstat || '''';

      
               EXECUTE IMMEDIATE s_sql;
      
               IF SQL%ROWCOUNT = 0
               THEN
                  --L'error serà que ESTAT ja el tenim en la taula i no admet duplicats--
                  DBMS_OUTPUT.ENABLE;
                  DBMS_OUTPUT.PUT_LINE('MODIFICAR_ESTAT:  ');                  
                  s_rsp := 'Actualització no realitzada';
                  RAISE e_estat;
               ELSE
                  DBMS_OUTPUT.ENABLE;
                  DBMS_OUTPUT.PUT_LINE('Modificacio feta de ESTAT: codi: '||n_idEstat||
                 ' Descripcio: '||p_descripcioEstat );
                 DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
                  s_rsp := 'OK Modificacio feta de ESTAT: codi: '||n_idEstat||
                 ' Descripcio: '||p_descripcioEstat ;
                 pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
               END IF;
         END IF;
  COMMIT;
EXCEPTION
   WHEN DUP_VAL_ON_INDEX THEN
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' ');
      s_rsp := 'Error: Estat duplicada. No es poden fer les modificacions';
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;      
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         -----------------------------------------
         s_rsp := 'Error: ' || SQLCODE || SUBSTR(SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         -----------------------------------------
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' ');
      DBMS_OUTPUT.put_line (s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;
END PRC_MODIFICAR_ESTAT;

PROCEDURE PRC_CONSULTA_ESTAT(
    s_rsp out NOCOPY VARCHAR2)
AS
CURSOR C_ESTAT IS
SELECT ESTAT.IDESTAT, ESTAT.DESCRIPCIOESTAT
FROM ESTAT
WHERE ESTAT.IDESTAT=ESTAT.IDESTAT;

BEGIN 
   c_procesLog := 'PRC_CONSULTA_ESTAT';
    c_dataHoraLog := SYSDATE;
     c_entradaLog :='CONSULTA ESTAT O SITUACIO';
    c_sortidalog := 's_rsp';
    
    SELECT COUNT(ESTAT.IDESTAT) INTO n_registres
    FROM ESTAT
    WHERE ESTAT.IDESTAT=ESTAT.IDESTAT;
        
    IF n_registres=0 THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('CONSULTA ESTAT: ');
    s_rsp := 'No hi han ESTATS donades dalta ';
    DBMS_OUTPUT.PUT_LINE(s_rsp);
    RAISE e_estat;
    END IF;
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('           CONSULTA DE ESTATS            ');
    DBMS_OUTPUT.PUT_LINE('-----------------------------------------------------');
    OPEN C_ESTAT;
               FETCH C_ESTAT INTO n_idEstat,n_descripcioEstat;
  WHILE C_ESTAT%FOUND LOOP
   DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE(
 '   Codi Estat '
 || n_idEstat
 ||' Descripcio '
 || n_descripcioEstat);
  s_rsp := 'OK  CONSULTA ESTATS
  Codi Estat:  '
 || n_idEstat
 ||' Descripcio: '
 ||n_descripcioEstat;
 pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  FETCH C_ESTAT INTO n_idEstat,n_descripcioEstat;
  END LOOP;
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('Total estats: '||n_registres);
  DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
CLOSE C_ESTAT;
COMMIT;
 EXCEPTION
	
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi-----------------------------------------
         s_rsp := 'Error: ' || SQLCODE || SUBSTR(SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi-----------------------------------------
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' '); 
      DBMS_OUTPUT.put_line (s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;
  
END PRC_CONSULTA_ESTAT;
END GESTION_ESTAT;