CREATE OR REPLACE
PACKAGE BODY          "GESTION_PAIS" AS
  c_procesLog	   LOG_TFC.PROCESLOG%TYPE;	
  c_dataHoraLog    LOG_TFC.DATAHORALOG%TYPE;
  c_entradaLog     LOG_TFC.ENTRADALOG%TYPE;	
  c_sortidaLog     LOG_TFC.SORTIDALOG%TYPE;
  s_rsp	           LOG_TFC.RSPLOG%TYPE; 
  n_registres  NUMBER;
  s_sql VARCHAR2 (2000);
  
  n_descripcioPais PAIS.descripcioPais%TYPE;
  n_codiPais PAIS.codiPais%TYPE;
  n_idPais   PAIS.IDPAIS%TYPE;
  n_NUM_ERR NUMBER(10);
  sortida varchar2(500):=''; 
  e_pais     EXCEPTION;
--------------------------------------------------------------
-- create procedure for table "LOG_TFC i PAIS"
/*****************************************************************************
Autor: Eduard Monzonis Hierro                                   UOC
18/05/2012                                             TFC: CONTROL ENERGIA.
                  PROCEDIEMENT GESTIO PAIS
DESCRIPCIO:
La funcionalitat d'aquest es donar d'alta el paisos que necesita el sitema per
gestionar PROVICIES, LOCALITAT i les UBICACIONS que es on hi han les dades
de les direccions del CLIENTS, FABRICANTS, COMPTADORS, CENTRALS
*******************************************************************************/
   procedure PRC_ALTA_PAIS(
    p_descripcioPais in PAIS.descripcioPais%TYPE,
    p_codiPais in PAIS.codiPais%TYPE,
    s_rsp out NOCOPY VARCHAR2) 
   AS
 
   BEGIN
    c_procesLog := 'PRC_ALTA_PAIS';
    c_dataHoraLog := SYSDATE;
    c_entradaLog :='Decripcio Pais: ' || p_descripcioPais;
    DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE('     ALTA PAIS     ');
    DBMS_OUTPUT.PUT_LINE('_____________________________');
    DBMS_OUTPUT.PUT_LINE(' Decripcio Pais: ' || p_descripcioPais||
    ' codi de Pais: '||p_codiPais); 
    c_sortidalog := 's_rsp';   
    If (p_descripcioPais IS NULL) then
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('ALTA_PAIS: '); 
      s_rsp := 'Falta especificar el Pas ';
      RAISE e_pais;
     END IF;
      -- Comprovem si existeix el pais a  donar d'alta
         SELECT COUNT (*)INTO n_registres 
            FROM PAIS 
            WHERE PAIS.descripcioPais = p_descripcioPais;
      If n_registres=0 then
          -- El donem d'alta  País          
            INSERT INTO PAIS(descripcioPais,codiPais) 
            VALUES(p_descripcioPais,p_codiPais);
            --Gravem en la taula log-----------------------------------------------------
           DBMS_OUTPUT.ENABLE;
            DBMS_OUTPUT.PUT_LINE('Insertat Pas: '||p_descripcioPais||
            ' Codi ISO del Pas:  '||p_codiPais);
            DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
            s_rsp :='Ok: Insertada Pas: '||p_descripcioPais||
            ' Codi ISO del Pas:  '||p_codiPais;
            pkg_general.gravar_log_procedure(c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
            DBMS_OUTPUT.PUT_LINE(s_rsp);
          ELSE

            DBMS_OUTPUT.ENABLE;
            DBMS_OUTPUT.PUT_LINE('ALTA_PAIS: ');           
          s_rsp := 'DESCRICIO Pais  duplicat';
          DBMS_OUTPUT.PUT_LINE(s_rsp);
          RAISE e_pais;
      END IF;
   COMMIT;
EXCEPTION
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         s_rsp := 'Error: ' || SQLCODE || SUBSTR (SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         s_rsp := 'Error: ' || s_rsp;
      END IF;
            DBMS_OUTPUT.ENABLE;
            DBMS_OUTPUT.PUT_LINE(' '); 
            DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;

   end PRC_ALTA_PAIS;
   
 PROCEDURE PRC_MODIFICAR_PAIS(
/********************************************************************************
Autor: Eduard Monzonis Hierro                                   UOC
18/05/2012                                             TFC: CONTROL ENERGIA.
   NOM:         PRC_MODIFICAR_PAIS
   DESCRIPCIÓ:
                Procediment encarregat de modificar les dades d'un pais. 
                Les dades es modificaran en la taula persona i el identificador de 
                Via apuntarà a la clau primaria del contacte de la taula Pais.
********************************************************************************/  
       p_idPais IN PAIS.idPais%TYPE,
       p_descripcioPais in PAIS.descripcioPais%TYPE,
       p_codiPais in PAIS.codiPais%TYPE,
       s_rsp out NOCOPY VARCHAR2) 
   AS
 
   BEGIN
    c_procesLog := 'PRC_MODIFICAR_PAIS';
    c_dataHoraLog := SYSDATE;
    c_entradaLog :='Decripcio Pais: ' || p_descripcioPais||
                    ', Codi_Pais: ' || p_codiPais;
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE('      MODIFICAR UN PAS       ');
    DBMS_OUTPUT.PUT_LINE('______________________________');
    DBMS_OUTPUT.PUT_LINE('Decripcio Pais: ' || p_descripcioPais||
                    ', Codi_Pais: ' || p_codiPais);
    c_sortidalog := 's_rsp';
    -- Comprovació del identificador Pais-----
    IF p_descripcioPais IS NULL THEN
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('MODIFICAR UN PAS: '); 
      s_rsp := 'Falta especificar el pas a modificar';
      DBMS_OUTPUT.put_line(s_rsp);
        RAISE e_pais;
    END IF;
    SELECT PAIS.IDPAIS INTO n_registres 
    FROM PAIS 
    WHERE PAIS.DESCRIPCIOPAIS = p_descripcioPais;
    
    If n_registres=0 then
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('MODIFICAR_PAIS: ');           
      s_rsp := 'PAIS no existeix a la BBDD';
      DBMS_OUTPUT.PUT_LINE(s_rsp);
      RAISE e_pais;
    END IF;
    
    --CERQUEM EL PAIS
         -- recuperem el codi Pais
    SELECT PAIS.idPais INTO n_idPais
    FROM PAIS
    WHERE PAIS.DESCRIPCIOPAIS= p_descripcioPais;
       
   s_sql := 'UPDATE PAIS SET ';
 
-- Construirem la sentencia UPDATE segons si hi ha valor en els paràmetres-
   IF p_descripcioPais IS NOT NULL THEN
-- Modifiquem el descripcio pasis
      s_sql := s_sql || 'DESCRIPCIOPAIS=''' || p_descripcioPais || ''',';
  END IF;
    IF p_codiPais IS NOT NULL THEN
-- Modifiquem el codi país
     s_sql := s_sql || 'CODIPAIS=''' || p_codiPais || ''',';
   END IF;
 
-- Eliminem la coma final de la sentencia SQL
    s_sql := SUBSTR (s_sql, 1, LENGTH (s_sql) - 1);
-- Afegim a la sentencia la condició del WHERE
    s_sql := s_sql || ' WHERE IDPAIS=''' ||n_idPais|| '''';

  EXECUTE IMMEDIATE s_sql;
   IF SQL%ROWCOUNT = 0  THEN
--L'error serà que el la via ja el tenim en la taula i no admet duplicats--
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('MODIFICAR_PAIS: ');                  
      s_rsp := 'Actualitzacio no realitzada';
      RAISE e_pais;
    ELSE
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('Modificacio feta del Pas: codi: '||n_idPais||
                 ' Descripcio: '||p_descripcioPais||
                 ' codi ISO: '||p_codiPais);
                 DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
                  s_rsp := 'OKModificacio feta del Pas: codi: '||n_idPais||
                 ' Descripcio: '||p_descripcioPais||
                 ' codi ISO: '||p_codiPais;

      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
    END IF;

COMMIT;
EXCEPTION
   WHEN DUP_VAL_ON_INDEX THEN
            DBMS_OUTPUT.ENABLE;
            DBMS_OUTPUT.PUT_LINE(' MODIFICAR_PAIS:  ');   
      s_rsp := 'Error: Pais duplicada. No es poden fer les modificacions';
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;      
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         -----------------------------------------
         s_rsp := 'Error: ' || SQLCODE || SUBSTR(SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         -----------------------------------------
         s_rsp := 'Error: ' || s_rsp;
      END IF;
            DBMS_OUTPUT.ENABLE;
            DBMS_OUTPUT.PUT_LINE('  ');
      DBMS_OUTPUT.put_line (s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;
END PRC_MODIFICAR_PAIS;

/********************************************************************************
Autor: Eduard Monzonis Hierro                                   UOC
18/05/2012                                             TFC: CONTROL ENERGIA.
   NOM:         PRC_CONSULTAR_PAIS
   DESCRIPCIÓ:
                Procediment encarregat de consultar les dades d'un pais. 
                Les dades a consultar en la taula pais i el identificador de 
                pais apuntarà a la clau primaria del Pais de la taula Pais.
********************************************************************************/  
PROCEDURE PRC_CONSULTAR_PAIS(
     s_rsp out NOCOPY VARCHAR2)
AS

CURSOR C_PAIS IS
SELECT PAIS.IDPAIS,PAIS.DESCRIPCIOPAIS,
        PAIS.CODIPAIS
FROM PAIS
WHERE PAIS.IDPAIS=PAIS.IDPAIS;

BEGIN
  c_procesLog := 'PRC_CONSULTAR_PAIS';
    c_dataHoraLog := SYSDATE;
    c_entradaLog :='   CONSULTA PAISOS   ';
    c_sortidalog := 's_rsp';
-- Comprovem que p_descripcioPais no sigui NULL----------------------------------------------
    SELECT COUNT(*)INTO n_registres
    FROM PAIS
    WHERE PAIS.IDPAIS=PAIS.IDPAIS;
  IF n_registres=0 THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('CONSULTAR_PAIS: ');             
        s_rsp := 'No hi han paisos donats en alta.  ';
    DBMS_OUTPUT.PUT_LINE(s_rsp);
    RAISE e_pais;
  END IF;
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('           CONSULTA PAISOS            ');
  DBMS_OUTPUT.PUT_LINE('--------------------------------------');

OPEN C_PAIS;
  FETCH C_PAIS INTO n_idPais,n_descripcioPais,n_codiPais;
  WHILE C_PAIS%FOUND LOOP
   DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE(
 '   Codi Pais '
 ||n_idPais
 ||' Descripcio '
 || n_descripcioPais||
 ' codi ISO pais: '||n_codiPais);
  s_rsp := 'OK  CONSULTA DELS PAISOS
   Codi Pais '
 ||n_idPais
 ||' Descripcio '
 || n_descripcioPais||
 ' codi ISO pais: '||n_codiPais;
 
  FETCH C_PAIS INTO n_idPais,n_descripcioPais,n_codiPais;

  pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  
  END LOOP;
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('Total paisos donat en alta: '||n_registres);
  DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
CLOSE C_PAIS;


  COMMIT;
 EXCEPTION
	
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi-----------------------------------------
         s_rsp := 'Error: ' || SQLCODE || SUBSTR(SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi-----------------------------------------
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' ');  
      DBMS_OUTPUT.put_line (s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;
  
  END PRC_CONSULTAR_PAIS;
 END GESTION_PAIS;
