CREATE OR REPLACE
PACKAGE BODY          "GESTION_PERSONA" AS
  c_procesLog LOG_TFC.procesLog%TYPE;	
  c_dataHoraLog LOG_TFC.dataHoraLog%TYPE;
  c_entradaLog LOG_TFC.entradaLog%TYPE;	
  c_sortidaLog LOG_TFC.sortidaLog%TYPE;
  s_rsp LOG_TFC.rspLog%TYPE; 
  n_registres  NUMBER;
  s_sql VARCHAR2 (2000);
  
  n_descripcioPersona PERSONA.DESCRIPCIOPERSONA%TYPE;
  n_idPersona   PERSONA.IDPERSONA%TYPE;
  n_NUM_ERR NUMBER(10);
  sortida varchar2(500):=''; 
  e_persona     EXCEPTION;
--------------------------------------------------------------
-- create procedure for table "LOG_TFC i PERSONA"
/*************************************************************************
Autor: Eduard Monzonis Hierro                                   UOC
18/05/2012                                             TFC: CONTROL ENERGIA.
                  PROCEDIMENT DONAR ALTA PERSONA
DESCRIPCIO:
Es un procediement per poder donar d'alta els tipus de persones  que el seu
rol dins de sistema i el negoci forman part del conjunt de CLIENTS.
S'ha fet estandard pel motiu de que pugui ser reutilitzat per altres
entitats en cas de una millora del sistema que precisi el desenvolupament
de la fase de l'aplicació al usuari final.
************************************************************************/
   procedure PRC_ALTA_PERSONA(
    p_descripcioPersona in PERSONA.DESCRIPCIOPERSONA%TYPE,
    s_rsp out NOCOPY VARCHAR2) 
   AS
 
   BEGIN
    c_procesLog := 'PRC_ALTA_PERSONA';
    c_dataHoraLog := SYSDATE;
    c_entradaLog :='Decripcio Persona: ' || p_descripcioPersona;
    DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE('     CLASSE DE CLIENT     ');
     DBMS_OUTPUT.PUT_LINE('______________________');
    c_sortidalog := 's_rsp';   
    If (p_descripcioPersona IS NULL) then
           DBMS_OUTPUT.ENABLE;
           DBMS_OUTPUT.PUT_LINE('ALTA_PERSONA: ');
           s_rsp := 'Falta especificar persona';
          RAISE e_persona;
     END IF;
      -- Comprovem si existeix el NIF a  donar d'alta
         SELECT COUNT (*)INTO n_registres 
            FROM PERSONA 
            WHERE DESCRIPCIOPERSONA =p_descripcioPersona;
      If n_registres=0 then
          INSERT INTO PERSONA(descripcioPersona) 
            VALUES(p_descripcioPersona);
            --Gravem en la taula log-----------------------------------------------------
            DBMS_OUTPUT.ENABLE;
              DBMS_OUTPUT.PUT_LINE('Insertada Classe de client: '||p_descripcioPersona);
              DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
            s_rsp :='Ok: En la Taula PERSONA Insertada persona o classe de client:  '|| p_descripcioPersona;
            pkg_general.gravar_log_procedure(c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
            DBMS_OUTPUT.PUT_LINE(s_rsp);
          ELSE
           DBMS_OUTPUT.ENABLE;
           DBMS_OUTPUT.PUT_LINE('ALTA_PERSONA: ');          
          s_rsp := 'DESCRICIO Persona  duplicat';
          DBMS_OUTPUT.PUT_LINE(s_rsp);
          RAISE e_persona;
      END IF;
   COMMIT;
EXCEPTION
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         s_rsp := 'Error: ' || SQLCODE || SUBSTR (SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' ');
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;

   end PRC_ALTA_PERSONA;
   
 PROCEDURE PRC_MODIFICAR_PERSONA(
/********************************************************************************
Autor: Eduard Monzonis Hierro                                   UOC
18/05/2012                                             TFC: CONTROL ENERGIA. 
   NOM:         PRC_MODIFICAR_PERSONA
   DESCRIPCIÓ:
                Procediment encarregat de modificar les dades d'un pais. 
                Les dades es modificaran en la taula persona i el identificador de 
                Via apuntarà a la clau primaria del contacte de la taula Pais.
********************************************************************************/  
       p_descripcioPersona in PERSONA.DESCRIPCIOPERSONA%TYPE,
       p_idPersona in PERSONA.IDPERSONA%TYPE,
        s_rsp out NOCOPY VARCHAR2) 
   AS
 
   BEGIN
    c_procesLog := 'PRC_MODIFICAR_PERSONA';
    c_dataHoraLog := SYSDATE;
    c_entradaLog :='Decripcio Persona: ' || p_descripcioPersona;
         DBMS_OUTPUT.PUT_LINE(' ');
     DBMS_OUTPUT.PUT_LINE('  MODIFICAR CLASSE DE CLIENT  ');
     DBMS_OUTPUT.PUT_LINE('______________________________');
    DBMS_OUTPUT.PUT_LINE('Nom de la Via Publica: '|| p_descripcioPersona);
    c_sortidalog := 's_rsp';
    -- Comprovació del identificador CLASSE CLIENT-----
          
      If  (p_descripcioPersona IS NULL) THEN
          DBMS_OUTPUT.ENABLE;
          DBMS_OUTPUT.PUT_LINE('MODIFICAR_PERSONA: '); 
   	   s_rsp := 'Falta especificar el persona';
           DBMS_OUTPUT.PUT_LINE(s_rsp);
           RAISE e_persona;
        ELSE
          
            SELECT COUNT (*)INTO n_registres 
            FROM PERSONA 
            WHERE DESCRIPCIOPERSONA = p_descripcioPersona;
           If n_registres=0 then
              DBMS_OUTPUT.ENABLE;
              DBMS_OUTPUT.PUT_LINE('MODIFICAR_PERSONA: ');            
              s_rsp := 'PERSONA no existeix a la BBDD';
              DBMS_OUTPUT.PUT_LINE(s_rsp);
               RAISE e_persona;
            END IF;

         -- recuperem el codi de la persona
  SELECT PERSONA.IDPERSONA,PERSONA.DESCRIPCIOPERSONA INTO n_idPersona,n_descripcioPersona
  FROM PERSONA
  WHERE DESCRIPCIOPERSONA=p_descripcioPersona;
              
        --s_sql :='UPDATE ESTAT SET';
         
         s_sql := 'UPDATE PERSONA SET ';
      
     

         -- Construirem la sentencia UPDATE segons si hi ha valor en els paràmetres-
             IF p_descripcioPersona IS NOT NULL THEN
                     -- Modifiquem el descripcio persona
          s_sql := s_sql || 'descripcioPersona=''' || p_descripcioPersona || ''',';
          END IF;
                               
               -- Eliminem la coma final de la sentencia SQL
               s_sql := SUBSTR (s_sql, 1, LENGTH (s_sql) - 1);
               -- Afegim a la sentencia la condició del WHERE
               s_sql := s_sql || ' WHERE idPersona=''' || n_idPersona|| '''';

      
               EXECUTE IMMEDIATE s_sql;
      
               IF SQL%ROWCOUNT = 0
               THEN
 --L'error serà que  la PERSONA ja el tenim en la taula i no admet duplicats--
                  DBMS_OUTPUT.ENABLE;
                  DBMS_OUTPUT.PUT_LINE('MODIFICAR_PERSONA: ');
                  s_rsp := 'Actualització no realitzada';
                  DBMS_OUTPUT.PUT_LINE(s_rsp);
                  RAISE e_persona;  
               ELSE
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('Modificacio feta de la Classe de Client
      : codi: '|| n_idPersona||
    ' Descripcio: '|| p_descripcioPersona);
     DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
     s_rsp := 'OK Modificacio feta de la PERSONA: codi: '||n_idPersona||
             ' Descripcio: '||p_descripcioPersona;
     pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  END IF;
END IF;
COMMIT;
EXCEPTION
   WHEN DUP_VAL_ON_INDEX THEN
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' '); 
      s_rsp := 'Error: Pais duplicada. No es poden fer les modificacions';
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;      
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         -----------------------------------------
         s_rsp := 'Error: ' || SQLCODE || SUBSTR(SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         -----------------------------------------
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' '); 
      DBMS_OUTPUT.put_line (s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;  
  END PRC_MODIFICAR_PERSONA;
  
/********************************************************************************
Autor: Eduard Monzonis Hierro                                   UOC
18/05/2012                                             TFC: CONTROL ENERGIA.
   NOM:         CONSULTAR_PERSONA
   DESCRIPCIÓ:
                Procediment encarregat de consultar les dades d'una persona. 
                Les dades a consultar en la taula persona i el identificador de 
                persona apuntarà a la clau primaria  de la taula Persona.
********************************************************************************/  

 procedure PRC_CONSULTAR_PERSONA(
    s_rsp out NOCOPY VARCHAR2)
AS

  CURSOR C_PERSONA IS
  SELECT PERSONA.IDPERSONA,PERSONA.DESCRIPCIOPERSONA
  FROM PERSONA
  WHERE PERSONA.IDPERSONA=PERSONA.IDPERSONA;
  e_persona EXCEPTION;
BEGIN
   c_procesLog := 'PRC_CONSULTA_PERSONA';
    c_dataHoraLog := SYSDATE;
     c_entradaLog :='CONSULTA DE CLASSE DE CLIENT';
    c_sortidalog := 's_rsp';
-- Comprovem que p_descripcioPersona no sigui NULL----------------------------------------------
     --1er. Comprovem que existeixi la persona-------------------------------
      SELECT COUNT (*) INTO n_registres 
      FROM PERSONA
      WHERE  PERSONA.IDPERSONA=PERSONA.IDPERSONA;
        
    If n_registres=0 then
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('CONSULTAR_PERSONA: '); 
    s_rsp := 'Classe de Client  no existent a la BBDD';
    DBMS_OUTPUT.PUT_LINE(s_rsp);
    RAISE e_persona;
    END IF;
    
DBMS_OUTPUT.ENABLE;
DBMS_OUTPUT.PUT_LINE('           CONSULTA CLASSR DE CLIENT           ');
DBMS_OUTPUT.PUT_LINE('-----------------------------------------------------');
-- Recuperem les dades de la taula PERSONA--------------------------

  OPEN C_PERSONA;
      FETCH C_PERSONA INTO n_idPersona ,n_descripcioPersona;
  WHILE C_PERSONA%FOUND LOOP
   DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE(
 '   Codi Classe Client '
 ||n_idPersona
 ||' Descripcio '
 || n_descripcioPersona);
  s_rsp := 'OK  CONSULTA PERSONA
  Codi Persona:  '
 ||n_idPersona
 ||' Descripcio: '
 || n_descripcioPersona;
 
  FETCH C_PERSONA INTO n_idPersona,n_descripcioPersona;

  pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  
  END LOOP;
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('Total Classes de Clients: '||n_registres);
  DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
CLOSE C_PERSONA;
COMMIT;
 EXCEPTION
	
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi-----------------------------------------
         s_rsp := 'Error: ' || SQLCODE || SUBSTR(SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi-----------------------------------------
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' '); 
      DBMS_OUTPUT.put_line (s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;
  
  END PRC_CONSULTAR_PERSONA;
END "GESTION_PERSONA";
