CREATE OR REPLACE
PACKAGE BODY          "GESTION_PROVINCIA" AS
  c_procesLog	 LOG_TFC.procesLog%TYPE;	
  c_dataHoraLog    LOG_TFC.dataHoraLog%TYPE;
  c_entradaLog     LOG_TFC.entradaLog%TYPE;	
  c_sortidaLog     LOG_TFC.sortidaLog%TYPE;
  s_rsp	       LOG_TFC.rspLog%TYPE; 
  n_registres  NUMBER;
  s_sql VARCHAR2 (2000);
  n_descripcioProvincia PROVINCIA.DESCRIPCIOPROVINCIA%TYPE;
  n_idPaisProvincia PROVINCIA.IDPAISPROVINCIA%TYPE;
  n_idProvincia  PROVINCIA.IDPROVINCIA%TYPE;
  n_NUM_ERR NUMBER(10);
  sortida varchar2(500):=''; 
  e_provincia     EXCEPTION;
  --------------------------------------------------------------
-- create procedure for table "LOG_TFC i PROVINCIA"
/********************************************************************************
Autor: Eduard Monzonis Hierro                                   UOC
18/05/2012                                             TFC: CONTROL ENERGIA.
   NOM:         PRC_ALTA_PROVINCIA
   DESCRIPCIÓ:
                Procediment encarregat donar d'alta provincias onn el id de pais
                direcciona a la taula PAIS
********************************************************************************/   
PROCEDURE PRC_ALTA_PROVINCIA(
    p_descripcioProvincia in PROVINCIA.DESCRIPCIOPROVINCIA%TYPE,
    p_idPaisProvincia in PROVINCIA.IDPAISPROVINCIA%TYPE,
    s_rsp out NOCOPY VARCHAR2)
    AS
    BEGIN
    c_procesLog := 'PRC_ALTA_PROVINCIA';
    c_dataHoraLog := SYSDATE;
    c_procesLog := 'PRC_ALTA_PROVINCIA';
    c_dataHoraLog := SYSDATE;
    c_entradaLog :='Decripcio Via: ' ||p_descripcioProvincia;
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE('   ALTA PROVINCIA     ');
    DBMS_OUTPUT.PUT_LINE('______________________');
    DBMS_OUTPUT.PUT_LINE('Provincia: '||p_descripcioProvincia||
    ' codi Pais_ '||p_idPaisProvincia);
    c_sortidalog := 's_rsp';   
    
    If (p_descripcioProvincia IS NULL) OR (p_idPaisProvincia IS NULL ) then
           DBMS_OUTPUT.ENABLE;
           DBMS_OUTPUT.PUT_LINE(' ALTA PROVINCIA: ');
           s_rsp := 'Falta especificar la provincia i el codi de Pais ';
           DBMS_OUTPUT.PUT_LINE(s_rsp);
          RAISE  e_provincia;
     END IF;
-- Comprovem si existeix el la provincia a  donar d'alta
         SELECT COUNT (*)INTO n_registres 
            FROM PROVINCIA
            WHERE DESCRIPCIOPROVINCIA =p_descripcioProvincia
            AND PROVINCIA.IDPAISPROVINCIA=p_idPaisProvincia;
            
          If n_registres=0 then
          -- El donem d'alta Provincia          
            INSERT INTO PROVINCIA(PROVINCIA.DESCRIPCIOPROVINCIA,PROVINCIA.IDPAISPROVINCIA) 
            VALUES(p_descripcioProvincia,p_idPaisProvincia);
            --Gravem en la taula log-----------------------------------------------------
          DBMS_OUTPUT.ENABLE;
          DBMS_OUTPUT.PUT_LINE('Insertada la Provincia: '||p_descripcioProvincia||
          ' amb el codi de Pais: ' ||p_idPaisProvincia);
          DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
          s_rsp :='Ok: Insertada la Provincia: '||p_descripcioProvincia||
          ' amb el codi de Pais: ' ||p_idPaisProvincia;
          pkg_general.gravar_log_procedure(c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
            DBMS_OUTPUT.PUT_LINE(s_rsp);
      ELSE
          DBMS_OUTPUT.ENABLE;
          DBMS_OUTPUT.PUT_LINE('ALTA PROVINCIA: ');
          s_rsp := 'Dades de la provincia duplicades.  ';
          DBMS_OUTPUT.PUT_LINE(s_rsp);
          RAISE e_provincia;
      END IF;
COMMIT;
   EXCEPTION
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         s_rsp := 'Error: ' || SQLCODE || SUBSTR (SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' ');
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;

END PRC_ALTA_PROVINCIA;
/********************************************************************************
 Autor: Eduard Monzonis Hierro                                   UOC
18/05/2012                                             TFC: CONTROL ENERGIA.
   NOM:         PRC_MODIFICAR_PROVINCIA
   DESCRIPCIÓ:
                Procediment encarregat donar de modificar una o vaies provincies
              
********************************************************************************/    
PROCEDURE PRC_MODIFICAR_PROVINCIA(
    p_idProvincia in PROVINCIA.IDPROVINCIA%TYPE,
    p_descripcioProvincia in PROVINCIA.DESCRIPCIOPROVINCIA%TYPE,
    p_idPaisProvincia in PROVINCIA.IDPAISPROVINCIA%TYPE,
    s_rsp out NOCOPY VARCHAR2)
    AS
    BEGIN
    c_procesLog := 'PRC_MODIFICAR_PROVINCIA';
    c_dataHoraLog := SYSDATE;
    c_entradaLog :='Id Provincia: ' ||p_idProvincia||
              ', Decripcio Provincia: ' ||p_descripcioProvincia ||
              ', Codi Pais: ' || p_idPaisProvincia;
    DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE('  MODIFICAR UNA PROVINCIA   ');
    DBMS_OUTPUT.PUT_LINE('____________________________');
    DBMS_OUTPUT.PUT_LINE('Codi Provincia: ' ||p_idProvincia||
              ', Decripcio Provincia: ' ||p_descripcioProvincia ||
              ', Codi Pais: ' || p_idPaisProvincia);
    c_sortidalog := 's_rsp';

    -- Comprovació del identificador Provincia-----
    IF p_idProvincia IS NULL THEN
           DBMS_OUTPUT.ENABLE;
           DBMS_OUTPUT.PUT_LINE('MODIFICAR UNA PROVINCIA : ');    
           s_rsp := 'Falta especificar el codi Provincia';
           DBMS_OUTPUT.put_line(s_rsp);
        RAISE e_provincia;
    END IF; 
    If  p_descripcioProvincia IS NULL THEN
           DBMS_OUTPUT.ENABLE;
           DBMS_OUTPUT.PUT_LINE('MODIFICAR UNA PROVINCIA: ');      
   	   s_rsp := 'Falta especificar la Provincia';
           DBMS_OUTPUT.put_line(s_rsp);
           RAISE e_provincia;
    END IF;
    If   p_idPaisProvincia IS NULL THEN
           DBMS_OUTPUT.ENABLE;
           DBMS_OUTPUT.PUT_LINE('MODIFICAR UNA PROVINCIA: ');      
   	   s_rsp := 'Falta especificar el codi del Pais. ';
           DBMS_OUTPUT.put_line(s_rsp);
           RAISE e_provincia;
    END IF;    
 SELECT COUNT (*)INTO n_registres 
 FROM PROVINCIA
 WHERE PROVINCIA.IDPROVINCIA = p_idProvincia
 AND PROVINCIA.IDPAISPROVINCIA=p_idPaisProvincia;
 
  If n_registres=0 then
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('MODIFICAR UNA PROVINCIA: ');           
    s_rsp := 'PROVINCIA no existeix a la BBDD';
    DBMS_OUTPUT.PUT_LINE(s_rsp);
    RAISE e_provincia;
   END IF;
        
-- recuperem el codi Provincia
  SELECT PROVINCIA.IDPROVINCIA INTO n_idProvincia
  FROM PROVINCIA
  WHERE PROVINCIA.IDPROVINCIA = p_idProvincia
  AND PROVINCIA.IDPAISPROVINCIA=p_idPaisProvincia;
 
 s_sql := 'UPDATE PROVINCIA SET ';
-- Construirem la sentencia UPDATE segons si hi ha valor en els paràmetres-
 IF p_descripcioProvincia IS NOT NULL THEN
-- Modifiquem el descripcio PROVINCIA
  s_sql := s_sql || 'DESCRIPCIOPROVINCIA=''' || p_descripcioProvincia || ''',';
 END IF;
 IF p_descripcioProvincia IS NOT NULL THEN
  s_sql := s_sql || 'IDPAISPROVINCIA=''' || p_idPaisProvincia || ''',';
 END IF;
-- Eliminem la coma final de la sentencia SQL
 s_sql := SUBSTR (s_sql, 1, LENGTH (s_sql) - 1);
-- Afegim a la sentencia la condició del WHERE
 s_sql := s_sql || ' WHERE IDPROVINCIA=''' || n_idProvincia|| '''';

  EXECUTE IMMEDIATE s_sql;
  IF SQL%ROWCOUNT = 0  THEN
--L'error serà que el la via ja el tenim en la taula i no admet duplicats--
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('MODIFICAR_PROVINCIA:  ');
      s_rsp := 'Actualitzacio no realitzada';
      RAISE e_provincia;
    ELSE
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('Modificacio de la Provincia
      feta satisfactoriament : codi Provincia: '||n_idProvincia||
                 ' Descripcio: ' ||p_idPaisProvincia ||
                 ' codi del Pais: '||p_idPaisProvincia );
      DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
    END IF;
COMMIT;
EXCEPTION
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         s_rsp := 'Error: ' || SQLCODE || SUBSTR (SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         s_rsp := 'Error: ' || s_rsp;
      END IF;
           DBMS_OUTPUT.ENABLE;
           DBMS_OUTPUT.PUT_LINE(' ');
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;
END PRC_MODIFICAR_PROVINCIA;

/********************************************************************************
 Autor: Eduard Monzonis Hierro                                   UOC
18/05/2012                                             TFC: CONTROL ENERGIA.
   NOM:         CONSULTA_PROVINCIA
   DESCRIPCIÓ:
                Procediment encarregat de consultar les dades d'una Provincia. 
                Les dades a consultar en la taula Provincia i el identificador de 
                Provincia apuntarà a la clau primaria  de la taula Pais.
********************************************************************************/      
PROCEDURE PRC_CONSULTA_UNA_PROVINCIA(
  p_descripcioProvincia in PROVINCIA.DESCRIPCIOPROVINCIA%TYPE,
    s_rsp out NOCOPY VARCHAR2)
AS
n_descripcioPais  PAIS.DESCRIPCIOPAIS%TYPE;
n_codiPais PAIS.CODIPAIS%TYPE;
BEGIN
 c_procesLog := 'PRC_CONSULTA_PROVINCIA';
    c_dataHoraLog := SYSDATE;
    c_entradaLog :=' Decripcio Provincia: ' ||p_descripcioProvincia;
    DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE('  CONSULTA D''UNA PROVINCIA ');
    DBMS_OUTPUT.PUT_LINE('____________________________');
    DBMS_OUTPUT.PUT_LINE('Decripcio Provincia: ' ||p_descripcioProvincia);
    c_sortidalog := 's_rsp';
 -- Comprovem que p_descripcioProvincia  no sigui NULL----------------------------------------------
      If  p_descripcioProvincia   IS NULL then
           DBMS_OUTPUT.ENABLE;
           DBMS_OUTPUT.PUT_LINE('CONSULTA D''UNA PROVINCIA: ');
   	   s_rsp := 'Falta especificar Provincia';
           DBMS_OUTPUT.put_line(s_rsp);
 	     RAISE  e_provincia;
      ELSE
  --1er. Comprovem que existeixi la Provincia-------------------------------
          
     SELECT COUNT (*)INTO n_registres 
     FROM PROVINCIA
     WHERE PROVINCIA.IDPROVINCIA =PROVINCIA.IDPROVINCIA
     AND PROVINCIA.DESCRIPCIOPROVINCIA=p_descripcioProvincia;        
      
  If n_registres=0 then
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('CONSULTA D''UNA PROVINCIA: ');
    s_rsp := 'PROVINCIA no existent a la BBDD';
    DBMS_OUTPUT.PUT_LINE(s_rsp);
    RAISE  e_provincia;
  END IF;
        -- Recuperem les dades de la taula PROVINCIA--------------------------
   SELECT PROVINCIA.IDPROVINCIA,
      PROVINCIA.DESCRIPCIOPROVINCIA,
      PAIS.DESCRIPCIOPAIS,
      PAIS.CODIPAIS INTO n_idProvincia,n_descripcioProvincia,
      n_descripcioPais,n_codiPais
      FROM PROVINCIA, PAIS
      WHERE  PROVINCIA.DESCRIPCIOPROVINCIA= p_descripcioProvincia
      AND PROVINCIA.IDPAISPROVINCIA=PAIS.IDPAIS;

      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('Consulta de la provincia: codi: '||n_idProvincia||
                 ' Descripcio: '||n_descripcioProvincia||
                 ' Pais: '||n_descripcioPais||
                 ' codi Pais ISO: '||n_codiPais);
      DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
      s_rsp := 'OK Consulta de la provincia: codi: '||n_idProvincia||
                 ' Descripcio: '||n_descripcioProvincia||
                 ' Pais: '||n_descripcioPais||
                 ' codi Pais ISO: '||n_codiPais;
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
    END IF;
COMMIT;
EXCEPTION
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         s_rsp := 'Error: ' || SQLCODE || SUBSTR (SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' ');
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;
end PRC_CONSULTA_UNA_PROVINCIA;

-- LLISTAT DE PROVINCIES AMB PAIS
PROCEDURE PRC_CONSULTA_PROVINCIA(
    s_rsp out NOCOPY VARCHAR2)
AS
n_descripcioPais  PAIS.DESCRIPCIOPAIS%TYPE;
n_codiPais PAIS.CODIPAIS%TYPE;
CURSOR C_PROVINCIA IS
 SELECT PROVINCIA.IDPROVINCIA,
      PROVINCIA.DESCRIPCIOPROVINCIA,
      PAIS.DESCRIPCIOPAIS,
      PAIS.CODIPAIS     
      FROM PROVINCIA, PAIS
      WHERE   PROVINCIA.IDPAISPROVINCIA=PAIS.IDPAIS;

BEGIN
    c_procesLog := 'PRC_CONSULTA_PROVINCIES';
    c_dataHoraLog := SYSDATE;
    c_entradaLog :='CONSULTA PROVINCIAS';
    c_sortidalog := 's_rsp';
    
  SELECT COUNT (*)  INTO n_registres
  FROM PROVINCIA
  WHERE PROVINCIA.IDPROVINCIA= PROVINCIA.IDPROVINCIA;
  
 IF n_registres=0 THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('CONSULTA de PROVINCIES: ');
    s_rsp := 'No hi han provinicies donades dalta ';
    DBMS_OUTPUT.PUT_LINE(s_rsp);
    RAISE e_provincia;
 END IF;
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('           CONSULTA DE LES PROVINCIES               ');
    DBMS_OUTPUT.PUT_LINE('-----------------------------------------------------');
  OPEN C_PROVINCIA;
   FETCH C_PROVINCIA INTO n_idProvincia,n_descripcioProvincia,n_descripcioPais,n_codiPais;
  WHILE C_PROVINCIA%FOUND LOOP
   DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE(
 '   Codi Provincia '
 || n_idProvincia||
 ' Descripcio '
 ||n_descripcioProvincia||
 ' Pais: '||n_descripcioPais||
 ' Codi ISO pais: '||n_codiPais);
  s_rsp := 'OK  CONSULTA PROVINCIES 
  Codi Provincia '
 || n_idProvincia||
 ' Descripcio '
 ||n_descripcioProvincia||
 ' Pais: '||n_descripcioPais||
 ' Codi ISO pais: '||n_codiPais;
 
 FETCH C_PROVINCIA INTO n_idProvincia,
 n_descripcioProvincia,n_descripcioPais,n_codiPais;

  pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  
  END LOOP;
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('Total provincies: '||n_registres);
  DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
CLOSE C_PROVINCIA;
COMMIT;
 EXCEPTION
	
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi-----------------------------------------
         s_rsp := 'Error: ' || SQLCODE || SUBSTR(SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi-----------------------------------------
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' '); 
      DBMS_OUTPUT.put_line (s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;
  

end PRC_CONSULTA_PROVINCIA;
END "GESTION_PROVINCIA";
