CREATE OR REPLACE
PACKAGE BODY          "GESTION_UBICACIO" AS
  c_procesLog LOG_TFC.procesLog%TYPE;	
  c_dataHoraLog LOG_TFC.dataHoraLog%TYPE;
  c_entradaLog LOG_TFC.entradaLog%TYPE;	
  c_sortidaLog LOG_TFC.sortidaLog%TYPE;
  s_rsp LOG_TFC.rspLog%TYPE; 
  n_registres  NUMBER;
  s_sql VARCHAR2 (2000);
  
   
  --p_idViaUbicacio UBICACIO.IDVIAUBICACIO%TYPE;
  n_descripcioVia VIA.DESCRIPCIOVIA%TYPE;
  n_direccioUbicacio UBICACIO.DIRECCIONUBICACIO%TYPE;
  n_numeroUbicacio UBICACIO.NUMEROUBICACIO%TYPE;
  n_pisUbicacio UBICACIO.PISUBICACIO%TYPE;
  n_portaUbicacio UBICACIO.PISUBICACIO%TYPE;
  n_codiPostalUbicacio UBICACIO.CODIPOSTAL%TYPE;
  n_localitatUbicacio LOCALITAT.DESCRIPCIOLOCALITAT%TYPE;
  n_provinciaUbicacio PROVINCIA.DESCRIPCIOPROVINCIA%TYPE;
  n_paisUbicacio PAIS.DESCRIPCIOPAIS%TYPE;
  n_idUbicacio UBICACIO.IDUBICA%TYPE;
   
  n_NUM_ERR NUMBER(10);
  sortida varchar2(500):=''; 
  e_ubicacio    EXCEPTION;
  
/*****************************************************************************
ALTA UBICACIO
Procediment per donar altes d'ubicacions per poder assignar a client o fabricant
o centrsl o comptador. Totes aquelles taules que depenent d'una ubicació
físicament geografica.
*****************************************************************************/
PROCEDURE PRC_ALTA_UBICACIO(
        p_idViaUbica in UBICACIO.IDVIAUBICACIO%TYPE,
        p_direccionUbica in UBICACIO.DIRECCIONUBICACIO%TYPE,
        p_numeroUbica in UBICACIO.NUMEROUBICACIO%TYPE,
        p_pisUbica in UBICACIO.PISUBICACIO%TYPE,
        p_portaUbica in UBICACIO.PORTAUBICACIO%TYPE,
        p_codiPostalUbica in UBICACIO.CODIPOSTAL%TYPE,
        p_idLocalitat in UBICACIO.IDLOCALITATUBICACIO%TYPE,
        s_rsp out NOCOPY VARCHAR2)
    AS
 
    BEGIN
    c_procesLog := 'PRC_ALTA_UBICACIO';
    c_dataHoraLog := SYSDATE;
    c_entradaLog :='Codi Via Publica: ' ||p_idViaUbica ||
                   ', Direccio : ' ||p_direccionUbica ||
                   ', Numero: ' ||p_numeroUbica ||
                   ', Pis: ' ||p_pisUbica ||
                   ', Porta: ' ||p_portaUbica ||
                   ', Codi Postal: ' ||p_codiPostalUbica  ||
                   ', Codi Localitat: ' ||p_idLocalitat;
    DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE('       ALTA UBICACIONS       ');
    DBMS_OUTPUT.PUT_LINE('_____________________________');
    DBMS_OUTPUT.PUT_LINE(' Codi Via Publica: ' ||p_idViaUbica ||
                   ', Direccio : ' ||p_direccionUbica ||
                   ', Numero: ' ||p_numeroUbica ||
                   ', Pis: ' ||p_pisUbica ||
                   ', Porta: ' ||p_portaUbica ||
                   ', Codi Postal: ' ||p_codiPostalUbica  ||
                   ', Codi Localitat: ' ||p_idLocalitat);                     
    c_sortidalog := 's_rsp';
 If (p_idViaUbica IS NULL) then
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('ALTA UBICACIONS : ');  
    s_rsp := 'Falta especificar Codi Via Publica  ';
    DBMS_OUTPUT.PUT_LINE(s_rsp);
    RAISE e_ubicacio ;
  END IF;
 If (p_direccionUbica IS NULL) then
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('ALTA UBICACIONS: '); 
    s_rsp := 'Falta especificar direccion  ';
    DBMS_OUTPUT.PUT_LINE(s_rsp);
    RAISE e_ubicacio ;
  END IF;
  If (p_numeroUbica IS NULL) then
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('ALTA UBICACIONS: ');     
      s_rsp := 'Falta especificar numero  ';
      DBMS_OUTPUT.PUT_LINE(s_rsp);           
      RAISE e_ubicacio ;
  END IF;     
  If (p_codiPostalUbica  IS NULL) then
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('ALTA UBICACIONS: ');     
      s_rsp := 'Falta especificar codi postal  ';
      DBMS_OUTPUT.PUT_LINE(s_rsp);              
      RAISE e_ubicacio ;
  END IF;
  If (p_idLocalitat  IS NULL) then
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('ALTA UBICACIONS: ');    
      s_rsp := 'Falta especificar codi localitat  ';
      DBMS_OUTPUT.PUT_LINE(s_rsp);             
      RAISE e_ubicacio ;
  END IF;
-- Comprovem si existeix UBICACIO a  donar d'alta
  SELECT COUNT (*) INTO n_registres 
  FROM UBICACIO
  WHERE UBICACIO.IDVIAUBICACIO=p_idViaUbica
        AND UBICACIO.DIRECCIONUBICACIO=p_direccionUbica
        AND UBICACIO.NUMEROUBICACIO=p_numeroUbica
        AND UBICACIO.PISUBICACIO=p_pisUbica
        AND UBICACIO.PORTAUBICACIO=p_portaUbica
        AND UBICACIO.CODIPOSTAL=p_codiPostalUbica
        AND UBICACIO.IDLOCALITATUBICACIO=p_idLocalitat;
            
  If n_registres=0 then
-- El donem d'alta UBICACIO         
  INSERT INTO UBICACIO(IDVIAUBICACIO,
                        DIRECCIONUBICACIO,
                        NUMEROUBICACIO,
                        PORTAUBICACIO,
                        PISUBICACIO,
                        UBICACIO.CODIPOSTAL,
                        IDLOCALITATUBICACIO) 
  VALUES(p_idViaUbica,
          p_direccionUbica,
          p_numeroUbica,
          p_pisUbica,
          p_portaUbica,
          p_codiPostalUbica,
          p_idLocalitat);

    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('Insertada ubicacio: 
    Codi via publica:'||p_idViaUbica||
    ' Direccio: '||p_direccionUbica||
    ' Numero: '||p_numeroUbica||
    ' Pis: '||p_pisUbica||
    ' Porta: '||p_portaUbica||
    ' Codi POstal: '||p_codiPostalUbica||
    ' Codi Localitat: '||p_idLocalitat);
    DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');

--Gravem en la taula log-----------------------------------------------------
    s_rsp :='Ok: Insertada ubicacio: 
    Codi via publica:'||p_idViaUbica||
    ' Direccio: '||p_direccionUbica||
    ' Numero: '||p_numeroUbica||
    ' Pis: '||p_pisUbica||
    ' Porta: '||p_portaUbica||
    ' Codi POstal: '||p_codiPostalUbica||
    ' Codi Localitat: '||p_idLocalitat;
    pkg_general.gravar_log_procedure(c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
    DBMS_OUTPUT.PUT_LINE(s_rsp);
  ELSE
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('ALTA UBICACIONS: ');   
    s_rsp := 'Dades Ubicacio duplicades ';
    DBMS_OUTPUT.PUT_LINE(s_rsp);
    RAISE e_ubicacio ;
  END IF;
   COMMIT;
   EXCEPTION
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         s_rsp := 'Error: ' || SQLCODE || SUBSTR (SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' ');   
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;

   END PRC_ALTA_UBICACIO;
/********************************************************************************
   NOM:         PRC_MODIFICAR_UBICACIO
   DESCRIPCIÓ:
      Procediment encarregat de modificar les dades d'una UBICACIO
      Les dades es modificaran en la taula UBICACIO i el identificador de 
      tipus UBICACIO apuntarà a la clau primaria del codi de la taula 
      UBICACIO.
********************************************************************************/          
PROCEDURE PRC_MODIFICAR_UBICACIO(
        p_idUbica IN UBICACIO.IDUBICA%TYPE,
        p_idViaUbica IN UBICACIO.IDVIAUBICACIO%TYPE,
        p_direccionUbica in UBICACIO.DIRECCIONUBICACIO%TYPE,
        p_numeroUbica in UBICACIO.NUMEROUBICACIO%TYPE,
        p_pisUbica in UBICACIO.PISUBICACIO%TYPE,
        p_portaUbica in UBICACIO.PORTAUBICACIO%TYPE,
        p_codiPostalUbica in UBICACIO.CODIPOSTAL%TYPE,
        p_idLocalitat in UBICACIO.IDLOCALITATUBICACIO%TYPE,
        s_rsp out NOCOPY VARCHAR2)
    AS
    BEGIN
    c_procesLog := 'PRC_MODIFICAR_UBICACIO';
    c_dataHoraLog := SYSDATE;
    c_entradaLog := ' Codi Ubicacio: ' ||p_idUbica||
                   '  Codi Via Publica: ' ||p_idViaUbica ||
                   '  Direccio : ' ||p_direccionUbica ||
                   '  Numero: ' ||p_numeroUbica ||
                   '  Pis: ' ||p_pisUbica ||
                   '  Porta: ' ||p_portaUbica ||
                   '  Codi Postal: ' ||p_codiPostalUbica  ||
                   '  Codi Localitat: ' ||p_idLocalitat;
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE('    MODIFICAR UBICACIO     ');
    DBMS_OUTPUT.PUT_LINE('___________________________');
    DBMS_OUTPUT.PUT_LINE('Codi Ubicacio:  '||p_idUbica ||
                   '  Codi Via Publica: ' ||p_idViaUbica ||
                   '  Direccio : ' ||p_direccionUbica ||
                   '  Numero: ' ||p_numeroUbica ||
                   '  Pis: ' ||p_pisUbica ||
                   '  Porta: ' ||p_portaUbica ||
                   '  Codi Postal: ' ||p_codiPostalUbica  ||
                   '  Codi Localitat: ' ||p_idLocalitat); 
    c_sortidalog := 's_rsp';
    -- Comprovació del identificador Tipus Funcions de Central-----
  If p_idUbica IS NULL then
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('MODIFICAR UBICACIO: ');       
    s_rsp := 'Falta especificar Codi  ubicacio. ';
    DBMS_OUTPUT.put_line(s_rsp);           
    RAISE e_ubicacio ;
  END IF;
   
 If p_idViaUbica IS NULL then
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('MODIFICAR UBICACIO: ');     
    s_rsp := 'Falta especificar Codi Via Publica.   ';
    DBMS_OUTPUT.put_line(s_rsp);           
    RAISE e_ubicacio;
  END IF;
  If p_direccionUbica IS NULL then
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('MODIFICAR UBICACIO: ');     
    s_rsp := 'Falta especificar direccion.  ';
    DBMS_OUTPUT.put_line(s_rsp);              
    RAISE e_ubicacio;
  END IF;
 If p_numeroUbica IS NULL then
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('MODIFICAR UBICACIO: ');      
    s_rsp := 'Falta especificar numero.  ';
    DBMS_OUTPUT.put_line(s_rsp);              
    RAISE e_ubicacio;
  END IF;     
  If p_codiPostalUbica  IS NULL then
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('MODIFICAR UBICACIO: ');      
    s_rsp := 'Falta especificar codi postal.  ';
    DBMS_OUTPUT.put_line(s_rsp);             
    RAISE e_ubicacio;
  END IF;
  If p_idLocalitat  IS NULL then
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('MODIFICAR UBICACIO: ');       
    s_rsp := 'Falta especificar codi localitat UBICACIO ';
    DBMS_OUTPUT.put_line(s_rsp);             
    RAISE e_ubicacio;
  END IF;
-- cerquem si existeix
  SELECT COUNT (*) INTO n_registres 
  FROM UBICACIO
  WHERE UBICACIO.IDUBICA=p_idUbica;
  
  If n_registres=0 then
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('MODIFICAR UBICACIO: ');      
    s_rsp := 'UBICACIO no existeix a la BBDD';
    DBMS_OUTPUT.PUT_LINE(s_rsp);
    RAISE e_ubicacio;
  END IF;
-- recuperem el codi UBICACIO
  SELECT UBICACIO.IDUBICA INTO n_idUbicacio
  FROM UBICACIO
  WHERE UBICACIO.IDUBICA=p_idUbica;
  
  s_sql := 'UPDATE UBICACIO SET ';
    
-- Construirem la sentencia UPDATE segons si hi ha valor en els paràmetres-
  IF p_idViaUbica IS NOT NULL THEN
-- Modifiquem el descripcio UBICACIO
    s_sql := s_sql || 'IDVIAUBICACIO=''' || p_idViaUbica|| ''',';
  END IF;
  IF p_direccionUbica IS NOT NULL THEN
   s_sql := s_sql || 'DIRECCIONUBICACIO=''' || p_direccionUbica|| ''',';
  END IF;
  IF p_numeroUbica IS NOT NULL THEN
    s_sql := s_sql || 'NUMEROUBICACIO=''' || p_numeroUbica || ''',';
  END IF;
  IF p_pisUbica IS NOT NULL THEN
    s_sql := s_sql || 'PISUBICACIO=''' || p_pisUbica|| ''',';
  END IF;
  IF p_portaUbica IS NOT NULL THEN
     s_sql := s_sql || 'PORTAUBICACIO=''' || p_portaUbica|| ''',';
  END IF;
  IF p_codiPostalUbica  IS NOT NULL THEN
    s_sql := s_sql || 'CODIPOSTAL=''' || p_codiPostalUbica || ''',';
  END IF;
  IF p_idLocalitat  IS NOT NULL THEN
    s_sql := s_sql || 'IDLOCALITATUBICACIOt=''' || p_idLocalitat || ''',';
  END IF;       
-- Eliminem la coma final de la sentencia SQL
  s_sql := SUBSTR (s_sql, 1, LENGTH (s_sql) - 1);
-- Afegim a la sentencia la condició del WHERE
  s_sql := s_sql || ' WHERE IDUBICA=''' ||n_idUbicacio|| '''';

 EXECUTE IMMEDIATE s_sql;
      
  IF SQL%ROWCOUNT = 0  THEN
--L'error serà que el la via ja el tenim en la taula i no admet duplicats--
    s_rsp := 'Actualitzacio no realitzada. ';
    RAISE e_ubicacio;
  ELSE
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('Modificacio feta en Ubicacio:  
                      Codi Via Publica: '||p_idViaUbica||
                   '  Direccio : ' ||p_direccionUbica ||
                   '  Numero: ' ||p_numeroUbica ||
                   '  Pis: ' ||p_pisUbica ||
                   '  Porta: ' ||p_portaUbica ||
                   '  Codi Postal: ' ||p_codiPostalUbica  ||
                   '  Codi Localitat: ' ||p_idLocalitat);
    DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
                  s_rsp := 'OK Modificacio feta en Ubicacio:  
                      Codi Via Publica: '||p_idViaUbica||
                   '  Direccio : ' ||p_direccionUbica ||
                   '  Numero: ' ||p_numeroUbica ||
                   '  Pis: ' ||p_pisUbica ||
                   '  Porta: ' ||p_portaUbica ||
                   '  Codi Postal: ' ||p_codiPostalUbica  ||
                   '  Codi Localitat: ' ||p_idLocalitat;
    pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  END IF;
COMMIT;
EXCEPTION
   WHEN DUP_VAL_ON_INDEX THEN
      s_rsp := 'Error: Ubicacio duplicada. No es poden fer les modificacions';
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;      
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         -----------------------------------------
         s_rsp := 'Error: ' || SQLCODE || SUBSTR(SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         -----------------------------------------
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('  '); 
      DBMS_OUTPUT.put_line (s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;                   
         
 END PRC_MODIFICAR_UBICACIO; 
/******************************************************************************
CONSULTA UNA UBICACIO segons la direcció i el codi de poblacio
******************************************************************************/
PROCEDURE PRC_CONSULTAR_UNA_UBICACIO_CP( 
      p_cpUbica in UBICACIO.CODIPOSTAL%TYPE,
     s_rsp out NOCOPY VARCHAR2)
  AS
  
CURSOR C_CP IS
SELECT UBICACIO.IDUBICA AS CODI, 
      VIA.DESCRIPCIOVIA AS VIA_PUBLICA,
      UBICACIO.DIRECCIONUBICACIO AS DIRECCIO,
      UBICACIO.NUMEROUBICACIO AS NUMERO,
      UBICACIO.PISUBICACIO AS PIS,
      UBICACIO.PORTAUBICACIO AS PORTA,
      UBICACIO.CODIPOSTAL AS CODI_POSTAL,
      LOCALITAT.DESCRIPCIOLOCALITAT AS POBLACIO,
      PROVINCIA.DESCRIPCIOPROVINCIA AS PROVINCIA,
      PAIS.DESCRIPCIOPAIS AS PAIS
FROM UBICACIO,VIA,LOCALITAT,PROVINCIA,PAIS
WHERE
VIA.IDVIA=UBICACIO.IDVIAUBICACIO
AND UBICACIO.IDUBICA=UBICACIO.IDUBICA
AND UBICACIO.IDLOCALITATUBICACIO=LOCALITAT.IDLOCALITAT
AND LOCALITAT.IDPROVINCIALOCALITAT=PROVINCIA.IDPROVINCIA
AND PROVINCIA.IDPAISPROVINCIA=PAIS.IDPAIS
AND UBICACIO.CODIPOSTAL= p_cpUbica 
ORDER BY UBICACIO.CODIPOSTAL;
    BEGIN
    c_procesLog := 'PRC_CONSULTAR_UBICACIO_CP';
    c_dataHoraLog := SYSDATE;
    c_entradaLog := ' Codi Postal : ' ||p_cpUbica ;
    c_sortidalog := 's_rsp';
    -- Comprovem que  dades codi postal
    SELECT DISTINCT COUNT(UBICACIO.CODIPOSTAL)INTO n_registres
    FROM UBICACIO
    WHERE UBICACIO.CODIPOSTAL=p_cpUbica 
    AND UBICACIO.IDUBICA=UBICACIO.IDUBICA;
    
  If  n_registres=0  then
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('CONSULTA UBICACIO PER CODI POSTAL:  ');      
    s_rsp := 'Les dades no existeixen en la BDD.  ';
    DBMS_OUTPUT.put_line(s_rsp);
    RAISE  e_ubicacio;
  END IF;
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('           CONSULTA UBICACIO                         ');
  DBMS_OUTPUT.PUT_LINE('-----------------------------------------------------');
OPEN C_CP;
   FETCH C_CP INTO n_idUbicacio,n_descripcioVia,n_direccioUbicacio,
   n_numeroUbicacio,n_pisUbicacio,n_portaUbicacio,
   n_codiPostalUbicacio,n_localitatUbicacio,
   n_provinciaUbicacio,n_paisUbicacio;
 WHILE C_CP%FOUND LOOP
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE(
 ' Codi Ubicacio: '
 ||n_idUbicacio||
 '   Via Publica: '
 ||n_descripcioVia||
 '   Direccio: '
 ||n_direccioUbicacio||
 '   Numero: '
 || n_numeroUbicacio||
 '   Pis: '
 ||n_pisUbicacio||
 '   Porta: '
 ||n_portaUbicacio||
 '   Codi Postal: '
 ||n_codiPostalUbicacio||
 '   Poblacio: '
 ||n_localitatUbicacio||
 '   Provincia: '
 || n_provinciaUbicacio||
 '   Pais: '
 ||n_paisUbicacio);
  s_rsp := 'OK  CONSULTA UBICACIO
   Codi Ubicacio: '
 ||n_idUbicacio||
 '    Via Publica: '
 ||n_descripcioVia||
 '   Direccio: '
 ||n_direccioUbicacio||
 '   Numero: '
 || n_numeroUbicacio||
 '   Pis: '
 ||n_pisUbicacio||
 '   Porta: '
 ||n_portaUbicacio||
 '   Codi Postal: '
 ||n_codiPostalUbicacio||
 '   Poblacio: '
 ||n_localitatUbicacio||
 '   Provincia: '
 || n_provinciaUbicacio||
 '   Pais: '
 ||n_paisUbicacio;
 
   FETCH C_CP INTO n_idUbicacio,n_descripcioVia,n_direccioUbicacio,
   n_numeroUbicacio,n_pisUbicacio,n_portaUbicacio,
   n_codiPostalUbicacio,n_localitatUbicacio,
   n_provinciaUbicacio,n_paisUbicacio;

  pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  
  END LOOP;
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('Total ubicacions: '||n_registres);
  DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
CLOSE C_CP;
COMMIT;
EXCEPTION
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         s_rsp := 'Error: ' || SQLCODE || SUBSTR (SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('  '); 
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;    
    
END PRC_CONSULTAR_UNA_UBICACIO_CP; 

PROCEDURE PRC_CONSULTAR_UBICACIONS(
        s_rsp out NOCOPY VARCHAR2)
AS
  
CURSOR C_CP IS
SELECT VIA.DESCRIPCIOVIA AS VIA_PUBLICA,
      UBICACIO.DIRECCIONUBICACIO AS DIRECCIO,
      UBICACIO.NUMEROUBICACIO AS NUMERO,
      UBICACIO.PISUBICACIO AS PIS,
      UBICACIO.PORTAUBICACIO AS PORTA,
      UBICACIO.CODIPOSTAL AS CODI_POSTAL,
      LOCALITAT.DESCRIPCIOLOCALITAT AS POBLACIO,
      PROVINCIA.DESCRIPCIOPROVINCIA AS PROVINCIA,
      PAIS.DESCRIPCIOPAIS AS PAIS
FROM UBICACIO,VIA,LOCALITAT,PROVINCIA,PAIS
WHERE
VIA.IDVIA=UBICACIO.IDVIAUBICACIO
AND UBICACIO.IDUBICA=UBICACIO.IDUBICA
AND UBICACIO.IDLOCALITATUBICACIO=LOCALITAT.IDLOCALITAT
AND LOCALITAT.IDPROVINCIALOCALITAT=PROVINCIA.IDPROVINCIA
AND PROVINCIA.IDPAISPROVINCIA=PAIS.IDPAIS
AND UBICACIO.CODIPOSTAL=UBICACIO.CODIPOSTAL
ORDER BY UBICACIO.CODIPOSTAL;
    BEGIN
    c_procesLog := 'PRC_CONSULTAR_UBICACIOS';
    c_dataHoraLog := SYSDATE;
    c_entradaLog := ' CONSULTA UBICACIONS ';
    c_sortidalog := 's_rsp';
    -- Comprovem que  dades codi postal
    SELECT DISTINCT COUNT(UBICACIO.CODIPOSTAL)INTO n_registres
    FROM UBICACIO
    WHERE UBICACIO.CODIPOSTAL=UBICACIO.CODIPOSTAL
    AND UBICACIO.IDUBICA=UBICACIO.IDUBICA;
    
  If  n_registres=0  then
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('CONSULTA UBICACIONS:  ');      
    s_rsp := 'Les dades no existeixen en la BDD.  ';
    DBMS_OUTPUT.put_line(s_rsp);
    RAISE  e_ubicacio;
  END IF;
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('           CONSULTA UBICACIONS                         ');
  DBMS_OUTPUT.PUT_LINE('-----------------------------------------------------');
OPEN C_CP;
   FETCH C_CP INTO n_descripcioVia,n_direccioUbicacio,
   n_numeroUbicacio,n_pisUbicacio,n_portaUbicacio,
   n_codiPostalUbicacio,n_localitatUbicacio,
   n_provinciaUbicacio,n_paisUbicacio;
 WHILE C_CP%FOUND LOOP
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE(
 '   Via Publica: '
 ||n_descripcioVia||
 '   Direccio: '
 ||n_direccioUbicacio||
 '   Numero: '
 || n_numeroUbicacio||
 '   Pis: '
 ||n_pisUbicacio||
 '   Porta: '
 ||n_portaUbicacio||
 '   Codi Postal: '
 ||n_codiPostalUbicacio||
 '   Poblacio: '
 ||n_localitatUbicacio||
 '   Provincia: '
 || n_provinciaUbicacio||
 '   Pais: '
 ||n_paisUbicacio);
  s_rsp := 'OK  CONSULTA UBICACIONS
     Via Publica: '
 ||n_descripcioVia||
 '   Direccio: '
 ||n_direccioUbicacio||
 '   Numero: '
 || n_numeroUbicacio||
 '   Pis: '
 ||n_pisUbicacio||
 '   Porta: '
 ||n_portaUbicacio||
 '   Codi Postal: '
 ||n_codiPostalUbicacio||
 '   Poblacio: '
 ||n_localitatUbicacio||
 '   Provincia: '
 || n_provinciaUbicacio||
 '   Pais: '
 ||n_paisUbicacio;
 
  FETCH C_CP INTO n_descripcioVia,n_direccioUbicacio,
   n_numeroUbicacio,n_pisUbicacio,n_portaUbicacio,
   n_codiPostalUbicacio,n_localitatUbicacio,
   n_provinciaUbicacio,n_paisUbicacio;

  pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  
  END LOOP;
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('Total ubicacions: '||n_registres);
  DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
CLOSE C_CP;
COMMIT;
EXCEPTION
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         s_rsp := 'Error: ' || SQLCODE || SUBSTR (SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('  '); 
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;      
        
END PRC_CONSULTAR_UBICACIONS;

END "GESTION_UBICACIO";
