CREATE OR REPLACE
PACKAGE BODY          "GESTION_VIA" AS
  c_procesLog	 LOG_TFC.procesLog%TYPE;	
  c_dataHoraLog    LOG_TFC.dataHoraLog%TYPE;
  c_entradaLog     LOG_TFC.entradaLog%TYPE;	
  c_sortidaLog     LOG_TFC.sortidaLog%TYPE;
  s_rsp	       LOG_TFC.rspLog%TYPE; 
  n_registres  NUMBER;
  s_sql VARCHAR2 (2000);
  n_descripcioVia VIA.descripcioVia%TYPE;
  n_idVia VIA.idVia%TYPE;
  n_NUM_ERR NUMBER(10);
  sortida varchar2(500):=''; 
  e_via     EXCEPTION;
--------------------------------------------------------------
-- create procedure for table "LOG_TFC i VIA"
/********************************************************************************
Autor: Eduard Monzonis Hierro                                   UOC
18/05/2012                                             TFC: CONTROL ENERGIA.
   NOM:         PRC_ALTA_VIA
   DESCRIPCIÓ:
                Procediment encarregat donar alta d'un via pública. 
                
********************************************************************************/
   procedure PRC_ALTA_VIA(
     p_descripcioVia in VIA.descripcioVia%TYPE,
    s_rsp out NOCOPY VARCHAR2) 
   AS
 
   BEGIN
    c_procesLog := 'PRC_ALTA_VIA';
    c_dataHoraLog := SYSDATE;
    c_entradaLog :='Decripcio Via: ' || p_descripcioVia;
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE('ALTA DE LA VIA PUBLICA');
    DBMS_OUTPUT.PUT_LINE('______________________');
    DBMS_OUTPUT.PUT_LINE('ALTA VIA: '|| p_descripcioVia);
    c_sortidalog := 's_rsp';   
    If (p_descripcioVia IS NULL) then
          DBMS_OUTPUT.ENABLE;
              DBMS_OUTPUT.PUT_LINE('ALTA_VIA:  ');
           s_rsp := 'Falta especificar el la Via Pública';
           DBMS_OUTPUT.PUT_LINE(s_rsp);
          RAISE e_via;
     END IF;
      -- Comprovem si existeix el VIA a  donar d'alta
         SELECT COUNT (*)INTO n_registres 
            FROM VIA 
            WHERE descripcioVia = p_descripcioVia;
      If n_registres=0 then
          -- El donem d'alta a la Via Publica          
           -- Insertem en la taula Persona----------------------------------------------	
            INSERT INTO VIA(descripcioVia) 
            VALUES(p_descripcioVia);
            --Gravem en la taula log-----------------------------------------------------
           DBMS_OUTPUT.ENABLE;
              DBMS_OUTPUT.PUT_LINE('Insertada la Via Pblica: '|| p_descripcioVia);
              DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
            s_rsp :='Ok: En la Taula VIA Insertada la Via Pblica:  '|| p_descripcioVia;
            pkg_general.gravar_log_procedure(c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
            DBMS_OUTPUT.PUT_LINE(s_rsp);
          ELSE
          DBMS_OUTPUT.ENABLE;
          DBMS_OUTPUT.PUT_LINE('ALTA_VIA: ');
          s_rsp := 'DESCRICIO VIA  duplicat';
          DBMS_OUTPUT.PUT_LINE(s_rsp);
          RAISE e_via;
      END IF;
   COMMIT;
EXCEPTION
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         s_rsp := 'Error: ' || SQLCODE || SUBSTR (SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' ');
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;

   end PRC_ALTA_VIA;
   
 PROCEDURE PRC_MODIFICAR_VIA(
/********************************************************************************
Autor: Eduard Monzonis Hierro                                   UOC
18/05/2012                                             TFC: CONTROL ENERGIA.   
   NOM:         PRC_MODIFICAR_VIA
   DESCRIPCIÓ:
                Procediment encarregat de modificar les  vias públicas. 
                Les dades es modificaran en la taula persona i el identificador de 
                Via apuntarà a la clau primaria del contacte de la taula Via.
********************************************************************************/  
       p_idVia IN VIA.idVia%TYPE,
       p_descripcioVia in VIA.descripcioVia%TYPE,
        s_rsp out NOCOPY VARCHAR2) 
   AS

   BEGIN
    c_procesLog := 'PRC_MODIFICAR_VIA';
    c_dataHoraLog := SYSDATE;
    c_entradaLog :='Decripcio Via: ' || p_descripcioVia;
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE('MODIFICAR LA VIA PUBLICA');
    DBMS_OUTPUT.PUT_LINE('______________________');
    DBMS_OUTPUT.PUT_LINE('Nom de la Via Publica: '|| p_descripcioVia);
    c_sortidalog := 's_rsp';
    -- Comprovació del identificador de la Via
      IF  p_descripcioVia IS NULL THEN
       DBMS_OUTPUT.ENABLE;
              DBMS_OUTPUT.PUT_LINE('MODIFICAR_VIA: ');
      s_rsp := 'Falta especificar el Nom de la Via Publica: ';
       DBMS_OUTPUT.put_line(s_rsp);
        RAISE e_via;
       
      -- 1er. Comprovem LA DESCRIPCIO
          SELECT COUNT (*)INTO n_registres 
            FROM VIA 
            WHERE DESCRIPCIOVIA =p_descripcioVia;
           If n_registres=0 then
            DBMS_OUTPUT.ENABLE;
              DBMS_OUTPUT.PUT_LINE('MODIFICAR_VIA: ');
            s_rsp := 'VIA no existent a la BBDD';
            DBMS_OUTPUT.PUT_LINE(s_rsp);
            RAISE e_via;
           END IF;
       -- recuperem el codi de la via
         SELECT VIA.idVia,VIA.DESCRIPCIOVIA INTO n_idVia,n_descripcioVia
              FROM VIA
              WHERE DESCRIPCIOVIA=p_descripcioVia;
          

         s_sql := 'UPDATE VIA SET ';
      
         -- Construirem la sentencia UPDATE segons si hi ha valor en els paràmetres-
               IF p_descripcioVia IS NOT NULL THEN
                     -- Modifiquem el nom
                     s_sql := s_sql || 'descripcioVia=''' || p_descripcioVia || ''',';
                     
               END IF;
                   
               -- Eliminem la coma final de la sentencia SQL
               --------------------------
               s_sql := SUBSTR (s_sql, 1, LENGTH (s_sql) - 1);
               -- Afegim a la sentencia la condició del WHERE
               ------------------------
               s_sql := s_sql || ' WHERE descripcioVia=''' || p_descripcioVia|| '''';
      
               EXECUTE IMMEDIATE s_sql;
      
               IF SQL%ROWCOUNT = 0
               THEN
                  --L'error serà que el la via ja el tenim en la taula i no admet duplicats--
                  DBMS_OUTPUT.ENABLE;
                  DBMS_OUTPUT.PUT_LINE('MODIFICAR_VIA: ');
                  s_rsp := 'Actualització no realitzada';
                  DBMS_OUTPUT.PUT_LINE(s_rsp);
                  RAISE e_via;
               ELSE
                  DBMS_OUTPUT.ENABLE;
                  DBMS_OUTPUT.PUT_LINE('Modificacio feta de la Via Pblica: codi: '||p_idVia||
                 ' Descripcio: '|| p_descripcioVia);
                 DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
                  s_rsp := 'OK Modificacio feta de la Via Pblica: codi: '||n_idVia||
                 ' Descripcio: '|| p_descripcioVia;
                 pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
               END IF;
    END IF;
  COMMIT;
  EXCEPTION
  WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         s_rsp := 'Error: ' || SQLCODE || SUBSTR (SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' ');
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;
  
END PRC_MODIFICAR_VIA;
/*******************************************************************************
CONSULTA DE TOTES LES VIES PUBLIQUES DONADES DALTA
*******************************************************************************/
PROCEDURE PRC_CONSULTA_VIA(
    s_rsp out NOCOPY VARCHAR2)
AS
CURSOR C_VIAS IS
  SELECT VIA.IDVIA,VIA.DESCRIPCIOVIA
  FROM VIA
  WHERE VIA.IDVIA=VIA.IDVIA;

BEGIN 
    c_procesLog := 'PRC_CONSULTA_VIAS';
    c_dataHoraLog := SYSDATE;
    c_entradaLog :='CONSULTA DE LES VIES PUBLIQUES';
    c_sortidalog := 's_rsp';
    
    SELECT COUNT(VIA.IDVIA)INTO n_registres
    FROM VIA
    WHERE VIA.IDVIA=VIA.IDVIA;
    
    IF n_registres=0 THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('CONSULTA DE VIES PUBLIQUES: ');
    s_rsp := 'No hi han vies publiques donades dalta ';
    DBMS_OUTPUT.PUT_LINE(s_rsp);
    RAISE e_via;
    END IF;
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('           CONSULTA DE LES VIES PUBLIQUES            ');
    DBMS_OUTPUT.PUT_LINE('-----------------------------------------------------');
  OPEN C_VIAS;
   FETCH C_VIAS INTO n_idVia,n_descripcioVia;
  WHILE C_VIAS%FOUND LOOP
   DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE(
 '   Codi Via '
 || n_idVia
 ||' Descripcio '
 || n_descripcioVia);
  s_rsp := 'OK  CONSULTA DE LES VIES PUBLIQUES
  Codi Via:  '
 || n_idVia
 ||' Descripcio: '
 || n_descripcioVia;
 
  FETCH C_VIAS INTO n_idVia,n_descripcioVia;

  pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  
  END LOOP;
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('Total vies pbliques: '||n_registres);
  DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
CLOSE C_VIAS;
COMMIT;
 EXCEPTION
	
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi-----------------------------------------
         s_rsp := 'Error: ' || SQLCODE || SUBSTR(SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi-----------------------------------------
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' '); 
      DBMS_OUTPUT.put_line (s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;
  
END PRC_CONSULTA_VIA;
END GESTION_VIA;
