CREATE OR REPLACE
PACKAGE BODY          "GESTION_CENTRAL" AS
  n_registres      NUMBER;
  s_sql           VARCHAR2 (2000);
  n_NUM_ERR 	  NUMBER(10);
  c_procesLog	  LOG_TFC.procesLog%TYPE;	
  c_dataHoraLog    LOG_TFC.dataHoraLog%TYPE;
  c_entradaLog     LOG_TFC.entradaLog%TYPE;	
  c_sortidaLog     LOG_TFC.sortidaLog%TYPE;
  s_rsp	 LOG_TFC.RSPLOG%TYPE;  
  
 
  n_idCentral CENTRAL.IDCENTRAL%TYPE;
  n_idTipoCentral CENTRAL.IDTIPOCENTRAL%TYPE;
  n_resulatInspeccio TIPO_INSPECCIO.DESCRIPCIOTINSPECCIO%TYPE;


  n_idUbicaCentral CENTRAL.IDUBICACENTRAL%TYPE;
  n_dataAltaCentral CENTRAL.DATAALTACENTRAL%TYPE;
  n_dataModificacioCentral CENTRAL.DATAMODIFICACENTRAL%TYPE;
  n_ultimaInspeccioCentral CENTRAL.DATAULTIMAINSPECCIOCENTRAL%TYPE;
  n_maxEnergia CENTRAL.ENERGIAMAXIMA%TYPE;
  n_minEnergia CENTRAL.ENERGIAMINIMA%TYPE;
  n_observacions CENTRAL.OBSERVACIONSCENTRAL%TYPE;
  
  n_descResultatInspeccio TIPO_INSPECCIO.DESCRIPCIOTINSPECCIO%type;
  n_descEstat  ESTAT.DESCRIPCIOESTAT%TYPE;
  n_descTipoCentral TIPO_CENTRAL.DESCRIPCIOTIPOCENTRAL%TYPE;
  n_descClasseCentral CLASSE_CENTRAL.DESCRIPCIOCLASSE%TYPE;
  n_localitatCentral LOCALITAT.DESCRIPCIOLOCALITAT%TYPE;
  n_descTipusFuncioCentral TIPUS_FUNCIONS.DESCRIPCIONFUNCIO%TYPE;   
  n_descClasseCenral CLASSE_CENTRAL.DESCRIPCIOCLASSE%TYPE;
  n_controlEstatCentral ESTAT.IDESTAT%TYPE;
  n_controlTipoClasse NUMBER;
 
  n_estatCentral number;
  n_idClasseCentral number;
  p_estatCentral  CENTRAL.ESTATCENTRAL%Type;
  p_idClasseCentral CENTRAL.IDCLASSECENTRAL%TYPE;
  p_idTipoCentral  CENTRAL.IDTIPOCENTRAL%Type;
  
  sortida VARCHAR2(1000):='';
  e_central   EXCEPTION;
/********************************************************************************
   NOM:         PRC_ALTA_CENTRAL_PRODUCCIO
   DESCRIPCIÓ:
                Procediment encarregat donar alta  Central Produccio. 
                La inserció de dades esta controlada per un disparador o trigger
		el qual té associat una seqúència SEQ_CENTRAL per generar
		la clau primaria en format numérica de forma autoincrementable 
		les dades es modificaran en la taula CENTRAL i el identificador de 
                clau primaria del de la taula Central.
********************************************************************************/ 
PROCEDURE PRC_ALTA_CENTRAL_PRODUCCIO(
          p_dataAltaCentral in CENTRAL.DATAALTACENTRAL%Type,
         -- p_estatCentral in CENTRAL.ESTATCENTRAL%Type,
         -- p_idClasseCentral in CENTRAL.IDCLASSECENTRAL%Type,
          p_idTipoCentral in CENTRAL.IDTIPOCENTRAL%Type,
          p_dataUltmimaInspeccioCentral in CENTRAL.DATAULTIMAINSPECCIOCENTRAL%TYPE,
          p_idInspeccioCentral in CENTRAL.IDINSPECCIOCENTRAL%Type,
          p_energiaMax in CENTRAL.ENERGIAMAXIMA%Type,
          p_energiaMin in CENTRAL.ENERGIAMINIMA%Type,
          p_idUbicaCentral in CENTRAL.IDUBICACENTRAL%Type,
          p_observacionsCentral in CENTRAL.OBSERVACIONSCENTRAL%Type,
          s_rsp out NOCOPY VARCHAR2)
  AS
     
  BEGIN
n_idClasseCentral:=1;
n_estatCentral:=1;  
    --Parametres per la taula LOG
      c_procesLog := 'PRC_ALTA_CENTRAL_PRODUCCIO';
      c_dataHoraLog := SYSDATE;
      c_entradaLog := 'Data Alta Central: ' ||p_dataAltaCentral|| 
                      --', Estat Central Produccio: ' ||n_estatCentral||
                     -- ', Id Classe Central: ' ||p_idClasseCentral|| 
                      ', Id Tipo Central: ' ||p_idTipoCentral ||
                      ', Data Inspeccio Central Produccio: ' ||p_dataUltmimaInspeccioCentral|| 
                      ', Resultat Inspeccio Produccio: ' ||p_idInspeccioCentral||
                      ', Energiaa Maxima Produida: ' ||p_energiaMax||
                      ', Energia Minima Produida: ' ||p_energiaMin||
                      ', Direccio Central Produccio: ' ||p_idUbicaCentral||
                      ', Observacions Central Produccio: ' ||p_observacionsCentral;
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE('       ALTA CENTRAL PRODUCCIO            ');
    DBMS_OUTPUT.PUT_LINE('-----------------------------------------'); 
    DBMS_OUTPUT.PUT_LINE('Data Alta Central: ' ||p_dataAltaCentral|| 
                     --', Estat Central Producció: ' ||n_estatCentral||
                     -- ', Id Classe Central: ' ||p_idClasseCentral|| 
                      ', Id Tipo Central: ' ||p_idTipoCentral ||
                      ', Data Inspeccio Central Produccio: ' ||p_dataUltmimaInspeccioCentral|| 
                      ', Resultat Inspeccio Produccio: ' ||p_idInspeccioCentral||
                      ', Energia Maxima Produida: ' ||p_energiaMax||
                      ', Energia Minima Produida: ' ||p_energiaMin||
                      ', Direccio Central Produccio: ' ||p_idUbicaCentral||
                      ', Observacions Central Produccio: ' ||p_observacionsCentral);
   c_sortidalog := 's_rsp';  
 
  n_estatCentral:=1;
  n_idClasseCentral:=1;
   
 -- Comprovem que Classe de Central sigui 1=Produccio i les dades que es volen inserir   
   IF p_dataAltaCentral IS NULL THEN
        DBMS_OUTPUT.ENABLE;
         DBMS_OUTPUT.PUT_LINE('        ALTA CENTRAL PRODUCCIO         '); 
         DBMS_OUTPUT.PUT_LINE('---------------------------------------');
         s_rsp := 'Falta especificar la Data alta  ';
         DBMS_OUTPUT.PUT_LINE(s_rsp);               
        RAISE  e_central;
    END IF;   
    IF  p_dataUltmimaInspeccioCentral IS NULL THEN
        DBMS_OUTPUT.ENABLE;
         DBMS_OUTPUT.PUT_LINE('        ALTA CENTRAL PRODUCCIO         '); 
         DBMS_OUTPUT.PUT_LINE('---------------------------------------');
         s_rsp := 'Falta especificar la Data de la Inspeccio  ';
         DBMS_OUTPUT.PUT_LINE(s_rsp);               
        RAISE  e_central;
    END IF;         
    IF  p_idInspeccioCentral IS NULL THEN
        DBMS_OUTPUT.ENABLE;
         DBMS_OUTPUT.PUT_LINE('        ALTA CENTRAL PRODUCCIO         '); 
         DBMS_OUTPUT.PUT_LINE('---------------------------------------');
        s_rsp := 'Falta especificar el Id del resultat Inspeccio ';
        DBMS_OUTPUT.PUT_LINE(s_rsp);               
        RAISE  e_central;
    END IF;                       
    IF  p_energiaMax IS NULL THEN
         DBMS_OUTPUT.ENABLE;
         DBMS_OUTPUT.PUT_LINE('        ALTA CENTRAL PRODUCCIO         '); 
         DBMS_OUTPUT.PUT_LINE('---------------------------------------');
         s_rsp := 'Falta especificar Energía Máxima que pot Produir ';
         DBMS_OUTPUT.PUT_LINE(s_rsp);               
         RAISE  e_central;
    END IF;        
    IF  p_energiaMin IS NULL THEN
        DBMS_OUTPUT.ENABLE;
        DBMS_OUTPUT.PUT_LINE('        ALTA CENTRAL PRODUCCIO         '); 
        DBMS_OUTPUT.PUT_LINE('---------------------------------------');
        s_rsp := 'Falta especificar Energía Mínima que pot Produir ';
        DBMS_OUTPUT.PUT_LINE(s_rsp);               
        RAISE  e_central;
    END IF;
    IF  p_idUbicaCentral IS NULL THEN
        DBMS_OUTPUT.ENABLE;
         DBMS_OUTPUT.PUT_LINE('        ALTA CENTRAL PRODUCCIO         '); 
         DBMS_OUTPUT.PUT_LINE('---------------------------------------');
        s_rsp := 'Falta especificar el codi Ubicacio que identifica la situacio
            geografica de la Central de produccio. ';
        DBMS_OUTPUT.PUT_LINE(s_rsp);               
        RAISE  e_central;
    END IF;
    
    SELECT  DISTINCT TIPO_INSPECCIO.DESCRIPCIOTINSPECCIO INTO n_resulatInspeccio
  FROM TIPO_INSPECCIO
  WHERE TIPO_INSPECCIO.IDTINSPCCIO=p_idInspeccioCentral;
  
  SELECT DISTINCT ESTAT.DESCRIPCIOESTAT INTO n_descEstat
  FROM ESTAT
  WHERE ESTAT.IDESTAT=n_estatCentral;
      SELECT  DISTINCT TIPO_CENTRAL.DESCRIPCIOTIPOCENTRAL  INTO n_descTipoCentral
  FROM TIPO_CENTRAL
  WHERE TIPO_CENTRAL.IDTIPOCENTRAL=p_idTipoCentral;
      
    SELECT  DISTINCT CLASSE_CENTRAL.DESCRIPCIOCLASSE INTO n_descClasseCentral
  FROM CLASSE_CENTRAL
  WHERE CLASSE_CENTRAL.IDCLASSE=n_idClasseCentral;
  
      SELECT DISTINCT LOCALITAT.DESCRIPCIOLOCALITAT  INTO n_localitatCentral
  FROM  UBICACIO, LOCALITAT
  WHERE UBICACIO.IDUBICA=p_idUbicaCentral
  AND UBICACIO.IDLOCALITATUBICACIO=LOCALITAT.IDLOCALITAT;
  
  
  SELECT DISTINCT COUNT (*) INTO n_registres
  FROM CENTRAL
  WHERE CENTRAL.IDUBICACENTRAL=p_idUbicaCentral
  AND CENTRAL.DATAULTIMAINSPECCIOCENTRAL=p_dataUltmimaInspeccioCentral
  AND CENTRAL.DATAALTACENTRAL=p_dataAltaCentral
  AND CENTRAL.ESTATCENTRAL=n_estatCentral;   
   
 If n_registres=0 then
  n_estatCentral:=1;
  n_idClasseCentral:=1;
 -- El donem d'alta a la Classe de Central 

 INSERT INTO CENTRAL(DATAALTACENTRAL,
                     ESTATCENTRAL,
                     IDCLASSECENTRAL,
                     IDTIPOCENTRAL,
                     DATAULTIMAINSPECCIOCENTRAL,
                     IDINSPECCIOCENTRAL,
                     ENERGIAMAXIMA,
                     ENERGIAMINIMA,
                     IDUBICACENTRAL,
                     OBSERVACIONSCENTRAL) 
            VALUES(p_dataAltaCentral,
                  n_estatCentral,
                  n_idClasseCentral,
                  p_idTipoCentral,
                  p_dataUltmimaInspeccioCentral,
                  p_idInspeccioCentral,
                  p_energiaMax,
                  p_energiaMin,
                  p_idUbicaCentral,
                  p_observacionsCentral);
              
  DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE( 'Insertada la Central amb  
  Data Alta Central: ' ||p_dataAltaCentral|| 
  ', Estat Central Produccio: '||n_descEstat||
  ', Classe Central: '||n_descClasseCenral|| 
  '  Tipo Central: '||n_descTipoCentral||
  ', Data Inspeccio Central Produccio: ' ||p_dataUltmimaInspeccioCentral|| 
  ', Resultat Inspeccio Produccio: '||n_resulatInspeccio||
  ', Energía Máxima Produida: ' ||p_energiaMax||
  ', Energía Minima Produida: ' ||p_energiaMin||
  ', Direccio Central Produccio: ' ||p_idUbicaCentral||' '||n_localitatCentral||
  ', Observacions Central Produccio: ' ||p_observacionsCentral);
   DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
  --Gravem en la taula log-----------------------------------------------------
  s_rsp :='Ok: Insertada la Central amb  
  Data Alta Central: ' ||p_dataAltaCentral|| 
  ', Estat Central Produccio: '||n_descEstat||
  ', Classe Central: '||n_descClasseCentral|| 
  '  Tipo Central: '||n_descTipoCentral||
    ', Energía Máxima Produida: ' ||p_energiaMax||
  ', Energía Minima Produida: ' ||p_energiaMin||
  ', Direccio Central Produccio: ' ||n_localitatCentral||
  ', Observacions Central Produccio: ' ||p_observacionsCentral;
  pkg_general.gravar_log_procedure(c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  ELSE
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('ALTA CENTRAL PRODUCCIO: ');
  DBMS_OUTPUT.PUT_LINE('Central Produccio Duplicada' );
  s_rsp := 'Central duplicada Data Alta Central: ' ||p_dataAltaCentral|| 
  ', Estat Central Produccio: '||n_descEstat||
  ', Classe Central: '||n_descClasseCenral|| 
  '  Tipo Central: '||n_descTipoCentral;
  DBMS_OUTPUT.PUT_LINE(s_rsp);
  RAISE e_central;
 END IF;
COMMIT;
EXCEPTION
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         s_rsp := 'Error: ' || SQLCODE || SUBSTR (SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' ');
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
ROLLBACK;           
END PRC_ALTA_CENTRAL_PRODUCCIO;
/********************************************************************************
   NOM:         PRC_ALTA_CENTRAL_DISTRIBUCIO
   DESCRIPCIÓ:
                Procediment encarregat donar alta  Central Distribucio. 
                La inserció de dades esta controlada per un disparador o trigger
		el qual té associat una seqúència SEQ_CENTRAL per generar
		la clau primaria en format numérica de forma autoincrementable 
		les dades es modificaran en la taula CENTRAL i el identificador de 
                clau primaria del de la taula Central.
********************************************************************************/
PROCEDURE PRC_ALTA_CENTRAL_DISTRIBUCIO(
          p_dataAltaCentral in CENTRAL.DATAALTACENTRAL%Type,
          p_dataUltmimaInspeccioCentral in CENTRAL.DATAULTIMAINSPECCIOCENTRAL%TYPE,
          p_idInspeccioCentral in CENTRAL.IDINSPECCIOCENTRAL%Type,
          p_energiaMax in CENTRAL.ENERGIAMAXIMA%Type,
          p_energiaMin in CENTRAL.ENERGIAMINIMA%Type,
          p_idUbicaCentral in CENTRAL.IDUBICACENTRAL%Type,
          p_observacionsCentral in CENTRAL.observacionsCentral%Type,
          s_rsp out NOCOPY VARCHAR2)
  AS
         
  BEGIN
 
    --Parametres per la taula LOG
      c_procesLog := 'PRC_ALTA_CENTRAL_DISTRIBUCIO';
      c_dataHoraLog := SYSDATE;
      c_entradaLog := 'Data Alta Central: ' ||p_dataAltaCentral|| 
                      --', Estat Central Producció: ' ||p_estatCentral||
                      --', Id Classe Central: ' ||p_idClasseCentral|| 
                      --', Id Tipo Central: ' ||p_idTipoCentral||
                      ', Data Inspeccio Central Distribucio: ' ||p_dataUltmimaInspeccioCentral|| 
                      ', Resultat Inspeccio Distribucio: ' ||p_idInspeccioCentral||
                      ', Energiaa Maxima Distribucio: ' ||p_energiaMax||
                      ', Energia Minima Distribucio: ' ||p_energiaMin||
                      ', Direccio Central Distribucio: ' ||p_idUbicaCentral||
                      ', Observacions Central Distribucio: ' ||p_observacionsCentral;
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE('       ALTA CENTRAL DISTRIBUCIO            ');
    DBMS_OUTPUT.PUT_LINE('-----------------------------------------'); 
    DBMS_OUTPUT.PUT_LINE('Data Alta Central: ' ||p_dataAltaCentral|| 
                      ', Data Inspeccio Central Distribucio: ' ||p_dataUltmimaInspeccioCentral|| 
                      ', Resultat Inspeccio Distribucio: ' ||p_idInspeccioCentral||
                      ', Energia Maxima Distribucio: ' ||p_energiaMax||
                      ', Energia Minima Distribucio: ' ||p_energiaMin||
                      ', Direccio Central Distribucio: ' ||p_idUbicaCentral||
                      ', Observacions Central Distribucio: ' ||p_observacionsCentral);
   c_sortidalog := 's_rsp';   
 -- Comprovem que Classe de Central sigui 2=Distribucio i les dades que es volen inserir  
  n_idTipoCentral:=2;
  n_estatCentral:=1;
  n_idClasseCentral:=0;
                   
    IF  p_dataUltmimaInspeccioCentral IS NULL THEN
        DBMS_OUTPUT.ENABLE;
        DBMS_OUTPUT.PUT_LINE('        ALTA CENTRAL DISTRIBUCIO        '); 
         DBMS_OUTPUT.PUT_LINE('---------------------------------------');
         s_rsp := 'Falta especificar la Data de la Inspeccio  ';
         DBMS_OUTPUT.PUT_LINE(s_rsp);               
        RAISE  e_central;
    END IF;         
    IF  p_idInspeccioCentral IS NULL THEN
        DBMS_OUTPUT.ENABLE;
         DBMS_OUTPUT.PUT_LINE('        ALTA CENTRAL DISTRIBUCIO          '); 
         DBMS_OUTPUT.PUT_LINE('------------------------------------------');
        s_rsp := 'Falta especificar el Id del resultat Inspeccio ';
        DBMS_OUTPUT.PUT_LINE(s_rsp);               
        RAISE  e_central;
    END IF;                       
    IF  p_energiaMax IS NULL THEN
         DBMS_OUTPUT.ENABLE;
         DBMS_OUTPUT.PUT_LINE('        ALTA CENTRAL DISTRIBUCIO          '); 
         DBMS_OUTPUT.PUT_LINE('------------------------------------------');
         s_rsp := 'Falta especificar Energía Máxima que pot Distribuir ';
         DBMS_OUTPUT.PUT_LINE(s_rsp);               
         RAISE  e_central;
    END IF;        
    IF  p_energiaMin IS NULL THEN
        DBMS_OUTPUT.ENABLE;
         DBMS_OUTPUT.PUT_LINE('        ALTA CENTRAL DISTRIBUCIO          '); 
         DBMS_OUTPUT.PUT_LINE('------------------------------------------');
        s_rsp := 'Falta especificar Energía Mínima que pot Distribuir';
        DBMS_OUTPUT.PUT_LINE(s_rsp);               
        RAISE  e_central;
    END IF;
    IF  p_idUbicaCentral IS NULL THEN
        DBMS_OUTPUT.ENABLE;
         DBMS_OUTPUT.PUT_LINE('        ALTA CENTRAL DISTRIBUCIO          '); 
         DBMS_OUTPUT.PUT_LINE('------------------------------------------');
        s_rsp := 'Falta especificar el codi Ubicacio que identifica la situacio
            geografica de la Central de Distribucio. ';
        DBMS_OUTPUT.PUT_LINE(s_rsp);               
        RAISE  e_central;
    END IF; 
  n_idTipoCentral:=6;
  n_estatCentral:=1;
  n_idClasseCentral:=2;
 SELECT  DISTINCT TIPO_INSPECCIO.DESCRIPCIOTINSPECCIO INTO n_resulatInspeccio
  FROM TIPO_INSPECCIO
  WHERE TIPO_INSPECCIO.IDTINSPCCIO=p_idInspeccioCentral;
  
  SELECT DISTINCT ESTAT.DESCRIPCIOESTAT INTO n_descEstat
  FROM ESTAT
  WHERE ESTAT.IDESTAT=n_estatCentral;
        
    SELECT  DISTINCT CLASSE_CENTRAL.DESCRIPCIOCLASSE INTO n_descClasseCentral
  FROM CLASSE_CENTRAL
  WHERE CLASSE_CENTRAL.IDCLASSE=n_idClasseCentral;
  
      SELECT DISTINCT LOCALITAT.DESCRIPCIOLOCALITAT  INTO n_localitatCentral
  FROM  UBICACIO, LOCALITAT
  WHERE UBICACIO.IDUBICA=p_idUbicaCentral
  AND UBICACIO.IDLOCALITATUBICACIO=LOCALITAT.IDLOCALITAT;
  
  
 -- Comprovem si existeix el        
            
  SELECT COUNT (*) INTO n_registres
  FROM CENTRAL
  WHERE IDUBICACENTRAL=p_idUbicaCentral
  AND  CENTRAL.IDCLASSECENTRAL=n_idTipoCentral;   
  
       
  If n_registres=0 then
 -- El donem d'alta a la Classe de Central 
 n_idTipoCentral:=6;
  n_estatCentral:=1;
  n_idClasseCentral:=2;
 INSERT INTO CENTRAL(DATAALTACENTRAL,
                     ESTATCENTRAL,
                     IDCLASSECENTRAL,
                     IDTIPOCENTRAL,
                     DATAULTIMAINSPECCIOCENTRAL,
                     IDINSPECCIOCENTRAL,
                     ENERGIAMAXIMA,
                     ENERGIAMINIMA,
                     IDUBICACENTRAL,
                     OBSERVACIONSCENTRAL) 
            VALUES(p_dataAltaCentral,
                  n_estatCentral,
                  n_idClasseCentral,
                  n_idTipoCentral,
                  p_dataUltmimaInspeccioCentral,
                  p_idInspeccioCentral,
                  p_energiaMax,
                  p_energiaMin,
                  p_idUbicaCentral,
                  p_observacionsCentral);
              
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE( 'Insertada la Central amb  
  Data Alta Central: ' ||p_dataAltaCentral|| 
  ', Estat Central Distribucio: ' ||p_estatCentral||' '||n_descEstat||
  '  Tipo Central: '||n_descTipoCentral||
  ', Data Inspeccio Central Distribucio: ' ||p_dataUltmimaInspeccioCentral|| 
  ', Resultat Inspeccio Distribucio: ' ||p_idInspeccioCentral||' '||n_resulatInspeccio||
  ', Energía Máxima Distribucio: ' ||p_energiaMax||
  ', Energía Minima Distribucio: ' ||p_energiaMin||
  ', Direccio Central Distribucio: ' ||p_idUbicaCentral||' '||n_localitatCentral||
  ', Observacions Central Distribucio: ' ||p_observacionsCentral);
   DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
  --Gravem en la taula log-----------------------------------------------------
   DBMS_OUTPUT.put_line ('OK: Insertada' || p_idTipoCentral);
    s_rsp :='Ok: insertada Central Distribucio: Data Alta Central: ' ||p_dataAltaCentral|| 
  ', Estat Central Distribucio: '||n_descEstat||
  '  Tipo Central: '||n_descTipoCentral||
   ', Energía Máxima Distribucio: ' ||p_energiaMax||
  ', Energía Minima Distribucio: ' ||p_energiaMin;
  pkg_general.gravar_log_procedure(c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  ELSE
  DBMS_OUTPUT.ENABLE;
         DBMS_OUTPUT.PUT_LINE('        ALTA CENTRAL DISTRIBUCIO          '); 
         DBMS_OUTPUT.PUT_LINE('------------------------------------------');
  DBMS_OUTPUT.PUT_LINE('Central Distribucio Duplicada ');
  s_rsp := 'Central Distribucio duplicada Data Alta Central: ' ||p_dataAltaCentral|| 
  ', Estat Central Distribucio: ' ||p_estatCentral||' '||n_descEstat||
  '  Tipo Central: '||n_descTipoCentral||
  ', Energía Máxima Distribucio: ' ||p_energiaMax||
  ', Energía Minima Distribucio: ' ||p_energiaMin||
  ', Direccio Central Distribucio: '||n_localitatCentral;
  DBMS_OUTPUT.PUT_LINE(s_rsp);
  RAISE e_central;
 END IF;
COMMIT;
EXCEPTION
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         s_rsp := 'Error: ' || SQLCODE || SUBSTR (SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' ');
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
ROLLBACK;           
END PRC_ALTA_CENTRAL_DISTRIBUCIO; 

/********************************************************************************
   NOM:         PRC_BAIXA_CENTRAL
   DESCRIPCIÓ:
                Procediment encarregat donar BAIXA  Central. 
                Es una modificacio de estat de la Central.
                0=BAIXA
                1=ALTA
                El procediment actualitza estatCentral a 0
********************************************************************************/
PROCEDURE PRC_BAIXA_CENTRAL(
          p_idCentral in CENTRAL.idCentral%TYPE,
          p_estatCentral in CENTRAL.estatCentral%Type,	
          p_dataModificacioCentral in CENTRAL.DATAMODIFICACENTRAL%Type,
          s_rsp out NOCOPY VARCHAR2)
AS
BEGIN
  --Parametres per la taula LOG
      c_procesLog := 'PRC_BAIXA_CENTRAL';
      c_dataHoraLog := SYSDATE;
      c_entradaLog := 'Id Central: ' ||p_idCentral|| 
                      ', Data Modificacio Central: ' ||p_dataModificacioCentral;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('            BAIXA CENTRAL                  '); 
      DBMS_OUTPUT.PUT_LINE('-------------------------------------------');      
      DBMS_OUTPUT.PUT_LINE(' Id Central: ' ||p_idCentral|| 
      ', Data Modificacio Central: ' ||p_dataModificacioCentral); 
      c_sortidalog := 's_rsp';
       -- Comprovem que Classe de Central sigui 1=Produccio i les dades que es volen inserir 
      SELECT CENTRAL.ESTATCENTRAL INTO n_controlEstatCentral
      FROM CENTRAL
      WHERE CENTRAL.IDCENTRAL=p_idCentral;
      
      IF n_controlEstatCentral=2 THEN
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('            BAIXA CENTRAL                  '); 
      DBMS_OUTPUT.PUT_LINE('-------------------------------------------');     
      s_rsp := 'La Central ja esta de Baixa.  ';
      DBMS_OUTPUT.PUT_LINE(s_rsp);               
      RAISE  e_central;
      END IF; 
      
      IF  p_idCentral IS NULL THEN
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('            BAIXA CENTRAL                  '); 
      DBMS_OUTPUT.PUT_LINE('-------------------------------------------');     
      s_rsp := 'Falta en id de la Central ';
      DBMS_OUTPUT.PUT_LINE(s_rsp);               
      RAISE  e_central;
      END IF;
      
      IF  p_dataModificacioCentral IS NULL THEN
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('            BAIXA CENTRAL                  '); 
      DBMS_OUTPUT.PUT_LINE('-------------------------------------------');     
      s_rsp := 'Falta la Data de Modificacio ';
      DBMS_OUTPUT.PUT_LINE(s_rsp);               
      RAISE  e_central;
    END IF;
    
    n_estatCentral:=2;
    
    SELECT CENTRAL.IDCENTRAL INTO n_idCentral
    FROM CENTRAL
    WHERE IDCENTRAL= p_idCentral;
              
  s_sql := 'UPDATE CENTRAL SET ESTATCENTRAL=n_estatCentral';
        
-- Construirem la sentencia UPDATE segons si hi ha valor en els paràmetres-
  IF p_dataModificacioCentral IS NOT NULL THEN
-- Modifiquem el descripcio classe central
  s_sql := s_sql || 'DATAMODIFICACENTRAL=''' ||p_dataModificacioCentral|| ''',';
  END IF;
                              
  -- Eliminem la coma final de la sentencia SQL
 s_sql := SUBSTR (s_sql, 1, LENGTH (s_sql) - 1);
-- Afegim a la sentencia la condició del WHER
 s_sql := s_sql || ' WHERE IDCENTRAL=''' || n_idCentral|| '''';
EXECUTE IMMEDIATE s_sql;

IF SQL%ROWCOUNT = 0 THEN
--L'error serà que id Central ja el tenim en la taula i no admet duplicats--
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('            BAIXA CENTRAL                  '); 
  DBMS_OUTPUT.PUT_LINE('-------------------------------------------');     
  s_rsp := 'Actualitzacio no realitzada '||p_idCentral;
  DBMS_OUTPUT.PUT_LINE(s_rsp);                  
  RAISE e_central;
ELSE

SELECT CLASSE_CENTRAL.DESCRIPCIOCLASSE INTO n_descClasseCentral
FROM CLASSE_CENTRAL,CENTRAL
WHERE CENTRAL.IDCLASSECENTRAL=CLASSE_CENTRAL.IDCLASSE
AND CENTRAL.IDCENTRAL=p_idCentral;

SELECT ESTAT.DESCRIPCIOESTAT INTO n_descEstat
FROM ESTAT
WHERE ESTAT.IDESTAT=n_estatCentral;

  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('Central ha estat donada de baixa: 
  Codi Central: '||p_idCentral||' '||n_descClasseCentral||
  ' Estat: ' ||n_descEstat||
  ', Data Modificacio Central: ' ||p_dataModificacioCentral);
   DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
  s_rsp := 'OK Central ha estat donada de baixa: 
  Codi Central: '||p_idCentral||' '||n_descClasseCentral||
  ' Estat: ' ||n_descEstat||
  ', Data Modificacio Central: ' ||p_dataModificacioCentral;
   pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
 END IF;
COMMIT;
 EXCEPTION

   WHEN DUP_VAL_ON_INDEX THEN
      DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('            BAIXA CENTRAL                  '); 
  DBMS_OUTPUT.PUT_LINE('-------------------------------------------');    
      s_rsp := 'Error: Central duplicada. No es poden fer les modificacions';
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;      
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         -----------------------------------------
         s_rsp := 'Error: ' || SQLCODE || SUBSTR(SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         -----------------------------------------
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' '); 
      DBMS_OUTPUT.put_line (s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  ROLLBACK;
END PRC_BAIXA_CENTRAL;

/********************************************************************************
   NOM:         PRC_ALTA_CENTRAL
   DESCRIPCIÓ:
                Procediment encarregat donar BAIXA  Central. 
                Es una modificacio de estat de la Central.
                0=BAIXA
                1=ALTA
                El procediment actualitza estatCentral a 0
********************************************************************************/
PROCEDURE PRC_ALTA_CENTRAL(
          p_idCentral in CENTRAL.idCentral%TYPE,
          p_estatCentral in CENTRAL.estatCentral%Type,	
          p_dataModificacioCentral in CENTRAL.DATAMODIFICACENTRAL%Type,
          s_rsp out NOCOPY VARCHAR2)
AS

BEGIN
  --Parametres per la taula LOG
      c_procesLog := 'PRC_ALTA_CENTRAL';
      c_dataHoraLog := SYSDATE;
      c_entradaLog := 'Id Central: ' ||p_idCentral|| 
                      ', Data Modificacio Central: ' ||p_dataModificacioCentral;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('            ALTA CENTRAL                  '); 
      DBMS_OUTPUT.PUT_LINE('-------------------------------------------');      
      DBMS_OUTPUT.PUT_LINE(' Id Central: ' ||p_idCentral|| 
      ', Data Modificacio Central: ' ||p_dataModificacioCentral); 
      c_sortidalog := 's_rsp';
       -- Comprovem que Classe de Central sigui 1=Produccio i les dades que es volen inserir 
      SELECT CENTRAL.ESTATCENTRAL INTO n_controlEstatCentral
      FROM CENTRAL
      WHERE CENTRAL.IDCENTRAL=p_idCentral;
      
      IF n_controlEstatCentral=1 THEN
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('            ALTA CENTRAL                  '); 
      DBMS_OUTPUT.PUT_LINE('-------------------------------------------');     
      s_rsp := 'La Central ja esta en ALTA.  ';
      DBMS_OUTPUT.PUT_LINE(s_rsp);               
      RAISE  e_central;
      END IF; 
      
      IF  p_idCentral IS NULL THEN
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('            ALTA CENTRAL                  '); 
      DBMS_OUTPUT.PUT_LINE('-------------------------------------------');    
      s_rsp := 'Falta en id de la Central ';
      DBMS_OUTPUT.PUT_LINE(s_rsp);               
      RAISE  e_central;
      END IF;
      
      IF  p_dataModificacioCentral IS NULL THEN
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('            ALTA CENTRAL                  '); 
      DBMS_OUTPUT.PUT_LINE('-------------------------------------------');
      s_rsp := 'Falta la Data de Modificacio ';
      DBMS_OUTPUT.PUT_LINE(s_rsp);               
      RAISE  e_central;
    END IF;
    
    n_estatCentral:=1;
    
    SELECT CENTRAL.IDCENTRAL INTO n_idCentral
    FROM CENTRAL
    WHERE IDCENTRAL= p_idCentral;
              
  s_sql := 'UPDATE CENTRAL SET ESTATCENTRAL=n_estatCentral';
        
-- Construirem la sentencia UPDATE segons si hi ha valor en els paràmetres-
  IF p_dataModificacioCentral IS NOT NULL THEN
-- Modifiquem el descripcio classe central
  s_sql := s_sql || 'DATAMODIFICACENTRAL=''' ||p_dataModificacioCentral|| ''',';
  END IF;
                              
  -- Eliminem la coma final de la sentencia SQL
 s_sql := SUBSTR (s_sql, 1, LENGTH (s_sql) - 1);
-- Afegim a la sentencia la condició del WHER
 s_sql := s_sql || ' WHERE IDCENTRAL=''' || n_idCentral|| '''';
EXECUTE IMMEDIATE s_sql;

IF SQL%ROWCOUNT = 0 THEN
--L'error serà que id Central ja el tenim en la taula i no admet duplicats--
  DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('            ALTA CENTRAL                  '); 
      DBMS_OUTPUT.PUT_LINE('-------------------------------------------');  
  s_rsp := 'Actualitzacio no realitzada '||p_idCentral;
  DBMS_OUTPUT.PUT_LINE(s_rsp);                  
  RAISE e_central;
ELSE

SELECT CLASSE_CENTRAL.DESCRIPCIOCLASSE INTO n_descClasseCentral
FROM CLASSE_CENTRAL,CENTRAL
WHERE CENTRAL.IDCLASSECENTRAL=CLASSE_CENTRAL.IDCLASSE
AND CENTRAL.IDCENTRAL=p_idCentral;

SELECT ESTAT.DESCRIPCIOESTAT INTO n_descEstat
FROM ESTAT
WHERE ESTAT.IDESTAT=n_estatCentral;

  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('Central ha estat donada en alta: 
  Codi Central: '||p_idCentral||' '||n_descClasseCentral||
  ' Estat: ' ||n_descEstat||
  ', Data Modificacio Central: ' ||p_dataModificacioCentral);
   DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
  s_rsp := 'OK Central ha estat donada de alta: 
  Codi Central: '||p_idCentral||' '||n_descClasseCentral||
  ' Estat: ' ||n_descEstat||
  ', Data Modificacio Central: ' ||p_dataModificacioCentral;
   pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
 END IF;
COMMIT;
 EXCEPTION

   WHEN DUP_VAL_ON_INDEX THEN
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('            ALTA CENTRAL                  '); 
      DBMS_OUTPUT.PUT_LINE('-------------------------------------------');
      s_rsp := 'Error: Central duplicada. No es poden fer les modificacions';
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;      
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         -----------------------------------------
         s_rsp := 'Error: ' || SQLCODE || SUBSTR(SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         -----------------------------------------
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' '); 
      DBMS_OUTPUT.put_line (s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  ROLLBACK;
END PRC_ALTA_CENTRAL;
/********************************************************************************
   NOM:         PRC_MODIFICAR_CENTRAL_PRODUC
   DESCRIPCIÓ:
                Procediment encarregat modificar la Central de Produccio. 
                Es crea un cursor per controlar si el valor de  la Classe de
                Central = 1 si es aixi modifiquem l'estructura de dades
                de la Central de Producció.
               
********************************************************************************/
PROCEDURE PRC_MODIFICAR_CENTRAL_PRODUC(
          p_idCentral in CENTRAL.IDCENTRAL%TYPE,
          p_estatCentral in CENTRAL.ESTATCENTRAL%Type,
          p_dataModificacioCentral in CENTRAL.DATAMODIFICACENTRAL%Type,
          p_idClasseCentral in CENTRAL.IDCLASSECENTRAL%Type,
          p_idTipoCentral in CENTRAL.IDTIPOCENTRAL%Type,
          p_dataUltmimaInspeccioCentral in CENTRAL.DATAULTIMAINSPECCIOCENTRAL%TYPE,
          p_idInspeccioCentral in CENTRAL.IDINSPECCIOCENTRAL%Type,
          p_energiaMax in CENTRAL.ENERGIAMAXIMA%Type,
          p_energiaMin in CENTRAL.ENERGIAMINIMA%Type,
          p_idUbicaCentral in CENTRAL.IDUBICACENTRAL%Type,
          p_observacionsCentral in CENTRAL.OBSERVACIONSCENTRAL%Type,
          s_rsp out NOCOPY VARCHAR2)
AS

BEGIN
 --Parametres per la taula LOG
     c_procesLog := 'PRC_MODIFICAR_CENTRAL_PRODUC';
     c_dataHoraLog := SYSDATE;
     c_entradaLog :='Id Central Produccio: ' ||p_idCentral|| 
   		', Data Modificacio Central Produccio: ' ||p_dataModificacioCentral|| 
                --', Id Classe Central Produccio: ' ||p_idClasseCentral || 
                ', Id Tipo Central Produccio: ' ||p_idTipoCentral|| 
   		', Id Inspeccio Central Produccio: ' ||p_idInspeccioCentral||
                ', Data Ultima Inspeccio Central Produccio: '||p_dataUltmimaInspeccioCentral||
                ', Energia Maxima Central Produccio: ' ||p_energiaMax ||
                ', Energia Minma Central Produccio: ' || p_energiaMin||
                ', Id Ubicacio Central Produccio: ' ||p_idUbicaCentral ||
   		', observacions Central Produccio: ' ||p_observacionsCentral;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' ');  
      DBMS_OUTPUT.PUT_LINE('    MODIFICAR LA CENTRAL DE PRODUCCIO     '); 
      DBMS_OUTPUT.PUT_LINE('----------------------------------------- ');
      DBMS_OUTPUT.PUT_LINE('Id Central Produccio: ' ||p_idCentral|| 
   		', Data Modificacio Central Produccio: ' ||p_dataModificacioCentral|| 
                --', Id Classe Central Produccio: ' ||p_idClasseCentral || 
                ', Id Tipo Central Produccio: ' ||p_idTipoCentral|| 
   		', Id Inspeccio Central Produccio: ' ||p_idInspeccioCentral||
                ', Data Ultima Inspeccio Central Produccio: '||p_dataUltmimaInspeccioCentral||
                ', Energia Maxima Central Produccio: ' ||p_energiaMax ||
                ', Energia Minma Central Produccio: ' || p_energiaMin||
                ', Id Ubicacio Central Produccio: ' ||p_idUbicaCentral ||
   		', observacions Central Produccio: ' ||p_observacionsCentral);
    c_sortidalog := 's_rsp';

SELECT  CENTRAL.IDCLASSECENTRAL INTO n_idClasseCentral
FROM  CENTRAL
WHERE CENTRAL.IDCLASSECENTRAL=1;

SELECT CLASSE_CENTRAL.DESCRIPCIOCLASSE INTO n_descClasseCentral
FROM  CLASSE_CENTRAL
WHERE CLASSE_CENTRAL.IDCLASSE=1;

-- MIREM SI LA CENTRAL ES DE PRODUCCIO
 IF n_idClasseCentral<>1 THEN
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('MODIFICAR LA CENTRAL DE PRODUCCIO:     '); 
  s_rsp := 'La central no es de Produccio es de '||n_descClasseCentral;
  DBMS_OUTPUT.PUT_LINE(s_rsp);        
  RAISE e_central;
  END IF;
  
-- Comprovació del identificador Central
  IF p_idCentral IS NULL THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('MODIFICAR LA CENTRAL DE PRODUCCIO:     '); 
    s_rsp := 'Falta especificar el el codi de la central ';
    DBMS_OUTPUT.PUT_LINE(s_rsp);        
    RAISE e_central;
  END IF;
  IF  p_dataModificacioCentral IS NULL THEN
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('MODIFICAR LA CENTRAL DE PRODUCCIO:     '); 
      s_rsp := 'Falta la Data de Modificacio ';
      DBMS_OUTPUT.PUT_LINE(s_rsp);               
      RAISE  e_central;
  END IF;
 IF  p_idTipoCentral IS NULL THEN
     DBMS_OUTPUT.ENABLE;
     DBMS_OUTPUT.PUT_LINE('MODIFICAR LA CENTRAL DE PRODUCCIO:     '); 
     s_rsp := 'Falta Id Tipo Central a Modificar ';
     DBMS_OUTPUT.PUT_LINE(s_rsp);               
     RAISE  e_central;
  END IF;          
  IF  p_idInspeccioCentral IS NULL THEN
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('MODIFICAR LA CENTRAL DE PRODUCCIO:     '); 
      s_rsp := 'Falta Id Inspeccio a Modificar ';
      DBMS_OUTPUT.PUT_LINE(s_rsp);               
      RAISE  e_central;
  END IF;
  IF  p_dataUltmimaInspeccioCentral IS NULL THEN
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('MODIFICAR LA CENTRAL DE PRODUCCIO:     '); 
      s_rsp := 'Falta Data Ultima Inspeccio a Modificar ';
      DBMS_OUTPUT.PUT_LINE(s_rsp);               
      RAISE  e_central;
  END IF;     
  IF  (p_energiaMax IS NULL)  OR (p_energiaMax<0) THEN
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('MODIFICAR LA CENTRAL DE PRODUCCIO:     '); 
      s_rsp := 'Falta Energia Maxima a Modificar o el valor es mes petit que 0 ';
      DBMS_OUTPUT.PUT_LINE(s_rsp);               
      RAISE  e_central;
  END IF;       
  IF  (p_energiaMin IS NULL) OR (p_energiaMin<0) THEN
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('MODIFICAR LA CENTRAL DE PRODUCCIO:     '); 
      s_rsp := 'Falta Energia Minima a Modificar o el valor es mes petit que 0  ';
      DBMS_OUTPUT.PUT_LINE(s_rsp);               
      RAISE  e_central;
  END IF;
  IF  p_idUbicaCentral  IS NULL THEN
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('MODIFICAR LA CENTRAL DE PRODUCCIO:     '); 
      s_rsp := 'Falta id Ubicacio Central a Modificar ';
      DBMS_OUTPUT.PUT_LINE(s_rsp);               
      RAISE  e_central;
  END IF;  
  SELECT COUNT (*) INTO n_registres 
  FROM CENTRAL
  WHERE idCentral = p_idCentral
  AND CENTRAL.IDCLASSECENTRAL=n_idClasseCentral;

  If n_registres=0 then
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('MODIFICAR LA CENTRAL DE PRODUCCIO:     '); 
    s_rsp := 'CENTRAL_PRODUCCIO no existeix a la BBDD';
    DBMS_OUTPUT.PUT_LINE(s_rsp);
    RAISE e_central;
  END IF;
-- recuperem el codi de la central
  SELECT CENTRAL.IDCENTRAL INTO n_idCentral
  FROM CENTRAL
  WHERE CENTRAL.IDCENTRAL= p_idCentral;
              
       	s_sql := 'UPDATE CENTRAL SET ';

-- Construirem la sentencia UPDATE segons si hi ha valor en els paràmetres-
  IF p_dataModificacioCentral IS NOT NULL THEN
-- Modifiquem el data modificacio central
    s_sql := s_sql || 'DATAMODIFICACENTRAL=''' ||p_dataModificacioCentral|| ''',';
  END IF;
  IF p_idTipoCentral IS NOT NULL THEN
-- Modifiquem el id Tipo Central
    s_sql := s_sql || 'IDTIPOCENTRAL=''' ||p_idTipoCentral|| ''',';
  END IF;
  IF p_idInspeccioCentral IS NOT NULL THEN
-- Modifiquem el id Tipo Central central
     s_sql := s_sql || 'IDINSPECCIOCENTRAL=''' ||p_idInspeccioCentral|| ''',';
  END IF;
  IF p_dataUltmimaInspeccioCentral IS NOT NULL THEN
-- Modifiquem data Ultmima Inspeccio Central
     s_sql := s_sql || 'DATAULTIMAINSPECCIOCENTRAL=''' ||p_dataUltmimaInspeccioCentral|| ''',';
  END IF;
  IF p_energiaMax IS NOT NULL THEN
-- Modifiquem energia Maxima central
    s_sql := s_sql || 'ENERGIAMAXIMA=''' ||p_energiaMax|| ''',';
  END IF;
  IF p_energiaMin IS NOT NULL THEN
-- Modifiquem energia Minima central
    s_sql := s_sql || 'ENERGIAMINIMA=''' ||p_energiaMin|| ''',';
  END IF;
  IF p_idUbicaCentral IS NOT NULL THEN
-- Modifiquem Id Ubicacio Central
    s_sql := s_sql || 'IDUBICACENTRAL=''' ||p_idUbicaCentral|| ''',';
  END IF;
  IF p_observacionsCentral IS NOT NULL THEN
-- Modifiquem el observacions central
    s_sql := s_sql || 'OBSERVACIONSCENTRAL=''' ||p_observacionsCentral|| ''',';
  END IF;
-- Eliminem la coma final de la sentencia SQL
    s_sql := SUBSTR (s_sql, 1, LENGTH (s_sql) - 1);
-- Afegim a la sentencia la condició del WHERE
    s_sql := s_sql || ' WHERE IDCENTRAL=''' ||n_idCentral|| '''';

EXECUTE IMMEDIATE s_sql;
  IF SQL%ROWCOUNT = 0 THEN
--L'error serà que id Central ja el tenim en la taula i no admet duplicats--
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('MODIFICAR LA CENTRAL DE PRODUCCIO:     '); 
    s_rsp := 'Actualitzacio no realitzada';
    DBMS_OUTPUT.PUT_LINE(s_rsp);                  
    RAISE e_central;
  ELSE
  SELECT TIPO_CENTRAL.DESCRIPCIOTIPOCENTRAL INTO n_descTipoCentral
  FROM CENTRAL, TIPO_CENTRAL
  WHERE CENTRAL.IDTIPOCENTRAL=p_idTipoCentral
  AND CENTRAL.IDTIPOCENTRAL=TIPO_CENTRAL.IDTIPOCENTRAL;
  
  SELECT LOCALITAT.DESCRIPCIOLOCALITAT INTO n_localitatCentral
  FROM UBICACIO, LOCALITAT
  WHERE UBICACIO.IDUBICA=p_idUbicaCentral
  AND UBICACIO.IDLOCALITATUBICACIO=LOCALITAT.IDLOCALITAT;
  
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('Actualitzacio satisfactoria Id Central Produccio: ' ||p_idCentral|| 
   		', Data Modificacio Central Produccio: ' ||p_dataModificacioCentral|| 
                ', Classe Central: ' ||n_descClasseCentral|| 
                ', Id Tipo Central Produccio: ' ||p_idTipoCentral||' '||n_descTipoCentral|| 
   		', Id Inspeccio Central Produccio: ' ||p_idInspeccioCentral||
                ', Data Ultima Inspeccio Central Produccio: '||p_dataUltmimaInspeccioCentral||
                ', Energia Maxima Central Produccio: ' ||p_energiaMax ||
                ', Energia Minma Central Produccio: ' || p_energiaMin||
                ', Ubicacio Central Produccio: ' ||n_localitatCentral||
   		', observacions Central Produccio: ' ||p_observacionsCentral);
    DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
    s_rsp := 'OK Actualitzacio satisfactoria Actualitzacio satisfactoria 
                Id Central Produccio: ' ||p_idCentral|| 
   		', Data Modificacio Central Produccio: ' ||p_dataModificacioCentral|| 
                ', Classe Central: ' ||n_descClasseCentral|| 
                ', Id Tipo Central Produccio: ' ||p_idTipoCentral||' '||n_descTipoCentral|| 
   		', Id Inspeccio Central Produccio: ' ||p_idInspeccioCentral||
                ', Data Ultima Inspeccio Central Produccio: '||p_dataUltmimaInspeccioCentral||
                ', Energia Maxima Central Produccio: ' ||p_energiaMax ||
                ', Energia Minma Central Produccio: ' || p_energiaMin||
                ', Ubicacio Central Produccio: ' ||n_localitatCentral||
   		', observacions Central Produccio: ' ||p_observacionsCentral;
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
    END IF;

COMMIT;
 EXCEPTION
	
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi-----------------------------------------
         s_rsp := 'Error: ' || SQLCODE || SUBSTR(SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi-----------------------------------------
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
       DBMS_OUTPUT.PUT_LINE(' '); 
      DBMS_OUTPUT.put_line (s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;
  
END PRC_MODIFICAR_CENTRAL_PRODUC;
/********************************************************************************
   NOM:         PRC_MODIFICAR_CENTRAL_DISTRIB
   DESCRIPCIÓ:
                Procediment encarregat modificar la Central de Distribució. 
                Es crea un cursor per controlar si el valor de  la Classe de
                Central = 1 si es aixi modifiquem l'estructura de dades
                de la Central de Distribució.
               
********************************************************************************/
PROCEDURE PRC_MODIFICAR_CENTRAL_DISTRIB(
p_idCentral in CENTRAL.IDCENTRAL%TYPE,
          p_estatCentral in CENTRAL.estatCentral%Type,
          p_dataModificacioCentral in CENTRAL.DATAMODIFICACENTRAL%Type,
          p_idClasseCentral in CENTRAL.IDCLASSECENTRAL%Type,
          p_idTipoCentral in CENTRAL.idTipoCentral%Type,
          p_idInspeccioCentral in CENTRAL.IDINSPECCIOCENTRAL%Type,
          p_dataUltmimaInspeccioCentral in CENTRAL.DATAULTIMAINSPECCIOCENTRAL%TYPE,
          p_energiaMax in CENTRAL.ENERGIAMAXIMA%Type,
          p_energiaMin in CENTRAL.ENERGIAMINIMA%Type,
          p_idUbicaCentral in CENTRAL.idUbicaCentral%Type,
          p_observacionsCentral in CENTRAL.observacionsCentral%Type,
          s_rsp out NOCOPY VARCHAR2)
 
AS

BEGIN
 --Parametres per la taula LOG
     c_procesLog := 'PRC_MODIFICAR_CENTRAL_PRODUC';
     c_dataHoraLog := SYSDATE;
     c_entradaLog :='Id Central Produccio: ' ||p_idCentral|| 
   		', Data Modificacio Central Produccio: ' ||p_dataModificacioCentral|| 
                --', Id Classe Central Produccio: ' ||p_idClasseCentral || 
                --', Id Tipo Central Produccio: ' ||p_idTipoCentral|| 
   		', Id Inspeccio Central Produccio: ' ||p_idInspeccioCentral||
                ', Data Ultima Inspeccio Central Produccio: '||p_dataUltmimaInspeccioCentral||
                ', Energia Maxima Central Produccio: ' ||p_energiaMax ||
                ', Energia Minma Central Produccio: ' || p_energiaMin||
                ', Id Ubicacio Central Produccio: ' ||p_idUbicaCentral ||
   		', observacions Central Produccio: ' ||p_observacionsCentral;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' ');  
      DBMS_OUTPUT.PUT_LINE('    MODIFICAR LA CENTRAL DE DISTRIBUCIO     '); 
      DBMS_OUTPUT.PUT_LINE('------------------------------------------- ');
      DBMS_OUTPUT.PUT_LINE('Id Central Produccio: ' ||p_idCentral|| 
   		', Data Modificacio Central Produccio: ' ||p_dataModificacioCentral|| 
                --', Id Classe Central Produccio: ' ||p_idClasseCentral || 
                --', Id Tipo Central Produccio: ' ||p_idTipoCentral|| 
   		', Id Inspeccio Central Produccio: ' ||p_idInspeccioCentral||
                ', Data Ultima Inspeccio Central Produccio: '||p_dataUltmimaInspeccioCentral||
                ', Energia Maxima Central Produccio: ' ||p_energiaMax ||
                ', Energia Minma Central Produccio: ' || p_energiaMin||
                ', Id Ubicacio Central Produccio: ' ||p_idUbicaCentral ||
   		', observacions Central Produccio: ' ||p_observacionsCentral);
    c_sortidalog := 's_rsp';

SELECT  CENTRAL.IDCLASSECENTRAL INTO n_idClasseCentral
FROM  CENTRAL
WHERE CENTRAL.IDCLASSECENTRAL=2;

SELECT CLASSE_CENTRAL.DESCRIPCIOCLASSE INTO n_descClasseCentral
FROM  CLASSE_CENTRAL
WHERE CLASSE_CENTRAL.IDCLASSE=2;

-- MIREM SI LA CENTRAL ES DE PRODUCCIO
 IF n_idClasseCentral<>1 THEN
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('MODIFICAR LA CENTRAL DE DISTRIBUCIO:     '); 
  s_rsp := 'La central no es de DISTRIBUCIO es de '||n_descClasseCentral;
  DBMS_OUTPUT.PUT_LINE(s_rsp);        
  RAISE e_central;
  END IF;
  
-- Comprovació del identificador Central
  IF p_idCentral IS NULL THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('MODIFICAR LA CENTRAL DE DISTRIBUCIO:     '); 
    s_rsp := 'Falta especificar el el codi de la central ';
    DBMS_OUTPUT.PUT_LINE(s_rsp);        
    RAISE e_central;
  END IF;
  IF  p_dataModificacioCentral IS NULL THEN
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('MODIFICAR LA CENTRAL DE DISTRIBUCIO:     '); 
      s_rsp := 'Falta la Data de Modificacio ';
      DBMS_OUTPUT.PUT_LINE(s_rsp);               
      RAISE  e_central;
  END IF;
          
  IF  p_idInspeccioCentral IS NULL THEN
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('MODIFICAR LA CENTRAL DE DISTRIBUCIO:     '); 
      s_rsp := 'Falta Id Inspeccio a Modificar ';
      DBMS_OUTPUT.PUT_LINE(s_rsp);               
      RAISE  e_central;
  END IF;
  IF  p_dataUltmimaInspeccioCentral IS NULL THEN
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('MODIFICAR LA CENTRAL DE DISTRIBUCIO:     '); 
      s_rsp := 'Falta Data Ultima Inspeccio a Modificar ';
      DBMS_OUTPUT.PUT_LINE(s_rsp);               
      RAISE  e_central;
  END IF;     
  IF  (p_energiaMax IS NULL)  OR (p_energiaMax<0) THEN
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('MODIFICAR LA CENTRAL DE DISTRIBUCIO:     '); 
      s_rsp := 'Falta Energia Maxima a Modificar o el valor es mes petit que 0 ';
      DBMS_OUTPUT.PUT_LINE(s_rsp);               
      RAISE  e_central;
  END IF;       
  IF  (p_energiaMin IS NULL) OR (p_energiaMin<0) THEN
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('MODIFICAR LA CENTRAL DE DISTRIBUCIO:     '); 
      s_rsp := 'Falta Energia Minima a Modificar o el valor es mes petit que 0  ';
      DBMS_OUTPUT.PUT_LINE(s_rsp);               
      RAISE  e_central;
  END IF;
  IF  p_idUbicaCentral  IS NULL THEN
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('MODIFICAR LA CENTRAL DE DISTRIBUCIO:     '); 
      s_rsp := 'Falta id Ubicacio Central a Modificar ';
      DBMS_OUTPUT.PUT_LINE(s_rsp);               
      RAISE  e_central;
  END IF;  
  SELECT COUNT (*) INTO n_registres 
  FROM CENTRAL
  WHERE idCentral = p_idCentral
  AND CENTRAL.IDCLASSECENTRAL=n_idClasseCentral;

  If n_registres=0 then
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('MODIFICAR LA CENTRAL DE DISTRIBUCIO:     '); 
    s_rsp := 'CENTRAL DISTRIBUCIO no existeix a la BBDD';
    DBMS_OUTPUT.PUT_LINE(s_rsp);
    RAISE e_central;
  END IF;
-- recuperem el codi de la central
  SELECT CENTRAL.IDCENTRAL INTO n_idCentral
  FROM CENTRAL
  WHERE CENTRAL.IDCENTRAL= p_idCentral;
              
       	s_sql := 'UPDATE CENTRAL SET ';

-- Construirem la sentencia UPDATE segons si hi ha valor en els paràmetres-
  IF p_dataModificacioCentral IS NOT NULL THEN
-- Modifiquem el data modificacio central
    s_sql := s_sql || 'DATAMODIFICACENTRAL=''' ||p_dataModificacioCentral|| ''',';
  END IF;
 IF p_idInspeccioCentral IS NOT NULL THEN
-- Modifiquem el id Tipo Central central
     s_sql := s_sql || 'IDINSPECCIOCENTRAL=''' ||p_idInspeccioCentral|| ''',';
  END IF;
  IF p_dataUltmimaInspeccioCentral IS NOT NULL THEN
-- Modifiquem data Ultmima Inspeccio Central
     s_sql := s_sql || 'DATAULTIMAINSPECCIOCENTRAL=''' ||p_dataUltmimaInspeccioCentral|| ''',';
  END IF;
  IF p_energiaMax IS NOT NULL THEN
-- Modifiquem energia Maxima central
    s_sql := s_sql || 'ENERGIAMAXIMA=''' ||p_energiaMax|| ''',';
  END IF;
  IF p_energiaMin IS NOT NULL THEN
-- Modifiquem energia Minima central
    s_sql := s_sql || 'ENERGIAMINIMA=''' ||p_energiaMin|| ''',';
  END IF;
  IF p_idUbicaCentral IS NOT NULL THEN
-- Modifiquem Id Ubicacio Central
    s_sql := s_sql || 'IDUBICACENTRAL=''' ||p_idUbicaCentral|| ''',';
  END IF;
  IF p_observacionsCentral IS NOT NULL THEN
-- Modifiquem el observacions central
    s_sql := s_sql || 'OBSERVACIONSCENTRAL=''' ||p_observacionsCentral|| ''',';
  END IF;
-- Eliminem la coma final de la sentencia SQL
    s_sql := SUBSTR (s_sql, 1, LENGTH (s_sql) - 1);
-- Afegim a la sentencia la condició del WHERE
    s_sql := s_sql || ' WHERE IDCENTRAL=''' ||n_idCentral|| '''';

EXECUTE IMMEDIATE s_sql;
  IF SQL%ROWCOUNT = 0 THEN
--L'error serà que id Central ja el tenim en la taula i no admet duplicats--
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('MODIFICAR LA CENTRAL DE PRODUCCIO:     '); 
    s_rsp := 'Actualitzacio no realitzada';
    DBMS_OUTPUT.PUT_LINE(s_rsp);                  
    RAISE e_central;
  ELSE
    
  SELECT LOCALITAT.DESCRIPCIOLOCALITAT INTO n_localitatCentral
  FROM CENTRAL, UBICACIO, LOCALITAT
  WHERE UBICACIO.IDUBICA=p_idUbicaCentral
  AND UBICACIO.IDLOCALITATUBICACIO=LOCALITAT.IDLOCALITAT;
  
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('Actualitzacio satisfactoria Id Central Produccio: ' ||p_idCentral|| 
   		', Data Modificacio Central Produccio: ' ||p_dataModificacioCentral|| 
                ', Classe Central: ' ||n_descClasseCentral|| 
    		', Id Inspeccio Central Produccio: ' ||p_idInspeccioCentral||
                ', Data Ultima Inspeccio Central Produccio: '||p_dataUltmimaInspeccioCentral||
                ', Energia Maxima Central Produccio: ' ||p_energiaMax ||
                ', Energia Minma Central Produccio: ' || p_energiaMin||
                ', Ubicacio Central Produccio: ' ||n_localitatCentral||
   		', observacions Central Produccio: ' ||p_observacionsCentral);
      DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
    s_rsp := 'OK Actualitzacio satisfactoria Actualitzacio satisfactoria 
                Id Central Produccio: ' ||p_idCentral|| 
   		', Data Modificacio Central Produccio: ' ||p_dataModificacioCentral|| 
                ', Classe Central: ' ||n_descClasseCentral|| 
   		', Id Inspeccio Central Produccio: ' ||p_idInspeccioCentral||
                ', Data Ultima Inspeccio Central Produccio: '||p_dataUltmimaInspeccioCentral||
                ', Energia Maxima Central Produccio: ' ||p_energiaMax ||
                ', Energia Minma Central Produccio: ' || p_energiaMin||
                ', Ubicacio Central Produccio: ' ||n_localitatCentral||
   		', observacions Central Produccio: ' ||p_observacionsCentral;
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
    END IF;
COMMIT;
 EXCEPTION
	
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi-----------------------------------------
         s_rsp := 'Error: ' || SQLCODE || SUBSTR(SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi-----------------------------------------
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
       DBMS_OUTPUT.PUT_LINE(' '); 
      DBMS_OUTPUT.put_line (s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;
END PRC_MODIFICAR_CENTRAL_DISTRIB;

PROCEDURE PRC_CONSULTAR_CENTRAL_PRODU(
          s_rsp out NOCOPY VARCHAR2)
AS
CURSOR C_CENTRAL_PRODU IS
SELECT  DISTINCT CENTRAL.IDCENTRAL,
CENTRAL.DATAALTACENTRAL,
ESTAT.DESCRIPCIOESTAT,
CENTRAL.DATAMODIFICACENTRAL,
CLASSE_CENTRAL.DESCRIPCIOCLASSE,
TIPUS_FUNCIONS.DESCRIPCIONFUNCIO,
TIPO_CENTRAL.DESCRIPCIOTIPOCENTRAL,
TIPO_INSPECCIO.DESCRIPCIOTINSPECCIO,
CENTRAL.DATAULTIMAINSPECCIOCENTRAL,
CENTRAL.ENERGIAMAXIMA,
CENTRAL.ENERGIAMINIMA,
LOCALITAT.DESCRIPCIOLOCALITAT,
CENTRAL.OBSERVACIONSCENTRAL
FROM CENTRAL,ESTAT,CLASSE_CENTRAL,TIPO_CENTRAL,TIPO_INSPECCIO,UBICACIO,LOCALITAT,TIPUS_FUNCIONS
WHERE ESTAT.IDESTAT=CENTRAL.ESTATCENTRAL
AND CENTRAL.IDCLASSECENTRAL=1
AND CENTRAL.IDTIPOCENTRAL=TIPO_CENTRAL.IDTIPOCENTRAL
AND CENTRAL.IDINSPECCIOCENTRAL=TIPO_INSPECCIO.IDTINSPCCIO
AND CENTRAL.IDUBICACENTRAL=UBICACIO.IDUBICA
AND UBICACIO.IDLOCALITATUBICACIO=LOCALITAT.IDLOCALITAT
AND CENTRAL.IDUBICACENTRAL=UBICACIO.IDUBICA
AND TIPO_CENTRAL.IDFUNCIOTIPOCENTRAL=TIPUS_FUNCIONS.IDFUNCIO
AND CENTRAL.IDCLASSECENTRAL=CLASSE_CENTRAL.IDCLASSE
ORDER BY CENTRAL.IDCENTRAL;

BEGIN 
--Parametres per la taula LOG--------------------------------------------------------------
     c_procesLog :=  'PRC_CONSULTAR_CENTRAL PRODUCCIO';
     c_dataHoraLog := SYSDATE;
     c_entradaLog :='CONSULTAR CENTRALS DE PRODUCCIO  ';
     c_sortidalog := 's_rsp';    
  SELECT COUNT (*)  INTO n_registres
  FROM CENTRAL
  WHERE CENTRAL.IDCENTRAL=CENTRAL.IDCENTRAL
  AND CENTRAL.IDCLASSECENTRAL=1;
  
  IF n_registres=0 THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('CONSULTAR CENTRALS DE PRODUCCIO: ');
    s_rsp := 'No hi han CENTRALS DE PRODUCCIO donades dalta ';
    DBMS_OUTPUT.PUT_LINE(s_rsp);
    RAISE e_central;
 END IF;
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('           CONSULTAR CENTRALS DE PRODUCCIO                ');
    DBMS_OUTPUT.PUT_LINE('----------------------------------------------------------');
  OPEN C_CENTRAL_PRODU;  
  FETCH C_CENTRAL_PRODU INTO n_idCentral,
      n_dataAltaCentral,
      n_descEstat,
      n_dataModificacioCentral,
      n_descClasseCentral,
      n_descTipusFuncioCentral,
      n_descTipoCentral,
      n_descResultatInspeccio,
      n_ultimaInspeccioCentral,
      n_maxEnergia,
      n_minEnergia,
      n_localitatCentral,
      n_observacions;

WHILE C_CENTRAL_PRODU%FOUND LOOP
   DBMS_OUTPUT.ENABLE;
   DBMS_OUTPUT.PUT_LINE(
 '   Codi Central: '
 ||n_idCentral||
 '   Classe de Central: '
 ||n_descClasseCentral|| 
   '   Data Alta: '
 ||n_descClasseCentral|| 
 '   Estat: '
 ||n_descEstat|| 
 '   Tipus de Central: '
 ||n_descTipoCentral||
  '   Caractristiques: '
 ||n_descTipusFuncioCentral||
  '   Energia Maxima:  '
 ||n_maxEnergia||
  '   Energia Minima: '
 ||n_minEnergia||
  '   Poblacio: '
 ||n_localitatCentral);
 -- '   Orservacions: '
 --||n_observacions);
  DBMS_OUTPUT.PUT_LINE(' ');
  s_rsp := 'OK  CONSULTA CENTRALS PRODUCCIO: 
     Codi Central: '
 ||n_idCentral;
 FETCH C_CENTRAL_PRODU  INTO n_idCentral,
      n_dataAltaCentral,
      n_descEstat,
      n_dataModificacioCentral,
      n_descClasseCentral,
      n_descTipusFuncioCentral,
      n_descTipoCentral,
      n_descResultatInspeccio,
      n_ultimaInspeccioCentral,
      n_maxEnergia,
      n_minEnergia,
      n_localitatCentral,
      n_observacions;
  pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  
  END LOOP;
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('Total Centrals de Produccio: '||n_registres);
  DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
CLOSE C_CENTRAL_PRODU;
COMMIT;
EXCEPTION
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         s_rsp := 'Error: ' || SQLCODE || SUBSTR (SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' ');
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;   
END PRC_CONSULTAR_CENTRAL_PRODU;

PROCEDURE PRC_CONSULTAR_CENTRAL_DISTRIB(
          s_rsp out NOCOPY VARCHAR2)
AS
CURSOR C_CENTRAL_DISTRIBU IS
SELECT DISTINCT CENTRAL.IDCENTRAL AS CODI,
      CLASSE_CENTRAL.DESCRIPCIOCLASSE AS CLASSE_CENTRAL,
      TIPO_CENTRAL.DESCRIPCIOTIPOCENTRAL AS TIPUS_CENTRAL,
      TIPUS_FUNCIONS.DESCRIPCIONFUNCIO AS CARACTERISTIQUES,
      CENTRAL.DATAALTACENTRAL AS DATA_ALTA,
      ESTAT.DESCRIPCIOESTAT AS ESTAT,
      CENTRAL.DATAMODIFICACENTRAL AS DATA_MODIFICACIO,
      TIPO_INSPECCIO.DESCRIPCIOTINSPECCIO AS RESULTAT_INSPECCIO,
      CENTRAL.DATAULTIMAINSPECCIOCENTRAL AS DATA_ULTIMA_INSPECCIO,
      CENTRAL.ENERGIAMAXIMA AS ENERGIA_MAXIMA,
      CENTRAL.ENERGIAMINIMA AS ENERGIA_MINIMA,
      LOCALITAT.DESCRIPCIOLOCALITAT AS LOCALITAT,
      CENTRAL.OBSERVACIONSCENTRAL
FROM CENTRAL,TIPO_CENTRAL,TIPUS_FUNCIONS,ESTAT,TIPO_INSPECCIO,
LOCALITAT,CLASSE_CENTRAL,UBICACIO
WHERE CENTRAL.IDCENTRAL=CENTRAL.IDCENTRAL
AND CENTRAL.IDCLASSECENTRAL=2
AND CENTRAL.IDTIPOCENTRAL=TIPO_CENTRAL.IDTIPOCENTRAL
AND TIPO_CENTRAL.IDFUNCIOTIPOCENTRAL=TIPUS_FUNCIONS.IDFUNCIO
AND CENTRAL.ESTATCENTRAL=ESTAT.IDESTAT
AND CENTRAL.IDINSPECCIOCENTRAL=TIPO_INSPECCIO.IDTINSPCCIO
AND CENTRAL.IDUBICACENTRAL=UBICACIO.IDUBICA
AND UBICACIO.IDLOCALITATUBICACIO=LOCALITAT.IDLOCALITAT
AND CENTRAL.IDCLASSECENTRAL=CLASSE_CENTRAL.IDCLASSE;
       

BEGIN 
--Parametres per la taula LOG--------------------------------------------------------------
     c_procesLog :=  'PRC_CONSULTAR_CENTRAL DISTRIBUCIO';
     c_dataHoraLog := SYSDATE;
     c_entradaLog :='CONSULTAR CENTRALS DE  DISTRIBUCIO  ';
     c_sortidalog := 's_rsp';    
  SELECT COUNT (*)  INTO n_registres
  FROM CENTRAL
  WHERE CENTRAL.IDCENTRAL=CENTRAL.IDCENTRAL
  AND CENTRAL.IDCLASSECENTRAL=2;
  
  IF n_registres=0 THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('CONSULTAR CENTRALS DE  DISTRIBUCIO: ');
    s_rsp := 'No hi han CENTRALS DE  DISTRIBUCIO donades dalta ';
    DBMS_OUTPUT.PUT_LINE(s_rsp);
    RAISE e_central;
 END IF;
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('           CONSULTAR CENTRALS DE  DISTRIBUCIO               ');
    DBMS_OUTPUT.PUT_LINE('----------------------------------------------------------');
  OPEN  C_CENTRAL_DISTRIBU;  
  FETCH  C_CENTRAL_DISTRIBU 
      INTO n_idCentral,
      n_descClasseCentral,
      n_descTipoCentral,
      n_descTipusFuncioCentral,
      n_dataAltaCentral,
      n_descEstat,
      n_dataModificacioCentral,
      n_descResultatInspeccio,
      n_ultimaInspeccioCentral,
      n_maxEnergia,
      n_minEnergia,
      n_localitatCentral,
      n_observacions;
WHILE C_CENTRAL_DISTRIBU%FOUND LOOP
   DBMS_OUTPUT.ENABLE;
   DBMS_OUTPUT.PUT_LINE(
 '   Codi Central: '
 ||n_idCentral||
 '   Classe de Central: '
 ||n_descClasseCentral|| 
  '   Data Alta: '
 ||n_dataAltaCentral|| 
 '   Estat: '
 ||n_descEstat|| 
 '   Data Modificacio: '
 ||n_dataModificacioCentral|| 
 '   Resultat Inspeccio: '
 ||n_descResultatInspeccio||
 '   Data Ultima Inspeccio: '
 ||n_ultimaInspeccioCentral||
  '   Energia Maxima:  '
 ||n_maxEnergia||
  '   Energia Minima: '
 ||n_minEnergia||
  '   Poblacio: '
 ||n_localitatCentral);
 -- '   Observacions: '
 --||n_observacions);
  s_rsp := 'OK  CENTRALS DE PRODUCCIO: 
     Codi Central: '
 ||n_idCentral||
 '   Classe de Central: '
 ||n_descClasseCentral|| 
  'Energia Maxima:  '
 ||n_maxEnergia||
  '   Energia Minima: '
 ||n_minEnergia||
  '   Poblacio: '
 ||n_localitatCentral;
 FETCH  C_CENTRAL_DISTRIBU
      INTO n_idCentral,
      n_descClasseCentral,
      n_descTipoCentral,
      n_descTipusFuncioCentral,
      n_dataAltaCentral,
      n_descEstat,
      n_dataModificacioCentral,
      n_descResultatInspeccio,
      n_ultimaInspeccioCentral,
      n_maxEnergia,
      n_minEnergia,
      n_localitatCentral,
      n_observacions;  
  pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  
  END LOOP;
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('Total Centrals de Distribucio: '||n_registres);
  DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
CLOSE  C_CENTRAL_DISTRIBU;
COMMIT;
EXCEPTION
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         s_rsp := 'Error: ' || SQLCODE || SUBSTR (SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' ');
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;   
END PRC_CONSULTAR_CENTRAL_DISTRIB; 

END "GESTION_CENTRAL";
