CREATE OR REPLACE
PACKAGE BODY          "GESTION_COMPTADOR" AS
  c_procesLog	   LOG_TFC.procesLog%TYPE;	
  c_dataHoraLog    LOG_TFC.dataHoraLog%TYPE;
  c_entradaLog     LOG_TFC.entradaLog%TYPE;	
  c_sortidaLog     LOG_TFC.sortidaLog%TYPE;
  s_rsp	           LOG_TFC.rspLog%TYPE;
  n_registres  NUMBER;
  s_sql VARCHAR2 (2000);
  
  n_idComptador  COMPTADOR.IDCOMPTADOR%TYPE;
  n_idModelComptador COMPTADOR.IDMODELOCOMPTADOR%TYPE;
  n_idUbicacioComptador COMPTADOR.IDUBICACOMPTADOR%TYPE;
  n_dataAltaComptador COMPTADOR.DATAALTACOMPTADOR%TYPE;
  n_estatComptador  COMPTADOR.IDESTADOCOMPATOR%TYPE;
  n_numeroSerieComptador  COMPTADOR.NUMSERIECOMPTADOR%TYPE;
  n_observacionsComptador  COMPTADOR.OBSERVACIONSCOMPTADOR%TYPE;
  
  n_estat  ESTAT.DESCRIPCIOESTAT%TYPE;
  n_localitat  LOCALITAT.DESCRIPCIOLOCALITAT%TYPE;
  n_provincia PROVINCIA.DESCRIPCIOPROVINCIA%TYPE;
  n_pais PAIS.DESCRIPCIOPAIS%TYPE;
  n_modelo MODELO.DESCRIPCIOMODELO%TYPE;
  n_dataModificacioComptador COMPTADOR.DATAMODIFICACIOCOMPATOR%TYPE;
  n_via VIA.DESCRIPCIOVIA%TYPE;
  n_direccio UBICACIO.NUMEROUBICACIO%TYPE;
  n_numero UBICACIO.NUMEROUBICACIO%TYPE;
  n_pis UBICACIO.PISUBICACIO%TYPE;
  n_porta UBICACIO.PORTAUBICACIO%TYPE;
  n_codiPostal UBICACIO.CODIPOSTAL%TYPE;
  
  n_estatComptadorControl NUMBER;
  
  n_NUM_ERR NUMBER(10);
  sortida varchar2(2000):=''; 
  e_comptador   EXCEPTION;
  
PROCEDURE PRC_ALTA_COMPTADOR(
   p_idModelComptador in COMPTADOR.IDMODELOCOMPTADOR%TYPE,
   p_idUbicacioComptador in COMPTADOR.IDUBICACOMPTADOR%TYPE,
   p_dataAltaComptador in COMPTADOR.DATAALTACOMPTADOR%TYPE,
   p_numeroSerieComptador in COMPTADOR.NUMSERIECOMPTADOR%TYPE,
   p_observacionsComptador in COMPTADOR.OBSERVACIONSCOMPTADOR%TYPE,
   s_rsp out NOCOPY VARCHAR2)
   AS
   BEGIN
    c_procesLog := 'PRC_ALTA_COMPTADOR';
    c_dataHoraLog := SYSDATE;
    c_entradaLog :='Id Model: ' || p_idModelComptador||
    ' Id Ubicacio Comptador: ' || p_idUbicacioComptador||
    ' , Data Alta Comptador: ' || p_dataAltaComptador||
    --' , Estat Comptador: ' || p_estatComptador ||
    ' , Numero Serie Comptador: ' || p_numeroSerieComptador||
    ' , Observacions Comptador: ' || p_observacionsComptador;
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE('      ALTA COMPTADOR     ');
    DBMS_OUTPUT.PUT_LINE('------------------------ ');
    DBMS_OUTPUT.PUT_LINE('Id Model: ' || p_idModelComptador||
    ' Id Ubicacio Comptador: ' || p_idUbicacioComptador||
    ' , Data Alta Comptador: ' || p_dataAltaComptador||
   -- ' , Estat Comptador: ' || p_estatComptador ||
    ' , Numero Serie Comptador: ' || p_numeroSerieComptador||
    ' , Observacions Comptador: ' || p_observacionsComptador);
    c_sortidalog := 's_rsp';
    --Comprovar dades
       If p_idModelComptador IS NULL then
            DBMS_OUTPUT.ENABLE;
            DBMS_OUTPUT.PUT_LINE('ALTA_COMPTADOR: ');
           s_rsp := 'Falta especificar Id Model Comptador ';
            DBMS_OUTPUT.PUT_LINE(s_rsp); 
          RAISE e_comptador;
        END IF;
       If p_idUbicacioComptador IS NULL then
            DBMS_OUTPUT.ENABLE;
            DBMS_OUTPUT.PUT_LINE('ALTA_COMPTADOR: ');
            s_rsp := 'Falta especificar Id Ubicacio Comptador ';
            DBMS_OUTPUT.PUT_LINE(s_rsp);            
          RAISE e_comptador;
        END IF;
      If p_dataAltaComptador IS NULL then
            DBMS_OUTPUT.ENABLE;
            DBMS_OUTPUT.PUT_LINE('ALTA_COMPTADOR: ');      
           s_rsp := 'Falta especificar Data Alta Comptador ';
           DBMS_OUTPUT.PUT_LINE(s_rsp);           
          RAISE e_comptador;
        END IF;
     If p_numeroSerieComptador IS NULL then
            DBMS_OUTPUT.ENABLE;
            DBMS_OUTPUT.PUT_LINE('ALTA_COMPTADOR: ');        
           s_rsp := 'Falta especificar Numero Serie Comptador ';
           DBMS_OUTPUT.PUT_LINE(s_rsp);              
          RAISE e_comptador;
        END IF;
     -- Comprovem si existeix el  donar el comptador
         SELECT COUNT (*) INTO n_registres 
            FROM COMPTADOR 
            WHERE COMPTADOR.NUMSERIECOMPTADOR = p_numeroSerieComptador ;
      If n_registres=0 then
      
     n_estatComptadorControl:=1;
      
      SELECT LOCALITAT.DESCRIPCIOLOCALITAT,
      PROVINCIA.DESCRIPCIOPROVINCIA,
      PAIS.DESCRIPCIOPAIS INTO n_localitat,n_provincia,n_pais
      FROM LOCALITAT, UBICACIO, PROVINCIA,PAIS
      WHERE LOCALITAT.IDLOCALITAT=UBICACIO.IDLOCALITATUBICACIO
      AND UBICACIO.IDUBICA=p_idUbicacioComptador
      AND LOCALITAT.IDPROVINCIALOCALITAT=PROVINCIA.IDPROVINCIA
      AND PROVINCIA.IDPAISPROVINCIA=PAIS.IDPAIS;
      
      SELECT ESTAT.DESCRIPCIOESTAT INTO n_estat
      FROM ESTAT
      WHERE ESTAT.IDESTAT=n_estatComptadorControl;
          
          -- El donem d'alta COMPTADOR          
            INSERT INTO COMPTADOR(IDMODELOCOMPTADOR,
            IDUBICACOMPTADOR,
            DATAALTACOMPTADOR,
            IDESTADOCOMPATOR,
            NUMSERIECOMPTADOR,
            OBSERVACIONSCOMPTADOR) 
            VALUES(p_idModelComptador,
                  p_idUbicacioComptador,
                  p_dataAltaComptador,
                  n_estatComptadorControl,
                  p_numeroSerieComptador,
                  p_observacionsComptador);
    --Gravem en la taula log-----------------------------------------------------
            DBMS_OUTPUT.ENABLE;
            DBMS_OUTPUT.PUT_LINE('ALTA_COMPTADOR: '); 
            DBMS_OUTPUT.PUT_LINE(' Comptador inserit: Id Model: ' || p_idModelComptador||
                  '  Ciutat: ' ||n_localitat||
                  '  Provincia: '||n_provincia||
                  '  Pais: '||n_pais||
                  '  Data Alta Comptador: ' || p_dataAltaComptador||
                  '  Estat Comptador: ' || n_estat ||
                  '  Numero Serie Comptador: ' || p_numeroSerieComptador||
                  '  Observacions Comptador: ' || p_observacionsComptador);
                  DBMS_OUTPUT.PUT_LINE('*********** FI DE LES OPERACIONS *********** ');
            s_rsp :='Ok Comptador inserit: Id Model: ' || p_idModelComptador||
                  --' Ciutat: ' ||n_localitat||
                  --' Provincia: '||n_provincia||
                 -- ' Pais: '||n_pais||
                  ' , Data Alta Comptador: ' || p_dataAltaComptador||
                  ' , Estat Comptador: ' || n_estat ||
                  ' , Numero Serie Comptador: ' || p_numeroSerieComptador||
                  ' , Observacions Comptador: ' || p_observacionsComptador;
            pkg_general.gravar_log_procedure(c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
            DBMS_OUTPUT.PUT_LINE(s_rsp);
    ELSE
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('ALTA COMPTADOR: ');    
    s_rsp := 'Comptador duplicada';
    DBMS_OUTPUT.PUT_LINE(s_rsp);
          RAISE e_comptador;
      END IF;
   COMMIT;
 EXCEPTION
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         s_rsp := 'Error: ' || SQLCODE || SUBSTR (SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' ');    
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  ROLLBACK;   
END PRC_ALTA_COMPTADOR;

PROCEDURE PRC_MODIFICA_COMPTADOR(
   p_idComptador in COMPTADOR.IDCOMPTADOR%TYPE,
   p_idModelComptador in COMPTADOR.IDMODELOCOMPTADOR%TYPE,
   p_idUbicacioComptador in COMPTADOR.IDUBICACOMPTADOR%TYPE,
   p_dataModificacioComptador in COMPTADOR.DATAMODIFICACIOCOMPATOR%TYPE,
   p_estatComptador in COMPTADOR.IDESTADOCOMPATOR%TYPE,
   p_numeroSerieComptador in COMPTADOR.NUMSERIECOMPTADOR%TYPE,
   p_observacionsComptador in COMPTADOR.OBSERVACIONSCOMPTADOR%TYPE,
   s_rsp out NOCOPY VARCHAR2)
   AS
   BEGIN
    --Parametres per la taula LOG--------------------------------------------------------------
     c_procesLog := 'PRC_MODIFICA_COMPTADOR';
     c_dataHoraLog := SYSDATE;
     c_entradaLog := 'Id ComptadorModel: ' || p_idComptador||
     ',Id Model: ' || p_idModelComptador||
    ' Id Ubicacio Comptador: ' || p_idUbicacioComptador||
    ' , Data modificacio Comptador: ' ||p_dataModificacioComptador||
    ' , Estat Comptador: ' || p_estatComptador ||
    ' , Numero Serie Comptador: ' || p_numeroSerieComptador||
    ' , Observacions Comptador: ' || p_observacionsComptador;
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE('     MODIFICAR COMPTADOR     ');
    DBMS_OUTPUT.PUT_LINE('---------------------------- '); 
    DBMS_OUTPUT.PUT_LINE(' Id ComptadorModel: ' || p_idComptador||
     ',Id Model Comptador: ' || p_idModelComptador||
    ' Id Ubicacio Comptador: ' || p_idUbicacioComptador||
    ' , Data modificacio  Comptador: ' ||p_dataModificacioComptador||
    ' , Estat Comptador: ' || p_estatComptador ||
    ' , Numero Serie Comptador: ' || p_numeroSerieComptador||
    ' , Observacions Comptador: ' || p_observacionsComptador); 
    c_sortidalog := 's_rsp';  
  
         -- Comprovem que p_idComptador no sigui NULL----------------------------------------------
         If p_idComptador IS NULL then
            DBMS_OUTPUT.ENABLE;
            DBMS_OUTPUT.PUT_LINE('MODIFICA_COMPTADOR: ');  
      	    s_rsp := 'Falta especificar id Comptador';
            DBMS_OUTPUT.PUT_LINE(s_rsp);           
          RAISE e_comptador;
         END IF;
         --1er. Comprovem que l'estat de la Client sigui actiu=1-------------------------------
            SELECT COUNT (*) INTO n_registres 
               FROM COMPTADOR
               WHERE COMPTADOR.IDCOMPTADOR= p_idComptador;
   
              If n_registres=0 then
               DBMS_OUTPUT.ENABLE;
               DBMS_OUTPUT.PUT_LINE('MODIFICA_COMPTADOR:  ');              
               s_rsp := 'COMPTADOR no existent a la BBDD';
               DBMS_OUTPUT.PUT_LINE(s_rsp);
               RAISE e_comptador;
              END IF;
            
              SELECT COMPTADOR.IDCOMPTADOR INTO n_idComptador
               FROM COMPTADOR
               WHERE COMPTADOR.IDCOMPTADOR= p_idComptador;      
      
         
  s_sql := 'UPDATE COMPTADOR SET ';
        
  --Construirem la sentencia UPDATE segons si hi ha valor en els parÃ metres-
  IF p_idModelComptador IS NOT NULL THEN
-- Modifiquem el nom
    s_sql := s_sql || 'IDMODELOCOMPTADOR=''' || p_idModelComptador || ''',';
  END IF;
  IF p_idUbicacioComptador IS NOT NULL THEN
-- Modifiquem id Ubicacio Comptador----------------------------------------
    s_sql := s_sql || 'DUBICACOMPTADOR=''' || p_idUbicacioComptador || ''',';
  END IF;
  IF p_dataModificacioComptador IS NOT NULL THEN
-- Modifiquem DATA MODIFICACIO----------------------------------------
    s_sql := s_sql || 'DATAMODIFICACIOCOMPATOR=''' ||p_dataModificacioComptador|| ''',';
  END IF;
                  
    IF p_estatComptador IS NOT NULL THEN
-- Modifiquem estat Comptado----------------------------------------
      s_sql := s_sql || 'IDESTADOCOMPATOR=''' || p_estatComptador || ''',';
    END IF;
    IF  p_numeroSerieComptador  IS NOT NULL THEN
-- Modifiquem numero Serie Comptador--------------------------------------------
      s_sql := s_sql || 'NUMSERIECOMPTADOR=''' || p_numeroSerieComptador || ''',';
    END IF;
                            
    IF  p_observacionsComptador IS NOT NULL THEN
                       
      s_sql := s_sql || 'OBSERVACIONSCOMPTADOR=''' || p_observacionsComptador || ''',';
    END IF;
        
-- Eliminem la coma final de la sentencia SQL--------------------------
    s_sql := SUBSTR (s_sql, 1, LENGTH (s_sql) - 1);
-- Afegim a la sentencia la condiciÃ³ del WHERE------------------------
    s_sql := s_sql || ' WHERE IDCOMPTADOR=''' ||n_idComptador|| '''';
         
EXECUTE IMMEDIATE s_sql;
         
  IF SQL%ROWCOUNT = 0  THEN
--L'error serÃ  que el DNI ja el tenim en la taula i no admet duplicats--
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('MODIFICA COMPTADOR: ');                     
      s_rsp := 'Actualitzacio no realitzada';
      DBMS_OUTPUT.PUT_LINE(s_rsp);                     
      RAISE e_comptador;
  ELSE
      SELECT LOCALITAT.DESCRIPCIOLOCALITAT,
      PROVINCIA.DESCRIPCIOPROVINCIA,
      PAIS.DESCRIPCIOPAIS INTO n_localitat,n_provincia,n_pais
      FROM LOCALITAT, UBICACIO, PROVINCIA,PAIS
      WHERE LOCALITAT.IDLOCALITAT=UBICACIO.IDLOCALITATUBICACIO
      AND UBICACIO.IDUBICA=p_idUbicacioComptador
      AND LOCALITAT.IDPROVINCIALOCALITAT=PROVINCIA.IDPROVINCIA
      AND PROVINCIA.IDPAISPROVINCIA=PAIS.IDPAIS;
      
      SELECT MODELO.DESCRIPCIOMODELO INTO n_modelo
      FROM MODELO
      WHERE MODELO.IDMODELO=p_idModelComptador;
      
      SELECT ESTAT.DESCRIPCIOESTAT INTO n_estat
      FROM ESTAT
      WHERE ESTAT.IDESTAT=p_estatComptador;
      
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('MODIFICA COMPTADOR: ');  
      DBMS_OUTPUT.PUT_LINE(' Codi comptador: '||n_idComptador||
      ' Codi Modelo: '||p_idModelComptador ||
      ' Modelo: '||n_modelo||
      ' Data modificacio: '||p_dataModificacioComptador||
      ' Estat: '||n_estat||
      ' Numero de serie: '||p_numeroSerieComptador||
      ' Localitat: '||n_localitat||
      ' Provincia: '||n_provincia||
      ' Pais: '||n_pais||
      ' Observacions: '||p_observacionsComptador); 
     DBMS_OUTPUT.PUT_LINE('*********** FI DE LES OPERACIONS ***********');
      s_rsp := 'OK: Modificacio satisfactoria per : Codi comptador: '||n_idComptador||
      ' Codi Modelo: '||p_idModelComptador||
      ' Modelo: '||n_modelo||
      ' Data modificacio: '||p_dataModificacioComptador||
      ' Estat: '||n_estat||
      ' Numero de serie: '||p_numeroSerieComptador||
      ' Observacions: '||p_observacionsComptador;
       pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  END IF;
COMMIT;
EXCEPTION
   WHEN DUP_VAL_ON_INDEX THEN
      s_rsp := 'Error: COMPTADOR duplicada. No es poden fer les modificacions';
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;      
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         -----------------------------------------
         s_rsp := 'Error: ' || SQLCODE || SUBSTR(SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         -----------------------------------------
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' ');    
      DBMS_OUTPUT.put_line (s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  ROLLBACK;

END PRC_MODIFICA_COMPTADOR; 

PROCEDURE PRC_CONSULTAR_COMPTADOR(
   s_rsp out NOCOPY VARCHAR2)
  AS
  CURSOR C_COMPTADOR IS
  SELECT DISTINCT COMPTADOR.IDCOMPTADOR AS CODI,
  MODELO.DESCRIPCIOMODELO AS MODELO,
  COMPTADOR.DATAALTACOMPTADOR AS FECHA_ALTA,
  ESTAT.DESCRIPCIOESTAT AS ESTAT,
  COMPTADOR.DATAMODIFICACIOCOMPATOR AS ULTIMA_MODIFICACIO,
  COMPTADOR.NUMSERIECOMPTADOR AS NUMERO_DE_SERIE,
  --VIA.DESCRIPCIOVIA,
  --UBICACIO.DIRECCIONUBICACIO AS DIRECCIO,
  --UBICACIO.NUMEROUBICACIO,
  --UBICACIO.PISUBICACIO,
  --UBICACIO.PORTAUBICACIO,
  --UBICACIO.CODIPOSTAL AS CODIPOSTAL,
  --LOCALITAT.DESCRIPCIOLOCALITAT,
  COMPTADOR.OBSERVACIONSCOMPTADOR AS OBSERVACIONS
  FROM COMPTADOR, MODELO,ESTAT,UBICACIO,LOCALITAT, VIA
  WHERE COMPTADOR.IDCOMPTADOR=COMPTADOR.IDCOMPTADOR
  AND COMPTADOR.IDMODELOCOMPTADOR=MODELO.IDMODELO
  AND COMPTADOR.IDESTADOCOMPATOR=ESTAT.IDESTAT
  AND COMPTADOR.IDUBICACOMPTADOR=UBICACIO.IDUBICA
  AND LOCALITAT.IDLOCALITAT=UBICACIO.IDLOCALITATUBICACIO;
  

  
    BEGIN
  c_procesLog := 'PRC_CONSULTAR_COMPTADOR';
       c_dataHoraLog := SYSDATE;
       c_entradaLog :='CONSULTA COPMTADORS ' ;
       c_sortidalog := 's_rsp';

--COMPROVEM EXITEIX COMPTADOR
  SELECT COUNT (*) INTO n_registres 
  FROM COMPTADOR
  WHERE COMPTADOR.IDCOMPTADOR=COMPTADOR.IDCOMPTADOR ;
          
  
  IF n_registres=0 THEN
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('CONSULTAR ELS COMPTADORS: ');  
  s_rsp := 'No hi han comptadors. ';
  DBMS_OUTPUT.PUT_LINE(s_rsp);           
  RAISE e_comptador;
  
  ELSE
  
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE(' ');
  DBMS_OUTPUT.PUT_LINE('      CONSULTAR ELS COMPTADORS            ');
  DBMS_OUTPUT.PUT_LINE('----------------------------------------- '); 
   
  OPEN C_COMPTADOR;
  FETCH C_COMPTADOR  INTO n_idComptador,
  n_modelo,
  n_dataAltaComptador,
  n_estat,
  n_dataModificacioComptador,
  n_numeroSerieComptador,
  n_observacionsComptador;  
        
  WHILE C_COMPTADOR%FOUND LOOP
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE(' Codi comptador: '||n_idComptador||
      ' Modelo: '||n_modelo||
      ' Data Alta: '||n_dataAltaComptador||
      ' Estat: '||n_estat||
      ' Data modificacio: '||n_dataModificacioComptador||
      ' Numero de serie: '||n_numeroSerieComptador||
      --' Via: ' ||n_via||
      --' Direccio: '||n_direccio||
      --' Numero: '||n_numero||
      --' Pis: '||n_pis||
      --' Porta: '||n_porta||
      --' Codi Postal: '||n_codiPostal||
      --' Localitat: '||n_localitat||
      ' Observacions: '||n_observacionsComptador); 
       s_rsp := 'OK  CONSULTA COMPTADORS  
       Codi comptador: '||n_idComptador||
      ' Modelo: '||n_modelo||
      ' Data Alta: '||n_dataAltaComptador||
      ' Estat: '||n_estat||
      ' Data modificacio: '||n_dataModificacioComptador||
      ' Numero de serie: '||n_numeroSerieComptador||
      --' Via: ' ||n_via||
      --' Direccio: '||n_direccio||
      --' Numero: '||n_numero||
      --' Pis: '||n_pis||
      --' Porta: '||n_porta||
      --' Codi Postal: '||n_codiPostal||
      --' Localitat: '||n_localitat||
      ' Observacions: '||n_observacionsComptador;
 FETCH C_COMPTADOR  INTO n_idComptador,
  n_modelo,
  n_dataAltaComptador,
  n_estat,
  n_dataModificacioComptador,
  n_numeroSerieComptador,
  n_observacionsComptador;  
   
  pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  END LOOP;
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('Total comptador: '||n_registres);
  DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
CLOSE C_COMPTADOR;
END IF;
COMMIT;
EXCEPTION
   WHEN DUP_VAL_ON_INDEX THEN
      s_rsp := 'Error: COMPTADOR duplicada. No es poden fer les modificacions';
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;      
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         -----------------------------------------
         s_rsp := 'Error: ' || SQLCODE || SUBSTR(SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         -----------------------------------------
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' ');    
      DBMS_OUTPUT.put_line (s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  ROLLBACK;
END PRC_CONSULTAR_COMPTADOR;

procedure PRC_PASSAR_COMPTADOR_ALTA( 
   p_idComptador in COMPTADOR.IDCOMPTADOR%TYPE,
   p_dataModificacioComptador in COMPTADOR.DATAMODIFICACIOCOMPATOR%TYPE,
   p_estatComptador in COMPTADOR.IDESTADOCOMPATOR%TYPE,
   s_rsp out NOCOPY VARCHAR2)
AS
BEGIN
     c_procesLog := 'PRC PASSAR COMPTADOR ALTA';
     c_dataHoraLog := SYSDATE;
     c_entradaLog := 'Id ComptadorModel: ' || p_idComptador||
    ' , Data modificacio Comptador: ' ||p_dataModificacioComptador;
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE('     MODIFICAR ESTAT COMPTADOR A ALTA     ');
    DBMS_OUTPUT.PUT_LINE('----------------------------------------- '); 
    DBMS_OUTPUT.PUT_LINE(' Id ComptadorModel: ' || p_idComptador||
    ' , Data modificacio Comptador: ' ||p_dataModificacioComptador); 
    c_sortidalog := 's_rsp';
  --- MIRO LA SITUACIO DEL COMPTADOR SI JA ESTA EN  ALTA AVISO
  SELECT COMPTADOR.IDESTADOCOMPATOR INTO n_estatComptadorControl
  FROM COMPTADOR
  WHERE COMPTADOR.IDCOMPTADOR=p_idComptador;
  
  IF n_estatComptadorControl=1 THEN
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('MODIFICAR ESTAT COMPTADOR A ALTA: ');  
  s_rsp := 'El comptador ja esta en situacio ALTA. ';
  DBMS_OUTPUT.PUT_LINE(s_rsp);           
  RAISE e_comptador;
  END IF;
  
  IF p_dataModificacioComptador IS NULL THEN
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('MODIFICAR ESTAT COMPTADOR A ALTA: ');  
  s_rsp := 'Falta especificar id Comptador';
  DBMS_OUTPUT.PUT_LINE(s_rsp);           
  RAISE e_comptador;
  END IF;
  IF p_idComptador IS NULL THEN
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('MMODIFICAR ESTAT COMPTADOR A ALTA: ');  
  s_rsp := 'Falta especificar id Comptador';
  DBMS_OUTPUT.PUT_LINE(s_rsp);           
  RAISE e_comptador;
  END IF;  
 SELECT COUNT (*) INTO n_registres 
 FROM COMPTADOR
 WHERE COMPTADOR.IDCOMPTADOR= p_idComptador;
   
 If n_registres=0 then
   DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('MODIFICAR ESTAT COMPTADOR A ALTA:  ');              
    s_rsp := 'COMPTADOR no existent a la BBDD';
    DBMS_OUTPUT.PUT_LINE(s_rsp);
    RAISE e_comptador;
  END IF;
  
  n_estatComptadorControl:=1;
  
  SELECT COMPTADOR.IDCOMPTADOR INTO n_idComptador
  FROM COMPTADOR
  WHERE COMPTADOR.IDCOMPTADOR= p_idComptador; 
  
  SELECT ESTAT.DESCRIPCIOESTAT INTO n_estat
  FROM ESTAT
  WHERE ESTAT.IDESTAT=n_estatComptadorControl;
  
s_sql := 'UPDATE COMPTADOR SET ';
        
  --Construirem la sentencia UPDATE segons si hi ha valor en els parÃ metres-
   IF p_dataModificacioComptador IS NOT NULL THEN
-- Modifiquem el nom
    s_sql := s_sql || 'DATAMODIFICACIOCOMPATOR=''' ||p_dataModificacioComptador|| ''',';
  END IF;
  IF n_estatComptadorControl IS NOT NULL THEN
-- Modifiquem el nom
    s_sql := s_sql || 'IDESTADOCOMPATOR=''' ||n_estatComptadorControl|| ''',';
  END IF;

-- Eliminem la coma final de la sentencia SQL--------------------------
    s_sql := SUBSTR (s_sql, 1, LENGTH (s_sql) - 1);
-- Afegim a la sentencia la condiciÃ³ del WHERE------------------------
    s_sql := s_sql || ' WHERE IDCOMPTADOR=''' ||n_idComptador|| '''';
         
EXECUTE IMMEDIATE s_sql;
   IF SQL%ROWCOUNT = 0 THEN
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('MODIFICAR ESTAT COMPTADOR A ALTA: ');                      
      s_rsp := 'Actualitzacio no realitzada';
      DBMS_OUTPUT.PUT_LINE(s_rsp);                       
      RAISE e_comptador;
    ELSE
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('MODIFICAR ESTAT COMPTADOR A ALTA:
      Codi Comptador: '||n_idComptador||
      ' Data Modificacio: '||p_dataModificacioComptador||
      ' Nou estat: '||n_estat); 
    DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
    s_rsp := 'OK: ODIFICAR ESTAT COMPTADOR A ALTA:
      Codi Comptador: '||n_idComptador||
      ' Data Modificacio: '||p_dataModificacioComptador||
      ' Nou estat: '||n_estat;
  pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
    END IF;

COMMIT;
  EXCEPTION
     	
    WHEN OTHERS THEN
     IF s_rsp IS NULL THEN
--L'error no ha estat controlat per codi-----------------------------------------
        s_rsp := 'Error: ' || SQLCODE || SUBSTR(SQLERRM, 1, 100);
      ELSE
-- L'error si ha estat controlat per codi-----------------------------------------
        s_rsp := 'Error: ' || s_rsp;
     END IF;
           DBMS_OUTPUT.ENABLE;
           DBMS_OUTPUT.PUT_LINE(' ');      
           DBMS_OUTPUT.put_line (s_rsp);
           pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
ROLLBACK;
END PRC_PASSAR_COMPTADOR_ALTA;

procedure PRC_PASSAR_COMPTADOR_BAIXA( 
   p_idComptador in COMPTADOR.IDCOMPTADOR%TYPE,
   p_dataModificacioComptador in COMPTADOR.DATAMODIFICACIOCOMPATOR%TYPE,
   p_estatComptador in COMPTADOR.IDESTADOCOMPATOR%TYPE,
   s_rsp out NOCOPY VARCHAR2)
AS
BEGIN
     c_procesLog := 'PRC PASSAR COMPTADOR BAIXA';
     c_dataHoraLog := SYSDATE;
     c_entradaLog := 'Id ComptadorModel: ' || p_idComptador||
    ' , Data modificacio Comptador: ' ||p_dataModificacioComptador;
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE('     MODIFICAR ESTAT COMPTADOR A BAIXA:     ');
    DBMS_OUTPUT.PUT_LINE('---------------------------------------- '); 
    DBMS_OUTPUT.PUT_LINE(' Id ComptadorModel: ' || p_idComptador||
    ' , Data modificacio Comptador: ' ||p_dataModificacioComptador); 
    c_sortidalog := 's_rsp';
  --- MIRO LA SITUACIO DEL COMPTADOR SI JA ESTA EN  BAIXA AVISO
  SELECT COMPTADOR.IDESTADOCOMPATOR INTO n_estatComptadorControl
  FROM COMPTADOR
  WHERE COMPTADOR.IDCOMPTADOR=p_idComptador;
  
  IF n_estatComptadorControl=2 THEN
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('MODIFICAR ESTAT COMPTADOR A BAIXA: ');  
  s_rsp := 'El comptador ja esta en situacio BAIXA. ';
  DBMS_OUTPUT.PUT_LINE(s_rsp);           
  RAISE e_comptador;
  END IF;
  
  IF p_dataModificacioComptador IS NULL THEN
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('MODIFICAR ESTAT COMPTADOR A BAIXA: ');  
  s_rsp := 'Falta especificar id Comptador';
  DBMS_OUTPUT.PUT_LINE(s_rsp);           
  RAISE e_comptador;
  END IF;
  IF p_idComptador IS NULL THEN
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('MODIFICAR ESTAT COMPTADOR A BAIXA: ');  
  s_rsp := 'Falta especificar id Comptador';
  DBMS_OUTPUT.PUT_LINE(s_rsp);           
  RAISE e_comptador;
  END IF;  
 SELECT COUNT (*) INTO n_registres 
 FROM COMPTADOR
 WHERE COMPTADOR.IDCOMPTADOR= p_idComptador;
   
 If n_registres=0 then
   DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('MODIFICAR ESTAT COMPTADOR A BAIXA:  ');              
    s_rsp := 'COMPTADOR no existent a la BBDD';
    DBMS_OUTPUT.PUT_LINE(s_rsp);
    RAISE e_comptador;
  END IF;
  
  n_estatComptadorControl:=2;
  
  SELECT COMPTADOR.IDCOMPTADOR INTO n_idComptador
  FROM COMPTADOR
  WHERE COMPTADOR.IDCOMPTADOR= p_idComptador; 
  
  SELECT ESTAT.DESCRIPCIOESTAT INTO n_estat
  FROM ESTAT
  WHERE ESTAT.IDESTAT=n_estatComptadorControl;
  
s_sql := 'UPDATE COMPTADOR SET ';
        
  --Construirem la sentencia UPDATE segons si hi ha valor en els parÃ metres-
   IF p_dataModificacioComptador IS NOT NULL THEN
-- Modifiquem el nom
    s_sql := s_sql || 'DATAMODIFICACIOCOMPATOR=''' ||p_dataModificacioComptador|| ''',';
  END IF;
  IF n_estatComptadorControl IS NOT NULL THEN
-- Modifiquem el nom
    s_sql := s_sql || 'IDESTADOCOMPATOR=''' ||n_estatComptadorControl|| ''',';
  END IF;

-- Eliminem la coma final de la sentencia SQL--------------------------
    s_sql := SUBSTR (s_sql, 1, LENGTH (s_sql) - 1);
-- Afegim a la sentencia la condiciÃ³ del WHERE------------------------
    s_sql := s_sql || ' WHERE IDCOMPTADOR=''' ||n_idComptador|| '''';
         
EXECUTE IMMEDIATE s_sql;
   IF SQL%ROWCOUNT = 0 THEN
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('MODIFICAR ESTAT COMPTADOR A BAIXA: ');                      
      s_rsp := 'Actualitzacio no realitzada';
      DBMS_OUTPUT.PUT_LINE(s_rsp);                       
      RAISE e_comptador;
    ELSE
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('MODIFICAR ESTAT COMPTADOR A BAIXA:
      Codi Comptador: '||n_idComptador||
      ' Data Modificacio: '||p_dataModificacioComptador||
      ' Nou estat: '||n_estat); 
    DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
    s_rsp := 'OK: MODIFICAR ESTAT COMPTADOR A BAIXA:
      Codi Comptador: '||n_idComptador||
      ' Data Modificacio: '||p_dataModificacioComptador||
      ' Nou estat: '||n_estat;
  pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
    END IF;

COMMIT;
  EXCEPTION
     	
    WHEN OTHERS THEN
     IF s_rsp IS NULL THEN
--L'error no ha estat controlat per codi-----------------------------------------
        s_rsp := 'Error: ' || SQLCODE || SUBSTR(SQLERRM, 1, 100);
      ELSE
-- L'error si ha estat controlat per codi-----------------------------------------
        s_rsp := 'Error: ' || s_rsp;
     END IF;
           DBMS_OUTPUT.ENABLE;
           DBMS_OUTPUT.PUT_LINE(' ');      
           DBMS_OUTPUT.put_line (s_rsp);
           pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
ROLLBACK;
END PRC_PASSAR_COMPTADOR_BAIXA;

END "GESTION_COMPTADOR";
