CREATE OR REPLACE
PACKAGE BODY          "GESTION_LINEA_CONECTAR" AS
 n_registres      NUMBER;
  s_sql           VARCHAR2 (2000);
  n_NUM_ERR 	  NUMBER(10);
 
  c_procesLog	  LOG_TFC.procesLog%TYPE;	
  c_dataHoraLog    LOG_TFC.dataHoraLog%TYPE;
  c_entradaLog     LOG_TFC.entradaLog%TYPE;	
  c_sortidaLog     LOG_TFC.sortidaLog%TYPE;
  s_rsp	 LOG_TFC.RSPLOG%TYPE;
  
  n_dataAltaLinea LINEA_CONECTAR_COMPTADOR.DATAALTALINEACONECTA%TYPE;
  n_dataModificacioLinea LINEA_CONECTAR_COMPTADOR.DATAMODIFICACIOLINEACONECTA%TYPE;
  n_observacions LINEA_CONECTAR_COMPTADOR.OBSERVACIOLINEACONECTA%TYPE;
  n_idTpusLinea LINEA_CONECTAR_COMPTADOR.IDLINEATIPOLINEACONECTA%TYPE;
  n_idconectaComptador NUMBER;
  n_controlCentral NUMBER; 
  n_idTipoLineaConecta  LINEA_CONECTAR_COMPTADOR.IDLINEATIPOLINEACONECTA%TYPE;
  n_conectaCentralDistribucio  LINEA_CONECTAR_COMPTADOR.CONNECTA1_CENTRALCONECTA%TYPE;
  n_conectaComptador  LINEA_CONECTAR_COMPTADOR.CONNECTA2_COMPTADORCONECTA%TYPE;
  n_idLineaConecta   LINEA_CONECTAR_COMPTADOR.IDLINEACONECTA%Type;
  n_parConecta LINEA_CONECTAR_COMPTADOR.PARLINEACOMPTADORCONECTA%TYPE;
  n_controlEstat ESTAT.IDESTAT%TYPE;
  n_descEstat ESTAT.DESCRIPCIOESTAT%TYPE;
  n_controlTipoLinea LINEA_TIPUS.IDTLINEA%TYPE;
  n_consumToleratLinea LINEA_TIPUS.CONSUMMAXIMTLINEA%TYPE;
  n_primerPart NUMBER;
  n_segonPart NUMBER;
  n_lineaDis_1 NUMBER;
  n_lineaDis_2 NUMBER;
  n_conectaCentralDistribucio_1  LINEA_CONECTAR_COMPTADOR.CONNECTA1_CENTRALCONECTA%TYPE;
  n_consumToleratLinea_1 NUMBER;
  n_conectaCentralDistribucio_2  LINEA_CONECTAR_COMPTADOR.CONNECTA1_CENTRALCONECTA%TYPE;
  n_consumToleratLinea_2 NUMBER;
  n_centralMaxEner NUMBER;
  n_controlPar NUMBER;
  sortida VARCHAR2(1000):='';
  e_linea_conecta   EXCEPTION;

/******************************************************************************
Autor: Eduard Monzonis Hierro                                   UOC
18/05/2012                                             TFC: CONTROL ENERGIA.
PROCEDIMENT ALTA CONNEXIO LINEAS AMB COMPTADORS
******************************************************************************/
PROCEDURE PRC_CONECTA_LINEA_COMPTADOR(
    p_idTipoLineaConecta in LINEA_CONECTAR_COMPTADOR.IDLINEATIPOLINEACONECTA%Type,
    p_dataAltaLineaConecta in LINEA_CONECTAR_COMPTADOR.DATAALTALINEACONECTA%Type,
    p_conectaCentralDistribucio in LINEA_CONECTAR_COMPTADOR.CONNECTA1_CENTRALCONECTA%Type,
    p_conectaComptador in LINEA_CONECTAR_COMPTADOR.CONNECTA2_COMPTADORCONECTA%Type,
    --p_parConecta in LINEA_CONECTAR_COMPTADOR.PARLINEACOMPTADORCONECTA%TYPE,
    p_observacionsLineaConecta in LINEA_CONECTAR_COMPTADOR.OBSERVACIOLINEACONECTA%Type,
    s_rsp out NOCOPY VARCHAR)
AS
 
BEGIN
    c_procesLog := 'PRC_CONECTA_LINEA_COMPTADOR';
    c_dataHoraLog := SYSDATE;
    c_entradaLog :=' Tipus Linea: ' || p_idTipoLineaConecta||
    ', Data Alta connexio Linea: ' ||p_dataAltaLineaConecta ||
    ', Central Distribucio: ' ||p_conectaCentralDistribucio||
    ', Comptador: ' ||p_conectaComptador||
    ', Observacions  Linea: ' ||p_observacionsLineaConecta;
     DBMS_OUTPUT.ENABLE;
     DBMS_OUTPUT.PUT_LINE(' ');
     DBMS_OUTPUT.PUT_LINE('    ALTA CONNEXIO COMPTADOR EN LINEAS   ');
     DBMS_OUTPUT.PUT_LINE('--------------------------------------- ');
     DBMS_OUTPUT.PUT_LINE(' Codi Tipus Linea: ' || p_idTipoLineaConecta||
    ', Data Alta connexio Linea: ' ||p_dataAltaLineaConecta ||
    ', Central Distribucio: ' ||p_conectaCentralDistribucio||
    ', Comptador: ' ||p_conectaComptador||
    ', Observacions  Linea: ' ||p_observacionsLineaConecta);
    c_sortidalog := 's_rsp';
    
    n_controlEstat:=1;
    
-- CONTROL DE PARAMETRES D'ENTRADA
    If p_idTipoLineaConecta IS NULL then
            DBMS_OUTPUT.ENABLE;
            DBMS_OUTPUT.PUT_LINE('ALTA CONNEXIO COMPTADOR EN LINEAS ');
            s_rsp := 'Falta especificar Id Tipo Linea Conectar ';
            DBMS_OUTPUT.PUT_LINE(s_rsp);           
          RAISE e_linea_conecta;
     END IF;
    If p_dataAltaLineaConecta  IS NULL then
            DBMS_OUTPUT.ENABLE;
            DBMS_OUTPUT.PUT_LINE('ALTA CONNEXIO COMPTADOR EN LINEAS:  ');    
            s_rsp := 'Falta especificar data Linea Conectar ';
            DBMS_OUTPUT.PUT_LINE(s_rsp);               
          RAISE e_linea_conecta;
     END IF;
     
     If p_conectaCentralDistribucio IS NULL then
            DBMS_OUTPUT.ENABLE;
            DBMS_OUTPUT.PUT_LINE('ALTA CONNEXIO COMPTADOR EN LINEAS:  ');        
            s_rsp := 'Falta especificar  Id Central Distribucio a conectar  ';
            DBMS_OUTPUT.PUT_LINE(s_rsp);            
          RAISE e_linea_conecta;
     END IF;
     --CONTROL DE CENTRAL DE DISTRIBUCIO SI EXISTEIX
      
      SELECT DISTINCT COUNT (CENTRAL.IDCENTRAL) INTO n_controlCentral
      FROM CENTRAL,CLASSE_CENTRAL
      WHERE CENTRAL.IDCENTRAL=p_conectaCentralDistribucio
      AND CLASSE_CENTRAL.IDCLASSE=2
      AND CENTRAL.ESTATCENTRAL=n_controlEstat;
     
     IF n_controlCentral=0 THEN
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('ALTA CONNEXIO COMPTADOR EN LINEAS:  ');        
      s_rsp := 'Falta especificar  Id Central Distribucio a conectar  ';
      DBMS_OUTPUT.PUT_LINE(s_rsp);            
      RAISE e_linea_conecta;
     END IF;
     
      SELECT DISTINCT CENTRAL.IDCENTRAL INTO n_conectaCentralDistribucio
      FROM CENTRAL,CLASSE_CENTRAL
      WHERE CENTRAL.IDCENTRAL=p_conectaCentralDistribucio
      AND CLASSE_CENTRAL.IDCLASSE=2
      AND CENTRAL.ESTATCENTRAL=n_controlEstat;
      
-- MIRO LAS LINEA DE DISTRIBUCIO QUE HI HA CONECTADES ENTRE ELLES      

SELECT DISTINCT
      COUNT(LINEA_CONECTA_CENTRAL.IDCONECTA)INTO n_lineaDis_1
FROM CENTRAL, LINEA_CONECTA_CENTRAL
WHERE CENTRAL.IDCENTRAL=LINEA_CONECTA_CENTRAL.CONNECTACDISTRI
--AND CENTRAL.IDCENTRAL=p_conectaCentralDistribucio
--AND (SELECT MAX (CENTRAL.ENERGIAMAXIMA)
--FROM  CENTRAL
--WHERE CENTRAL.IDCENTRAL=p_conectaCentralDistribucio)>0
AND LINEA_CONECTA_CENTRAL.IDESTATC=1;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('LINEAS:  '||n_lineaDis_1);
  
  IF   n_lineaDis_1=0 THEN
   DBMS_OUTPUT.ENABLE;
       DBMS_OUTPUT.PUT_LINE('ALTA CONNEXIO COMPTADOR EN LINEAS: 
       La Central de distribucio no existeix: '||p_conectaCentralDistribucio);        
            s_rsp := 'ALTA CONNEXIO COMPTADOR EN LINEAS: 
       El comptador no te assignat un contracte o no esta
       en situacio alta com a disponible: '||p_conectaCentralDistribucio;
            DBMS_OUTPUT.PUT_LINE(s_rsp);            
          RAISE e_linea_conecta; 
     END IF;   
     
 SELECT CENTRAL.ENERGIAMAXIMA INTO n_centralMaxEner
 FROM CENTRAL
 WHERE CENTRAL.IDCENTRAL=p_conectaCentralDistribucio;
  
     --CONTROL COMPTADOR SI EXISTEIX I TE UN CONTRACTE EN VIGOR
          
     SELECT COUNT (COMPTADOR.IDCOMPTADOR) INTO n_registres
     FROM COMPTADOR, CONTRACTE
     WHERE COMPTADOR.IDCOMPTADOR=p_conectaComptador
     AND CONTRACTE.IDCONTADORCONTRACTE=COMPTADOR.IDCOMPTADOR
     AND CONTRACTE.IDESTATCONTRACTE=n_controlEstat;
      
  -- mirem el tipus de linea que vol conectar-se i que estigui en alta  
     SELECT COUNT (LINEA_TIPUS.IDTLINEA)  INTO n_controlTipoLinea
     FROM LINEA_TIPUS
     WHERE LINEA_TIPUS.IDTLINEA=p_idTipoLineaConecta
     AND LINEA_TIPUS.IDESTATTLINEA=n_controlEstat;
     
-- MIRO SI ESTA ASSIGNAT EL COMPTADOR A LA LINEA QUE HI HA LA CENTRAL DE DISTRIBUCIO
 SELECT COUNT (*) INTO  n_conectaComptador
 FROM LINEA_CONECTAR_COMPTADOR
 WHERE  LINEA_CONECTAR_COMPTADOR.CONNECTA1_CENTRALCONECTA=n_lineaDis_1
 AND LINEA_CONECTAR_COMPTADOR.CONNECTA2_COMPTADORCONECTA=p_conectaComptador
 AND LINEA_CONECTAR_COMPTADOR.PARLINEACOMPTADORCONECTA=
 LINEA_CONECTAR_COMPTADOR.PARLINEACOMPTADORCONECTA;
    
   -- si n_registres=0  el comptador no te contracte en situacio alta per
   -- connectar.
   -- si n_controlTipoLinea=0 el tipus de linea no exiteix
   -- si n_controlCentral=0 la central de distribucio no existeix o no esta
   -- disponible
   -- si n_conectaCentralDistribucio es igual a p_conectaCentralDistribucio
   -- a p_conectaCentralDistribucio conte el codi de la Central de 
   -- Distribucio.
   --Llavors la connexio es viable i insertem els valors sino emet excepcio.
   -- n_conrolPar controla si el comptador te assignada la linea alternativa
   -- nomes podem haver 2 conectivitats de linea
  SELECT COUNT (LINEA_CONECTAR_COMPTADOR.PARLINEACOMPTADORCONECTA) INTO n_controlPar
 FROM LINEA_CONECTAR_COMPTADOR
 WHERE  LINEA_CONECTAR_COMPTADOR.CONNECTA2_COMPTADORCONECTA=p_conectaComptador
 AND LINEA_CONECTAR_COMPTADOR.PARLINEACOMPTADORCONECTA=
 LINEA_CONECTAR_COMPTADOR.PARLINEACOMPTADORCONECTA;
 
  If n_controlCentral=0 then
       DBMS_OUTPUT.ENABLE;
       DBMS_OUTPUT.PUT_LINE('ALTA CONNEXIO COMPTADOR EN LINEAS: 
       La Central de distribucio no existeix: '||p_conectaCentralDistribucio);        
            s_rsp := 'ALTA CONNEXIO COMPTADOR EN LINEAS: 
       El comptador no te assignat un contracte o no esta
       en situacio alta com a disponible: '||p_conectaCentralDistribucio;
            DBMS_OUTPUT.PUT_LINE(s_rsp);            
          RAISE e_linea_conecta; 
     END IF;   

SELECT DISTINCT CENTRAL.IDCENTRAL INTO n_conectaCentralDistribucio
FROM CENTRAL, LINEA_CONECTA_CENTRAL
WHERE LINEA_CONECTA_CENTRAL.IDCONECTA=n_lineaDis_1
AND CENTRAL.IDCENTRAL=
LINEA_CONECTA_CENTRAL.CONNECTACDISTRI;


    
    SELECT DISTINCT COUNT(PARLINEACOMPTADORCONECTA) INTO n_primerPart
    FROM LINEA_CONECTAR_COMPTADOR
    WHERE LINEA_CONECTAR_COMPTADOR.PARLINEACOMPTADORCONECTA=1
    AND LINEA_CONECTAR_COMPTADOR.CONNECTA2_COMPTADORCONECTA=p_conectaComptador;
    
    
 -- CONECTEM EL PRIMER PART SI PRIMER PART=0   
If  n_conectaComptador=0  AND n_controlPar=0  then
     n_controlEstat:=1;
     n_primerPart:=1;
    -- El donem d'alta la connexio viable          
INSERT INTO LINEA_CONECTAR_COMPTADOR(
            IDLINEATIPOLINEACONECTA,
            DATAALTALINEACONECTA,
            IDESTATLINEACONECTA,
            CONNECTA1_CENTRALCONECTA,
            CONNECTA2_COMPTADORCONECTA,
            PARLINEACOMPTADORCONECTA,
            OBSERVACIOLINEACONECTA) 
VALUES(p_idTipoLineaConecta,
            p_dataAltaLineaConecta,
            n_controlEstat,
            n_lineaDis_1,
            p_conectaComptador,
            n_primerPart,
            p_observacionsLineaConecta);
--Gravem en la taula log-----------------------------------------------------            
 SELECT LINEA_TIPUS.CONSUMMAXIMTLINEA INTO n_consumToleratLinea
 FROM LINEA_TIPUS
 WHERE LINEA_TIPUS.IDTLINEA=p_idTipoLineaConecta;
 SELECT ESTAT.DESCRIPCIOESTAT INTO n_descEstat
 FROM ESTAT
 WHERE ESTAT.IDESTAT=n_controlEstat;
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('Connexio inserida PRIMERA connexio:
  Tipus de Linea Connectada: '||p_idTipoLineaConecta||
 --' amb una tolerancia de: '||n_consumToleratLinea||' Kw/h. 
  ' en data de connexio: '||p_dataAltaLineaConecta||
   ' estat de linea: '||n_descEstat||
   ' conectat a la Central Distribucio: '||n_conectaCentralDistribucio||
   ' el comptador: '||p_conectaComptador||
   ' connexio primaria: '||n_primerPart||
   ' Observacions: '||p_observacionsLineaConecta);
    DBMS_OUTPUT.PUT_LINE('******** FI DE LES OPERACIONS ********');
            --Gravem en la taula log-----------------------------------------------------
  s_rsp :='Ok Connexio inserida:
  Tipus de Linea Connectada: '||p_idTipoLineaConecta||
   -- ' amb una tolerancia de: '||n_consumToleratLinea||' Kw/h. 
  ' en data de connexio: '||p_dataAltaLineaConecta||
  -- ' estat de linea: '||n_descEstat||
   ' conectat a la Central Distribucio: '||n_conectaCentralDistribucio||
   ' el comptador: '||p_conectaComptador||
   ' connexio primaria: '||n_primerPart;

  pkg_general.gravar_log_procedure(c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  --DBMS_OUTPUT.PUT_LINE(s_rsp);

  ELSE
     
 If  n_conectaComptador>0 AND n_controlPar>0  then 
     n_controlEstat:=1;
     n_segonPart:=2 ;
    -- El donem d'alta la connexio viable          
INSERT INTO LINEA_CONECTAR_COMPTADOR(
            IDLINEATIPOLINEACONECTA,
            DATAALTALINEACONECTA,
            IDESTATLINEACONECTA,
            CONNECTA1_CENTRALCONECTA,
            CONNECTA2_COMPTADORCONECTA,
            PARLINEACOMPTADORCONECTA,
            OBSERVACIOLINEACONECTA) 
VALUES(p_idTipoLineaConecta,
            p_dataAltaLineaConecta,
            n_controlEstat,
            n_lineaDis_1,
            p_conectaComptador,
            n_segonPart,
            p_observacionsLineaConecta);
--Gravem en la taula log-----------------------------------------------------            
 --11,'01/03/2012',1,16,11,'CONECTAT',sortida
 SELECT LINEA_TIPUS.CONSUMMAXIMTLINEA INTO n_consumToleratLinea
 FROM LINEA_TIPUS
 WHERE LINEA_TIPUS.IDTLINEA=p_idTipoLineaConecta;
 SELECT ESTAT.DESCRIPCIOESTAT INTO n_descEstat
 FROM ESTAT
 WHERE ESTAT.IDESTAT=n_controlEstat;
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('Connexio inserida SEGONA connexio:
   Tipus de Linea Connectada: '||p_idTipoLineaConecta||
 --' amb una tolerancia de: '||n_consumToleratLinea||' Kw/h.  
 ' en data de connexio: '||p_dataAltaLineaConecta||
   
   ' estat de linea: '||n_descEstat||
  
   ' conectat a la Central Distribucio: '||n_conectaCentralDistribucio||
   ' el comptador: '||p_conectaComptador||
   ' connexio secundaria: '||n_segonPart||
   ' Observacions: '||p_observacionsLineaConecta);
   
   DBMS_OUTPUT.PUT_LINE('******** FI DE LES OPERACIONS ********');
            --Gravem en la taula log-----------------------------------------------------
  s_rsp :='Ok Connexio inserida:
  Tipus de Linea Connectada: '||p_idTipoLineaConecta||
  ---' amb una tolerancia de: '||n_consumToleratLinea||' Kw/h. 
   'en data de connexio: '||p_dataAltaLineaConecta||
   ' estat de linea: '||n_descEstat||
   ' conectat a la Central Distribucio: '||n_conectaCentralDistribucio||
   ' el comptador: '||p_conectaComptador||
   ' connexio secundaria: '||n_segonPart;
   --' Observacions: '||p_observacionsLineaConecta;
            pkg_general.gravar_log_procedure(c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
            --DBMS_OUTPUT.PUT_LINE(s_rsp);
  -- ELSE
          
 
   END IF;
   DBMS_OUTPUT.ENABLE;
          DBMS_OUTPUT.PUT_LINE('ALTA CONNEXIO COMPTADOR EN LINEAS: ');
          s_rsp := ' Linea te el comptador te les dues connexios maximes
          autoritzades el nombre de par es de: '||n_segonPart|| ' pel comptador: '||p_conectaComptador ;
          DBMS_OUTPUT.PUT_LINE(s_rsp);
          RAISE e_linea_conecta; 
END IF;  

COMMIT; 
EXCEPTION
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         s_rsp := 'Error: ' || SQLCODE || SUBSTR (SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' '); 
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;
END PRC_CONECTA_LINEA_COMPTADOR;  
/******************************************************************************
Autor: Eduard Monzonis Hierro                                   UOC
18/05/2012                                             TFC: CONTROL ENERGIA.

--- MODIFICAR CONEXIONS DE COMPTADOR

******************************************************************************/
PROCEDURE PRC_MODIFICA_CONECTA_COMPTADOR(
    p_idLineaConecta in LINEA_CONECTAR_COMPTADOR.IDLINEACONECTA%TYPE,
    p_idTipoLineaConecta in LINEA_CONECTAR_COMPTADOR.IDLINEATIPOLINEACONECTA%Type,
    p_dataModificaLineaConecta in LINEA_CONECTAR_COMPTADOR.DATAMODIFICACIOLINEACONECTA%Type,
    p_estatLineaConecta in LINEA_CONECTAR_COMPTADOR.IDESTATLINEACONECTA%Type,
    p_conectaCentralDistribucio in LINEA_CONECTAR_COMPTADOR.CONNECTA1_CENTRALCONECTA%Type,
    p_conectaComptador in LINEA_CONECTAR_COMPTADOR.CONNECTA2_COMPTADORCONECTA%Type,
    p_parConecta in LINEA_CONECTAR_COMPTADOR.PARLINEACOMPTADORCONECTA%TYPE,
    p_observacionsLineaConecta in LINEA_CONECTAR_COMPTADOR.OBSERVACIOLINEACONECTA%Type,
    s_rsp out NOCOPY VARCHAR)
AS
 
BEGIN
    c_procesLog := 'PRC_MODIFICA_CONECTA_COMPTADOR';
    c_dataHoraLog := SYSDATE;
    c_entradaLog :=' Id Linea: '||p_idLineaConecta||
    ' Tipus Linea: ' || p_idTipoLineaConecta||
    ', Data Modificacio connexio Linea: ' ||p_dataModificaLineaConecta ||
    ', Linea Central Distribucio: ' ||p_conectaCentralDistribucio||
    ', Comptador: ' ||p_conectaComptador||
    ', Estat de la Linea: ' ||p_estatLineaConecta||
    ', Observacions  Linea: ' ||p_observacionsLineaConecta;
     DBMS_OUTPUT.ENABLE;
     DBMS_OUTPUT.PUT_LINE(' ');
     DBMS_OUTPUT.PUT_LINE('     MODIFICAR CONNEXIO COMPTADOR A LA  LINEA   ');
     DBMS_OUTPUT.PUT_LINE('------------------------------------------------ ');
     DBMS_OUTPUT.PUT_LINE('
     Id Linea: '||p_idLineaConecta||
     ', Tipus Linea: ' || p_idTipoLineaConecta||
    ', Data Modificacio connexio Linea: ' ||p_dataModificaLineaConecta ||
    ', Linea Central Distribucio: ' ||p_conectaCentralDistribucio||
    ', Comptador: ' ||p_conectaComptador||
    ', Estat de la Linea: ' ||p_estatLineaConecta||
    ', Observacions  Linea: ' ||p_observacionsLineaConecta);
    c_sortidalog := 's_rsp';
    
       
    -- CONTROL DE DADES
    IF p_idLineaConecta IS NULL THEN
            DBMS_OUTPUT.ENABLE;
            DBMS_OUTPUT.PUT_LINE('MODIFICAR CONNEXIO COMPTADOR A LA  LINEA: ');
            s_rsp := 'Falta especificar Id Tipo Linea Conectar ';
            DBMS_OUTPUT.PUT_LINE(s_rsp);           
          RAISE e_linea_conecta;
     END IF;
    
    If (p_idTipoLineaConecta IS NULL) then
            DBMS_OUTPUT.ENABLE;
            DBMS_OUTPUT.PUT_LINE('MODIFICAR CONNEXIO COMPTADOR A LA  LINEA: ');
            s_rsp := 'Falta especificar Id Tipo Linea Conectar ';
            DBMS_OUTPUT.PUT_LINE(s_rsp);           
          RAISE e_linea_conecta;
     END IF;
    If p_dataModificaLineaConecta  IS NULL then
            DBMS_OUTPUT.ENABLE;
            DBMS_OUTPUT.PUT_LINE('MODIFICAR CONNEXIO COMPTADOR A LA  LINEA:  ');    
            s_rsp := 'Falta especificar data Modificacio Linea Conectar ';
            DBMS_OUTPUT.PUT_LINE(s_rsp);               
          RAISE e_linea_conecta;
     END IF;
      If (p_estatLineaConecta IS NULL) then
            DBMS_OUTPUT.ENABLE;
            DBMS_OUTPUT.PUT_LINE('MODIFICAR CONNEXIO COMPTADOR A LA  LINEA:  ');        
            s_rsp := 'Falta especificar el Estat 1=ALTA o 0=BAIXA ';
            DBMS_OUTPUT.PUT_LINE(s_rsp);            
          RAISE e_linea_conecta;
     END IF;
     If (p_estatLineaConecta<0 OR p_estatLineaConecta>3
     OR p_estatLineaConecta=0) then
            DBMS_OUTPUT.ENABLE;
            DBMS_OUTPUT.PUT_LINE('MODIFICAR CONNEXIO COMPTADOR A LA  LINEA:  ');        
            s_rsp := 'Falta especificar el Estat 1=ALTA o 2=BAIXA ';
            DBMS_OUTPUT.PUT_LINE(s_rsp);            
          RAISE e_linea_conecta;
     END IF;
     If p_conectaCentralDistribucio IS NULL then
            DBMS_OUTPUT.ENABLE;
            DBMS_OUTPUT.PUT_LINE('MODIFICAR CONNEXIO COMPTADOR A LA  LINEA:  ');        
            s_rsp := 'Falta especificar  ID Linea Central Distribucio  ';
            DBMS_OUTPUT.PUT_LINE(s_rsp);            
          RAISE e_linea_conecta;
     END IF;
     --CONTROL LINEA DE CENTRAL DE DISTRIBUCIO SI EXISTEIX
     n_controlCentral:=0;
     SELECT DISTINCT LINEA_CONECTA_CENTRAL.IDCONECTA INTO n_controlCentral
    FROM LINEA_CONECTA_CENTRAL,CENTRAL
    WHERE LINEA_CONECTA_CENTRAL.CONNECTACDISTRI=p_conectaCentralDistribucio
    AND CENTRAL.IDCENTRAL=p_conectaCentralDistribucio;
    
      
    -- control que el contador existeix en la linea, conectat
     If n_controlCentral=0 OR n_controlCentral IS NULL THEN
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('MODIFICAR CONNEXIO COMPTADOR A LA  LINEA:  '
      ||p_conectaCentralDistribucio||
      ' La linea de la Central Distribucio no existeix  ');        
      s_rsp := ' La linea de la Central Distribucio no existeix  ';
      DBMS_OUTPUT.PUT_LINE(s_rsp);            
      RAISE e_linea_conecta;
     END IF;
    
     --CONTROL COMPTADOR SI EXISTEIX
     SELECT COMPTADOR.IDCOMPTADOR INTO n_idconectaComptador
     FROM COMPTADOR
     WHERE COMPTADOR.IDCOMPTADOR=p_conectaComptador;
     
If (n_idconectaComptador=0) then
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('MODIFICAR CONNEXIO COMPTADOR A LA  LINEA:
    no existeix '||p_conectaComptador);        
    s_rsp := 'Id Comptador no existeix  ';
    DBMS_OUTPUT.PUT_LINE(s_rsp);            
    RAISE e_linea_conecta; 
END IF;
     -- recuperem el codi  Linea
    SELECT LINEA_CONECTAR_COMPTADOR.IDLINEACONECTA INTO n_idLineaConecta 
    FROM LINEA_CONECTAR_COMPTADOR
    WHERE LINEA_CONECTAR_COMPTADOR.IDLINEACONECTA=p_idLineaConecta;
       
  -- CONTROL SI EXISTEIX LA LINEA
          
 If n_registres=0 then
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('MODIFICAR CONNEXIO COMPTADOR A LA  LINEA: ');                 
    s_rsp := 'Tipus Linea no existent a la BBDD';
    DBMS_OUTPUT.PUT_LINE(s_rsp);
    RAISE e_linea_conecta; 
END IF;
              
s_sql := 'UPDATE LINEA_CONECTAR_COMPTADOR SET ';
-- Construirem la sentencia UPDATE segons si hi ha valor en els paràmetres-
IF p_idTipoLineaConecta IS NOT NULL THEN
-- Modifiquem id Tipo LineaConecta
  s_sql := s_sql || 'IDLINEACONECTA=''' ||p_idTipoLineaConecta|| ''',';
 END IF;
IF p_dataModificaLineaConecta IS NOT NULL THEN
 -- Modifiquem data Modifica Linea Conecta
 s_sql := s_sql || 'DATAMODIFICACIOLINEACONECTA=''' ||p_dataModificaLineaConecta|| ''',';
END IF;
IF p_estatLineaConecta IS NOT NULL THEN
-- Modifiquem estat Linea Conecta
  s_sql := s_sql || 'IDESTATLINEACONECTA=''' ||p_estatLineaConecta|| ''',';
END IF;                   
IF p_conectaCentralDistribucio IS NOT NULL THEN
-- Modifiquem conecta Central Distribucio
s_sql := s_sql || 'CONNECTA1_CENTRALCONECTA=''' ||n_controlCentral|| ''',';
END IF;
IF p_conectaComptador IS NOT NULL THEN
-- Modifiquem conecta Central Distribucio
 s_sql := s_sql || 'CONNECTA2_COMPTADORCONECTA=''' ||p_conectaComptador|| ''',';
END IF;
IF p_parConecta IS NOT NULL THEN
 -- Modifiquem conecta par del comptador
  s_sql := s_sql || 'PARLINEACOMPTADORCONECTA=''' ||p_parConecta|| ''',';
END IF;
IF p_observacionsLineaConecta IS NOT NULL THEN
 -- Modifiquem conecta observacions
  s_sql := s_sql || 'OBSERVACIOLINEACONECTA=''' ||p_observacionsLineaConecta|| ''',';
END IF;
-- Eliminem la coma final de la sentencia SQL--------------------------
  s_sql := SUBSTR (s_sql, 1, LENGTH (s_sql) - 1);
-- Afegim a la sentencia la condiciÃ³ del WHERE------------------------
  s_sql := s_sql || ' WHERE IDLINEACONECTA=''' ||n_idLineaConecta|| '''';
 EXECUTE IMMEDIATE s_sql;              
  IF SQL%ROWCOUNT = 0 THEN
  --L'error serà que Tipo Linea ja el tenim en la taula i no admet duplicats--
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('MODIFICA_CONECTA_COMPTADOR:');                  
    s_rsp := 'Actualitzacio no realitzada';
    DBMS_OUTPUT.PUT_LINE(s_rsp);                  
    RAISE e_linea_conecta; 
ELSE

SELECT ESTAT.DESCRIPCIOESTAT INTO n_descEstat
FROM ESTAT
WHERE ESTAT.IDESTAT=p_estatLineaConecta;

 DBMS_OUTPUT.ENABLE;
 DBMS_OUTPUT.PUT_LINE('MODIFICAR CONNEXIO COMPTADOR A LA  LINEA:
 Modificat satisfactoriament en el Codi de Linea: '||p_idLineaConecta||
 '  data modificacio: '||p_dataModificaLineaConecta||
 ' estat linea: '||n_descEstat||
 ' central distribucio: '||n_controlCentral||
 ' comptador :'||p_conectaComptador||
 ' par modificat: ' ||p_parConecta||
 ' observacions: '||p_observacionsLineaConecta); 
 DBMS_OUTPUT.put_line ('******** FI DE LES OPERACIONS ******** ');       
 s_rsp := 'OK Modificat satisfactoriament en el Codi de Linea: '||p_idLineaConecta||
 '  data modificacio: '||p_dataModificaLineaConecta||
 ' estat linea: '||n_descEstat||
 ' central distribucio: '||n_controlCentral||
 ' comptador :'||p_conectaComptador||
 ' par modificat: ' ||p_parConecta||
 ' observacions: '||p_observacionsLineaConecta;
 pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
              END IF;
      COMMIT;
  EXCEPTION
    WHEN DUP_VAL_ON_INDEX THEN
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' ');    
      s_rsp := 'Error:  Linea duplicada. No es poden fer les modificacions';
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;      
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         -----------------------------------------
         s_rsp := 'Error: ' || SQLCODE || SUBSTR(SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         -----------------------------------------
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('MODIFICA_CONECTA_COMPTADOR: '); 
      DBMS_OUTPUT.put_line (s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
ROLLBACK;    

END PRC_MODIFICA_CONECTA_COMPTADOR;  

/******************************************************************************
Autor: Eduard Monzonis Hierro                                   UOC
18/05/2012                                             TFC: CONTROL ENERGIA.

CONSULTA D'UNA LINEA

*******************************************************************************/
 
PROCEDURE PRC_CONSULTAR_CONEXIO_LINEA(
  p_idLineaConecta in LINEA_CONECTAR_COMPTADOR.IDLINEACONECTA%TYPE,
  s_rsp out NOCOPY VARCHAR2)
AS

CURSOR C_CONNEXIO_LINEA IS
SELECT LINEA_CONECTAR_COMPTADOR.IDLINEACONECTA,
LINEA_CONECTAR_COMPTADOR.DATAALTALINEACONECTA,
ESTAT.DESCRIPCIOESTAT,
LINEA_CONECTAR_COMPTADOR.DATAMODIFICACIOLINEACONECTA,
LINEA_TIPUS.CONSUMMAXIMTLINEA,
CENTRAL.IDCENTRAL,
LINEA_CONECTAR_COMPTADOR.CONNECTA2_COMPTADORCONECTA,
LINEA_CONECTAR_COMPTADOR.PARLINEACOMPTADORCONECTA,
LINEA_CONECTAR_COMPTADOR.OBSERVACIOLINEACONECTA
FROM LINEA_CONECTAR_COMPTADOR,ESTAT,LINEA_CONECTA_CENTRAL,LINEA_TIPUS,CENTRAL
WHERE LINEA_CONECTA_CENTRAL.IDCONECTA=LINEA_CONECTAR_COMPTADOR.CONNECTA1_CENTRALCONECTA
AND LINEA_CONECTAR_COMPTADOR.IDLINEACONECTA=p_idLineaConecta
AND  LINEA_CONECTAR_COMPTADOR.IDESTATLINEACONECTA=ESTAT.IDESTAT
AND  LINEA_CONECTAR_COMPTADOR.IDLINEATIPOLINEACONECTA=LINEA_TIPUS.IDTLINEA
AND LINEA_CONECTA_CENTRAL.CONNECTACDISTRI=CENTRAL.IDCENTRAL;

BEGIN
    c_procesLog := 'PRC_CONSULTAR_CONEXIO_CENTRAL';
    c_dataHoraLog := SYSDATE;
    c_entradaLog :=' Codi Linea: ' ||p_idLineaConecta;
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE('    CONSULTA UNA LINEA CONNECTADA      ');
    DBMS_OUTPUT.PUT_LINE('---------------------------------------');
     DBMS_OUTPUT.PUT_LINE('CONSULTAR_CONEXIO_CENTRAL: 
     Codi Linea: ' ||p_idLineaConecta);
    c_sortidalog := 's_rsp';
   IF  p_idLineaConecta is null THEN
            DBMS_OUTPUT.ENABLE;
            DBMS_OUTPUT.PUT_LINE('CONSULTA UNA LINEA CONNECTADA: ');
            s_rsp := 'Falta especificar Codi Linea ';
            DBMS_OUTPUT.PUT_LINE(s_rsp);           
          RAISE e_linea_conecta;
     END IF;
-- miro si la linea existeix
SELECT COUNT(*) INTO n_registres
FROM LINEA_CONECTAR_COMPTADOR
WHERE LINEA_CONECTAR_COMPTADOR.IDLINEACONECTA=p_idLineaConecta;

IF n_registres=0 THEN
 DBMS_OUTPUT.ENABLE;
 DBMS_OUTPUT.PUT_LINE('CONSULTA UNA LINEA CONNECTADA: ');
 s_rsp := 'La linea no existeix. ';
 DBMS_OUTPUT.PUT_LINE(s_rsp);           
 RAISE e_linea_conecta;
END IF;
 DBMS_OUTPUT.ENABLE;
 DBMS_OUTPUT.PUT_LINE(' ');
 DBMS_OUTPUT.PUT_LINE('    CONSULTA UNA LINEA CONNECTADA      ');
 DBMS_OUTPUT.PUT_LINE('---------------------------------------');
OPEN C_CONNEXIO_LINEA;
FETCH C_CONNEXIO_LINEA
INTO n_idLineaConecta,
n_dataAltaLinea,
n_descEstat,
n_dataModificacioLinea,
n_centralMaxEner,
n_conectaCentralDistribucio,
n_conectaComptador,
n_parConecta,
n_observacions;
  WHILE C_CONNEXIO_LINEA%FOUND LOOP
   DBMS_OUTPUT.ENABLE;
   DBMS_OUTPUT.PUT_LINE(
 '   Codi Linea: '
 ||n_idLineaConecta||
 ' Data Alta: '
 ||n_dataAltaLinea||
 ' Estat: '
 ||n_descEstat||
 ' Data Modificacio: '
 ||n_dataModificacioLinea||
 ' Energia Maxima torelable: '
 ||n_centralMaxEner||
' Central Distribucio: '
 ||n_conectaCentralDistribucio|| 
 ' Comptador: '
 ||n_conectaComptador||
 'Par de connexio: '
 ||n_parConecta||
 ' Observacions: '
 ||n_observacions);
  s_rsp := 'OK  CONSULTA UNA LINEA CONNECTADA
     Codi Linea: '
 ||n_idLineaConecta||
 ' Data Alta: '
 ||n_dataAltaLinea||
 ' Estat: '
 ||n_descEstat||
 ' Data Modificacio: '
 ||n_dataModificacioLinea||
 ' Energia Maxima torelable: '
 ||n_centralMaxEner||
' Central Distribucio: '
 ||n_conectaCentralDistribucio|| 
 ' Comptador: '
 ||n_conectaComptador||
 'Par de connexio: '
 ||n_parConecta||
 ' Observacions: '
 ||n_observacions;
FETCH C_CONNEXIO_LINEA
INTO n_idLineaConecta,
n_dataAltaLinea,
n_descEstat,
n_dataModificacioLinea,
n_centralMaxEner,
n_conectaCentralDistribucio,
n_conectaComptador,
n_parConecta,
n_observacions;

pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  
END LOOP;
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('Total connexions Linea: '||n_registres);
  DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
CLOSE C_CONNEXIO_LINEA;
COMMIT;
  EXCEPTION
     	
    WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
  -- L'error no ha estat controlat per codi-----------------------------------------
        s_rsp := 'Error: ' || SQLCODE || SUBSTR(SQLERRM, 1, 100);
      ELSE
   -- L'error si ha estat controlat per codi-----------------------------------------
         s_rsp := 'Error: ' || s_rsp;
      END IF;
         DBMS_OUTPUT.ENABLE;
         DBMS_OUTPUT.PUT_LINE('  ');        
         DBMS_OUTPUT.put_line (s_rsp);
         pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
ROLLBACK;
END PRC_CONSULTAR_CONEXIO_LINEA;

/******************************************************************************
Autor: Eduard Monzonis Hierro                                   UOC
18/05/2012                                             TFC: CONTROL ENERGIA.

CONSULTA LINEAS CONECTADES I NO CONECTADES

*******************************************************************************/
 
PROCEDURE PRC_CONSULTAR_LINEAS(
   s_rsp out NOCOPY VARCHAR2)
AS

CURSOR C_CONNEXIO_LINEA IS
SELECT LINEA_CONECTAR_COMPTADOR.IDLINEACONECTA,
LINEA_CONECTAR_COMPTADOR.DATAALTALINEACONECTA,
ESTAT.DESCRIPCIOESTAT,
LINEA_CONECTAR_COMPTADOR.DATAMODIFICACIOLINEACONECTA,
LINEA_TIPUS.CONSUMMAXIMTLINEA,
CENTRAL.IDCENTRAL,
LINEA_CONECTAR_COMPTADOR.CONNECTA2_COMPTADORCONECTA,
LINEA_CONECTAR_COMPTADOR.PARLINEACOMPTADORCONECTA,
LINEA_CONECTAR_COMPTADOR.OBSERVACIOLINEACONECTA
FROM LINEA_CONECTAR_COMPTADOR,ESTAT,LINEA_CONECTA_CENTRAL,LINEA_TIPUS,CENTRAL
WHERE LINEA_CONECTA_CENTRAL.IDCONECTA=LINEA_CONECTAR_COMPTADOR.CONNECTA1_CENTRALCONECTA
AND LINEA_CONECTAR_COMPTADOR.IDLINEACONECTA=LINEA_CONECTAR_COMPTADOR.IDLINEACONECTA
AND  LINEA_CONECTAR_COMPTADOR.IDESTATLINEACONECTA=ESTAT.IDESTAT
AND  LINEA_CONECTAR_COMPTADOR.IDLINEATIPOLINEACONECTA=LINEA_TIPUS.IDTLINEA
AND LINEA_CONECTA_CENTRAL.CONNECTACDISTRI=CENTRAL.IDCENTRAL
ORDER BY IDLINEACONECTA;
BEGIN
    c_procesLog := 'PRC_CONSULTAR_LINEAS';
    c_dataHoraLog := SYSDATE;
    c_entradaLog :=' CONSULTA LINEAS ';
        c_sortidalog := 's_rsp';
  
-- miro si hi ha lineas
SELECT COUNT(*) INTO n_registres
FROM LINEA_CONECTAR_COMPTADOR
WHERE LINEA_CONECTAR_COMPTADOR.IDLINEACONECTA=LINEA_CONECTAR_COMPTADOR.IDLINEACONECTA;

IF n_registres=0 THEN
 DBMS_OUTPUT.ENABLE;
 DBMS_OUTPUT.PUT_LINE('CONSULTA LINEAS ');
 s_rsp := 'No hi han lineas connectadas. ';
 DBMS_OUTPUT.PUT_LINE(s_rsp);           
 RAISE e_linea_conecta;
END IF;
 DBMS_OUTPUT.ENABLE;
 DBMS_OUTPUT.PUT_LINE(' ');
 DBMS_OUTPUT.PUT_LINE('           CONSULTA LINEAS             ');
 DBMS_OUTPUT.PUT_LINE('---------------------------------------');
OPEN C_CONNEXIO_LINEA;
FETCH C_CONNEXIO_LINEA
INTO n_idLineaConecta,
n_dataAltaLinea,
n_descEstat,
n_dataModificacioLinea,
n_centralMaxEner,
n_conectaCentralDistribucio,
n_conectaComptador,
n_parConecta,
n_observacions;
  WHILE C_CONNEXIO_LINEA%FOUND LOOP
   DBMS_OUTPUT.ENABLE;
   DBMS_OUTPUT.PUT_LINE(
 '   Codi Linea: '
 ||n_idLineaConecta||
 ' Data Alta: '
 ||n_dataAltaLinea||
 ' Estat: '
 ||n_descEstat||
 ' Data Modificacio: '
 ||n_dataModificacioLinea||
 ' Energia Maxima torelable: '
 ||n_centralMaxEner||
' Central Distribucio: '
 ||n_conectaCentralDistribucio|| 
 ' Comptador: '
 ||n_conectaComptador||
 ' Par de connexio: '
 ||n_parConecta||
 ' Observacions: '
 ||n_observacions);
 DBMS_OUTPUT.PUT_LINE('   '); 
  s_rsp := 'OK   CONSULTA LINEAS  
     Codi Linea: '
 ||n_idLineaConecta||
 ' Data Alta: '
 ||n_dataAltaLinea||
 ' Estat: '
 ||n_descEstat||
 ' Data Modificacio: '
 ||n_dataModificacioLinea||
 ' Energia Maxima torelable: '
 ||n_centralMaxEner||
' Central Distribucio: '
 ||n_conectaCentralDistribucio|| 
 ' Comptador: '
 ||n_conectaComptador||
 ' Par de connexio: '
 ||n_parConecta;
 --' Observacions: '
-- ||n_observacions;
FETCH C_CONNEXIO_LINEA
INTO n_idLineaConecta,
n_dataAltaLinea,
n_descEstat,
n_dataModificacioLinea,
n_centralMaxEner,
n_conectaCentralDistribucio,
n_conectaComptador,
n_parConecta,
n_observacions;

pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  
END LOOP;
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('Total Lineas: '||n_registres);
  DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
  DBMS_OUTPUT.PUT_LINE('   '); 
CLOSE C_CONNEXIO_LINEA;
COMMIT;
  EXCEPTION
     	
    WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
  -- L'error no ha estat controlat per codi-----------------------------------------
        s_rsp := 'Error: ' || SQLCODE || SUBSTR(SQLERRM, 1, 100);
      ELSE
   -- L'error si ha estat controlat per codi-----------------------------------------
         s_rsp := 'Error: ' || s_rsp;
      END IF;
         DBMS_OUTPUT.ENABLE;
         DBMS_OUTPUT.PUT_LINE('   ');        
         DBMS_OUTPUT.put_line (s_rsp);
         pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
ROLLBACK;   
END PRC_CONSULTAR_LINEAS;   
END "GESTION_LINEA_CONECTAR";
