CREATE OR REPLACE
PACKAGE BODY          "GESTION_HIST_CONSUMS" AS
   --DECLARACIO DE: varibles generals
  s_sql           VARCHAR2 (2000);
  n_NUM_ERR 	  NUMBER(10);
  n_lineas number;
  
  c_procesLog	  	LOG_TFC.procesLog%TYPE;	
  c_dataHoraLog   	LOG_TFC.dataHoraLog%TYPE;
  c_entradaLog     	LOG_TFC.entradaLog%TYPE;	
  c_sortidaLog     	LOG_TFC.sortidaLog%TYPE;
  s_rsp	 		LOG_TFC.RSPLOG%TYPE;
  g_idComptadorHist    HIST_LECTURA.IDCOMPTADORHISTLECTURA%TYPE;  
  g_idLineaHistLectura HIST_LECTURA.IDLINEAHISTLECTURA%TYPE;
  
  sortida VARCHAR2(1000):='';
  e_hist_consum   EXCEPTION;
  
  
-- CONSTRUCCIO DE LA PROCEDURE PRC ACTUALIZAR HISTORIC CONSUMS  
PROCEDURE PRC_ACTUALIZAR_HIS_CONSUM(
  g_idComptadorHist  in  HIST_LECTURA.IDCOMPTADORHISTLECTURA%TYPE,
  g_idLineaHistLectura IN HIST_LECTURA.IDLINEAHISTLECTURA%TYPE,
  g_anyHistLectura  in   HIST_LECTURA.ANYOHISTLECTURA%TYPE,
  g_mesHistLectura  in   HIST_LECTURA.MESHISTLECTURA%TYPE,
  g_totalConsumHistLectura in  HIST_LECTURA.TOTALCONSUMOHISTLECTURA%TYPE,
 s_rsp out NOCOPY VARCHAR2)
 AS
 
BEGIN
    -- CREACIO DE VARIABLES ENTRADA I SORTIDA
    c_procesLog := 'GESTION_HIST_CONSUMS';
    c_dataHoraLog := SYSDATE;
    c_entradaLog :='GESTION_HIST_CONSUMS:
              Contador: '||g_idComptadorHist||
            ' Linea: '||g_idLineaHistLectura||
            ', any Hist Lectura: '||g_anyHistLectura ||
            ', mes Hist Lectura: '||g_mesHistLectura||
            ', total Consum Hist Lectura: '||g_totalConsumHistLectura;
     DBMS_OUTPUT.ENABLE;
     DBMS_OUTPUT.PUT_LINE(' ');
     DBMS_OUTPUT.PUT_LINE('      HISTORIC DE LECTURES        ');
     DBMS_OUTPUT.PUT_LINE('--------------------------------- ');
     DBMS_OUTPUT.PUT_LINE(' Contador: '||g_idComptadorHist||
            ' Linea: '||g_idLineaHistLectura||
            ', any Hist Lectura: '||g_anyHistLectura ||
            ', mes Hist Lectura: '||g_mesHistLectura||
            ', total Consum Hist Lectura: '||g_totalConsumHistLectura);
     c_sortidalog := 's_rsp';
     
     
     if (g_idComptadorHist IS NULL) then
            DBMS_OUTPUT.ENABLE;
            DBMS_OUTPUT.PUT_LINE('GESTIO_HIST_CONSUMS: ');
            s_rsp := 'Falta especificar Codi Comptador: ';
            DBMS_OUTPUT.PUT_LINE(s_rsp);           
          RAISE e_hist_consum;
     END IF;
/***********************************************************************
      SELECT DISTINCT LINEA_CONECTAR.CONNECTA1_CENTRALCONECTA into n_lineas
        FROM LINEA_CONECTAR
        WHERE LINEA_CONECTAR.CONNECTA2_COMPTADORCONECTA=g_idComptadorHist;
     g_idLineaHistLectura:=n_lineas;
****************************************************************************/
-- INSTRUCCIO INSERT PER INTRUDUIR VALORS ANY I MES DE CONSUMS
    INSERT INTO HIST_LECTURA(IDCOMPTADORHISTLECTURA,
                              IDLINEAHISTLECTURA,
                              ANYOHISTLECTURA,
                              MESHISTLECTURA,
                              TOTALCONSUMOHISTLECTURA) 
            VALUES(g_idComptadorHist,
                   g_idLineaHistLectura,
                  g_anyHistLectura,
                  g_mesHistLectura,
                  g_totalConsumHistLectura);
            
            
  --Gravem en la taula log-----------------------------------------------------
            DBMS_OUTPUT.ENABLE;
            DBMS_OUTPUT.put_line ('OK: Insertat Consum al Historic 
            del comptador: ' ||g_idComptadorHist||' del any '||g_anyHistLectura||
            ' del mes '||g_mesHistLectura||' amb un consum de '
            ||g_totalConsumHistLectura||' kw/h.');
            DBMS_OUTPUT.PUT_LINE('******** FI DE LES OPERACIONS ********');
            s_rsp :='Ok: Insertat Consum al Historic del comptador: '
            ||g_idComptadorHist||
            ', '||g_idLineaHistLectura||
            ' del any '||g_anyHistLectura ||
            ' del mes ' ||g_mesHistLectura||
            ' amb un consum de '||g_totalConsumHistLectura||' kw/h.';
            pkg_general.gravar_log_procedure(c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
            DBMS_OUTPUT.PUT_LINE(s_rsp);  
      -- END LOOP;
  
  COMMIT; 
EXCEPTION
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         s_rsp := 'Error: ' || SQLCODE || SUBSTR (SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' '); 
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  ROLLBACK; 
  --- FI DE PROCES

  END PRC_ACTUALIZAR_HIS_CONSUM; 
END "GESTION_HIST_CONSUMS";
