CREATE OR REPLACE
PACKAGE BODY          "GESTION_INPECCIONS" AS
 c_procesLog LOG_TFC.procesLog%TYPE;	
  c_dataHoraLog LOG_TFC.dataHoraLog%TYPE;
  c_entradaLog LOG_TFC.entradaLog%TYPE;	
  c_sortidaLog LOG_TFC.sortidaLog%TYPE;
  s_rsp LOG_TFC.rspLog%TYPE; 
  n_registres  NUMBER;
  s_sql VARCHAR2 (2000);
  
  n_descripcioResultatInspeccio TIPO_INSPECCIO.DESCRIPCIOTINSPECCIO%TYPE;
  n_codiInspector INSPECCIO.CODIINSPECTOR%TYPE;
  n_dataInspeccio INSPECCIO.DATAINSPECCIO%TYPE;
  n_idInspeccio  INSPECCIO.IDINSPECCIO%TYPE;
  n_observacions INSPECCIO.OBSERVACIONSINSPECCIO%TYPE;
  n_NUM_ERR NUMBER(10);
  sortida varchar2(500):=''; 
  e_inspeccio     EXCEPTION;
/***************************************************************************************
	NOM: 
		PROCEDIMENT PER DONAR ALTA_INSPECCIONS
	
	DESCRIPCIÓ:
		Segons el disseny expressat en el model realcional.

***************************************************************************************/  
PROCEDURE PRC_ALTA_INSPECCIONS(
    p_dataInspeccio in INSPECCIO.DATAINSPECCIO%Type,
    p_codiInspector in INSPECCIO.CODIINSPECTOR%Type,
     p_resultatInspeccio in INSPECCIO.IDSUPERAINSPECCIO%TYPE,
    p_observacionsInspeccio in INSPECCIO.OBSERVACIONSINSPECCIO%Type,
    s_rsp out NOCOPY VARCHAR)
 AS
 BEGIN
    c_procesLog := 'PRC_ALTA_INSPECCIONS';
    c_dataHoraLog := SYSDATE;
    c_entradaLog :=' Data Inspeccio: ' ||p_dataInspeccio||
    ', Codi Inspector: ' ||p_codiInspector||
    ', Id Resultat Inspeccio: '||p_resultatInspeccio||
    ', Observacions Inspeccio: ' ||p_observacionsInspeccio;
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE('         ALTA INSPECCIONS           ');
    DBMS_OUTPUT.PUT_LINE('----------------------------------- ');
    DBMS_OUTPUT.PUT_LINE(' Data Inspeccio: ' ||p_dataInspeccio||
    ' Id Resultat Inspeccio: '||p_resultatInspeccio||'  Codi Inspector: ' ||p_codiInspector||
    '  Observacions Inspeccio: ' ||p_observacionsInspeccio);
    c_sortidalog := 's_rsp'; 
    
    -- comprovacio de dades entrades per donar d'alta 
    if p_dataInspeccio IS NULL then
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' ');
      DBMS_OUTPUT.PUT_LINE('         ALTA INSPECCIONS           ');
      DBMS_OUTPUT.PUT_LINE('----------------------------------- ');
      s_rsp := 'Falta especificar Data Inspeccio feta ';
      DBMS_OUTPUT.PUT_LINE(s_rsp);           
      RAISE e_inspeccio;
    END IF;
    if p_codiInspector IS NULL then
        DBMS_OUTPUT.ENABLE;
        DBMS_OUTPUT.PUT_LINE(' ');
        DBMS_OUTPUT.PUT_LINE('         ALTA INSPECCIONS           ');
        DBMS_OUTPUT.PUT_LINE('----------------------------------- ');
        s_rsp := 'Falta especificar Codi de l´Inspector ';
        DBMS_OUTPUT.PUT_LINE(s_rsp);           
        RAISE e_inspeccio;
     END IF;
     
-- Comprovem si existeix el estat  donar d'alta
    SELECT COUNT (*)INTO n_registres 
    FROM INSPECCIO
    WHERE CODIINSPECTOR= p_codiInspector
    AND DATAINSPECCIO= p_dataInspeccio
    AND INSPECCIO.OBSERVACIONSINSPECCIO=p_observacionsInspeccio;
    
    
    If n_registres=0 then
-- El donem d'alta Tipus Linea          
   INSERT INTO INSPECCIO(DATAINSPECCIO,
                        CODIINSPECTOR,
                        IDSUPERAINSPECCIO,
                        OBSERVACIONSINSPECCIO) 
            VALUES(p_dataInspeccio,
                  p_codiInspector,
                  p_resultatInspeccio,
                  p_observacionsInspeccio);
                  
SELECT TIPO_INSPECCIO.DESCRIPCIOTINSPECCIO 
INTO n_descripcioResultatInspeccio
FROM TIPO_INSPECCIO
WHERE TIPO_INSPECCIO.IDTINSPCCIO=p_resultatInspeccio;
--Gravem en la taula log-----------------------------------------------------            
 
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE(' Inserida Inspeccio: ' ||p_dataInspeccio||
    ', Codi Inspector: ' ||p_codiInspector||
    ', Resultat Inspeccio: '||n_descripcioResultatInspeccio||
    ', Observacions Inspeccio: ' ||p_observacionsInspeccio);
    DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
--Gravem en la taula log-----------------------------------------------------
    s_rsp :='Ok Inserida Inspeccio: ' ||p_dataInspeccio||
    ', Codi Inspector: ' ||p_codiInspector||
    ', Resultat Inspeccio: '||n_descripcioResultatInspeccio||
    ', Observacions Inspeccio: ' ||p_observacionsInspeccio;
    pkg_general.gravar_log_procedure(c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
    DBMS_OUTPUT.PUT_LINE(s_rsp);
  ELSE
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('ALTA INSPECCIONS: ');
    s_rsp := 'Inspeccio duplicada';
    DBMS_OUTPUT.PUT_LINE(s_rsp);
    RAISE e_inspeccio;
  END IF;
COMMIT;     
EXCEPTION
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         s_rsp := 'Error: ' || SQLCODE || SUBSTR (SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' '); 
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  ROLLBACK;     
END PRC_ALTA_INSPECCIONS;

--- MODIFICAR INPECCIONS    
PROCEDURE PRC_MODIFICAR_INSPECCIONS(
    p_idInspeccio in INSPECCIO.IDINSPECCIO%Type,
    p_dataInspeccio in INSPECCIO.DATAINSPECCIO%Type,
    p_codiInspector in INSPECCIO.CODIINSPECTOR%Type,
    p_resultatInspeccio in INSPECCIO.IDSUPERAINSPECCIO%TYPE,
    p_observacionsInspeccio in INSPECCIO.OBSERVACIONSINSPECCIO%Type,
    s_rsp out NOCOPY VARCHAR2)
 AS
 BEGIN
    c_procesLog := 'PRC_MODIFICAR_INSPECCIONS';
    c_dataHoraLog := SYSDATE;
    c_entradaLog :=' Id Inspeccio: '||p_idInspeccio||
    ', Data Inspeccio: '||p_dataInspeccio||
    ', Codi Inspector: ' ||p_codiInspector||
    ', Codi resultat Inspeccio: '||p_resultatInspeccio||
    ', Observacions Inspeccio: ' ||p_observacionsInspeccio;
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE('         MODIFICAR INSPECCIONS           ');
    DBMS_OUTPUT.PUT_LINE('---------------------------------------- ');    
    DBMS_OUTPUT.PUT_LINE(' Id Inspeccio: '||p_idInspeccio||
    ', Data Inspeccio: '||p_dataInspeccio||
    ', Codi Inspector: ' ||p_codiInspector||
    ', Codi Resultat Inspeccio: '||p_resultatInspeccio||
    ', Observacions Inspeccio: ' ||p_observacionsInspeccio); 
    c_sortidalog := 's_rsp';      
-- comprovacio de dades    
    IF (p_idInspeccio IS NULL) OR (p_idInspeccio=0) THEN
        DBMS_OUTPUT.ENABLE;
        DBMS_OUTPUT.PUT_LINE('MODIFICAR INSPECCIONS: ');     
       s_rsp := 'Falta especificar el codi Inspeccio ';
       DBMS_OUTPUT.PUT_LINE(s_rsp);        
        RAISE e_inspeccio;
    END IF; 
    IF p_dataInspeccio IS NULL THEN
        DBMS_OUTPUT.ENABLE;
        DBMS_OUTPUT.PUT_LINE('MODIFICAR INSPECCIONS: ');     
       s_rsp := 'Falta especificar la data Inspeccio ';
       DBMS_OUTPUT.PUT_LINE(s_rsp);        
       RAISE e_inspeccio;
    END IF;
    IF p_codiInspector IS NULL THEN
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('MODIFICAR INSPECCIONS: ');     
      s_rsp := 'Falta especificar el codi Inspector Inspeccio ';
      DBMS_OUTPUT.PUT_LINE(s_rsp);        
      RAISE e_inspeccio;
    END IF;
        --1er. Comprovem que Inspeccio -------------------------------
SELECT IDINSPECCIO INTO n_idInspeccio
FROM INSPECCIO
WHERE IDINSPECCIO=p_idInspeccio;

SELECT TIPO_INSPECCIO.DESCRIPCIOTINSPECCIO 
INTO n_descripcioResultatInspeccio
FROM TIPO_INSPECCIO
WHERE TIPO_INSPECCIO.IDTINSPCCIO=p_resultatInspeccio;
                   
 If n_idInspeccio=0 then
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('MODIFICAR INSPECCIONS: ');                 
      s_rsp := 'INSPECCIO no existent a la BBDD';
      DBMS_OUTPUT.PUT_LINE(s_rsp);
      RAISE e_inspeccio;
   END IF;
  s_sql := 'UPDATE INSPECCIO SET ';
 -- Construirem la sentencia UPDATE segons si hi ha valor en els paràmetres-
  IF p_dataInspeccio IS NOT NULL THEN
-- Modifiquem data Inspeccio
  s_sql := s_sql || 'DATAINSPECCIO=''' ||p_dataInspeccio|| ''',';
  END IF;
  IF p_codiInspector IS NOT NULL THEN
  -- Modifiquem codi inspector
  s_sql := s_sql || 'CODIINSPECTOR=''' ||p_codiInspector|| ''',';
  END IF;
  IF p_resultatInspeccio IS NOT NULL THEN
-- Modifiquem resultat Inspeccio
  s_sql := s_sql || 'IDSUPERAINSPECCIO=''' ||p_resultatInspeccio|| ''',';
  END IF; 
  IF p_observacionsInspeccio IS NOT NULL THEN
  -- Modifiquem Observacions Inspeccio
  s_sql := s_sql || 'OBSERVACIONSINSPECCIO=''' ||p_observacionsInspeccio|| ''',';
  END IF; 
-- Eliminem la coma final de la sentencia SQL--------------------------
  s_sql := SUBSTR (s_sql, 1, LENGTH (s_sql) - 1); 
-- Afegim a la sentencia la condiciÃ³ del WHERE------------------------
  s_sql := s_sql || ' WHERE IDINSPECCIO=''' ||n_idInspeccio|| '''';
                  
  EXECUTE IMMEDIATE s_sql;
  
  IF SQL%ROWCOUNT = 0 THEN
--L'error serà que Tipo Linea ja el tenim en la taula i no admet duplicats--
    --L'error serÃ  que el DNI ja el tenim en la taula i no admet duplicats--
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('MODIFICAR_FABRICANT: ');                     
      s_rsp := 'Actualitzacio no realitzada  ';
    RAISE e_inspeccio;
  ELSE
    DBMS_OUTPUT.ENABLE;
       DBMS_OUTPUT.PUT_LINE('Modificacio feta: Id Inspeccio: '||n_idInspeccio||
    ', Data Inspeccio: '||p_dataInspeccio||
    ', Codi Inspector: ' ||p_codiInspector||
    ', Codi Resultat Inspeccio: '||n_descripcioResultatInspeccio||
    ', Observacions Inspeccio: ' ||p_observacionsInspeccio);
    DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
    s_rsp := 'OK Modificat satisfactoriament Id Inspeccio: '||n_idInspeccio||
    ', Data Inspeccio: '||p_dataInspeccio||
    ', Codi Inspector: ' ||p_codiInspector||
    ', Codi Resultat Inspeccio: '||n_descripcioResultatInspeccio||
    ', Observacions Inspeccio: ' ||p_observacionsInspeccio;
    pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
END IF;
COMMIT;
  EXCEPTION
   WHEN OTHERS THEN
    IF s_rsp IS NULL THEN
-- L'error no ha estat controlat per codi
      s_rsp := 'Error: ' || SQLCODE || SUBSTR (SQLERRM, 1, 100);
    ELSE
-- L'error si ha estat controlat per codi
     s_rsp := 'Error: ' || s_rsp;
    END IF;
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('  ');    
    DBMS_OUTPUT.put_line(s_rsp);
    pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  ROLLBACK;  
END PRC_MODIFICAR_INSPECCIONS;

-- CONSULTA INPECCIONS
PROCEDURE PRC_CONSULTAR_INSPECCIONS(
          s_rsp out NOCOPY VARCHAR2)
AS
CURSOR C_INSPECCIONS IS
  SELECT INSPECCIO.IDINSPECCIO AS CODI,
          INSPECCIO.DATAINSPECCIO AS FECHA,
          INSPECCIO.CODIINSPECTOR AS CODI_INSPECTOR,
          TIPO_INSPECCIO.DESCRIPCIOTINSPECCIO AS RESULTAT,
          INSPECCIO.OBSERVACIONSINSPECCIO AS OBSERVACIONS
    FROM INSPECCIO,TIPO_INSPECCIO
    WHERE INSPECCIO.IDINSPECCIO=INSPECCIO.IDINSPECCIO
    AND INSPECCIO.IDSUPERAINSPECCIO=TIPO_INSPECCIO.IDTINSPCCIO;
BEGIN
 c_procesLog := 'PRC_CONSULTAR_INSPECCIONS';
  c_dataHoraLog := SYSDATE;
  c_entradaLog := 'CONSULTA INSPECCIONS';
  c_sortidalog := 's_rsp';
 SELECT COUNT (*)  INTO n_registres
  FROM INSPECCIO
  WHERE INSPECCIO.IDINSPECCIO=INSPECCIO.IDINSPECCIO;
  
 IF n_registres=0 THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('CONSULTA INSPECCIONS: ');
    s_rsp := 'No hi han inspeccions donades dalta ';
    DBMS_OUTPUT.PUT_LINE(s_rsp);
    RAISE e_inspeccio;
 END IF;
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('           CONSULTA INSPECCIONS               ');
    DBMS_OUTPUT.PUT_LINE('-----------------------------------------------------');
  OPEN C_INSPECCIONS;
   FETCH C_INSPECCIONS INTO n_idInspeccio,n_dataInspeccio,
   n_codiInspector,n_descripcioResultatInspeccio,n_observacions;
  WHILE C_INSPECCIONS%FOUND LOOP
   DBMS_OUTPUT.ENABLE;
   DBMS_OUTPUT.PUT_LINE(
 '   Codi Inspeccio: '
 ||n_idInspeccio||
 ' Data Inspeccio: '
 ||n_dataInspeccio||
 ' Coodi Inspeccio: '||n_codiInspector||
 ' Resultat: '||n_descripcioResultatInspeccio||
 ' Observacions: '||n_observacions);
  s_rsp := 'OK  CONSULTA INSPECCIONS 
    Codi Inspeccio: '
 ||n_idInspeccio||
 ' Data Inspeccio: '
 ||n_dataInspeccio||
 ' Coodi Inspeccio: '||n_codiInspector||
 ' Resultat: '||n_descripcioResultatInspeccio||
 ' Observacions: '||n_observacions;
 
   FETCH C_INSPECCIONS INTO n_idInspeccio,n_dataInspeccio,
   n_dataInspeccio,n_descripcioResultatInspeccio,n_observacions;

  pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  
  END LOOP;
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('Total Inspeccions: '||n_registres);
  DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
CLOSE C_INSPECCIONS;
COMMIT;

EXCEPTION
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         s_rsp := 'Error: ' || SQLCODE || SUBSTR (SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' ');
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;    
END PRC_CONSULTAR_INSPECCIONS;
END  "GESTION_INPECCIONS";
