CREATE OR REPLACE PACKAGE BODY          "GESTION_LECTURA" AS
  n_idComptadorLectura  number;
  n_lecturaAnterior 	number;
  n_idTipoLectura	number;
  n_idLectura		number;
  n_dataLectura         char(10);
  n_confirmaLectura     number;
  n_valorLecturaAnterior 	NUMBER;
  n_consumLectura	number;
  n_idContracte		CONTRACTE.IDCONTRACTE%TYPE;
  n_idLinea LINEA_CONECTAR_COMPTADOR.IDLINEACONECTA%TYPE;
  n_descTipusLectura TIPO_LECTURA.DESCRIPCIOLECTURA%TYPE;
  n_idLineaHistLectura LINEA_CONECTAR_COMPTADOR.IDLINEACONECTA%TYPE;
  n_lecturaActual NUMBER;
   
  g_idComptadorHist    NUMBER;
  g_idLineaHistLectura NUMBER;
  g_anyHistLectura     VARCHAR2(4);
  g_mesHistLectura     VARCHAR2(2);
  g_totalConsumHistLectura  NUMBER;

CURSOR C_LLEGIR_LINEA IS
SELECT LINEA_CONECTA_CENTRAL.CONNECTACDISTRI,
LINEA_CONECTAR_COMPTADOR.IDLINEACONECTA,
CENTRAL.ENERGIAMAXIMA,
LINEA_TIPUS.CONSUMMAXIMTLINEA
FROM LINEA_CONECTA_CENTRAL,LINEA_CONECTAR_COMPTADOR,LINEA_TIPUS,CENTRAL
WHERE CENTRAL.IDCENTRAL=LINEA_CONECTA_CENTRAL.CONNECTACDISTRI
AND LINEA_CONECTAR_COMPTADOR.IDLINEATIPOLINEACONECTA=LINEA_TIPUS.IDTLINEA;

n_centralDistribucio LINEA_CONECTA_CENTRAL.CONNECTACDISTRI%TYPE;
n_lineaConectada LINEA_CONECTAR_COMPTADOR.IDLINEACONECTA%TYPE;
n_energiaMaximaCentral CENTRAL.ENERGIAMAXIMA%TYPE;
n_energiaMaximaLinea LINEA_TIPUS.CONSUMMAXIMTLINEA%TYPE;
 
  
  c_procesLog	  	LOG_TFC.procesLog%TYPE;	
  c_dataHoraLog   	LOG_TFC.dataHoraLog%TYPE;
  c_entradaLog     	LOG_TFC.entradaLog%TYPE;	
  c_sortidaLog     	LOG_TFC.sortidaLog%TYPE;
  
  s_rsp	 		LOG_TFC.RSPLOG%TYPE;
  n_registres      NUMBER; 
  s_sql           VARCHAR2 (2000);
  n_NUM_ERR 	  NUMBER(10);
  sortida VARCHAR2(2000):='';
  e_lectura   EXCEPTION;
/*****************************************************************************
Autor: Eduard Monzonis Hierro                                   UOC
18/05/2012                                             TFC: CONTROL ENERGIA.
                  PROCEDIMENT LECTURA DE COMPTADORS.
DESCRIPCIO:
Les dades es generen cridant el procediment 
GESTION_LECTURA.PRC_LEER_LECTURA(<id comptador>,<confirmacio de lectura>,
<data de la letura>,<id tipus de lectura>,
<valor de la lectura feta en el comptador>,sortida);
 On l el tipus de lectura 1=Presencial 2=Telematica.
 El procediment esta automatizat i carega dades calculades dels consums
 del mes i any i la linea per la que esta conectat el comptador.
 ****************************************************************************/
PROCEDURE PRC_LEER_LECTURA(
        p_idComptadorLectura IN LECTURA.IDCOMPTADORLECTURA%TYPE,
        p_confirmaLectura IN LECTURA.CONFIRMALECTURA%TYPE,
        p_dataLectura IN LECTURA.DATALECTURA%TYPE,
        p_idTipoLectura IN LECTURA.IDTIPOLECTURA%TYPE,
        p_lecturaActual IN LECTURA.LECTURAACTUAL%TYPE,
        s_rsp out NOCOPY VARCHAR)
AS
  
BEGIN
   
    c_procesLog := 'PRC_LEER_LECTURAS';
    c_dataHoraLog := SYSDATE;
    c_entradaLog :=' Id Comptador: ' ||p_idComptadorLectura||
    	', Confirma: ' ||p_confirmaLectura ||
    	', Data lectura: ' ||p_dataLectura||
    	', Tipus de Lectura: ' ||p_idTipoLectura||
    	', Lectura Comptador: ' ||p_lecturaActual;
        
        g_idComptadorHist:=p_idComptadorLectura;
        --g_idLineaHistLectura:=n_idLineaHistLectura;
        g_anyHistLectura:= SUBSTR (p_dataLectura, 7, 4);
        g_mesHistLectura:= SUBSTR (p_dataLectura, 4, 2);
        g_totalConsumHistLectura:=n_consumLectura;
          --g_totalConsumHistLectura:=n_consumLectura;
     DBMS_OUTPUT.ENABLE;
     DBMS_OUTPUT.PUT_LINE(' ');
     DBMS_OUTPUT.PUT_LINE('      LLEGIR LECTURA COMPTADOR       ');
     DBMS_OUTPUT.PUT_LINE('-------------------------------------');
     DBMS_OUTPUT.PUT_LINE(': Id Comptador: ' 
	||p_idComptadorLectura||
    	', Confirma: ' ||p_confirmaLectura ||
    	', Data Lectura: ' ||p_dataLectura||
    	', Tipus de Lectura: ' ||p_idTipoLectura||
    	', Lectura Comptador: ' ||p_lecturaActual);
     c_sortidalog := 's_rsp';

     
      -- cerco la linea que conecta
      SELECT LINEA_CONECTAR_COMPTADOR.CONNECTA1_CENTRALCONECTA into n_idLineaHistLectura
      FROM LINEA_CONECTAR_COMPTADOR
      WHERE LINEA_CONECTAR_COMPTADOR.CONNECTA2_COMPTADORCONECTA=p_idComptadorLectura;
      
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('LLEGIR LECTURA COMPTADOR: Linea conectada: '
      ||n_idLineaHistLectura);
      g_idLineaHistLectura:=n_idLineaHistLectura;
      
      IF n_idLineaHistLectura<>n_idLineaHistLectura THEN
        DBMS_OUTPUT.ENABLE;
        DBMS_OUTPUT.PUT_LINE('LLEGIR LECTURA COMPTADOR: Linea conectada 
        no existeix : '
        ||n_idContracte);
        s_rsp := 'Comptador no te Linea '||p_idComptadorLectura;
        DBMS_OUTPUT.PUT_LINE(s_rsp);
        RAISE e_lectura;
        ELSE 
       
      g_idLineaHistLectura:=n_idLineaHistLectura;
         
      END IF;
        
     --COMPROVACIO DEL COMPTADOR SI EXISTEIX EN CONTRACTE I ESTA ALTA
OPEN C_LLEGIR_LINEA;
FETCH C_LLEGIR_LINEA
INTO
n_centralDistribucio,
n_lineaConectada,
n_energiaMaximaCentral,
n_energiaMaximaLinea;

g_idLineaHistLectura:=n_lineaConectada;

        SELECT COUNT(*) INTO n_idContracte
	FROM CONTRACTE
	WHERE CONTRACTE.IDCONTADORCONTRACTE=p_idComptadorLectura
	AND CONTRACTE.IDESTATCONTRACTE=1;
        DBMS_OUTPUT.ENABLE;
        DBMS_OUTPUT.PUT_LINE('LLEGIR LECTURA COMPTADOR: Contracte: '
        ||n_idContracte);
        
      IF n_idContracte=0 THEN
        DBMS_OUTPUT.ENABLE;
        DBMS_OUTPUT.PUT_LINE('Comptador no te contracte: '||p_idComptadorLectura);
        s_rsp := 'Comptador no te contracte '||p_idComptadorLectura;
        DBMS_OUTPUT.PUT_LINE(s_rsp);
        RAISE e_lectura;
      ELSE
                g_idComptadorHist:=p_idComptadorLectura;
      END IF;
          
        -- COMPROVACIO DEL TIPO DE LECTURA
        SELECT TIPO_LECTURA.IDTIPOLECTURA INTO n_idTipoLectura
        FROM TIPO_LECTURA
        WHERE TIPO_LECTURA.IDTIPOLECTURA=p_idTipoLectura;
        
        IF n_idTipoLectura IS NOT NULL  THEN
        DBMS_OUTPUT.ENABLE;
        DBMS_OUTPUT.PUT_LINE('Comptador te el tipus de lectura: '||n_idTipoLectura);
        --- EL VALOR DEL TIPUS DE LINEA LECTURA ESTA A t_lectura
        
        ELSE
        
        DBMS_OUTPUT.ENABLE;
        DBMS_OUTPUT.PUT_LINE('Comptador no te tipus de lectura: '||p_idComptadorLectura);
        s_rsp := 'Comptador no te tipus de lectura: '||p_idComptadorLectura;
        DBMS_OUTPUT.PUT_LINE(s_rsp);
        RAISE e_lectura;
        END IF;
      
             -- CERQUEM LA LECTURA ANTERIOR FETA
        
        SELECT COUNT (DISTINCT LECTURA.LECTURAACTUAL)INTO n_lecturaAnterior 
        FROM LECTURA
        WHERE LECTURA.IDCOMPTADORLECTURA=p_idComptadorLectura
        AND LECTURA.DATALECTURA<p_dataLectura;
        --AND  ROWNUM=1;
        --n_LecturaAnterior te la lectura anterior 
        n_valorLecturaAnterior:=n_lecturaAnterior;
                
    IF n_lecturaAnterior=0 THEN
        DBMS_OUTPUT.ENABLE;
        DBMS_OUTPUT.PUT_LINE('Ultima lectura feta  del comptador: '||p_idComptadorLectura||
        '  no existeix es nul');
        s_rsp := 'Ultima lectura feta  del comptador: '||p_idComptadorLectura||
        '  no existeix es nul';
        DBMS_OUTPUT.PUT_LINE(s_rsp);
        RAISE e_lectura;
    END IF;
        
    -- CALCULEM EL CONSUM
    IF   (p_lecturaActual-n_valorLecturaAnterior)<0 THEN
      n_consumLectura:=n_valorLecturaAnterior-p_lecturaActual;
      g_totalConsumHistLectura:=n_consumLectura;
      ELSE
      n_consumLectura:=p_lecturaActual-n_valorLecturaAnterior;
      g_totalConsumHistLectura:=n_consumLectura;
    END IF;
    DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('El consum de comptador: '||p_idComptadorLectura||
        ' en la data: '||p_dataLectura||' es de: '||n_consumLectura||' kw/h.');
        
      -- COMPROVEM DE QUE SI ES UNA LECTURA ADONAR D'ALTA 
 /*********************************************************    
     SELECT COUNT(*)INTO n_registres
       FROM LECTURA
       WHERE LECTURA.IDCOMPTADORLECTURA=p_idComptadorLectura
       AND LECTURA.DATALECTURA<p_dataLectura
       AND LECTURA.IDTIPOLECTURA=p_idTipoLectura
       AND LECTURA.LECTURAANTERIOR>n_lecturaAnterior; 
    ******************************************************/   
       
      SELECT DISTINCT COUNT(*) INTO n_registres
       FROM LECTURA
       WHERE LECTURA.IDCOMPTADORLECTURA=p_idComptadorLectura
       AND LECTURA.DATALECTURA=p_dataLectura
       AND LECTURA.IDTIPOLECTURA=p_idTipoLectura
       AND LECTURA.LECTURAACTUAL<>n_lecturaAnterior;
       
       IF n_registres=0 THEN
     
  /********************** 
   -- WHILE n_registres=0 LOOP
    IF n_registres=0 THEN
    GESTION_HIST_CONSUMS.PRC_ACTUALIZAR_HIS_CONSUM(g_idComptadorHist,
 g_idLineaHistLectura,g_anyHistLectura,g_mesHistLectura,
 g_totalConsumHistLectura,s_rsp);
 **********************************/
   -- isertem dades de la lectura
      INSERT INTO LECTURA(IDCOMPTADORLECTURA,
                              CONFIRMALECTURA,
                              DATALECTURA,
                              IDTIPOLECTURA,
                              CONSUMLECTURA,
                              LECTURAACTUAL,
                              LECTURAANTERIOR) 
            VALUES(p_idComptadorLectura,
                  p_confirmaLectura,
                  p_dataLectura,
                  p_idTipoLectura,
                  n_consumLectura,
                  p_lecturaActual,
                  n_valorLecturaAnterior);

--  ACTUALITZA LA TAULA DE HISTORICS HIST_LECTURA
                  
  GESTION_HIST_CONSUMS.PRC_ACTUALIZAR_HIS_CONSUM(
  g_idComptadorHist,
  g_idLineaHistLectura,
  g_anyHistLectura,
  g_mesHistLectura,
  g_totalConsumHistLectura,s_rsp);

--Gravem en la taula log-----------------------------------------------------
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('El consum de comptador: '
  ||p_idComptadorLectura||
  ' en la data: '
  ||p_dataLectura||
  ' es de: '||n_consumLectura||' kw/h.');
  DBMS_OUTPUT.PUT_LINE('********** FI DE LES OPERACIONS ********** ');
  s_rsp :='Ok: insertada El consum de comptador: '
  ||p_idComptadorLectura||
  ' en la data: '
  ||p_dataLectura||
  ' es de: '||n_consumLectura||' kw/h.';
  pkg_general.gravar_log_procedure(c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
 ELSE
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('LLEGIR LECTURA: duplicat ');
  s_rsp := 'Lectura ja feta pel comptador '||p_idComptadorLectura;
  DBMS_OUTPUT.PUT_LINE(s_rsp);
  RAISE e_lectura; 
 END IF;
CLOSE C_LLEGIR_LINEA;
COMMIT; 
EXCEPTION
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         s_rsp := 'Error: ' || SQLCODE || SUBSTR (SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' '); 
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
 
  ROLLBACK;     

END PRC_LEER_LECTURA;
/******************************************************************************
Autor: Eduard Monzonis Hierro                                   UOC
18/05/2012                                             TFC: CONTROL ENERGIA.
          PROCEDIMENT INICIA LECTURES PER CONTRACTE D'ALTA FET.
DESCRIPCIO:
Aques procediment inicialitza els valor de lectura actual, lectura anterior
i consum.
Es un procediment automatizat que es cridat pel procediment de altes de
CONTRACTE de CLIENT.
******************************************************************************/
PROCEDURE PRC_INICIA_LECTURA(
        lec_idComptadorLectura IN LECTURA.IDCOMPTADORLECTURA%TYPE,
        lec_dataLectura IN LECTURA.DATALECTURA%TYPE,
        s_rsp out NOCOPY VARCHAR)
AS
  
BEGIN
c_procesLog := 'PRC_INICIA_LECTURA';
    c_dataHoraLog := SYSDATE;
    c_entradaLog :=' Id Comptador Alta en CONTRACTE: ' ||lec_idComptadorLectura||
      ', Data  Alta Lectura Inicial: '||lec_dataLectura;
        -- passo valors a les variables
         --lec_confirmaLectura:=p_confirmaLectura;
        -- n_idComptadorLectura:=lec_idComptadorLectura;
         --n_confirmaLectura :=1;
         --n_dataLectura:=lec_dataLectura;
         --n_idTipoLectura:=lec_confirmaLectura;
         --n_consumLectura:=0;
         --n_lecturaActual:=0;
         --n_lecturaAnterior:=0;
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE(' ');
  DBMS_OUTPUT.PUT_LINE('INICIAlITZATS LECTURAS COMPTADOR ALTA EN CONTRACTE FETA: 
     Codi Comptador Alta en CONTRACTE: '||lec_idComptadorLectura||
      ', Data  Alta en CONTRACTE: '||lec_dataLectura);
     c_sortidalog := 's_rsp';
     
  IF  lec_idComptadorLectura<>0 THEN
-- POSA ELS CONSUMS DELS COMPTADORS A ZERO QUAN ES DONA ALTA D'UN CONTRACTE
                  n_confirmaLectura:=1;
                  n_idTipoLectura:=1;
                  n_consumLectura:=0;
                  n_lecturaActual:=0;
                  n_lecturaAnterior:=0;           
    --INSERT INICIALITZA VALORS DEL COMPTADOR DONAT ALTA A CONTRACTE
         INSERT INTO LECTURA(IDCOMPTADORLECTURA,
                              CONFIRMALECTURA,
                              DATALECTURA,
                              IDTIPOLECTURA,
                              CONSUMLECTURA,
                              LECTURAACTUAL,
                              LECTURAANTERIOR) 
            VALUES(lec_idComptadorLectura,
                  n_confirmaLectura,
                  lec_dataLectura,
                  n_idTipoLectura,
                  n_consumLectura,
                  n_lecturaActual,
                  n_lecturaAnterior);
            --Gravem en la taula log-----------------------------------------------------
  DBMS_OUTPUT.ENABLE;        
  DBMS_OUTPUT.put_line ('OK: INICIAlITZATS LECTURAS COMPTADOR ALTA EN CONTRACTE FETA: 
            Id Comptador Alta en CONTRACTE: ' ||lec_idComptadorLectura||
    	', Confirma Alta en CONTRACTE: ' ||n_confirmaLectura||
    	', Data  Alta en CONTRACTE: ' ||n_dataLectura||
    	', Tipus de Lectura: ' ||n_idTipoLectura||
    	', Lectura inicialitzada: ' ||n_consumLectura||
        ', Consums inicialitzat:'||n_consumLectura||
        ', Lectura Anteior inicialitzada: '||n_LecturaAnterior);
        
  s_rsp :='OK: INICIAlITZATS LECTURAS COMPTADOR ALTA EN CONTRACTE FETA: 
            Id Comptador Alta en CONTRACTE: ' ||lec_idComptadorLectura;
pkg_general.gravar_log_procedure(c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
 ELSE
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('COMPTADOR ALTA EN CONTRACTE FETA  duplicat ');
  s_rsp := 'COMPTADOR ALTA EN CONTRACTE FETA  duplicat'||lec_idComptadorLectura;
  DBMS_OUTPUT.PUT_LINE(s_rsp);
  RAISE e_lectura; 
END IF;
COMMIT; 
EXCEPTION
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         s_rsp := 'Error: ' || SQLCODE || SUBSTR (SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('______________'); 
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
 
  ROLLBACK;     
END PRC_INICIA_LECTURA;
/******************************************************************************
CONSULTA DE LECTURES 
ORDENADES PER DATA ALTA
******************************************************************************/
PROCEDURE PRC_CONSULTAR_LECTURES(
        s_rsp out NOCOPY VARCHAR)
 AS
 
CURSOR C_LECTURES IS
SELECT LECTURA.IDLECTURA,
LINEA_CONECTAR_COMPTADOR.IDLINEACONECTA,
LECTURA.IDCOMPTADORLECTURA,
LECTURA.CONFIRMALECTURA,
LECTURA.DATALECTURA,
TIPO_LECTURA.DESCRIPCIOLECTURA,
LECTURA.CONSUMLECTURA
FROM LECTURA,LINEA_CONECTAR_COMPTADOR,TIPO_LECTURA
WHERE LECTURA.IDLECTURA=LECTURA.IDLECTURA
AND LINEA_CONECTAR_COMPTADOR.CONNECTA2_COMPTADORCONECTA=LECTURA.IDCOMPTADORLECTURA
AND LECTURA.IDTIPOLECTURA=TIPO_LECTURA.IDTIPOLECTURA
ORDER BY LECTURA.DATALECTURA,LECTURA.IDLECTURA;

BEGIN
 c_procesLog := 'PRC_CONSULTAR_LECTURES';
  c_dataHoraLog := SYSDATE;
  c_entradaLog := 'PRC_CONSULTAR_LECTURES';
  c_sortidalog := 's_rsp';
 SELECT COUNT (*)  INTO n_registres
  FROM LECTURA
  WHERE LECTURA.IDLECTURA=LECTURA.IDLECTURA;
  
 IF n_registres=0 THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('CONSULTA LECTURES: ');
    s_rsp := 'No hi han lectures donades dalta ';
    DBMS_OUTPUT.PUT_LINE(s_rsp);
    RAISE e_lectura; 
 END IF;
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE('           CONSULTA LECTURES               ');
    DBMS_OUTPUT.PUT_LINE('-----------------------------------------------------');
  OPEN C_LECTURES;
  FETCH C_LECTURES 
  INTO n_idLectura,
  n_idLinea,
  n_idComptadorLectura,
  n_confirmaLectura,
  n_dataLectura,
  n_descTipusLectura,
  n_consumLectura;
  WHILE C_LECTURES%FOUND LOOP
   DBMS_OUTPUT.ENABLE;
   DBMS_OUTPUT.PUT_LINE(
 '   Numero de Lectura: '
 ||n_idLectura||
 ' Linea de lectura: '
 ||n_idLinea||
 ' Codi Comptador: '
 ||n_idComptadorLectura||
 ' Lectura validada: '
 ||n_confirmaLectura||
  ' Data Lectura: '
 ||n_dataLectura||
  ' Tipus de lectura: '
 ||n_descTipusLectura|| 
 ' Consum Lectura: '||n_consumLectura||
  ' Kw/h del mes. ');
  DBMS_OUTPUT.PUT_LINE(' ');
  s_rsp := 'OK  Numero de Lectura: '
 ||n_idLectura||
 ' Linea de lectura: '
 ||n_idLinea||
 ' Codi Comptador: '
 ||n_idComptadorLectura||
 ' Lectura validada: '
 ||n_confirmaLectura||
  ' Data Lectura: '
 ||n_dataLectura||
  ' Tipus de lectura: '
 ||n_descTipusLectura|| 
 ' Consum Lectura: '||n_consumLectura||
 ' Kw/h del mes. ';
 
  FETCH C_LECTURES 
  INTO n_idLectura,
  n_idLinea,
  n_idComptadorLectura,
  n_confirmaLectura,
  n_dataLectura,
  n_descTipusLectura,
  n_consumLectura;

  pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  
  END LOOP;
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('Total Lectures: '||n_registres);
  DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
CLOSE C_LECTURES ;
COMMIT;

EXCEPTION
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         s_rsp := 'Error: ' || SQLCODE || SUBSTR (SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' ');
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;           
        
        
        
END PRC_CONSULTAR_LECTURES;
END "GESTION_LECTURA";
