CREATE OR REPLACE
PACKAGE BODY          "GESTION_MODELO" AS
c_procesLog	   LOG_TFC.procesLog%TYPE;	
  c_dataHoraLog    LOG_TFC.dataHoraLog%TYPE;
  c_entradaLog     LOG_TFC.entradaLog%TYPE;	
  c_sortidaLog     LOG_TFC.sortidaLog%TYPE;
  s_rsp	           LOG_TFC.rspLog%TYPE; 
  n_registres  NUMBER;
  s_sql VARCHAR2 (2000);
  
  n_idModelo  MODELO.IDMODELO%Type;
  n_descripcioModelo MODELO.DESCRIPCIOMODELO%Type;
  n_estatModelo  MODELO.ESTATMODELO%Type;
  n_anyModelo  MODELO.ANYOFABRICAMODELO%Type;
  n_idFabricantModelo  MODELO.IDFABRICANTMODELO%Type;
  n_observacionsModelo  MODELO.OBSERVACIONSMODELO%Type;
  n_dataModificacioModel MODELO.DATAMODIFICACIOMODELO%TYPE;
  n_dataAltaModel MODELO.DATAALTAMODELO%TYPE;
  
  n_fabricant FABRICANT.NOMCOMERCIALFABRICANT%TYPE;
  n_idEstatModelo MODELO.ESTATMODELO%TYPE;
  n_controlEstat NUMBER;
  n_descModel ESTAT.DESCRIPCIOESTAT%TYPE;
  
  n_NUM_ERR NUMBER(10);
  sortida varchar2(500):=''; 
  e_model     EXCEPTION;
--------------------------------------------------------------
/******************************************************************************
Autor: Eduard Monzonis Hierro                                   UOC
18/05/2012                                             TFC: CONTROL ENERGIA.
              PROCEDIMENT ALTA DE MODEL DE COMPTADOR
DESCRIPCIO.
Gestiona els models de COMPTADORS i depen de FABRICANTS. Els comptadors
tene definides les propietats físiques que aquest procediment insereix.
******************************************************************************/
PROCEDURE PRC_ALTA_MODELO(
    p_descripcioModelo in MODELO.DESCRIPCIOMODELO%Type,
    p_anyModelo in MODELO.ANYOFABRICAMODELO%Type,
    p_idFabricantModelo in MODELO.IDFABRICANTMODELO%Type,
    p_dataAltaModelo in MODELO.DATAALTAMODELO%Type,
    p_estatModelo in MODELO.ESTATMODELO%Type,
    p_observacionsModelo in MODELO.OBSERVACIONSMODELO%Type,
    s_rsp out NOCOPY VARCHAR2)
AS
 
BEGIN
    c_procesLog := 'PRC_ALTA_MODELO';
    c_dataHoraLog := SYSDATE;
    c_entradaLog :='Decripcio Model: ' ||p_descripcioModelo ||
    ' , Any Model: ' ||p_anyModelo||
    ' , id Fabricant Model: ' || p_idFabricantModelo ||
    ' , Data Alta Model: ' || p_dataAltaModelo||
    ' , Observacions Modelo : ' ||p_observacionsModelo;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' ');
      DBMS_OUTPUT.PUT_LINE('     ALTA MODELS              ');
      DBMS_OUTPUT.PUT_LINE('______________________________');
      DBMS_OUTPUT.PUT_LINE(' Decripcio Model: ' ||p_descripcioModelo ||
    ' , Any Model: ' ||  p_anyModelo||
    ' , id Fabricant Model: ' || p_idFabricantModelo ||
    ' , Data Alta Model: ' || p_dataAltaModelo||
    ' , Observacions Modelo : ' ||p_observacionsModelo); 
    c_sortidalog := 's_rsp';
    n_estatModelo:=1;
 If p_descripcioModelo IS NULL then
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('ALTA MODELS: ');      
      s_rsp := 'Falta especificar Decripcio Model ';
      DBMS_OUTPUT.PUT_LINE(s_rsp);
      RAISE e_model;
  END IF;
  If p_anyModelo IS NULL then
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('ALTA MODELS: ');      
      s_rsp := 'Falta especificar Any Model ';
      DBMS_OUTPUT.PUT_LINE(s_rsp);           
      RAISE e_model;      
  END IF;
-- Comprovem si existeix el estat  donar d'alta
  SELECT COUNT (*)INTO n_registres 
  FROM MODELO 
  WHERE MODELO.DESCRIPCIOMODELO = p_descripcioModelo
  AND MODELO.ANYOFABRICAMODELO= p_anyModelo
  AND MODELO.DATAALTAMODELO=p_dataAltaModelo
  AND MODELO.IDFABRICANTMODELO=p_idFabricantModelo;
        
  If n_registres=0 then
-- El donem d'alta a la estat 
--POSEM L'ESTAT A 1=ALTA
  
  INSERT INTO MODELO (DESCRIPCIOMODELO,
            ANYOFABRICAMODELO,
            IDFABRICANTMODELO,
            DATAALTAMODELO,
            ESTATMODELO,
            OBSERVACIONSMODELO) 
            VALUES(p_descripcioModelo,
            p_anyModelo,
            p_idFabricantModelo,
            p_dataAltaModelo,
            n_estatModelo,
            p_observacionsModelo);
--Gravem en la taula log-----------------------------------------------------
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('Insertada model: 
            Descripcion: '||p_descripcioModelo||
            ' Data alta: '||p_dataAltaModelo||
            ' Any model:  '||p_anyModelo||
            ' Observacions: '||p_observacionsModelo);
            DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
            s_rsp :='Ok: Insertada model: 
            Descripcion: '||p_descripcioModelo||
            ' Data alta: '||p_dataAltaModelo||
            ' Any model:  '||p_anyModelo||
            ' Observacions: '||p_observacionsModelo;
            pkg_general.gravar_log_procedure(c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
            DBMS_OUTPUT.PUT_LINE(s_rsp);
          ELSE
           DBMS_OUTPUT.ENABLE;
           DBMS_OUTPUT.PUT_LINE('     ALTA MODELS             ');
           DBMS_OUTPUT.PUT_LINE('_____________________________');       
           s_rsp := 'DADES duplicades';
           DBMS_OUTPUT.PUT_LINE(s_rsp);
          RAISE e_model;
      END IF;
COMMIT;
  EXCEPTION
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         s_rsp := 'Error: ' || SQLCODE || SUBSTR (SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' '); 
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;
  END PRC_ALTA_MODELO;
/*****************************************************************************
Autor: Eduard Monzonis Hierro                                   UOC
18/05/2012                                             TFC: CONTROL ENERGIA.
                PRCEDIMENT MODIFICAR MODEL COMPTADOR
DESCRIPCIO:
Procediement per modificar les dades del model de comptador.
*****************************************************************************/
  PROCEDURE PRC_MODIFICAR_MODELO(
    p_idModelo in MODELO.IDMODELO%Type,
    p_descripcioModelo in MODELO.DESCRIPCIOMODELO%Type,
    p_anyModelo in MODELO.ANYOFABRICAMODELO%Type,
    p_idFabricantModelo in MODELO.IDFABRICANTMODELO%Type,
    p_dataModificaModelo in MODELO.DATAMODIFICACIOMODELO%Type,
    p_estatModelo in MODELO.ESTATMODELO%Type,
    p_observacionsModelo in MODELO.OBSERVACIONSMODELO%Type,
    s_rsp out NOCOPY VARCHAR2)
AS
 
BEGIN
    c_procesLog := 'PRC_MODIFICAR_MODELO';
    c_dataHoraLog := SYSDATE;
    c_entradaLog :=' Codi Model: ' ||p_idModelo||
    ', Descripcio Model: ' ||p_descripcioModelo||
    ', Any Model: ' ||p_anyModelo||
    ', Data Modifica Model: ' ||p_dataModificaModelo||
    ', Observacions Modelo  '||p_observacionsModelo;
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE(' ');
  DBMS_OUTPUT.PUT_LINE('     MODIFICAR UN MODEL              ');
  DBMS_OUTPUT.PUT_LINE('_____________________________________');  
  DBMS_OUTPUT.PUT_LINE(' Codi Modelo: ' ||p_idModelo||
    ', Descripcio Modelo: ' ||p_descripcioModelo||
    ', Any Modelo: ' ||p_anyModelo||
    ', Data Modifica Modelo: ' ||p_dataModificaModelo||
    ', Observacions Modelo  '||p_observacionsModelo); 
      c_sortidalog := 's_rsp';
-- comprovacio de dades    
  IF p_idModelo IS NULL THEN
   DBMS_OUTPUT.ENABLE;
   DBMS_OUTPUT.PUT_LINE('MODIFICAR UN MODEL: ');     
   s_rsp := 'Falta especificar el el codi Modelo ';
   DBMS_OUTPUT.PUT_LINE(s_rsp);        
   RAISE e_model; 
  END IF;
  If p_descripcioModelo IS NULL then
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('MODIFICAR UN MODEL: ');
    s_rsp := 'Falta especificar descripcio Modelo ';
    DBMS_OUTPUT.PUT_LINE(s_rsp);           
    RAISE e_model; 
  END IF;
  If p_anyModelo IS NULL then
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('MODIFICAR UN MODEL: ');    
    s_rsp := 'Falta especificar any Modelo ';
    DBMS_OUTPUT.PUT_LINE(s_rsp);               
    RAISE e_model; 
  END IF;
  If p_dataModificaModelo IS NULL then
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('MODIFICAR UN MODEL: ');        
    s_rsp := 'Falta especificar data Modificacio Modelo ';
    DBMS_OUTPUT.PUT_LINE(s_rsp);            
    RAISE e_model; 
   END IF;
-- recuperem el codi MODELO
  SELECT MODELO.IDMODELO INTO n_idModelo
  FROM MODELO
  WHERE MODELO.IDMODELO=p_idModelo;
     
  If n_registres=0 then
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('MODIFICAR UN MODEL: ');                 
    s_rsp := 'MODELO no existent a la BBDD';
    DBMS_OUTPUT.PUT_LINE(s_rsp);
    RAISE e_model; 
  END IF;
  s_sql := 'UPDATE MODELO SET ';

-- Construirem la sentencia UPDATE segons si hi ha valor en els paràmetres-
  IF p_descripcioModelo IS NOT NULL THEN
-- Modifiquem descripcio Modelo
    s_sql := s_sql || 'DESCRIPCIOMODELO=''' ||p_descripcioModelo|| ''',';
  END IF;
  IF p_anyModelo IS NOT NULL THEN
-- Modifiquem any Modelo
   s_sql := s_sql || 'ANYOFABRICAMODELO=''' ||p_anyModelo|| ''',';
  END IF;
  IF p_dataModificaModelo IS NOT NULL THEN
-- Modifiquem data Modificacio Modelo
    s_sql := s_sql || 'DATAMODIFICACIOMODELO=''' ||p_dataModificaModelo|| ''',';
  END IF; 
  IF p_observacionsModelo IS NOT NULL THEN
-- Modifiquem Observacions Modelo
    s_sql := s_sql || 'OBSERVACIONSMODELO=''' ||p_observacionsModelo|| ''',';
  END IF;
-- Eliminem la coma final de la sentencia SQL--------------------------
  s_sql := SUBSTR (s_sql, 1, LENGTH (s_sql) - 1);
-- Afegim a la sentencia la condiciÃ³ del WHERE------------------------
  s_sql := s_sql || ' WHERE IDMODELO=''' ||p_idModelo|| '''';

EXECUTE IMMEDIATE s_sql;
      
  IF SQL%ROWCOUNT = 0 THEN
--L'error serà que Tipo Linea ja el tenim en la taula i no admet duplicats--
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('MODIFICAR UN MODEL: ');                  
    s_rsp := 'Actualitzacio no realitzada';
    DBMS_OUTPUT.PUT_LINE(s_rsp);                  
    RAISE e_model; 
  ELSE
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('MODIFICAR UN MODEL: '); 
    DBMS_OUTPUT.PUT_LINE('Actualitzacio Model amb el
    Codi Model: '||p_idModelo||
    ' Descripcio del Model: '||p_descripcioModelo||
    ' Any del Model: '||p_anyModelo||
    ' Data de la modificacio: '||p_dataModificaModelo||
    ' Observacions. '||p_observacionsModelo||' ha estat satisfactoria.');
    DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
    s_rsp := 'OK :Actualitzacio Model amb el
    Codi Model: '||p_idModelo||
    ' Descripcio del Model: '||p_descripcioModelo||
    ' Any del Model: '||p_anyModelo||
    ' Data de la modificacio: '||p_dataModificaModelo||
    ' Observacions. '||p_observacionsModelo||' ha estat satisfactoria.';
    pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  END IF;
COMMIT;
  EXCEPTION
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         s_rsp := 'Error: ' || SQLCODE || SUBSTR (SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         s_rsp := 'Error: ' || s_rsp;
      END IF;
     DBMS_OUTPUT.ENABLE;
     DBMS_OUTPUT.PUT_LINE(' '); 
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  ROLLBACK;
END PRC_MODIFICAR_MODELO;
/******************************************************************************
Autor: Eduard Monzonis Hierro                                   UOC
18/05/2012                                             TFC: CONTROL ENERGIA.
                  PROCEDIMENT BAIXA MODEL COMPTADOR
DESCRIPCIO:
Consulta d'un model de comptador.
******************************************************************************/
PROCEDURE PRC_BAIXA_MODELO(
    p_idModelo in MODELO.IDMODELO%Type,
    p_descripcioModelo in MODELO.DESCRIPCIOMODELO%Type,
    p_estatModelo in MODELO.ESTATMODELO%Type,	
    p_dataModificaModelo in MODELO.DATAMODIFICACIOMODELO%Type,
    s_rsp out NOCOPY VARCHAR2)
AS
 
BEGIN
  c_procesLog := 'PRC_BAIXA_MODELO';
  c_dataHoraLog := SYSDATE;
  c_entradaLog :='Id Tipus Linea: ' ||p_idModelo||
  ' Data Estat Tipus Linea: ' ||p_dataModificaModelo;
  DBMS_OUTPUT.PUT_LINE(' ');
  DBMS_OUTPUT.PUT_LINE('       BAIXA  MODEL          ');
  DBMS_OUTPUT.PUT_LINE('_____________________________');
  DBMS_OUTPUT.PUT_LINE('Codi Model: ' ||p_idModelo||
  ' Data modificacio: ' ||p_dataModificaModelo);
  c_sortidalog := 's_rsp';    
--controlem dades
 IF (p_idModelo IS NULL) OR (p_idModelo=0) THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('BAIXA  MODEL : ');       
    s_rsp := 'Falta especificar el codi del model o b el model sha posat 0  ';
    DBMS_OUTPUT.PUT_LINE(s_rsp);           
    RAISE e_model; 
  END IF;
  IF p_dataModificaModelo IS NULL THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('BAIXA  MODEL : ');       
    s_rsp := 'Falta especificar la data de la modificacio. ';
    DBMS_OUTPUT.PUT_LINE(s_rsp);           
    RAISE e_model; 
  END IF;
--1er. Comprovem que existeixi el Model-------------------------------  
   SELECT COUNT (*) INTO n_registres 
   FROM MODELO
   WHERE MODELO.IDMODELO=p_idModelo; 
-- ISERTEM SI NO EXISTEIX
 IF p_idModelo=0 THEN
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('BAIXA  MODEL: '||p_idModelo||
  ' ha de fer-se una alta del model. ');       
  s_rsp := 'BAIXA  MODEL: '||p_idModelo||
  ' ha de fer-se una alta del model. ';
  DBMS_OUTPUT.PUT_LINE(s_rsp);           
  RAISE e_model;
 END IF;
  --RECUPEREM EL MODEL
 SELECT 
 MODELO.IDMODELO,
 MODELO.DATAMODIFICACIOMODELO,
 MODELO.ANYOFABRICAMODELO,
 MODELO.ESTATMODELO,
 MODELO.DESCRIPCIOMODELO,
 MODELO.IDFABRICANTMODELO,
 MODELO.OBSERVACIONSMODELO 
 INTO n_idModelo,
      n_dataModificacioModel,
      n_anyModelo,
      n_idEstatModelo,
      n_descripcioModelo,
      n_idFabricantModelo,
      n_observacionsModelo 
 FROM MODELO
 WHERE MODELO.IDMODELO=p_idModelo;
 
 SELECT FABRICANT.NOMCOMERCIALFABRICANT INTO n_fabricant
 FROM FABRICANT, MODELO
 WHERE FABRICANT.IDFABRICANT= MODELO.IDFABRICANTMODELO;
 
 -- posem el control Estat e 2=BAIXA
 n_controlEstat:=2; 
-- Actualitzem
 s_sql := 'UPDATE MODELO SET ';
     -- Construirem la sentencia UPDATE segons si hi ha valor en els paràmetres-             
  IF (n_idEstatModelo IS NOT NULL) AND (n_idEstatModelo=1) THEN
-- Modifiquem Data Estat model
     s_sql := s_sql || 'ESTATMODELO=''' ||n_controlEstat|| ''',';
  END IF;
  IF p_dataModificaModelo IS NOT NULL THEN
-- Modifiquem Data Estat model
    s_sql := s_sql || 'DATAMODIFICACIOMODELO=''' ||p_dataModificaModelo|| ''',';
  END IF;
 -- Eliminem la coma final de la sentencia SQL--------------------------
    s_sql := SUBSTR (s_sql, 1, LENGTH (s_sql) - 1);
-- Afegim a la sentencia la condiciÃ³ del WHERE------------------------
 s_sql := s_sql || ' WHERE IDMODELO=''' ||p_idModelo|| '''';
   
EXECUTE IMMEDIATE s_sql;
 DBMS_OUTPUT.ENABLE;
 DBMS_OUTPUT.PUT_LINE('BAIXA  MODEL: '); 
 DBMS_OUTPUT.PUT_LINE('Actualitzacio de baixa model: '||p_idModelo||
    ' data de la baixa: '||p_dataModificaModelo||
    ' estat: '||n_controlEstat||
    '=Baixa del Model: '||n_descripcioModelo||
    ' del Fabricant: '||n_fabricant||
    ' Observacions. '||n_observacionsModelo||' ha estat satisfactoria.');
    DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
    s_rsp := 'OK Actualitzacio de baixa model: '||p_idModelo||
    ' data de la baixa: '||p_dataModificaModelo||
    ' estat: '||n_controlEstat||
    '=Baixa del Model: '||n_descripcioModelo||
    ' del Fabricant: '||n_fabricant||
    ' Observacions. '||n_observacionsModelo||' ha estat satisfactoria.';
     pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
COMMIT;
 EXCEPTION
    WHEN DUP_VAL_ON_INDEX THEN
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('BAIXA LINEA TIPUS: ');    
      s_rsp := 'Error: Tipo Linea duplicada. No es poden fer les modificacions';
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;      
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         -----------------------------------------
         s_rsp := 'Error: ' || SQLCODE || SUBSTR(SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         -----------------------------------------
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' '); 
      DBMS_OUTPUT.put_line (s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;    

END PRC_BAIXA_MODELO;

PROCEDURE PRC_CONSULTAR_MODELO(
  s_rsp out NOCOPY VARCHAR2)
AS

CURSOR C_MODELO IS
SELECT MODELO.IDMODELO AS CODI,
       MODELO.DATAALTAMODELO AS DATA_ALTA,
       ESTAT.DESCRIPCIOESTAT AS ESTAT,
       MODELO.DATAMODIFICACIOMODELO AS DATA_MODIFICACIO,
       MODELO.ANYOFABRICAMODELO AS ANY_FABRICACIO,
       MODELO.DESCRIPCIOMODELO AS DESCRIPCIO,
       FABRICANT.NOMCOMERCIALFABRICANT AS FABRICANT,
       MODELO.OBSERVACIONSMODELO AS OBSERVACIONS
FROM MODELO,FABRICANT,ESTAT
WHERE MODELO.IDFABRICANTMODELO=FABRICANT.IDFABRICANT
AND MODELO.ESTATMODELO=ESTAT.IDESTAT
AND MODELO.IDMODELO=MODELO.IDMODELO;
 
BEGIN
 c_procesLog := 'PRC_CONSULTAR_MODEL';
 c_dataHoraLog := SYSDATE;
 c_entradaLog :='CONSULTA MODELS ';
 c_sortidalog := 's_rsp'; 
 SELECT COUNT(*)INTO n_registres
    FROM MODELO
    WHERE MODELO.IDMODELO=MODELO.IDMODELO;
 IF n_registres=0 THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('CONSULTA MODELS: ');             
    s_rsp := 'No hi han models donats en alta.  ';
    DBMS_OUTPUT.PUT_LINE(s_rsp);
    RAISE e_model;
  END IF;
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('      CONSULTA MODELS DE COPMTADORS           ');
  DBMS_OUTPUT.PUT_LINE('----------------------------------------------');
  OPEN C_MODELO;
  FETCH C_MODELO  INTO n_idModelo,
      n_dataAltaModel,
      n_descModel,
      n_dataModificacioModel,
      n_anyModelo,
      n_descripcioModelo,
      n_fabricant,
      n_observacionsModelo;
  WHILE C_MODELO%FOUND LOOP
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE(
 '   Codi Model: '
 ||n_idModelo||
 ' Data alta: '
 ||n_dataModificacioModel||
 ' Esta: '
 ||n_descModel||
 ' Data ultima modificacio: '
 ||n_dataModificacioModel||
 ' Any fabricacio: '
 ||n_anyModelo||
 ' Descripcio: '
 ||n_descripcioModelo||
 ' Fabricant: '
 ||n_fabricant||
 ' Observacions: '
 ||n_observacionsModelo );
  s_rsp := 'OK CONSULTA MODELS Codi Model: '
 ||n_idModelo||
 ' Data alta: '
 ||n_dataModificacioModel||
 ' Esta: '
 ||n_descModel||
 ' Data ultima modificacio: '
 ||n_dataModificacioModel||
 ' Any fabricacio: '
 ||n_anyModelo||
 ' Descripcio: '
 ||n_descripcioModelo||
 ' Fabricant: '
 ||n_fabricant||
 ' Observacions: '
 ||n_observacionsModelo ;
 
FETCH C_MODELO  INTO n_idModelo,
      n_dataAltaModel,
      n_descModel,
      n_dataModificacioModel,
      n_anyModelo,
      n_descripcioModelo,
      n_fabricant,
      n_observacionsModelo ;
  pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
   END LOOP;
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('Total models donats en alta: '||n_registres);
  DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
CLOSE C_MODELO;
COMMIT;
     EXCEPTION
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         s_rsp := 'Error: ' || SQLCODE || SUBSTR (SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' '); 
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;
    END PRC_CONSULTAR_MODELO;
END "GESTION_MODELO";
