CREATE OR REPLACE
PACKAGE BODY          "GESTION_TIPUS_FUNCIONS" AS
c_procesLog LOG_TFC.procesLog%TYPE;	
  c_dataHoraLog LOG_TFC.dataHoraLog%TYPE;
  c_entradaLog LOG_TFC.entradaLog%TYPE;	
  c_sortidaLog LOG_TFC.sortidaLog%TYPE;
  s_rsp LOG_TFC.rspLog%TYPE; 
  n_registres  NUMBER;
  s_sql VARCHAR2 (2000);
  
  n_descripcioTFuncions TIPUS_FUNCIONS.DESCRIPCIONFUNCIO%TYPE;
  n_idTFuncions   TIPUS_FUNCIONS.IDFUNCIO%TYPE;
  n_NUM_ERR NUMBER(10);
  sortida varchar2(500):=''; 
  e_tipo_Funcions    EXCEPTION;
--------------------------------------------------------------
-- create procedure for table "LOG_TFC i TIPUS_FUNCIONS"
/********************************************************************************
Autor: Eduard Monzonis Hierro                                   UOC
18/05/2012                                             TFC: CONTROL ENERGIA.
   NOM:         PRC_ALTA_TIPUS_FUNCIONS
   DESCRIPCIÓ:
      Procediment encarregat de dades d'alta a la taula Tipus Funcions de Central
      Distribució. 
      
********************************************************************************/ 
   procedure PRC_ALTA_TIPUS_FUNCIONS(
    p_descripcioTFuncions in TIPUS_FUNCIONS.DESCRIPCIONFUNCIO%TYPE,
    s_rsp out NOCOPY VARCHAR2) 
   AS
 
   BEGIN
    c_procesLog := 'PRC_ALTA_TIPUS_FUNCIONS';
    c_dataHoraLog := SYSDATE;
    c_entradaLog :='Decripcio Tipo Funcions de Central Produccio: ' || p_descripcioTFuncions;
    DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE('ALTA TIPUS DE FUNCIONS DE LA CENTRAL DE PRODUCCIO');
    DBMS_OUTPUT.PUT_LINE('______________________');
    DBMS_OUTPUT.PUT_LINE('Tipus de Funcio: '|| p_descripcioTFuncions);
    c_sortidalog := 's_rsp';   
    If (p_descripcioTFuncions IS NULL) then
           DBMS_OUTPUT.ENABLE;
           DBMS_OUTPUT.PUT_LINE('ALTA TIPUS DE FUNCIONS DE LA CENTRAL DE PRODUCCIO  ');
           s_rsp := 'Falta especificar Tipo Funcions de Central Produccio';
           DBMS_OUTPUT.PUT_LINE(s_rsp);
          RAISE e_tipo_Funcions;
     END IF;
      -- Comprovem si existeix el Tipo Funcions de Central Distribució a  donar d'alta
         SELECT COUNT (*) INTO n_registres 
            FROM TIPUS_FUNCIONS 
            WHERE DESCRIPCIONFUNCIO=p_descripcioTFuncions;
      If n_registres=0 then
          -- El donem d'alta a la tipus lectura          
            INSERT INTO TIPUS_FUNCIONS(DESCRIPCIONFUNCIO) 
            VALUES(p_descripcioTFuncions);
            --Gravem en la taula log-----------------------------------------------------
              DBMS_OUTPUT.ENABLE;
              DBMS_OUTPUT.PUT_LINE('Insertada el tipus de Funcio de la 
              Central de Produccio: '||p_descripcioTFuncions);
              DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
              s_rsp :='Ok: En la Taula TIPUS DE FUNCIONS Insertada
              Tipus de funcio de la Central de Produccio:  '||p_descripcioTFuncions;
              pkg_general.gravar_log_procedure(c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
              DBMS_OUTPUT.PUT_LINE(s_rsp);
          ELSE
              DBMS_OUTPUT.ENABLE;
              DBMS_OUTPUT.PUT_LINE('ALTA TIPUS DE FUNCIONS DE LA CENTRAL DE PRODUCCIO ');
              s_rsp := 'DESCRICIO Tipus de funcio duplicada ';
              DBMS_OUTPUT.PUT_LINE(s_rsp);
          RAISE e_tipo_Funcions;
        END IF;
   COMMIT;
EXCEPTION
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         DBMS_OUTPUT.ENABLE;
              DBMS_OUTPUT.PUT_LINE('ALTA TIPUS DE FUNCIONS DE LA CENTRAL DE PRODUCCIO ');
         s_rsp := 'Error: ' || SQLCODE || SUBSTR (SQLERRM, 1, 100);
         DBMS_OUTPUT.PUT_LINE(s_rsp);
      ELSE
         -- L'error si ha estat controlat per codi
        DBMS_OUTPUT.ENABLE;
              DBMS_OUTPUT.PUT_LINE('ALTA TIPUS DE FUNCIONS DE LA CENTRAL DE PRODUCCIO');
         s_rsp := 'Error: ' || s_rsp;
         DBMS_OUTPUT.PUT_LINE(s_rsp);
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('  ');
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;

END PRC_ALTA_TIPUS_FUNCIONS;
   
PROCEDURE PRC_MODIFICAR_TIPUS_FUNCIONS(
/********************************************************************************
Autor: Eduard Monzonis Hierro                                   UOC
18/05/2012                                             TFC: CONTROL ENERGIA.
   NOM:         PRC_MODIFICAR_TIPUS_FUNCIONS
   DESCRIPCIÓ:
      Procediment encarregat de modificar les dades d'un Tipus Funcions de Central
      Distribució. 
      Les dades es modificaran en la taula Tipus_Funcions i el identificador de 
      tipus Funcions apuntarà a la clau primaria del codi de la taula 
      Tipus_Funcions.
********************************************************************************/  
    p_descripcioTFuncions in TIPUS_FUNCIONS.DESCRIPCIONFUNCIO%TYPE,
    p_idTFuncions in TIPUS_FUNCIONS.IDFUNCIO%TYPE,
    s_rsp out NOCOPY VARCHAR2)
   AS
 
   BEGIN
    c_procesLog := 'PRC_MODIFICAR_TIPUS_FUNCIONS';
    c_dataHoraLog := SYSDATE;
    c_entradaLog :='Decripcio Tipus Funcions de Central: ' || p_descripcioTFuncions;
    DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE('MODIFICAR EL TIPUS DE FUNCIONS DE LA CENTRAL DE PRODUCCIO');
    DBMS_OUTPUT.PUT_LINE('______________________');
    DBMS_OUTPUT.PUT_LINE('Tipus de Funcio: '|| p_descripcioTFuncions);    
    c_sortidalog := 's_rsp';
    -- Comprovació del identificador Tipus Funcions de Central-----
      
    If  p_descripcioTFuncions IS NULL THEN
           DBMS_OUTPUT.ENABLE;
            DBMS_OUTPUT.PUT_LINE('MODIFICAR EL TIPUS DE FUNCIONS DE LA CENTRAL DE PRODUCCIO:  ');
   	   s_rsp := 'Falta especificar Tipus Funcions de Central';
           DBMS_OUTPUT.put_line(s_rsp);
           RAISE e_tipo_Funcions;
        END IF;
          
            SELECT COUNT (*) INTO n_registres 
            FROM TIPUS_FUNCIONS
            WHERE TIPUS_FUNCIONS.DESCRIPCIONFUNCIO=p_descripcioTFuncions;
      If n_registres=0 then
           DBMS_OUTPUT.ENABLE;
           DBMS_OUTPUT.PUT_LINE('MODIFICAR EL TIPUS DE FUNCIONS DE LA CENTRAL DE PRODUCCIO:  ');
           s_rsp := 'TIPUS FUNCIONS no existeix a la BBDD';
           DBMS_OUTPUT.PUT_LINE(s_rsp);
           RAISE e_tipo_Funcions;
        END IF;
         
          -- recuperem el codi de la tipus lectura
    SELECT TIPUS_FUNCIONS.IDFUNCIO,
    TIPUS_FUNCIONS.DESCRIPCIONFUNCIO INTO n_idTFuncions,n_descripcioTFuncions
    FROM TIPUS_FUNCIONS
    WHERE TIPUS_FUNCIONS.IDFUNCIO=p_descripcioTFuncions;
    
    s_sql := 'UPDATE TIPUS_FUNCIONS SET ';
    
 -- Construirem la sentencia UPDATE segons si hi ha valor en els paràmetres-
    IF p_descripcioTFuncions IS NOT  NULL THEN
    -- Modifiquem el descripcio Tipus Funcions de Central
    s_sql := s_sql || 'DESCRIPCIONFUNCIO=''' || p_descripcioTFuncions || ''',';
    END IF;
   -- Eliminem la coma final de la sentencia SQL
    s_sql := SUBSTR (s_sql, 1, LENGTH (s_sql) - 1);
   -- Afegim a la sentencia la condició del WHERE
    s_sql := s_sql || ' WHERE IDFUNCIO=''' ||n_idTFuncions|| '''';

  EXECUTE IMMEDIATE s_sql;
      
  IF SQL%ROWCOUNT = 0 THEN
--L'error serà que el la via ja el tenim en la taula i no admet duplicats--
     DBMS_OUTPUT.ENABLE;
     DBMS_OUTPUT.PUT_LINE('MODIFICAR EL TIPUS DE FUNCIONS DE LA CENTRAL DE PRODUCCIO:  ');
     s_rsp := 'Actualitzaci0 no realitzada';
     DBMS_OUTPUT.PUT_LINE(s_rsp);
     RAISE e_tipo_Funcions;
  ELSE
     DBMS_OUTPUT.ENABLE;
     DBMS_OUTPUT.PUT_LINE('Modificacio feta del Tipus de Funcio
     de la Central de Produccio: codi: '||n_idTFuncions||
     ' Descripcio: '||p_descripcioTFuncions);
     DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
     DBMS_OUTPUT.put_line ('OK: Modificacio feta del Tipus de Funcio
     de la Central de Produccio: codi: '||n_idTFuncions||
     ' Descripcio: '||n_descripcioTFuncions);
     pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
 END IF;
COMMIT;
EXCEPTION
   WHEN DUP_VAL_ON_INDEX THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('MODIFICAR_TIPUS_FUNCIONS: ');
    s_rsp := 'Error: Tipus Funcions de Central duplicada. 
    No es poden fer les modificacions';
    DBMS_OUTPUT.put_line(s_rsp);
    pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
    ROLLBACK;      
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         -----------------------------------------
         s_rsp := 'Error: ' || SQLCODE || SUBSTR(SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         -----------------------------------------
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' ');
      DBMS_OUTPUT.put_line (s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;
END PRC_MODIFICAR_TIPUS_FUNCIONS;
/********************************************************************************
Autor: Eduard Monzonis Hierro                                   UOC
18/05/2012                                             TFC: CONTROL ENERGIA.
   NOM:         PRC_CONSULTAR_TIPUS_FUNCIONS
   DESCRIPCIÓ:
      Procediment encarregat de modificar les dades d'un Tipus Funcions de Central
      Distribució. 
      Les dades es consulten en la taula Tipus_Funcions i el identificador de 
      tipus Funcions apuntarà a la clau primaria del codi de la taula 
      Tipus_Funcions.
********************************************************************************/   
procedure PRC_CONSULTAR_TIPUS_FUNCIONS(
    s_rsp out NOCOPY VARCHAR2)
    
AS

CURSOR C_FUNCIONS IS
  SELECT TIPUS_FUNCIONS.IDFUNCIO,TIPUS_FUNCIONS.DESCRIPCIONFUNCIO
  FROM TIPUS_FUNCIONS
  WHERE TIPUS_FUNCIONS.IDFUNCIO=TIPUS_FUNCIONS.IDFUNCIO;

BEGIN
    c_procesLog := 'PRC_CONSULTAR_TIPUS_FUNCIONS';
    c_dataHoraLog := SYSDATE;
    c_entradaLog :='CONSULTA TIPUS DE FUNCIONS DE LES CENTRALS DE PRODUCCIO';
    c_sortidalog := 's_rsp';
 
  --1er. Comprovem que existeixi Tipus de Funcion-------------------------------
    SELECT COUNT (*) INTO n_registres 
    FROM TIPUS_FUNCIONS
    WHERE  TIPUS_FUNCIONS.IDFUNCIO=TIPUS_FUNCIONS.IDFUNCIO;
        
    IF n_registres=0 THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('CONSULTA TIPUS DE FUNCIONS DE LES CENTRALS DE PRODUCCIO: ');
    s_rsp := 'No hi han tipus de funcions donades dalta ';
    DBMS_OUTPUT.PUT_LINE(s_rsp);
    RAISE e_tipo_Funcions;
    END IF;
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('           CONSULTA TIPUS DE FUNCIONS DE LES CENTRALS DE PRODUCCIO            ');
    DBMS_OUTPUT.PUT_LINE('------------------------------------------------------------------------------');
    OPEN C_FUNCIONS;
    FETCH C_FUNCIONS INTO n_idTFuncions,n_descripcioTFuncions;
  WHILE C_FUNCIONS%FOUND LOOP
   DBMS_OUTPUT.ENABLE;
   DBMS_OUTPUT.PUT_LINE(
 '   Codi Tipus Funcio:  '
 || n_idTFuncions
 ||' Descripcio '
 || n_descripcioTFuncions);
  s_rsp := 'OK  CONSULTA TIPUS FUNCIONS DE LES CENTRALS
  Codi Tipus Funcio:  '
 ||n_idTFuncions
 ||' Descripcio: '
 ||n_descripcioTFuncions;
  FETCH C_FUNCIONS INTO n_idTFuncions,n_descripcioTFuncions;

  pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  
  END LOOP;
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('Total fucions tipus: '||n_registres);
  DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
CLOSE C_FUNCIONS;
   COMMIT;
EXCEPTION
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         s_rsp := 'Error: ' || SQLCODE || SUBSTR (SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         s_rsp := 'Error: ' || s_rsp;
      END IF;
        DBMS_OUTPUT.ENABLE;
        DBMS_OUTPUT.PUT_LINE(' ');
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;    
END PRC_CONSULTAR_TIPUS_FUNCIONS;    
    
END "GESTION_TIPUS_FUNCIONS";
