CREATE OR REPLACE
PACKAGE BODY          "GESTION_TIPO_INSPECCIO" AS
 c_procesLog LOG_TFC.procesLog%TYPE;	
  c_dataHoraLog LOG_TFC.dataHoraLog%TYPE;
  c_entradaLog LOG_TFC.entradaLog%TYPE;	
  c_sortidaLog LOG_TFC.sortidaLog%TYPE;
  s_rsp LOG_TFC.rspLog%TYPE; 
  n_registres  NUMBER;
  s_sql VARCHAR2 (2000);
  
  n_descripcioInspeccio TIPO_INSPECCIO.DESCRIPCIOTINSPECCIO%TYPE;
  n_idInspeccio   TIPO_INSPECCIO.IDTINSPCCIO%TYPE;
  n_NUM_ERR NUMBER(10);
  sortida varchar2(500):=''; 
  e_tipo_inspeccio     EXCEPTION;
/***************************************************************************************
Autor: Eduard Monzonis Hierro                                   UOC
18/05/2012                                             TFC: CONTROL ENERGIA.
	NOM: 
		PROCEDIMENT PER DONAR ALTA_TIPO_INSPECCIO
	
	DESCRIPCIÓ:
		Segons el disseny expressat en el model realcional.

***************************************************************************************/
PROCEDURE PRC_ALTA_TIPO_INSPECCIO(
    p_descripcioInspeccio in TIPO_INSPECCIO.DESCRIPCIOTINSPECCIO%TYPE,
    s_rsp out NOCOPY VARCHAR2)
 AS
 
   BEGIN
    c_procesLog := 'PRC_ALTA_TIPO_INSPECCIO';
    c_dataHoraLog := SYSDATE;
    c_entradaLog :='Decripcio Tipo Inspeccio: ' ||p_descripcioInspeccio;
    DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE('ALTA TIPUS DE INSPECCIONS');
    DBMS_OUTPUT.PUT_LINE('______________________');
    DBMS_OUTPUT.PUT_LINE('ALTA_TIPO_INSPECCIO: Decripcio Tipo Inspeccio: ' 
    ||p_descripcioInspeccio);
    c_sortidalog := 's_rsp';   
  If (p_descripcioInspeccio IS NULL) then
            DBMS_OUTPUT.ENABLE;
            DBMS_OUTPUT.PUT_LINE('ALTA_TIPO_INSPECCIO: ');
           s_rsp := 'Falta especificar tipus d´Inspeccio';
           DBMS_OUTPUT.PUT_LINE(s_rsp);
          RAISE e_tipo_inspeccio;
     END IF;
      -- Comprovem si existeix el el tipus de lectura a  donar d'alta
         SELECT COUNT (*)INTO n_registres 
            FROM TIPO_INSPECCIO
            WHERE DESCRIPCIOTINSPECCIO = p_descripcioInspeccio;
      If n_registres=0 then
          -- El donem d'alta a la tipus lectura          
            INSERT INTO TIPO_INSPECCIO(DESCRIPCIOTINSPECCIO) 
            VALUES(p_descripcioInspeccio);
            --Gravem en la taula log-----------------------------------------------------
            DBMS_OUTPUT.PUT_LINE('Insertada el tipus inspeccio: '
            ||p_descripcioInspeccio);
            DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
            s_rsp :='Ok: Insertat satisfactoriament'|| p_descripcioInspeccio;
            pkg_general.gravar_log_procedure(c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
            DBMS_OUTPUT.PUT_LINE(s_rsp);
          ELSE
            DBMS_OUTPUT.ENABLE;
            DBMS_OUTPUT.PUT_LINE('ALTA_TIPO_INSPECCIO: ');
          s_rsp := 'Tipus Inspeccio duplicat ';
          DBMS_OUTPUT.PUT_LINE(s_rsp);
          RAISE e_tipo_inspeccio;
      END IF;
   COMMIT;
EXCEPTION
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         s_rsp := 'Error: ' || SQLCODE || SUBSTR (SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('  ');
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;

END PRC_ALTA_TIPO_INSPECCIO;
/***************************************************************************************
Autor: Eduard Monzonis Hierro                                   UOC
18/05/2012                                             TFC: CONTROL ENERGIA.
	NOM:  PRC_MODIFICAR_TIPO_INSPECCIO
              PROCEDIMENT PERMODIFICAR TIPO INSPECCIO
	
	DESCRIPCIÓ:
		Segons el disseny expressat en el model realcional.

***************************************************************************************/
PROCEDURE PRC_MODIFICAR_TIPO_INSPECCIO(
    p_descripcioInspeccio in TIPO_INSPECCIO.DESCRIPCIOTINSPECCIO%TYPE,
    p_idInspeccio in TIPO_INSPECCIO.IDTINSPCCIO%TYPE,
    s_rsp out NOCOPY VARCHAR2)
 AS
 
   BEGIN
    c_procesLog := 'PRC_MODIFICAR_TIPO_INSPECCIO';
    c_dataHoraLog := SYSDATE;
    c_entradaLog :='Decripcio Tipo Inspeccio: ' ||p_descripcioInspeccio;
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE('MODIFICAR EL TIPUS DE INSPECCIONS');
    DBMS_OUTPUT.PUT_LINE('______________________');
    DBMS_OUTPUT.PUT_LINE('Tipus de Inspeccio: '||p_descripcioInspeccio);    

    c_sortidalog := 's_rsp';
    -- Comprovació Tipus de Inspeccio-----
      
    If  (p_descripcioInspeccio  IS NULL) THEN
       DBMS_OUTPUT.ENABLE;
       DBMS_OUTPUT.PUT_LINE('MODIFICAR EL TIPUS DE INSPECCIONS ');
       s_rsp := 'Falta especificar tipus Inspeccio ';
       DBMS_OUTPUT.put_line(s_rsp);
       RAISE e_tipo_inspeccio;
  END IF;
          
  SELECT COUNT (*) INTO n_registres 
  FROM TIPO_INSPECCIO
  WHERE TIPO_INSPECCIO.DESCRIPCIOTINSPECCIO=p_descripcioInspeccio;
  
  If n_registres=0 then
     DBMS_OUTPUT.ENABLE;
     DBMS_OUTPUT.PUT_LINE('MODIFICAR_TIPO_INSPECCIO:  ');
     s_rsp := 'TIPO_INSPECCIO no existeix a la BBDD';
     DBMS_OUTPUT.PUT_LINE(s_rsp);
     RAISE e_tipo_inspeccio;
  END IF;
      
-- recuperem el codi de la tipus lectura
  SELECT TIPO_INSPECCIO.IDTINSPCCIO,
  TIPO_INSPECCIO.DESCRIPCIOTINSPECCIO INTO n_idInspeccio,n_descripcioInspeccio  
  FROM TIPO_INSPECCIO
  WHERE TIPO_INSPECCIO.DESCRIPCIOTINSPECCIO=p_descripcioInspeccio;
        
  s_sql := 'UPDATE TIPO_INSPECCIO SET ';
-- Construirem la sentencia UPDATE segons si hi ha valor en els paràmetres-
  IF p_descripcioInspeccio  IS NOT NULL THEN
 -- Modifiquem el descripcio pasis
  s_sql := s_sql || 'DESCRIPCIOTINSPECCIO=''' ||p_descripcioInspeccio || ''',';
  END IF;
  -- Eliminem la coma final de la sentencia SQL
  s_sql := SUBSTR (s_sql, 1, LENGTH (s_sql) - 1);
  -- Afegim a la sentencia la condició del WHERE
 s_sql := s_sql || ' WHERE IDTINSPECCIO=''' ||n_idInspeccio|| '''';

  EXECUTE IMMEDIATE s_sql;
      
 IF SQL%ROWCOUNT = 0 THEN
  --L'error serà que el la via ja el tenim en la taula i no admet duplicats--
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE(' MODIFICAR_TIPO_INSPECCIO ');
    s_rsp := 'Actualitzacio no realitzada';
    DBMS_OUTPUT.PUT_LINE(s_rsp);
    RAISE e_tipo_inspeccio;
 ELSE
     DBMS_OUTPUT.ENABLE;
     DBMS_OUTPUT.PUT_LINE('Modificacio feta del Tipus Inspeccio
      Codi Tipus Inspeccio: '||n_idInspeccio||
     ' Descripcio: '||p_descripcioInspeccio );
     DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
     DBMS_OUTPUT.put_line ('OK: Modificacio feta del Tipus de Inspeccio
     de la Central de Produccio: codi: '||n_idInspeccio||
     ' Descripcio: '||p_descripcioInspeccio);
     pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
 END IF;
COMMIT;

EXCEPTION
   WHEN DUP_VAL_ON_INDEX THEN
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('MODIFICAR_TIPO_INSPECCIO ');
      s_rsp := 'Error: Tipus Inspeccions duplicada. No es poden fer les modificacions';
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;      
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         -----------------------------------------
         s_rsp := 'Error: ' || SQLCODE || SUBSTR(SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         -----------------------------------------
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' ');
      DBMS_OUTPUT.put_line (s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;
  END PRC_MODIFICAR_TIPO_INSPECCIO;    
/***************************************************************************************
Autor: Eduard Monzonis Hierro                                   UOC
18/05/2012                                             TFC: CONTROL ENERGIA.
	NOM:  PRC_CONSULTAR_TIPO_INSPECCIO
              PROCEDIMENT PER CONSULTAR TIPO INSPECCIO
	
	DESCRIPCIÓ:
		Segons el disseny expressat en el model realcional.

***************************************************************************************/    
procedure PRC_CONSULTAR_TIPO_INSPECCIO(
         s_rsp out NOCOPY VARCHAR2)
AS
CURSOR C_TIPO_INSPECCIO IS
SELECT TIPO_INSPECCIO.IDTINSPCCIO,
TIPO_INSPECCIO.DESCRIPCIOTINSPECCIO
FROM TIPO_INSPECCIO
WHERE TIPO_INSPECCIO.IDTINSPCCIO=TIPO_INSPECCIO.IDTINSPCCIO;

BEGIN
    c_procesLog := 'PRC_CONSULTAR_TIPO_INSPECCIO';
    c_dataHoraLog := SYSDATE;
    c_entradaLog :='CONSULTA TIPUS DE FUNCIONS DE LES CENTRALS DE PRODUCCIO';
    c_sortidalog := 's_rsp';

  --1er. Comprovem que existeixi Tipus de Funcion-------------------------------
    SELECT COUNT (*) INTO n_registres 
    FROM TIPO_INSPECCIO
    WHERE TIPO_INSPECCIO.IDTINSPCCIO=TIPO_INSPECCIO.IDTINSPCCIO;
        
    IF n_registres=0 THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('CONSULTA TIPUS INSPECCIONS ');
    s_rsp := 'No hi han tipus inspeccions donades dalta ';
    DBMS_OUTPUT.PUT_LINE(s_rsp);
    RAISE e_tipo_inspeccio;
    END IF;
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('           CONSULTA TIPUS INSPECCIONS            ');
    DBMS_OUTPUT.PUT_LINE('-------------------------------------------------');
    OPEN C_TIPO_INSPECCIO;
    FETCH C_TIPO_INSPECCIO INTO n_idInspeccio,n_descripcioInspeccio;
  WHILE C_TIPO_INSPECCIO%FOUND LOOP
   DBMS_OUTPUT.ENABLE;
   DBMS_OUTPUT.PUT_LINE(
 '   Codi Tipus Inspeccions:  '
 || n_idInspeccio
 ||' Descripcio '
 || n_descripcioInspeccio);
  s_rsp := 'OK  CONSULTA INSPECCIONS
  Codi Tipus Inspeccio:  '
 || n_idInspeccio
 ||' Descripcio: '
 ||n_descripcioInspeccio;
  FETCH C_TIPO_INSPECCIO INTO  n_idInspeccio,n_descripcioInspeccio;

  pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  
  END LOOP;
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('Total tipus Inspeccions: '||n_registres);
  DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
CLOSE C_TIPO_INSPECCIO;
COMMIT;
EXCEPTION
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         s_rsp := 'Error: ' || SQLCODE || SUBSTR (SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' ');
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;     
   END PRC_CONSULTAR_TIPO_INSPECCIO;
END "GESTION_TIPO_INSPECCIO";
