CREATE OR REPLACE
PACKAGE BODY          "GESTION_TIPO_CENTRAL" AS
  n_registres      NUMBER;
  s_sql           VARCHAR2 (2000);
  n_NUM_ERR 	  NUMBER(10);
  c_procesLog	  LOG_TFC.procesLog%TYPE;	
  c_dataHoraLog    LOG_TFC.dataHoraLog%TYPE;
  c_entradaLog     LOG_TFC.entradaLog%TYPE;	
  c_sortidaLog     LOG_TFC.sortidaLog%TYPE;
  s_rsp	 LOG_TFC.RSPLOG%TYPE;  
  n_idTipoCentral TIPO_CENTRAL.IDTIPOCENTRAL%TYPE;
  n_descripcioTipoCentral TIPO_CENTRAL.DESCRIPCIOTIPOCENTRAL%TYPE;
  n_idFuncionCentral  TIPO_CENTRAL.IDFUNCIOTIPOCENTRAL%TYPE;
  n_quantitatTipoCentral TIPO_CENTRAL.QUANTITATTIPOCENTRAL%TYPE;
  n_estatTiposCentral TIPO_CENTRAL.ESTATTIPOCENTRAL%TYPE;
  n_dataEstatTipoCentral TIPO_CENTRAL.DATAESTATTIPOCENTRAL%TYPE;
  n_observacioTiposCentral TIPO_CENTRAL.OBSERVACIONSTIPOCENTRAL%TYPE;
  n_estat ESTAT.DESCRIPCIOESTAT%TYPE;
  n_funcions TIPUS_FUNCIONS.DESCRIPCIONFUNCIO%TYPE;
  
  n_descEstat ESTAT.DESCRIPCIOESTAT%TYPE;
  n_funcio TIPUS_FUNCIONS.DESCRIPCIONFUNCIO%TYPE;
  
  sortida VARCHAR2(1000):='';
  e_tipo_central   EXCEPTION;
/********************************************************************
Autor: Eduard Monzonis Hierro                                   UOC
18/05/2012                                             TFC: CONTROL ENERGIA.
            PROCEDIMENT PCR_ALTA_TIPO_CENTRAL
Procediment per donar d'alta el tipus de central de producció d'energia.
*********************************************************************/
PROCEDURE PRC_ALTA_TIPO_CENTRAL(
   p_descripcioTipoCentral in TIPO_CENTRAL.DESCRIPCIOTIPOCENTRAL%TYPE,
   p_idFuncionCentral in TIPO_CENTRAL.IDFUNCIOTIPOCENTRAL%TYPE,
   p_quantitatTipoCentral in TIPO_CENTRAL.QUANTITATTIPOCENTRAL%TYPE,
   p_estatTiposCentral in TIPO_CENTRAL.ESTATTIPOCENTRAL%TYPE,
   p_dataEstatTipoCentral in TIPO_CENTRAL.DATAESTATTIPOCENTRAL%TYPE,
   p_observacioTiposCentral in TIPO_CENTRAL.OBSERVACIONSTIPOCENTRAL%TYPE,
   s_rsp out NOCOPY VARCHAR2)
   AS
 
   BEGIN
    c_procesLog := 'PCR_ALTA_TIPO_CENTRAL';
    c_dataHoraLog := SYSDATE;
    c_entradaLog :=
    'Descripcio Tipo Central: ' || p_descripcioTipoCentral||
    ', Id Funcion Central: ' || p_idFuncionCentral||
    ', Quantitat Tipo Central: ' || p_quantitatTipoCentral||
    --', Estat Tipos Central: ' || p_estatTiposCentral||
    ', Data Estat Tipo Central: ' || p_dataEstatTipoCentral||
    ', Observacio Tipos Central: ' || p_observacioTiposCentral;
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE('       ALTA TIPUS DE CENTRALS        ');
    DBMS_OUTPUT.PUT_LINE('-------------------------------------');
    DBMS_OUTPUT.PUT_LINE(' Descripcio Tipo Central: ' || p_descripcioTipoCentral||
    ', Id Funcion Central: ' || p_idFuncionCentral||
    ', Quantitat Tipo Central: ' || p_quantitatTipoCentral||
    --', Estat Tipos Central: ' || p_estatTiposCentral||
    ', Data Estat Tipo Central: ' || p_dataEstatTipoCentral||
    ', Observacio Tipos Central: ' || p_observacioTiposCentral);
    c_sortidalog := 's_rsp';
    
    n_estatTiposCentral:=1;
    
    SELECT ESTAT.DESCRIPCIOESTAT INTO n_estat
    FROM ESTAT
    WHERE ESTAT.IDESTAT=n_estatTiposCentral;
    
    SELECT TIPUS_FUNCIONS.DESCRIPCIONFUNCIO INTO n_funcions
    FROM TIPUS_FUNCIONS
    WHERE TIPUS_FUNCIONS.IDFUNCIO=p_idFuncionCentral;
    
     If p_descripcioTipoCentral IS NULL then
            DBMS_OUTPUT.ENABLE;
            DBMS_OUTPUT.PUT_LINE('ALTA TIPUS DE CENTRALS: ');
           s_rsp := 'Falta especificar Tipo Central';
           DBMS_OUTPUT.PUT_LINE(s_rsp);
          RAISE e_tipo_central;
     END IF;
   If (p_idFuncionCentral IS NULL) OR (p_idFuncionCentral=0) OR (p_idFuncionCentral<0) then
            DBMS_OUTPUT.ENABLE;
            DBMS_OUTPUT.PUT_LINE('ALTA TIPUS DE CENTRALS: ');
           s_rsp := 'Falta especificar Id Funcion CentraL. ';
           DBMS_OUTPUT.PUT_LINE(s_rsp);
          RAISE e_tipo_central;
     END IF;
     If (p_quantitatTipoCentral IS NULL OR p_quantitatTipoCentral<0) then
            DBMS_OUTPUT.ENABLE;
            DBMS_OUTPUT.PUT_LINE('ALTA TIPUS DE CENTRALS:  ');
           s_rsp := 'Falta especificar Quantitat Tipo Central o el vaLor es mes petit que 0 ';
           DBMS_OUTPUT.PUT_LINE(s_rsp);
          RAISE e_tipo_central;
     END IF;
-- Comprovem si existeix el el tipus de lectura a  donar d'alta
   SELECT COUNT (*)INTO n_registres 
   FROM TIPO_CENTRAL 
   WHERE DESCRIPCIOTIPOCENTRAL = p_descripcioTipoCentral
   AND TIPO_CENTRAL.ESTATTIPOCENTRAL=n_estatTiposCentral;
      
  If n_registres=0 then
-- El donem d'alta a la tipus lectura          
  INSERT INTO TIPO_CENTRAL (DESCRIPCIOTIPOCENTRAL,
                        IDFUNCIOTIPOCENTRAL,
                        QUANTITATTIPOCENTRAL,
                        ESTATTIPOCENTRAL,
                        DATAESTATTIPOCENTRAL,
                        OBSERVACIONSTIPOCENTRAL) 
            VALUES(p_descripcioTipoCentral,
                  p_idFuncionCentral,
                  p_quantitatTipoCentral,
                  n_estatTiposCentral,
                  p_dataEstatTipoCentral,
                  p_observacioTiposCentral);
            --Gravem en la taula log-----------------------------------------------------
  
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('Insertada satisfatoriament el tipus de
  Central '||p_descripcioTipoCentral||
  ' Data alta:'||p_dataEstatTipoCentral||
  ' Estat: '||n_estat||
   ' Unitats: '||p_quantitatTipoCentral||
  ' Cacteristiques: '||n_funcions||
  ' Observacions:'||p_observacioTiposCentral);
  DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
  s_rsp :='Ok: Insertada satisfatoriament el tipus de
  Central '||p_descripcioTipoCentral||
  ' Data alta:'||p_dataEstatTipoCentral||
  ' Estat: '||n_estat||
  ' Unitats: '||p_quantitatTipoCentral||
  ' Cacteristiques: '||n_funcions||
  ' Observacions:'||p_observacioTiposCentral;
  pkg_general.gravar_log_procedure(c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  ELSE
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('ALTA TIPUS DE CENTRALS: ');
    s_rsp := 'DESCRICIO Tipus Central duplicat';
    DBMS_OUTPUT.PUT_LINE(s_rsp);
    RAISE e_tipo_central;
  END IF;
COMMIT;
EXCEPTION
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         s_rsp := 'Error: ' || SQLCODE || SUBSTR (SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('ALTA_TIPO_CENTRAL:  ');
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;

  END PRC_ALTA_TIPO_CENTRAL;
/********************************************************************
Autor: Eduard Monzonis Hierro                                   UOC
18/05/2012                                             TFC: CONTROL ENERGIA.
            PROCEDIMENT PCR_MODIFICA_TIPO_CENTRAL
Procediment per modificar el tipus de central de producció d'energia.
*********************************************************************/   
procedure PRC_MODIFICAR_TIPO_CENTRAL(
   p_idTipoCentral in TIPO_CENTRAL.IDTIPOCENTRAL%TYPE,
   p_descripcioTipoCentral in TIPO_CENTRAL.DESCRIPCIOTIPOCENTRAL%TYPE,
   p_idFuncionCentral in TIPO_CENTRAL.IDFUNCIOTIPOCENTRAL%TYPE,
   p_quantitatTipoCentral in TIPO_CENTRAL.QUANTITATTIPOCENTRAL%TYPE, 
   p_estatTiposCentral in TIPO_CENTRAL.ESTATTIPOCENTRAL%TYPE,
   p_dataEstatTipoCentral in TIPO_CENTRAL.DATAESTATTIPOCENTRAL%TYPE,
   p_observacioTiposCentral in TIPO_CENTRAL.OBSERVACIONSTIPOCENTRAL%TYPE,
   s_rsp out NOCOPY VARCHAR2)
   AS
 
   BEGIN
    c_procesLog := 'PCR_MODIFICA_TIPO_CENTRAL';
    c_dataHoraLog := SYSDATE;
    c_entradaLog := 'Id Tipo Central Tipo Central: ' ||p_idTipoCentral||
    ', Descripcio Tipo Central: ' || p_descripcioTipoCentral||
    ', Id Funcion Central: ' || p_idFuncionCentral||
    ', Quantitat Tipo Central: ' || p_quantitatTipoCentral||
    --', Estat Tipos Central: ' || p_estatTiposCentral||
    ', Data Estat Tipo Central: ' || p_dataEstatTipoCentral||
    ', Observacio Tipos Central: ' || p_observacioTiposCentral;
        DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE(' ');
    DBMS_OUTPUT.PUT_LINE('       MODIFICACION TIPUS DE CENTRALS        ');
    DBMS_OUTPUT.PUT_LINE('---------------------------------------------');
        DBMS_OUTPUT.PUT_LINE(' Codi Tipo Central: ' ||p_idTipoCentral||
    ', Descripcio Tipo Central: ' || p_descripcioTipoCentral||
    ', Id Funcion Central: ' || p_idFuncionCentral||
    ', Quantitat Tipo Central: ' || p_quantitatTipoCentral||
    --', Estat Tipos Central: ' || p_estatTiposCentral||
    ', Data Estat Tipo Central: ' || p_dataEstatTipoCentral||
    ', Observacio Tipos Central: ' || p_observacioTiposCentral);
    c_sortidalog := 's_rsp';
      -- Comprovació del identificador tipus Central i dades a modificar-----
    IF p_idTipoCentral IS NULL THEN
        DBMS_OUTPUT.ENABLE;
        DBMS_OUTPUT.PUT_LINE('MODIFICACION TIPUS DE CENTRALS: ');
        s_rsp := 'Falta especificar el codi tipus Central  ';
        DBMS_OUTPUT.put_line(s_rsp);
        RAISE e_tipo_central;
       
      If  p_descripcioTipoCentral IS NULL THEN
           DBMS_OUTPUT.ENABLE;
           DBMS_OUTPUT.PUT_LINE('MODIFICACION TIPUS DE CENTRALS:  ');
   	   s_rsp := 'Falta especificar tipus Central  ';
           DBMS_OUTPUT.put_line(s_rsp);
           RAISE e_tipo_central;
      END IF;
        If  p_idFuncionCentral IS NULL THEN
           DBMS_OUTPUT.ENABLE;
           DBMS_OUTPUT.PUT_LINE('MODIFICACION TIPUS DE CENTRALS:  ');
   	   s_rsp := 'Falta especificar id Funcion Central';
           DBMS_OUTPUT.put_line(s_rsp);
           RAISE e_tipo_central;
      END IF;
        If  (p_quantitatTipoCentral IS NULL) OR (p_quantitatTipoCentral<0) THEN
           DBMS_OUTPUT.ENABLE;
           DBMS_OUTPUT.PUT_LINE('MODIFICACION TIPUS DE CENTRALS:  ');
   	   s_rsp := 'Falta especificar Quantitat Tipo Central o el vaLor es més petit que 0';
           DBMS_OUTPUT.put_line(s_rsp);
           RAISE e_tipo_central;
      END IF;
        If  (p_estatTiposCentral IS NULL OR p_estatTiposCentral<0 OR p_estatTiposCentral<2) THEN
           DBMS_OUTPUT.ENABLE;
           DBMS_OUTPUT.PUT_LINE('MODIFICA_TIPO_CENTRAL:  ');
   	   s_rsp := 'Falta especificar Estat Tipos Central, 1=ALTA o 2=BAIXA';
           DBMS_OUTPUT.put_line(s_rsp);
           RAISE e_tipo_central;
      END IF;
      If (p_dataEstatTipoCentral IS NULL) then
            DBMS_OUTPUT.ENABLE;
            DBMS_OUTPUT.PUT_LINE('MODIFICA_TIPO_CENTRAL:  ');
           s_rsp := 'Falta especificar Data Estat Tipo Central';
           DBMS_OUTPUT.PUT_LINE(s_rsp);
          RAISE e_tipo_central;
     END IF;      
        ELSE
    SELECT COUNT (*) INTO n_registres 
            FROM TIPO_CENTRAL
            WHERE IDTIPOCENTRAL = p_idTipoCentral;
           If n_registres=0 then
              DBMS_OUTPUT.ENABLE;
              DBMS_OUTPUT.PUT_LINE('MODIFICA_TIPO_CENTRAL:  ');
              s_rsp := 'TIPO_CENTRAL: no existeix a la BBDD';
              DBMS_OUTPUT.PUT_LINE(s_rsp);
               RAISE e_tipo_central;
            END IF;
          -- Comprovem els paràmetres NULL i advertim si falta algun paràmetre
      If  (p_descripcioTipoCentral IS NULL) THEN
           DBMS_OUTPUT.ENABLE;
           DBMS_OUTPUT.PUT_LINE('MODIFICA_TIPO_CENTRAL:  ');
   	   s_rsp := 'Falta especificar tipus Central';
           DBMS_OUTPUT.put_line(s_rsp);
           RAISE e_tipo_central;
        END IF;
        If  (p_idFuncionCentral IS NULL) THEN
           DBMS_OUTPUT.ENABLE;
           DBMS_OUTPUT.PUT_LINE('MODIFICA_TIPO_CENTRAL:  ');
   	   s_rsp := 'Falta especificar id Funcion Central';
           DBMS_OUTPUT.put_line(s_rsp);
           RAISE e_tipo_central;
      END IF;
        If  (p_quantitatTipoCentral IS NULL OR p_quantitatTipoCentral<0) THEN
           DBMS_OUTPUT.ENABLE;
           DBMS_OUTPUT.PUT_LINE('MODIFICA_TIPO_CENTRAL:  ');
   	   s_rsp := 'Falta especificar Quantitat Tipo Central o el vaLor es més petit que 0';
           DBMS_OUTPUT.put_line(s_rsp);
           RAISE e_tipo_central;
      END IF;
        If  (p_estatTiposCentral IS NULL OR p_estatTiposCentral<0 OR p_estatTiposCentral>1) THEN
           DBMS_OUTPUT.ENABLE;
           DBMS_OUTPUT.PUT_LINE('MODIFICA_TIPO_CENTRAL:  ');
   	   s_rsp := 'Falta especificar Estat Tipos Central, 1=ALTA o 0=BAIXA';
           DBMS_OUTPUT.put_line(s_rsp);
           RAISE e_tipo_central;
      END IF;
      If (p_dataEstatTipoCentral IS NULL) then
            DBMS_OUTPUT.ENABLE;
            DBMS_OUTPUT.PUT_LINE('MODIFICA_TIPO_CENTRAL:  ');
           s_rsp := 'Falta especificar Data Estat Tipo Central';
           DBMS_OUTPUT.PUT_LINE(s_rsp);
          RAISE e_tipo_central;
     END IF;
      -- recuperem el codi de la TIPO_CENTRAL
          SELECT IDTIPOCENTRAL  INTO n_idTipoCentral
               FROM TIPO_CENTRAL
              WHERE IDTIPOCENTRAL=p_idTipoCentral;
          
          s_sql := 'UPDATE TIPO_CENTRAL SET ';
 
         -- Construirem la sentencia UPDATE segons si hi ha valor en els paràmetres-
             IF p_descripcioTipoCentral IS NOT NULL THEN
                     -- Modifiquem el descripcio 
                     s_sql := s_sql || 'DESCRIPCIOTIPOCENTRAL=''' ||p_descripcioTipoCentral|| ''',';
              END IF;        
              IF p_idFuncionCentral IS NOT NULL THEN       
                     s_sql := s_sql || 'IDFUNCIOTIPOCENTRAL=''' ||p_idFuncionCentral|| ''',';
               END IF;
              IF p_quantitatTipoCentral IS NOT NULL THEN       
                     s_sql := s_sql || 'QUANTITATTIPOCENTRAL=''' ||p_quantitatTipoCentral|| ''',';
               END IF;
              IF p_estatTiposCentral IS NOT NULL THEN       
                     s_sql := s_sql || 'ESTATTIPOCENTRAL=''' ||p_estatTiposCentral|| ''',';
               END IF;  
               IF p_dataEstatTipoCentral IS NOT NULL THEN       
                     s_sql := s_sql || 'DATAESTATTIPOCENTRAL=''' ||p_dataEstatTipoCentral|| ''',';
               END IF; 
               IF p_observacioTiposCentral IS NOT NULL THEN       
                     s_sql := s_sql || 'OBSERVACIONSTIPOCENTRAL=''' ||p_observacioTiposCentral|| ''',';
               END IF;               
  
               -- Eliminem la coma final de la sentencia SQL
               s_sql := SUBSTR (s_sql, 1, LENGTH (s_sql) - 1);
               -- Afegim a la sentencia la condició del WHERE
               s_sql := s_sql || ' WHERE IDTIPOCENTRAL=''' ||n_idTipoCentral|| '''';
      
               EXECUTE IMMEDIATE s_sql;
              IF SQL%ROWCOUNT = 0  THEN
                  --L'error serà que Tipo Central ja el tenim en la taula i no admet duplicats--
                  DBMS_OUTPUT.ENABLE;
                  DBMS_OUTPUT.PUT_LINE('MODIFICA_TIPO_CENTRAL:  ');
                  s_rsp := 'Actualització no realitzada';
                  DBMS_OUTPUT.PUT_LINE(s_rsp);
                  RAISE e_tipo_central;
               ELSE
            SELECT TIPUS_FUNCIONS.DESCRIPCIONFUNCIO INTO n_funcio
            FROM TIPUS_FUNCIONS, TIPO_CENTRAL
            WHERE TIPO_CENTRAL.IDFUNCIOTIPOCENTRAL=p_idFuncionCentral;
            
            SELECT ESTAT.DESCRIPCIOESTAT INTO n_estat
            FROM ESTAT, TIPO_CENTRAL
            WHERE TIPO_CENTRAL.ESTATTIPOCENTRAL=p_estatTiposCentral;
         
                  DBMS_OUTPUT.ENABLE;
                  DBMS_OUTPUT.PUT_LINE('MODIFICA TIPO CENTRAL:  
                  Codi tipo central: '||n_idTipoCentral||
                  ' Descripcio: '||p_descripcioTipoCentral||
                  ' Unitats: '||p_quantitatTipoCentral||
                  ' Caracteristiques: '||n_funcio||
                  ' Estat: '||n_estat||
                  ' Data Estat Tipo Central: '||p_dataEstatTipoCentral||
                  ' Observacions: '||p_observacioTiposCentral||' Modificacio satisfactoria. ');
                  DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');
                  s_rsp := 'OK  Codi tipo central: '||n_idTipoCentral||
                  ' Descripcio: '||p_descripcioTipoCentral||
                  ' Unitats: '||p_quantitatTipoCentral||
                  ' Caracteristiques: '||n_funcio||
                  ' Estat: '||n_estat||
                  ' Data Estat Tipo Central: '||p_dataEstatTipoCentral||
                  ' Observacions: '||p_observacioTiposCentral||' Modificacio satisfactoria. ';
                  
                  pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
         END IF;
      END IF;
  COMMIT;
EXCEPTION
   WHEN DUP_VAL_ON_INDEX THEN
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('MODIFICAR TIPO CENTRAL: ');
      s_rsp := 'Error: Tipo Central duplicada. No es poden fer les modificacions';
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;      
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         -----------------------------------------
         s_rsp := 'Error: ' || SQLCODE || SUBSTR(SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         -----------------------------------------
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' ');
      DBMS_OUTPUT.put_line (s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;
END PRC_MODIFICAR_TIPO_CENTRAL;
/********************************************************************
Autor: Eduard Monzonis Hierro                                   UOC
18/05/2012                                             TFC: CONTROL ENERGIA.
              PROCEDIMENT PCR_CONSULTA_TIPO_CENTRAL
Procediment per consultar el tipus de central de producció d'energia.
*********************************************************************/
PROCEDURE PRC_CONSULTAR_TIPO_CENTRAL(  
  s_rsp out NOCOPY VARCHAR2)
  AS
  
  CURSOR C_TIPO_CENTRAL IS
  
  SELECT  DISTINCT TIPO_CENTRAL.IDTIPOCENTRAL,
  TIPO_CENTRAL.DESCRIPCIOTIPOCENTRAL,
  TIPO_CENTRAL.DATAESTATTIPOCENTRAL,
  ESTAT.DESCRIPCIOESTAT,
  TIPO_CENTRAL.QUANTITATTIPOCENTRAL,
  TIPUS_FUNCIONS.DESCRIPCIONFUNCIO,
  TIPO_CENTRAL.OBSERVACIONSTIPOCENTRAL
  FROM TIPO_CENTRAL,TIPUS_FUNCIONS,ESTAT
  WHERE TIPO_CENTRAL.IDTIPOCENTRAL=TIPO_CENTRAL.IDTIPOCENTRAL
  AND TIPO_CENTRAL.ESTATTIPOCENTRAL=ESTAT.IDESTAT
  AND TIPO_CENTRAL.IDFUNCIOTIPOCENTRAL=TIPUS_FUNCIONS.IDFUNCIO;
  
  BEGIN
  c_procesLog := 'CONSULTAR_TIPO_CENTRAL';
  c_dataHoraLog := SYSDATE;
  c_entradaLog :=' CONSULTA TIPUS DE CENTRALS' ;
  c_sortidalog := 's_rsp'; 
  
  SELECT COUNT (*) INTO n_registres
  FROM TIPO_CENTRAL
  WHERE TIPO_CENTRAL.IDTIPOCENTRAL=TIPO_CENTRAL.IDTIPOCENTRAL;
  
  IF n_registres=0 THEN
      DBMS_OUTPUT.ENABLE;
     DBMS_OUTPUT.PUT_LINE('CONSULTAR TIPO CENTRAL ');             
     s_rsp := 'Tipo de Central no existent a la BBDD';
     DBMS_OUTPUT.PUT_LINE(s_rsp);
     RAISE e_tipo_central;
     END IF;
     
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('           CONSULTA TIPO CENTRAL                 ');
    DBMS_OUTPUT.PUT_LINE('-------------------------------------------------');
    
OPEN C_TIPO_CENTRAL;
    FETCH C_TIPO_CENTRAL INTO n_idTipoCentral,n_descripcioTipoCentral,
    n_dataEstatTipoCentral,n_descEstat,n_quantitatTipoCentral,n_funcio,
    n_observacioTiposCentral;
  WHILE C_TIPO_CENTRAL%FOUND LOOP
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE(
 '   Codi Tipo Central:  '
 ||n_idTipoCentral
 ||' Descripcio '
 ||n_descripcioTipoCentral||
 ' Data estat tipo centras: '||n_dataEstatTipoCentral||
 ' Estat Central: '||n_descEstat||
 ' Unitats: '||n_quantitatTipoCentral||
 ' Caracteristiques: '||n_funcio||
 ' Observacions: '||n_observacioTiposCentral );
  s_rsp := 'OK  CONSULTA TIPO CENTRAL:   
  Codi Tipo Central:  '
 ||n_idTipoCentral
 ||' Descripcio '
 ||n_descripcioTipoCentral||
 ' Data estat tipo centras: '||n_dataEstatTipoCentral||
 ' Estat Central: '||n_descEstat||
 ' Unitats: '||n_quantitatTipoCentral||
 ' Caracteristiques: '||n_funcio||
 ' Observacions: '||n_observacioTiposCentral ;
  FETCH C_TIPO_CENTRAL INTO n_idTipoCentral,n_descripcioTipoCentral,
    n_dataEstatTipoCentral,n_estat,n_quantitatTipoCentral,n_funcio,
    n_observacioTiposCentral;
  pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
  
  END LOOP;
  DBMS_OUTPUT.ENABLE;
  DBMS_OUTPUT.PUT_LINE('Total tipo de Centrals: '||n_registres);
  DBMS_OUTPUT.PUT_LINE('****** FI DE LES OPERACIONS *******');

CLOSE C_TIPO_CENTRAL;

COMMIT;
EXCEPTION
   WHEN DUP_VAL_ON_INDEX THEN
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE('CONSULTAR TIPO DE CENTRAL: ');
      s_rsp := 'Error: Tipo Central duplicada. No es poden fer les modificacions';
      DBMS_OUTPUT.put_line(s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;      
   WHEN OTHERS THEN
      IF s_rsp IS NULL THEN
         -- L'error no ha estat controlat per codi
         -----------------------------------------
         s_rsp := 'Error: ' || SQLCODE || SUBSTR(SQLERRM, 1, 100);
      ELSE
         -- L'error si ha estat controlat per codi
         -----------------------------------------
         s_rsp := 'Error: ' || s_rsp;
      END IF;
      DBMS_OUTPUT.ENABLE;
      DBMS_OUTPUT.PUT_LINE(' ');
      DBMS_OUTPUT.put_line (s_rsp);
      pkg_general.gravar_log_procedure (c_procesLog, c_dataHoraLog, c_entradaLog, c_sortidaLog, s_rsp);
      ROLLBACK;
  END PRC_CONSULTAR_TIPO_CENTRAL;  
END "GESTION_TIPO_CENTRAL";
